/* DateTimePickerView.c generated by valac 0.36.4, the Vala compiler
 * generated from DateTimePickerView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>
 *              Jaap Broekhuizen <jaapz.b@gmail.com>
 *              Victor Eduardo <victoreduardm@gmal.com>
 *              Tom Beckmann <tom@elementary.io>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "granite.h"


#define TYPE_DATE_TIME_PICKER_VIEW (date_time_picker_view_get_type ())
#define DATE_TIME_PICKER_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATE_TIME_PICKER_VIEW, DateTimePickerView))
#define DATE_TIME_PICKER_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATE_TIME_PICKER_VIEW, DateTimePickerViewClass))
#define IS_DATE_TIME_PICKER_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATE_TIME_PICKER_VIEW))
#define IS_DATE_TIME_PICKER_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATE_TIME_PICKER_VIEW))
#define DATE_TIME_PICKER_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATE_TIME_PICKER_VIEW, DateTimePickerViewClass))

typedef struct _DateTimePickerView DateTimePickerView;
typedef struct _DateTimePickerViewClass DateTimePickerViewClass;
typedef struct _DateTimePickerViewPrivate DateTimePickerViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DateTimePickerView {
	GtkGrid parent_instance;
	DateTimePickerViewPrivate * priv;
};

struct _DateTimePickerViewClass {
	GtkGridClass parent_class;
};


static gpointer date_time_picker_view_parent_class = NULL;

GType date_time_picker_view_get_type (void) G_GNUC_CONST;
enum  {
	DATE_TIME_PICKER_VIEW_DUMMY_PROPERTY
};
DateTimePickerView* date_time_picker_view_new (void);
DateTimePickerView* date_time_picker_view_construct (GType object_type);
static GObject * date_time_picker_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);


DateTimePickerView* date_time_picker_view_construct (GType object_type) {
	DateTimePickerView * self = NULL;
	self = (DateTimePickerView*) g_object_new (object_type, NULL);
	return self;
}


DateTimePickerView* date_time_picker_view_new (void) {
	return date_time_picker_view_construct (TYPE_DATE_TIME_PICKER_VIEW);
}


static GObject * date_time_picker_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DateTimePickerView * self;
	GtkLabel* date_label = NULL;
	GtkLabel* _tmp0_;
	GraniteWidgetsDatePicker* datepicker = NULL;
	GraniteWidgetsDatePicker* _tmp1_;
	GtkLabel* time_label = NULL;
	GtkLabel* _tmp2_;
	GraniteWidgetsTimePicker* timepicker = NULL;
	GraniteWidgetsTimePicker* _tmp3_;
	GtkLabel* _tmp4_;
	GraniteWidgetsDatePicker* _tmp5_;
	GtkLabel* _tmp6_;
	GraniteWidgetsTimePicker* _tmp7_;
	parent_class = G_OBJECT_CLASS (date_time_picker_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATE_TIME_PICKER_VIEW, DateTimePickerView);
	_tmp0_ = (GtkLabel*) gtk_label_new ("Date:");
	g_object_ref_sink (_tmp0_);
	date_label = _tmp0_;
	_tmp1_ = granite_widgets_date_picker_new ();
	g_object_ref_sink (_tmp1_);
	datepicker = _tmp1_;
	_tmp2_ = (GtkLabel*) gtk_label_new ("Time:");
	g_object_ref_sink (_tmp2_);
	time_label = _tmp2_;
	_tmp3_ = granite_widgets_time_picker_new ();
	g_object_ref_sink (_tmp3_);
	timepicker = _tmp3_;
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp4_ = date_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp4_, 0, 1, 1, 1);
	_tmp5_ = datepicker;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp5_, 1, 1, 1, 1);
	_tmp6_ = time_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp6_, 0, 2, 1, 1);
	_tmp7_ = timepicker;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp7_, 1, 2, 1, 1);
	_g_object_unref0 (timepicker);
	_g_object_unref0 (time_label);
	_g_object_unref0 (datepicker);
	_g_object_unref0 (date_label);
	return obj;
}


static void date_time_picker_view_class_init (DateTimePickerViewClass * klass) {
	date_time_picker_view_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = date_time_picker_view_constructor;
}


static void date_time_picker_view_instance_init (DateTimePickerView * self) {
}


GType date_time_picker_view_get_type (void) {
	static volatile gsize date_time_picker_view_type_id__volatile = 0;
	if (g_once_init_enter (&date_time_picker_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DateTimePickerViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_picker_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimePickerView), 0, (GInstanceInitFunc) date_time_picker_view_instance_init, NULL };
		GType date_time_picker_view_type_id;
		date_time_picker_view_type_id = g_type_register_static (gtk_grid_get_type (), "DateTimePickerView", &g_define_type_info, 0);
		g_once_init_leave (&date_time_picker_view_type_id__volatile, date_time_picker_view_type_id);
	}
	return date_time_picker_view_type_id__volatile;
}



