/* SourceListView.c generated by valac 0.36.4, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>
 *              Jaap Broekhuizen <jaapz.b@gmail.com>
 *              Victor Eduardo <victoreduardm@gmal.com>
 *              Tom Beckmann <tom@elementary.io>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "granite.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_SOURCE_LIST_VIEW (source_list_view_get_type ())
#define SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_LIST_VIEW, SourceListView))
#define SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_LIST_VIEW, SourceListViewClass))
#define IS_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_LIST_VIEW))
#define IS_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_LIST_VIEW))
#define SOURCE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_LIST_VIEW, SourceListViewClass))

typedef struct _SourceListView SourceListView;
typedef struct _SourceListViewClass SourceListViewClass;
typedef struct _SourceListViewPrivate SourceListViewPrivate;
typedef struct _Block5Data Block5Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SourceListView {
	GtkPaned parent_instance;
	SourceListViewPrivate * priv;
};

struct _SourceListViewClass {
	GtkPanedClass parent_class;
};

struct _Block5Data {
	int _ref_count_;
	SourceListView* self;
	GtkLabel* label;
};


static gpointer source_list_view_parent_class = NULL;

GType source_list_view_get_type (void) G_GNUC_CONST;
enum  {
	SOURCE_LIST_VIEW_DUMMY_PROPERTY
};
SourceListView* source_list_view_new (void);
SourceListView* source_list_view_construct (GType object_type);
static GObject * source_list_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _source_list_view___lambda10_ (Block5Data* _data5_, GraniteWidgetsSourceListItem* item);
static void __source_list_view___lambda10__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender, GraniteWidgetsSourceListItem* item, gpointer self);


SourceListView* source_list_view_construct (GType object_type) {
	SourceListView * self = NULL;
	self = (SourceListView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, NULL);
	return self;
}


SourceListView* source_list_view_new (void) {
	return source_list_view_construct (TYPE_SOURCE_LIST_VIEW);
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		SourceListView* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->label);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void _source_list_view___lambda10_ (Block5Data* _data5_, GraniteWidgetsSourceListItem* item) {
	SourceListView* self;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp2_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GtkLabel* _tmp10_;
	GraniteWidgetsSourceListItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GraniteWidgetsSourceListItem* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	self = _data5_->self;
	_tmp0_ = item;
	if (_tmp0_ == NULL) {
		GtkLabel* _tmp1_;
		_tmp1_ = _data5_->label;
		gtk_label_set_label (_tmp1_, "No selected item");
		return;
	}
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_item_get_badge (_tmp3_);
	_tmp5_ = _tmp4_;
	if (g_strcmp0 (_tmp5_, "") != 0) {
		GraniteWidgetsSourceListItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp6_ = item;
		_tmp7_ = granite_widgets_source_list_item_get_badge (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = _tmp8_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GraniteWidgetsSourceListItem* _tmp9_;
		_tmp9_ = item;
		granite_widgets_source_list_item_set_badge (_tmp9_, "");
	}
	_tmp10_ = _data5_->label;
	_tmp11_ = item;
	_tmp12_ = granite_widgets_source_list_item_get_parent (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = item;
	_tmp17_ = granite_widgets_source_list_item_get_name (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strdup_printf ("%s - %s", _tmp15_, _tmp18_);
	_tmp20_ = _tmp19_;
	gtk_label_set_label (_tmp10_, _tmp20_);
	_g_free0 (_tmp20_);
}


static void __source_list_view___lambda10__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	_source_list_view___lambda10_ (self, item);
}


static GObject * source_list_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SourceListView * self;
	Block5Data* _data5_;
	GraniteWidgetsSourceListItem* music_item = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GThemedIcon* _tmp3_;
	GThemedIcon* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* library_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp5_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	GraniteWidgetsSourceListItem* my_store_podcast_item = NULL;
	GraniteWidgetsSourceListItem* _tmp9_;
	GraniteWidgetsSourceListItem* _tmp10_;
	GThemedIcon* _tmp11_;
	GThemedIcon* _tmp12_;
	GraniteWidgetsSourceListItem* my_store_music_item = NULL;
	GraniteWidgetsSourceListItem* _tmp13_;
	GraniteWidgetsSourceListItem* _tmp14_;
	GThemedIcon* _tmp15_;
	GThemedIcon* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* my_store_item = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	GraniteWidgetsSourceListExpandableItem* _tmp18_;
	GThemedIcon* _tmp19_;
	GThemedIcon* _tmp20_;
	GraniteWidgetsSourceListExpandableItem* _tmp21_;
	GraniteWidgetsSourceListItem* _tmp22_;
	GraniteWidgetsSourceListExpandableItem* _tmp23_;
	GraniteWidgetsSourceListItem* _tmp24_;
	GraniteWidgetsSourceListExpandableItem* store_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp25_;
	GraniteWidgetsSourceListExpandableItem* _tmp26_;
	GraniteWidgetsSourceListExpandableItem* _tmp27_;
	GraniteWidgetsSourceListExpandableItem* _tmp28_;
	GraniteWidgetsSourceListItem* player1_item = NULL;
	GraniteWidgetsSourceListItem* _tmp29_;
	GraniteWidgetsSourceListItem* _tmp30_;
	GThemedIcon* _tmp31_;
	GThemedIcon* _tmp32_;
	GraniteWidgetsSourceListItem* player2_item = NULL;
	GraniteWidgetsSourceListItem* _tmp33_;
	GraniteWidgetsSourceListItem* _tmp34_;
	GraniteWidgetsSourceListItem* _tmp35_;
	GThemedIcon* _tmp36_;
	GThemedIcon* _tmp37_;
	GraniteWidgetsSourceListExpandableItem* device_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp38_;
	GraniteWidgetsSourceListExpandableItem* _tmp39_;
	GraniteWidgetsSourceListExpandableItem* _tmp40_;
	GraniteWidgetsSourceListItem* _tmp41_;
	GraniteWidgetsSourceListExpandableItem* _tmp42_;
	GraniteWidgetsSourceListItem* _tmp43_;
	GraniteWidgetsSourceList* source_list = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp44_;
	GraniteWidgetsSourceListExpandableItem* _tmp45_;
	GraniteWidgetsSourceList* _tmp46_;
	GraniteWidgetsSourceList* _tmp47_;
	GraniteWidgetsSourceList* _tmp48_;
	GraniteWidgetsSourceListExpandableItem* _tmp49_;
	GraniteWidgetsSourceListExpandableItem* _tmp50_;
	GraniteWidgetsSourceListExpandableItem* _tmp51_;
	GraniteWidgetsSourceList* _tmp52_;
	GraniteWidgetsSourceListExpandableItem* _tmp53_;
	GraniteWidgetsSourceListExpandableItem* _tmp54_;
	GraniteWidgetsSourceListExpandableItem* _tmp55_;
	GraniteWidgetsSourceList* _tmp56_;
	GraniteWidgetsSourceListExpandableItem* _tmp57_;
	GraniteWidgetsSourceListExpandableItem* _tmp58_;
	GraniteWidgetsSourceListExpandableItem* _tmp59_;
	GtkLabel* _tmp60_;
	GraniteWidgetsSourceList* _tmp61_;
	GtkLabel* _tmp62_;
	GraniteWidgetsSourceList* _tmp63_;
	parent_class = G_OBJECT_CLASS (source_list_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_LIST_VIEW, SourceListView);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = granite_widgets_source_list_item_new ("Music");
	music_item = _tmp0_;
	_tmp1_ = music_item;
	granite_widgets_source_list_item_set_badge (_tmp1_, "1");
	_tmp2_ = music_item;
	_tmp3_ = (GThemedIcon*) g_themed_icon_new ("library-music");
	_tmp4_ = _tmp3_;
	granite_widgets_source_list_item_set_icon (_tmp2_, (GIcon*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = granite_widgets_source_list_expandable_item_new ("Libraries");
	library_category = _tmp5_;
	_tmp6_ = library_category;
	granite_widgets_source_list_expandable_item_expand_all (_tmp6_, TRUE, TRUE);
	_tmp7_ = library_category;
	_tmp8_ = music_item;
	granite_widgets_source_list_expandable_item_add (_tmp7_, _tmp8_);
	_tmp9_ = granite_widgets_source_list_item_new ("Podcasts");
	my_store_podcast_item = _tmp9_;
	_tmp10_ = my_store_podcast_item;
	_tmp11_ = (GThemedIcon*) g_themed_icon_new ("library-podcast");
	_tmp12_ = _tmp11_;
	granite_widgets_source_list_item_set_icon (_tmp10_, (GIcon*) _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = granite_widgets_source_list_item_new ("Music");
	my_store_music_item = _tmp13_;
	_tmp14_ = my_store_music_item;
	_tmp15_ = (GThemedIcon*) g_themed_icon_new ("library-music");
	_tmp16_ = _tmp15_;
	granite_widgets_source_list_item_set_icon (_tmp14_, (GIcon*) _tmp16_);
	_g_object_unref0 (_tmp16_);
	_tmp17_ = granite_widgets_source_list_expandable_item_new ("My Store");
	my_store_item = _tmp17_;
	_tmp18_ = my_store_item;
	_tmp19_ = (GThemedIcon*) g_themed_icon_new ("system-software-install");
	_tmp20_ = _tmp19_;
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp18_, (GIcon*) _tmp20_);
	_g_object_unref0 (_tmp20_);
	_tmp21_ = my_store_item;
	_tmp22_ = my_store_music_item;
	granite_widgets_source_list_expandable_item_add (_tmp21_, _tmp22_);
	_tmp23_ = my_store_item;
	_tmp24_ = my_store_podcast_item;
	granite_widgets_source_list_expandable_item_add (_tmp23_, _tmp24_);
	_tmp25_ = granite_widgets_source_list_expandable_item_new ("Stores");
	store_category = _tmp25_;
	_tmp26_ = store_category;
	granite_widgets_source_list_expandable_item_expand_all (_tmp26_, TRUE, TRUE);
	_tmp27_ = store_category;
	_tmp28_ = my_store_item;
	granite_widgets_source_list_expandable_item_add (_tmp27_, (GraniteWidgetsSourceListItem*) _tmp28_);
	_tmp29_ = granite_widgets_source_list_item_new ("Player 1");
	player1_item = _tmp29_;
	_tmp30_ = player1_item;
	_tmp31_ = (GThemedIcon*) g_themed_icon_new ("multimedia-player");
	_tmp32_ = _tmp31_;
	granite_widgets_source_list_item_set_icon (_tmp30_, (GIcon*) _tmp32_);
	_g_object_unref0 (_tmp32_);
	_tmp33_ = granite_widgets_source_list_item_new ("Player 2");
	player2_item = _tmp33_;
	_tmp34_ = player2_item;
	granite_widgets_source_list_item_set_badge (_tmp34_, "3");
	_tmp35_ = player2_item;
	_tmp36_ = (GThemedIcon*) g_themed_icon_new ("phone");
	_tmp37_ = _tmp36_;
	granite_widgets_source_list_item_set_icon (_tmp35_, (GIcon*) _tmp37_);
	_g_object_unref0 (_tmp37_);
	_tmp38_ = granite_widgets_source_list_expandable_item_new ("Devices");
	device_category = _tmp38_;
	_tmp39_ = device_category;
	granite_widgets_source_list_expandable_item_expand_all (_tmp39_, TRUE, TRUE);
	_tmp40_ = device_category;
	_tmp41_ = player1_item;
	granite_widgets_source_list_expandable_item_add (_tmp40_, _tmp41_);
	_tmp42_ = device_category;
	_tmp43_ = player2_item;
	granite_widgets_source_list_expandable_item_add (_tmp42_, _tmp43_);
	_tmp44_ = granite_widgets_source_list_expandable_item_new ("");
	_tmp45_ = _tmp44_;
	_tmp46_ = granite_widgets_source_list_new (_tmp45_);
	g_object_ref_sink (_tmp46_);
	_tmp47_ = _tmp46_;
	_g_object_unref0 (_tmp45_);
	source_list = _tmp47_;
	_tmp48_ = source_list;
	_tmp49_ = granite_widgets_source_list_get_root (_tmp48_);
	_tmp50_ = _tmp49_;
	_tmp51_ = library_category;
	granite_widgets_source_list_expandable_item_add (_tmp50_, (GraniteWidgetsSourceListItem*) _tmp51_);
	_tmp52_ = source_list;
	_tmp53_ = granite_widgets_source_list_get_root (_tmp52_);
	_tmp54_ = _tmp53_;
	_tmp55_ = store_category;
	granite_widgets_source_list_expandable_item_add (_tmp54_, (GraniteWidgetsSourceListItem*) _tmp55_);
	_tmp56_ = source_list;
	_tmp57_ = granite_widgets_source_list_get_root (_tmp56_);
	_tmp58_ = _tmp57_;
	_tmp59_ = device_category;
	granite_widgets_source_list_expandable_item_add (_tmp58_, (GraniteWidgetsSourceListItem*) _tmp59_);
	_tmp60_ = (GtkLabel*) gtk_label_new ("No selected item");
	g_object_ref_sink (_tmp60_);
	_data5_->label = _tmp60_;
	gtk_paned_set_position ((GtkPaned*) self, 150);
	_tmp61_ = source_list;
	gtk_paned_pack1 ((GtkPaned*) self, (GtkWidget*) _tmp61_, FALSE, FALSE);
	_tmp62_ = _data5_->label;
	gtk_paned_add2 ((GtkPaned*) self, (GtkWidget*) _tmp62_);
	_tmp63_ = source_list;
	g_signal_connect_data (_tmp63_, "item-selected", (GCallback) __source_list_view___lambda10__granite_widgets_source_list_item_selected, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_g_object_unref0 (source_list);
	_g_object_unref0 (device_category);
	_g_object_unref0 (player2_item);
	_g_object_unref0 (player1_item);
	_g_object_unref0 (store_category);
	_g_object_unref0 (my_store_item);
	_g_object_unref0 (my_store_music_item);
	_g_object_unref0 (my_store_podcast_item);
	_g_object_unref0 (library_category);
	_g_object_unref0 (music_item);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return obj;
}


static void source_list_view_class_init (SourceListViewClass * klass) {
	source_list_view_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = source_list_view_constructor;
}


static void source_list_view_instance_init (SourceListView * self) {
}


GType source_list_view_get_type (void) {
	static volatile gsize source_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&source_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceListView), 0, (GInstanceInitFunc) source_list_view_instance_init, NULL };
		GType source_list_view_type_id;
		source_list_view_type_id = g_type_register_static (gtk_paned_get_type (), "SourceListView", &g_define_type_info, 0);
		g_once_init_leave (&source_list_view_type_id__volatile, source_list_view_type_id);
	}
	return source_list_view_type_id__volatile;
}



