/* StorageView.c generated by valac 0.36.4, the Vala compiler
 * generated from StorageView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>
 *              Jaap Broekhuizen <jaapz.b@gmail.com>
 *              Victor Eduardo <victoreduardm@gmal.com>
 *              Tom Beckmann <tom@elementary.io>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "granite.h"


#define TYPE_STORAGE_VIEW (storage_view_get_type ())
#define STORAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STORAGE_VIEW, StorageView))
#define STORAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STORAGE_VIEW, StorageViewClass))
#define IS_STORAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STORAGE_VIEW))
#define IS_STORAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STORAGE_VIEW))
#define STORAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STORAGE_VIEW, StorageViewClass))

typedef struct _StorageView StorageView;
typedef struct _StorageViewClass StorageViewClass;
typedef struct _StorageViewPrivate StorageViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _StorageView {
	GtkGrid parent_instance;
	StorageViewPrivate * priv;
};

struct _StorageViewClass {
	GtkGridClass parent_class;
};


static gpointer storage_view_parent_class = NULL;

GType storage_view_get_type (void) G_GNUC_CONST;
enum  {
	STORAGE_VIEW_DUMMY_PROPERTY
};
StorageView* storage_view_new (void);
StorageView* storage_view_construct (GType object_type);
static GObject * storage_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);


StorageView* storage_view_construct (GType object_type) {
	StorageView * self = NULL;
	self = (StorageView*) g_object_new (object_type, NULL);
	return self;
}


StorageView* storage_view_new (void) {
	return storage_view_construct (TYPE_STORAGE_VIEW);
}


static GObject * storage_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	StorageView * self;
	GFile* file_root = NULL;
	GFile* _tmp0_;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (storage_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STORAGE_VIEW, StorageView);
	_tmp0_ = g_file_new_for_path ("/");
	file_root = _tmp0_;
	{
		GFileInfo* info = NULL;
		GFile* _tmp1_;
		GFileInfo* _tmp2_;
		guint64 size = 0ULL;
		GFileInfo* _tmp3_;
		guint64 _tmp4_;
		GraniteWidgetsStorageBar* storage = NULL;
		guint64 _tmp5_;
		guint64 _tmp6_;
		GraniteWidgetsStorageBar* _tmp7_;
		GraniteWidgetsStorageBar* _tmp8_;
		guint64 _tmp9_;
		GraniteWidgetsStorageBar* _tmp10_;
		guint64 _tmp11_;
		GraniteWidgetsStorageBar* _tmp12_;
		guint64 _tmp13_;
		GraniteWidgetsStorageBar* _tmp14_;
		guint64 _tmp15_;
		GraniteWidgetsStorageBar* _tmp16_;
		guint64 _tmp17_;
		GraniteWidgetsStorageBar* _tmp18_;
		_tmp1_ = file_root;
		_tmp2_ = g_file_query_filesystem_info (_tmp1_, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE, NULL, &_inner_error_);
		info = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = info;
		_tmp4_ = g_file_info_get_attribute_uint64 (_tmp3_, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
		size = _tmp4_;
		_tmp5_ = size;
		_tmp6_ = size;
		_tmp7_ = granite_widgets_storage_bar_new_with_total_usage (_tmp5_, _tmp6_ / 2);
		g_object_ref_sink (_tmp7_);
		storage = _tmp7_;
		_tmp8_ = storage;
		_tmp9_ = size;
		granite_widgets_storage_bar_update_block_size (_tmp8_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_AUDIO, _tmp9_ / 40);
		_tmp10_ = storage;
		_tmp11_ = size;
		granite_widgets_storage_bar_update_block_size (_tmp10_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_VIDEO, _tmp11_ / 30);
		_tmp12_ = storage;
		_tmp13_ = size;
		granite_widgets_storage_bar_update_block_size (_tmp12_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_APP, _tmp13_ / 20);
		_tmp14_ = storage;
		_tmp15_ = size;
		granite_widgets_storage_bar_update_block_size (_tmp14_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_PHOTO, _tmp15_ / 10);
		_tmp16_ = storage;
		_tmp17_ = size;
		granite_widgets_storage_bar_update_block_size (_tmp16_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_FILES, _tmp17_ / 5);
		_tmp18_ = storage;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
		_g_object_unref0 (storage);
		_g_object_unref0 (info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		g_critical ("StorageView.vala:45: %s", _tmp20_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file_root);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_object_unref0 (file_root);
	return obj;
}


static void storage_view_class_init (StorageViewClass * klass) {
	storage_view_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = storage_view_constructor;
}


static void storage_view_instance_init (StorageView * self) {
}


GType storage_view_get_type (void) {
	static volatile gsize storage_view_type_id__volatile = 0;
	if (g_once_init_enter (&storage_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StorageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) storage_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StorageView), 0, (GInstanceInitFunc) storage_view_instance_init, NULL };
		GType storage_view_type_id;
		storage_view_type_id = g_type_register_static (gtk_grid_get_type (), "StorageView", &g_define_type_info, 0);
		g_once_init_leave (&storage_view_type_id__volatile, storage_view_type_id);
	}
	return storage_view_type_id__volatile;
}



