/* Utilities.c generated by valac 0.36.4, the Vala compiler
 * generated from Utilities.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Maxwell Barvian <maxwell@elementaryos.org>,
 *                          Robert Dyer
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define GRANITE_DRAWING_TYPE_UTILITIES (granite_drawing_utilities_get_type ())
#define GRANITE_DRAWING_UTILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilities))
#define GRANITE_DRAWING_UTILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilitiesClass))
#define GRANITE_DRAWING_IS_UTILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_DRAWING_TYPE_UTILITIES))
#define GRANITE_DRAWING_IS_UTILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_DRAWING_TYPE_UTILITIES))
#define GRANITE_DRAWING_UTILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilitiesClass))

typedef struct _GraniteDrawingUtilities GraniteDrawingUtilities;
typedef struct _GraniteDrawingUtilitiesClass GraniteDrawingUtilitiesClass;
typedef struct _GraniteDrawingUtilitiesPrivate GraniteDrawingUtilitiesPrivate;

#define GRANITE_DRAWING_TYPE_COLOR (granite_drawing_color_get_type ())
#define GRANITE_DRAWING_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColor))
#define GRANITE_DRAWING_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))
#define GRANITE_DRAWING_IS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_IS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))

typedef struct _GraniteDrawingColor GraniteDrawingColor;
typedef struct _GraniteDrawingColorClass GraniteDrawingColorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GraniteDrawingUtilities {
	GObject parent_instance;
	GraniteDrawingUtilitiesPrivate * priv;
};

struct _GraniteDrawingUtilitiesClass {
	GObjectClass parent_class;
};


static gpointer granite_drawing_utilities_parent_class = NULL;

GType granite_drawing_utilities_get_type (void) G_GNUC_CONST;
enum  {
	GRANITE_DRAWING_UTILITIES_DUMMY_PROPERTY
};
void granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
GType granite_drawing_color_get_type (void) G_GNUC_CONST;
GraniteDrawingColor* granite_drawing_utilities_average_color (GdkPixbuf* source);
GraniteDrawingColor* granite_drawing_color_new (gdouble R, gdouble G, gdouble B, gdouble A);
GraniteDrawingColor* granite_drawing_color_construct (GType object_type, gdouble R, gdouble G, gdouble B, gdouble A);
GraniteDrawingColor* granite_drawing_color_set_val (GraniteDrawingColor* self, gdouble val);
GraniteDrawingColor* granite_drawing_color_multiply_sat (GraniteDrawingColor* self, gdouble amount);
GraniteDrawingUtilities* granite_drawing_utilities_new (void);
GraniteDrawingUtilities* granite_drawing_utilities_construct (GType object_type);


/**
         * Adds a closed sub-path rounded rectangle of the given size and border radius to the current path
         * at position (x, y) in user-space coordinates.
         *
         * @param cr a {@link Cairo.Context}
         * @param x the X coordinate of the top left corner of the rounded rectangle
         * @param y the Y coordinate to the top left corner of the rounded rectangle
         * @param width the width of the rounded rectangle
         * @param height the height of the rounded rectangle
         * @param radius the border radius of the rounded rectangle
         */
void granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius) {
	cairo_t* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	cairo_t* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	cairo_t* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	cairo_t* _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	cairo_t* _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	cairo_t* _tmp32_;
	g_return_if_fail (cr != NULL);
	_tmp0_ = cr;
	_tmp1_ = x;
	_tmp2_ = radius;
	_tmp3_ = y;
	cairo_move_to (_tmp0_, _tmp1_ + _tmp2_, _tmp3_);
	_tmp4_ = cr;
	_tmp5_ = x;
	_tmp6_ = width;
	_tmp7_ = radius;
	_tmp8_ = y;
	_tmp9_ = radius;
	_tmp10_ = radius;
	cairo_arc (_tmp4_, (_tmp5_ + _tmp6_) - _tmp7_, _tmp8_ + _tmp9_, _tmp10_, G_PI * 1.5, G_PI * 2);
	_tmp11_ = cr;
	_tmp12_ = x;
	_tmp13_ = width;
	_tmp14_ = radius;
	_tmp15_ = y;
	_tmp16_ = height;
	_tmp17_ = radius;
	_tmp18_ = radius;
	cairo_arc (_tmp11_, (_tmp12_ + _tmp13_) - _tmp14_, (_tmp15_ + _tmp16_) - _tmp17_, _tmp18_, (gdouble) 0, G_PI * 0.5);
	_tmp19_ = cr;
	_tmp20_ = x;
	_tmp21_ = radius;
	_tmp22_ = y;
	_tmp23_ = height;
	_tmp24_ = radius;
	_tmp25_ = radius;
	cairo_arc (_tmp19_, _tmp20_ + _tmp21_, (_tmp22_ + _tmp23_) - _tmp24_, _tmp25_, G_PI * 0.5, G_PI);
	_tmp26_ = cr;
	_tmp27_ = x;
	_tmp28_ = radius;
	_tmp29_ = y;
	_tmp30_ = radius;
	_tmp31_ = radius;
	cairo_arc (_tmp26_, _tmp27_ + _tmp28_, _tmp29_ + _tmp30_, _tmp31_, G_PI, G_PI * 1.5);
	_tmp32_ = cr;
	cairo_close_path (_tmp32_);
}


/**
         * Averages the colors in the {@link Gdk.Pixbuf} and returns it.
         *
         * @param source the {@link Gdk.Pixbuf}
         * 
         * @return the {@link Granite.Drawing.Color} containing the averaged color
         */
GraniteDrawingColor* granite_drawing_utilities_average_color (GdkPixbuf* source) {
	GraniteDrawingColor* result = NULL;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	guint8* dataPtr = NULL;
	GdkPixbuf* _tmp0_;
	guint8* _tmp1_;
	gdouble pixels = 0.0;
	GdkPixbuf* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_;
	gdouble _tmp56_;
	GraniteDrawingColor* _tmp57_;
	GraniteDrawingColor* _tmp58_;
	GraniteDrawingColor* _tmp59_;
	GraniteDrawingColor* _tmp60_;
	GraniteDrawingColor* _tmp61_;
	GraniteDrawingColor* _tmp62_;
	g_return_val_if_fail (source != NULL, NULL);
	rTotal = 0.0;
	gTotal = 0.0;
	bTotal = 0.0;
	_tmp0_ = source;
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
	dataPtr = _tmp1_;
	_tmp2_ = source;
	_tmp3_ = gdk_pixbuf_get_height (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_rowstride (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = source;
	_tmp9_ = gdk_pixbuf_get_n_channels (_tmp8_);
	_tmp10_ = _tmp9_;
	pixels = (gdouble) ((_tmp4_ * _tmp7_) / _tmp10_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gint _tmp13_;
				gdouble _tmp14_;
				guint8 r = 0U;
				guint8* _tmp15_;
				guint8 _tmp16_;
				guint8 g = 0U;
				guint8* _tmp17_;
				guint8 _tmp18_;
				guint8 b = 0U;
				guint8* _tmp19_;
				guint8 _tmp20_;
				guint8 max = 0U;
				guint8 _tmp21_;
				guint8 _tmp22_;
				guint8 _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
				guint8 min = 0U;
				guint8 _tmp26_;
				guint8 _tmp27_;
				guint8 _tmp28_;
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble delta = 0.0;
				guint8 _tmp31_;
				guint8 _tmp32_;
				gdouble _tmp33_ = 0.0;
				gdouble _tmp34_;
				gdouble sat = 0.0;
				gdouble score = 0.0;
				gdouble _tmp37_;
				gdouble _tmp38_;
				guint8 _tmp39_;
				gdouble _tmp40_;
				gdouble _tmp41_;
				guint8 _tmp42_;
				gdouble _tmp43_;
				gdouble _tmp44_;
				guint8 _tmp45_;
				gdouble _tmp46_;
				guint8* _tmp47_;
				GdkPixbuf* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = i;
					i = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				_tmp13_ = i;
				_tmp14_ = pixels;
				if (!(((gdouble) _tmp13_) < _tmp14_)) {
					break;
				}
				_tmp15_ = dataPtr;
				_tmp16_ = _tmp15_[0];
				r = _tmp16_;
				_tmp17_ = dataPtr;
				_tmp18_ = _tmp17_[1];
				g = _tmp18_;
				_tmp19_ = dataPtr;
				_tmp20_ = _tmp19_[2];
				b = _tmp20_;
				_tmp21_ = r;
				_tmp22_ = g;
				_tmp23_ = b;
				_tmp24_ = MAX ((gdouble) _tmp22_, (gdouble) _tmp23_);
				_tmp25_ = MAX ((gdouble) _tmp21_, _tmp24_);
				max = (guint8) _tmp25_;
				_tmp26_ = r;
				_tmp27_ = g;
				_tmp28_ = b;
				_tmp29_ = MIN ((gdouble) _tmp27_, (gdouble) _tmp28_);
				_tmp30_ = MIN ((gdouble) _tmp26_, _tmp29_);
				min = (guint8) _tmp30_;
				_tmp31_ = max;
				_tmp32_ = min;
				delta = (gdouble) (_tmp31_ - _tmp32_);
				_tmp34_ = delta;
				if (_tmp34_ == ((gdouble) 0)) {
					_tmp33_ = 0.0;
				} else {
					gdouble _tmp35_;
					guint8 _tmp36_;
					_tmp35_ = delta;
					_tmp36_ = max;
					_tmp33_ = _tmp35_ / _tmp36_;
				}
				sat = _tmp33_;
				_tmp37_ = sat;
				score = 0.2 + (0.8 * _tmp37_);
				_tmp38_ = rTotal;
				_tmp39_ = r;
				_tmp40_ = score;
				rTotal = _tmp38_ + (_tmp39_ * _tmp40_);
				_tmp41_ = gTotal;
				_tmp42_ = g;
				_tmp43_ = score;
				gTotal = _tmp41_ + (_tmp42_ * _tmp43_);
				_tmp44_ = bTotal;
				_tmp45_ = b;
				_tmp46_ = score;
				bTotal = _tmp44_ + (_tmp45_ * _tmp46_);
				_tmp47_ = dataPtr;
				_tmp48_ = source;
				_tmp49_ = gdk_pixbuf_get_n_channels (_tmp48_);
				_tmp50_ = _tmp49_;
				dataPtr = _tmp47_ + _tmp50_;
			}
		}
	}
	_tmp51_ = rTotal;
	_tmp52_ = pixels;
	_tmp53_ = gTotal;
	_tmp54_ = pixels;
	_tmp55_ = bTotal;
	_tmp56_ = pixels;
	_tmp57_ = granite_drawing_color_new ((_tmp51_ / G_MAXUINT8) / _tmp52_, (_tmp53_ / G_MAXUINT8) / _tmp54_, (_tmp55_ / G_MAXUINT8) / _tmp56_, (gdouble) 1);
	_tmp58_ = _tmp57_;
	_tmp59_ = granite_drawing_color_set_val (_tmp58_, 0.8);
	_tmp60_ = _tmp59_;
	_tmp61_ = granite_drawing_color_multiply_sat (_tmp60_, 1.15);
	_tmp62_ = _tmp61_;
	_g_object_unref0 (_tmp60_);
	_g_object_unref0 (_tmp58_);
	result = _tmp62_;
	return result;
}


GraniteDrawingUtilities* granite_drawing_utilities_construct (GType object_type) {
	GraniteDrawingUtilities * self = NULL;
	self = (GraniteDrawingUtilities*) g_object_new (object_type, NULL);
	return self;
}


GraniteDrawingUtilities* granite_drawing_utilities_new (void) {
	return granite_drawing_utilities_construct (GRANITE_DRAWING_TYPE_UTILITIES);
}


static void granite_drawing_utilities_class_init (GraniteDrawingUtilitiesClass * klass) {
	granite_drawing_utilities_parent_class = g_type_class_peek_parent (klass);
}


static void granite_drawing_utilities_instance_init (GraniteDrawingUtilities * self) {
}


/**
     * A utility class for frequently-performed drawing operations.
     */
GType granite_drawing_utilities_get_type (void) {
	static volatile gsize granite_drawing_utilities_type_id__volatile = 0;
	if (g_once_init_enter (&granite_drawing_utilities_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteDrawingUtilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_drawing_utilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteDrawingUtilities), 0, (GInstanceInitFunc) granite_drawing_utilities_instance_init, NULL };
		GType granite_drawing_utilities_type_id;
		granite_drawing_utilities_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteDrawingUtilities", &g_define_type_info, 0);
		g_once_init_leave (&granite_drawing_utilities_type_id__volatile, granite_drawing_utilities_type_id);
	}
	return granite_drawing_utilities_type_id__volatile;
}



