/* Logger.c generated by valac 0.36.4, the Vala compiler
 * generated from Logger.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer
 *                2015-2017 elementary LLC, Rico Tzschichholz
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define GRANITE_SERVICES_TYPE_LOG_LEVEL (granite_services_log_level_get_type ())

#define GRANITE_SERVICES_TYPE_CONSOLE_COLOR (granite_services_console_color_get_type ())

#define GRANITE_SERVICES_TYPE_LOGGER (granite_services_logger_get_type ())
#define GRANITE_SERVICES_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLogger))
#define GRANITE_SERVICES_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLoggerClass))
#define GRANITE_SERVICES_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_LOGGER))
#define GRANITE_SERVICES_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_SERVICES_TYPE_LOGGER))
#define GRANITE_SERVICES_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLoggerClass))

typedef struct _GraniteServicesLogger GraniteServicesLogger;
typedef struct _GraniteServicesLoggerClass GraniteServicesLoggerClass;
typedef struct _GraniteServicesLoggerPrivate GraniteServicesLoggerPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GRANITE_SERVICES_LOG_LEVEL_DEBUG,
	GRANITE_SERVICES_LOG_LEVEL_INFO,
	GRANITE_SERVICES_LOG_LEVEL_NOTIFY,
	GRANITE_SERVICES_LOG_LEVEL_WARN,
	GRANITE_SERVICES_LOG_LEVEL_ERROR,
	GRANITE_SERVICES_LOG_LEVEL_FATAL
} GraniteServicesLogLevel;

typedef enum  {
	GRANITE_SERVICES_CONSOLE_COLOR_BLACK,
	GRANITE_SERVICES_CONSOLE_COLOR_RED,
	GRANITE_SERVICES_CONSOLE_COLOR_GREEN,
	GRANITE_SERVICES_CONSOLE_COLOR_YELLOW,
	GRANITE_SERVICES_CONSOLE_COLOR_BLUE,
	GRANITE_SERVICES_CONSOLE_COLOR_MAGENTA,
	GRANITE_SERVICES_CONSOLE_COLOR_CYAN,
	GRANITE_SERVICES_CONSOLE_COLOR_WHITE
} GraniteServicesConsoleColor;

struct _GraniteServicesLogger {
	GObject parent_instance;
	GraniteServicesLoggerPrivate * priv;
};

struct _GraniteServicesLoggerClass {
	GObjectClass parent_class;
};


static gpointer granite_services_logger_parent_class = NULL;
static GraniteServicesLogLevel granite_services_logger__DisplayLevel;
static GraniteServicesLogLevel granite_services_logger__DisplayLevel = GRANITE_SERVICES_LOG_LEVEL_WARN;
static GMutex granite_services_logger_write_mutex;
static GMutex granite_services_logger_write_mutex = {0};

GType granite_services_log_level_get_type (void) G_GNUC_CONST;
GType granite_services_console_color_get_type (void) G_GNUC_CONST;
GType granite_services_logger_get_type (void) G_GNUC_CONST;
enum  {
	GRANITE_SERVICES_LOGGER_DUMMY_PROPERTY
};
void granite_services_logger_initialize (const gchar* app_name);
static void granite_services_logger_glib_log_func (const gchar* d, GLogLevelFlags flags, const gchar* msg);
void granite_services_logger_notification (const gchar* msg);
static void granite_services_logger_write (GraniteServicesLogLevel level, gchar* msg);
static gchar* granite_services_logger_get_time (void);
GraniteServicesLogLevel granite_services_logger_get_DisplayLevel (void);
static void granite_services_logger_set_color_for_level (GraniteServicesLogLevel level);
static void granite_services_logger_reset_color (void);
static void granite_services_logger_set_foreground (GraniteServicesConsoleColor color);
static void granite_services_logger_set_background (GraniteServicesConsoleColor color);
static void granite_services_logger_set_color (GraniteServicesConsoleColor color, gboolean isForeground);
GraniteServicesLogger* granite_services_logger_new (void);
GraniteServicesLogger* granite_services_logger_construct (GType object_type);
void granite_services_logger_set_DisplayLevel (GraniteServicesLogLevel value);
static void granite_services_logger_finalize (GObject * obj);
static void _vala_granite_services_logger_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_services_logger_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static const gchar* GRANITE_SERVICES_LOGGER_LOG_LEVEL_TO_STRING[6] = {"DEBUG", "INFO", "NOTIFY", "WARNING", "ERROR", "FATAL"};

/**
     * LogLevel:
     */
GType granite_services_log_level_get_type (void) {
	static volatile gsize granite_services_log_level_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_log_level_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_SERVICES_LOG_LEVEL_DEBUG, "GRANITE_SERVICES_LOG_LEVEL_DEBUG", "debug"}, {GRANITE_SERVICES_LOG_LEVEL_INFO, "GRANITE_SERVICES_LOG_LEVEL_INFO", "info"}, {GRANITE_SERVICES_LOG_LEVEL_NOTIFY, "GRANITE_SERVICES_LOG_LEVEL_NOTIFY", "notify"}, {GRANITE_SERVICES_LOG_LEVEL_WARN, "GRANITE_SERVICES_LOG_LEVEL_WARN", "warn"}, {GRANITE_SERVICES_LOG_LEVEL_ERROR, "GRANITE_SERVICES_LOG_LEVEL_ERROR", "error"}, {GRANITE_SERVICES_LOG_LEVEL_FATAL, "GRANITE_SERVICES_LOG_LEVEL_FATAL", "fatal"}, {0, NULL, NULL}};
		GType granite_services_log_level_type_id;
		granite_services_log_level_type_id = g_enum_register_static ("GraniteServicesLogLevel", values);
		g_once_init_leave (&granite_services_log_level_type_id__volatile, granite_services_log_level_type_id);
	}
	return granite_services_log_level_type_id__volatile;
}


GType granite_services_console_color_get_type (void) {
	static volatile gsize granite_services_console_color_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_console_color_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_SERVICES_CONSOLE_COLOR_BLACK, "GRANITE_SERVICES_CONSOLE_COLOR_BLACK", "black"}, {GRANITE_SERVICES_CONSOLE_COLOR_RED, "GRANITE_SERVICES_CONSOLE_COLOR_RED", "red"}, {GRANITE_SERVICES_CONSOLE_COLOR_GREEN, "GRANITE_SERVICES_CONSOLE_COLOR_GREEN", "green"}, {GRANITE_SERVICES_CONSOLE_COLOR_YELLOW, "GRANITE_SERVICES_CONSOLE_COLOR_YELLOW", "yellow"}, {GRANITE_SERVICES_CONSOLE_COLOR_BLUE, "GRANITE_SERVICES_CONSOLE_COLOR_BLUE", "blue"}, {GRANITE_SERVICES_CONSOLE_COLOR_MAGENTA, "GRANITE_SERVICES_CONSOLE_COLOR_MAGENTA", "magenta"}, {GRANITE_SERVICES_CONSOLE_COLOR_CYAN, "GRANITE_SERVICES_CONSOLE_COLOR_CYAN", "cyan"}, {GRANITE_SERVICES_CONSOLE_COLOR_WHITE, "GRANITE_SERVICES_CONSOLE_COLOR_WHITE", "white"}, {0, NULL, NULL}};
		GType granite_services_console_color_type_id;
		granite_services_console_color_type_id = g_enum_register_static ("GraniteServicesConsoleColor", values);
		g_once_init_leave (&granite_services_console_color_type_id__volatile, granite_services_console_color_type_id);
	}
	return granite_services_console_color_type_id__volatile;
}


/**
         * This method initializes the Logger
         *
         * @param app_name name of app that is logging
         */
void granite_services_logger_initialize (const gchar* app_name) {
	g_return_if_fail (app_name != NULL);
	g_log_set_default_handler ((GLogFunc) granite_services_logger_glib_log_func, NULL);
}


/**
         * Logs message using Notify level formatting
         *
         * @param msg message to be logged
         */
void granite_services_logger_notification (const gchar* msg) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (msg != NULL);
	_tmp0_ = msg;
	_tmp1_ = g_strdup (_tmp0_);
	granite_services_logger_write (GRANITE_SERVICES_LOG_LEVEL_NOTIFY, _tmp1_);
}


static gchar* granite_services_logger_get_time (void) {
	gchar* result = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = g_date_time_get_hour (now);
	_tmp2_ = g_date_time_get_minute (now);
	_tmp3_ = g_date_time_get_second (now);
	_tmp4_ = g_date_time_get_microsecond (now);
	_tmp5_ = g_strdup_printf ("%.2d:%.2d:%.2d.%.6d", _tmp1_, _tmp2_, _tmp3_, _tmp4_);
	result = _tmp5_;
	_g_date_time_unref0 (now);
	return result;
}


static void granite_services_logger_write (GraniteServicesLogLevel level, gchar* msg) {
	GraniteServicesLogLevel _tmp0_;
	GraniteServicesLogLevel _tmp1_;
	GraniteServicesLogLevel _tmp2_;
	GraniteServicesLogLevel _tmp3_;
	FILE* _tmp4_;
	GraniteServicesLogLevel _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	FILE* _tmp9_;
	const gchar* _tmp10_;
	g_return_if_fail (msg != NULL);
	_tmp0_ = level;
	_tmp1_ = granite_services_logger_get_DisplayLevel ();
	_tmp2_ = _tmp1_;
	if (_tmp0_ < _tmp2_) {
		_g_free0 (msg);
		return;
	}
	g_mutex_lock (&granite_services_logger_write_mutex);
	_tmp3_ = level;
	granite_services_logger_set_color_for_level (_tmp3_);
	_tmp4_ = stdout;
	_tmp5_ = level;
	_tmp6_ = GRANITE_SERVICES_LOGGER_LOG_LEVEL_TO_STRING[_tmp5_];
	_tmp7_ = granite_services_logger_get_time ();
	_tmp8_ = _tmp7_;
	fprintf (_tmp4_, "[%s %s]", _tmp6_, _tmp8_);
	_g_free0 (_tmp8_);
	granite_services_logger_reset_color ();
	_tmp9_ = stdout;
	_tmp10_ = msg;
	fprintf (_tmp9_, " %s\n", _tmp10_);
	g_mutex_unlock (&granite_services_logger_write_mutex);
	_g_free0 (msg);
}


static void granite_services_logger_set_color_for_level (GraniteServicesLogLevel level) {
	GraniteServicesLogLevel _tmp0_;
	_tmp0_ = level;
	switch (_tmp0_) {
		case GRANITE_SERVICES_LOG_LEVEL_DEBUG:
		{
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_GREEN);
			break;
		}
		case GRANITE_SERVICES_LOG_LEVEL_INFO:
		{
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_BLUE);
			break;
		}
		case GRANITE_SERVICES_LOG_LEVEL_NOTIFY:
		{
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_MAGENTA);
			break;
		}
		case GRANITE_SERVICES_LOG_LEVEL_WARN:
		{
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_YELLOW);
			break;
		}
		case GRANITE_SERVICES_LOG_LEVEL_ERROR:
		{
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_RED);
			break;
		}
		case GRANITE_SERVICES_LOG_LEVEL_FATAL:
		{
			granite_services_logger_set_background (GRANITE_SERVICES_CONSOLE_COLOR_RED);
			granite_services_logger_set_foreground (GRANITE_SERVICES_CONSOLE_COLOR_WHITE);
			break;
		}
		default:
		break;
	}
}


static void granite_services_logger_reset_color (void) {
	FILE* _tmp0_;
	_tmp0_ = stdout;
	fprintf (_tmp0_, "\x001b[0m");
}


static void granite_services_logger_set_foreground (GraniteServicesConsoleColor color) {
	GraniteServicesConsoleColor _tmp0_;
	_tmp0_ = color;
	granite_services_logger_set_color (_tmp0_, TRUE);
}


static void granite_services_logger_set_background (GraniteServicesConsoleColor color) {
	GraniteServicesConsoleColor _tmp0_;
	_tmp0_ = color;
	granite_services_logger_set_color (_tmp0_, FALSE);
}


static void granite_services_logger_set_color (GraniteServicesConsoleColor color, gboolean isForeground) {
	GraniteServicesConsoleColor color_code = 0;
	GraniteServicesConsoleColor _tmp0_;
	gboolean _tmp1_;
	FILE* _tmp3_;
	GraniteServicesConsoleColor _tmp4_;
	_tmp0_ = color;
	color_code = (_tmp0_ + 30) + 60;
	_tmp1_ = isForeground;
	if (!_tmp1_) {
		GraniteServicesConsoleColor _tmp2_;
		_tmp2_ = color_code;
		color_code = _tmp2_ + 10;
	}
	_tmp3_ = stdout;
	_tmp4_ = color_code;
	fprintf (_tmp3_, "\x001b[%dm", (gint) _tmp4_);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void granite_services_logger_glib_log_func (const gchar* d, GLogLevelFlags flags, const gchar* msg) {
	gchar* domain = NULL;
	const gchar* _tmp0_;
	gchar* message = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp6_;
	GraniteServicesLogLevel level = 0;
	GLogLevelFlags _tmp19_;
	GLogLevelFlags _tmp20_;
	GraniteServicesLogLevel _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	g_return_if_fail (msg != NULL);
	_tmp0_ = d;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = d;
		_tmp2_ = g_strdup_printf ("[%s] ", _tmp1_);
		_g_free0 (domain);
		domain = _tmp2_;
	} else {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		_g_free0 (domain);
		domain = _tmp3_;
	}
	_tmp5_ = msg;
	_tmp6_ = string_contains (_tmp5_, "\n");
	if (_tmp6_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = msg;
		_tmp8_ = string_contains (_tmp7_, "\r");
		_tmp4_ = _tmp8_;
	}
	if (_tmp4_) {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp9_ = domain;
		_tmp10_ = msg;
		_tmp11_ = string_replace (_tmp10_, "\n", "");
		_tmp12_ = _tmp11_;
		_tmp13_ = string_replace (_tmp12_, "\r", "");
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup_printf ("%s%s", _tmp9_, _tmp14_);
		_g_free0 (message);
		message = _tmp15_;
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
	} else {
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = domain;
		_tmp17_ = msg;
		_tmp18_ = g_strdup_printf ("%s%s", _tmp16_, _tmp17_);
		_g_free0 (message);
		message = _tmp18_;
	}
	_tmp19_ = flags;
	flags = _tmp19_ & G_LOG_LEVEL_MASK;
	_tmp20_ = flags;
	switch (_tmp20_) {
		case G_LOG_LEVEL_CRITICAL:
		{
			level = GRANITE_SERVICES_LOG_LEVEL_FATAL;
			break;
		}
		case G_LOG_LEVEL_ERROR:
		{
			level = GRANITE_SERVICES_LOG_LEVEL_ERROR;
			break;
		}
		case G_LOG_LEVEL_INFO:
		case G_LOG_LEVEL_MESSAGE:
		{
			level = GRANITE_SERVICES_LOG_LEVEL_INFO;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			level = GRANITE_SERVICES_LOG_LEVEL_DEBUG;
			break;
		}
		default:
		case G_LOG_LEVEL_WARNING:
		{
			level = GRANITE_SERVICES_LOG_LEVEL_WARN;
			break;
		}
	}
	_tmp21_ = level;
	_tmp22_ = message;
	_tmp23_ = g_strdup (_tmp22_);
	granite_services_logger_write (_tmp21_, _tmp23_);
	_g_free0 (message);
	_g_free0 (domain);
}


GraniteServicesLogger* granite_services_logger_construct (GType object_type) {
	GraniteServicesLogger * self = NULL;
	self = (GraniteServicesLogger*) g_object_new (object_type, NULL);
	return self;
}


GraniteServicesLogger* granite_services_logger_new (void) {
	return granite_services_logger_construct (GRANITE_SERVICES_TYPE_LOGGER);
}


GraniteServicesLogLevel granite_services_logger_get_DisplayLevel (void) {
	GraniteServicesLogLevel result;
	GraniteServicesLogLevel _tmp0_;
	_tmp0_ = granite_services_logger__DisplayLevel;
	result = _tmp0_;
	return result;
}


void granite_services_logger_set_DisplayLevel (GraniteServicesLogLevel value) {
	GraniteServicesLogLevel _tmp0_;
	_tmp0_ = value;
	granite_services_logger__DisplayLevel = _tmp0_;
}


static void granite_services_logger_class_init (GraniteServicesLoggerClass * klass) {
	granite_services_logger_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_services_logger_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_services_logger_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_services_logger_finalize;
}


static void granite_services_logger_instance_init (GraniteServicesLogger * self) {
}


static void granite_services_logger_finalize (GObject * obj) {
	GraniteServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLogger);
	G_OBJECT_CLASS (granite_services_logger_parent_class)->finalize (obj);
}


/**
     * This class helps in the use of logs in a Granite application.
     *
     */
GType granite_services_logger_get_type (void) {
	static volatile gsize granite_services_logger_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_logger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesLogger), 0, (GInstanceInitFunc) granite_services_logger_instance_init, NULL };
		GType granite_services_logger_type_id;
		granite_services_logger_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesLogger", &g_define_type_info, 0);
		g_once_init_leave (&granite_services_logger_type_id__volatile, granite_services_logger_type_id);
	}
	return granite_services_logger_type_id__volatile;
}


static void _vala_granite_services_logger_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLogger);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_services_logger_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_LOGGER, GraniteServicesLogger);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



