/* Settings.c generated by valac 0.36.4, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer,
 *                          Rico Tzschichholz <ricotz@ubuntu.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE (granite_services_settings_serializable_get_type ())
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializable))
#define GRANITE_SERVICES_IS_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE))
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializableIface))

typedef struct _GraniteServicesSettingsSerializable GraniteServicesSettingsSerializable;
typedef struct _GraniteServicesSettingsSerializableIface GraniteServicesSettingsSerializableIface;

#define GRANITE_SERVICES_TYPE_SETTINGS (granite_services_settings_get_type ())
#define GRANITE_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings))
#define GRANITE_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettingsClass))
#define GRANITE_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SETTINGS))
#define GRANITE_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_SERVICES_TYPE_SETTINGS))
#define GRANITE_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettingsClass))

typedef struct _GraniteServicesSettings GraniteServicesSettings;
typedef struct _GraniteServicesSettingsClass GraniteServicesSettingsClass;
typedef struct _GraniteServicesSettingsPrivate GraniteServicesSettingsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL,
	GRANITE_SERVICES_SETTINGS_LAST_SIGNAL
};
static guint granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_LAST_SIGNAL] = {0};

struct _GraniteServicesSettingsSerializableIface {
	GTypeInterface parent_iface;
	gchar* (*settings_serialize) (GraniteServicesSettingsSerializable* self);
	void (*settings_deserialize) (GraniteServicesSettingsSerializable* self, const gchar* s);
};

struct _GraniteServicesSettings {
	GObject parent_instance;
	GraniteServicesSettingsPrivate * priv;
};

struct _GraniteServicesSettingsClass {
	GObjectClass parent_class;
	void (*verify) (GraniteServicesSettings* self, const gchar* key);
};

struct _GraniteServicesSettingsPrivate {
	gboolean saving_key;
	GSettings* _schema;
};


static gpointer granite_services_settings_parent_class = NULL;

GType granite_services_settings_serializable_get_type (void) G_GNUC_CONST;
gchar* granite_services_settings_serializable_settings_serialize (GraniteServicesSettingsSerializable* self);
void granite_services_settings_serializable_settings_deserialize (GraniteServicesSettingsSerializable* self, const gchar* s);
GType granite_services_settings_get_type (void) G_GNUC_CONST;
#define GRANITE_SERVICES_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettingsPrivate))
enum  {
	GRANITE_SERVICES_SETTINGS_DUMMY_PROPERTY,
	GRANITE_SERVICES_SETTINGS_SCHEMA
};
static void granite_services_settings_stop_monitor (GraniteServicesSettings* self);
GraniteServicesSettings* granite_services_settings_construct (GType object_type, const gchar* schema);
GraniteServicesSettings* granite_services_settings_construct_with_backend (GType object_type, const gchar* schema, GSettingsBackend* backend);
GraniteServicesSettings* granite_services_settings_construct_with_backend_and_path (GType object_type, const gchar* schema, GSettingsBackend* backend, const gchar* path);
GraniteServicesSettings* granite_services_settings_construct_with_path (GType object_type, const gchar* schema, const gchar* path);
GSettings* granite_services_settings_get_schema (GraniteServicesSettings* self);
static void granite_services_settings_load_key (GraniteServicesSettings* self, const gchar* key);
static void _granite_services_settings_load_key_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void granite_services_settings_start_monitor (GraniteServicesSettings* self);
static void granite_services_settings_handle_notify (GraniteServicesSettings* self, GObject* sender, GParamSpec* property);
static void _granite_services_settings_handle_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void granite_services_settings_call_verify (GraniteServicesSettings* self, const gchar* key);
static void granite_services_settings_save_key (GraniteServicesSettings* self, const gchar* key);
static void granite_services_settings_handle_verify_notify (GraniteServicesSettings* self, GObject* sender, GParamSpec* property);
static void _granite_services_settings_handle_verify_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void granite_services_settings_verify (GraniteServicesSettings* self, const gchar* key);
static void granite_services_settings_real_verify (GraniteServicesSettings* self, const gchar* key);
static void granite_services_settings_set_schema (GraniteServicesSettings* self, GSettings* value);
static GObject * granite_services_settings_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void granite_services_settings_finalize (GObject * obj);
static void _vala_granite_services_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_services_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Serializes the object into a string representation.
         *
         * @return the string representation of the object
         */
gchar* granite_services_settings_serializable_settings_serialize (GraniteServicesSettingsSerializable* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE (self)->settings_serialize (self);
}


/**
         * Un-serializes the object from a string representation.
         *
         * @param s the string representation of the object
         */
void granite_services_settings_serializable_settings_deserialize (GraniteServicesSettingsSerializable* self, const gchar* s) {
	g_return_if_fail (self != NULL);
	GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE (self)->settings_deserialize (self, s);
}


static void granite_services_settings_serializable_base_init (GraniteServicesSettingsSerializableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
     * This interface is used by objects that need to be serialized in a Settings.
     * The object must have a string representation and provide these methods to
     * translate between the string and object representations.
     */
GType granite_services_settings_serializable_get_type (void) {
	static volatile gsize granite_services_settings_serializable_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_settings_serializable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSettingsSerializableIface), (GBaseInitFunc) granite_services_settings_serializable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_services_settings_serializable_type_id;
		granite_services_settings_serializable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteServicesSettingsSerializable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_services_settings_serializable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&granite_services_settings_serializable_type_id__volatile, granite_services_settings_serializable_type_id);
	}
	return granite_services_settings_serializable_type_id__volatile;
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema.
         *
         * @param schema the name of the schema to interact with
         */
GraniteServicesSettings* granite_services_settings_construct (GType object_type, const gchar* schema) {
	GraniteServicesSettings * self = NULL;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	g_return_val_if_fail (schema != NULL, NULL);
	_tmp0_ = schema;
	_tmp1_ = g_settings_new (_tmp0_);
	_tmp2_ = _tmp1_;
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp2_, NULL);
	_g_object_unref0 (_tmp2_);
	return self;
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema and {@link GLib.SettingsBackend}.
         *
         * @param schema the name of the schema to interact with
         * @param backend the desired backend to use
         */
GraniteServicesSettings* granite_services_settings_construct_with_backend (GType object_type, const gchar* schema, GSettingsBackend* backend) {
	GraniteServicesSettings * self = NULL;
	const gchar* _tmp0_;
	GSettingsBackend* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	g_return_val_if_fail (schema != NULL, NULL);
	g_return_val_if_fail (backend != NULL, NULL);
	_tmp0_ = schema;
	_tmp1_ = backend;
	_tmp2_ = g_settings_new_with_backend (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp3_, NULL);
	_g_object_unref0 (_tmp3_);
	return self;
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema, {@link GLib.SettingsBackend}, and path.
         * 
         *
         * @param schema the name of the schema to interact with
         * @param backend the desired backend to use
         * @param path the path to use
         */
GraniteServicesSettings* granite_services_settings_construct_with_backend_and_path (GType object_type, const gchar* schema, GSettingsBackend* backend, const gchar* path) {
	GraniteServicesSettings * self = NULL;
	const gchar* _tmp0_;
	GSettingsBackend* _tmp1_;
	const gchar* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	g_return_val_if_fail (schema != NULL, NULL);
	g_return_val_if_fail (backend != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = schema;
	_tmp1_ = backend;
	_tmp2_ = path;
	_tmp3_ = g_settings_new_with_backend_and_path (_tmp0_, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp4_, NULL);
	_g_object_unref0 (_tmp4_);
	return self;
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema, and path.
         * 
         * You only need to do this if you want to directly create a settings object with a schema that
         * doesn't have a specified path of its own. That's quite rare.
         *
         * It is a programmer error to call this function for a schema that has an explicitly specified path.
         *
         * @param schema the name of the schema to interact with
         * @param path the path to use
         */
GraniteServicesSettings* granite_services_settings_construct_with_path (GType object_type, const gchar* schema, const gchar* path) {
	GraniteServicesSettings * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	g_return_val_if_fail (schema != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = schema;
	_tmp1_ = path;
	_tmp2_ = g_settings_new_with_path (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp3_, NULL);
	_g_object_unref0 (_tmp3_);
	return self;
}


static void _granite_services_settings_load_key_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	granite_services_settings_load_key ((GraniteServicesSettings*) self, key);
}


static void granite_services_settings_stop_monitor (GraniteServicesSettings* self) {
	GSettings* _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_schema;
	g_signal_parse_name ("changed", g_settings_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_services_settings_load_key_g_settings_changed, self);
}


static void granite_services_settings_start_monitor (GraniteServicesSettings* self) {
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_schema;
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _granite_services_settings_load_key_g_settings_changed, self, 0);
}


static void _granite_services_settings_handle_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	granite_services_settings_handle_notify ((GraniteServicesSettings*) self, _sender, pspec);
}


static void granite_services_settings_handle_notify (GraniteServicesSettings* self, GObject* sender, GParamSpec* property) {
	guint _tmp0_;
	GParamSpec* _tmp1_;
	const gchar* _tmp2_;
	GParamSpec* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
	_tmp1_ = property;
	_tmp2_ = _tmp1_->name;
	granite_services_settings_call_verify (self, _tmp2_);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
	_tmp3_ = property;
	_tmp4_ = _tmp3_->name;
	granite_services_settings_save_key (self, _tmp4_);
}


static void granite_services_settings_handle_verify_notify (GraniteServicesSettings* self, GObject* sender, GParamSpec* property) {
	GParamSpec* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = property;
	_tmp1_ = _tmp0_->name;
	_tmp2_ = self->priv->_schema;
	g_object_get (_tmp2_, "schema-id", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	g_warning ("Settings.vala:198: Key '%s' failed verification in schema '%s', changi" \
"ng value", _tmp1_, _tmp5_);
	_g_free0 (_tmp5_);
}


static void _granite_services_settings_handle_verify_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	granite_services_settings_handle_verify_notify ((GraniteServicesSettings*) self, _sender, pspec);
}


static void granite_services_settings_call_verify (GraniteServicesSettings* self, const gchar* key) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	guint _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_verify_notify_g_object_notify, self, 0);
	_tmp0_ = key;
	granite_services_settings_verify (self, _tmp0_);
	_tmp1_ = key;
	g_signal_emit (self, granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL], g_quark_from_string (_tmp1_));
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _granite_services_settings_handle_verify_notify_g_object_notify, self);
}


/**
         * Verify the given key, changing the property if necessary. Refer to the example given for the class.
         *
         * @param key the key in question
         */
static void granite_services_settings_real_verify (GraniteServicesSettings* self, const gchar* key) {
	g_return_if_fail (key != NULL);
}


void granite_services_settings_verify (GraniteServicesSettings* self, const gchar* key) {
	g_return_if_fail (self != NULL);
	GRANITE_SERVICES_SETTINGS_GET_CLASS (self)->verify (self, key);
}


static gpointer _g_param_spec_ref0 (gpointer self) {
	return self ? g_param_spec_ref (self) : NULL;
}


static void granite_services_settings_load_key (GraniteServicesSettings* self, const gchar* key) {
	const gchar* _tmp0_;
	GObjectClass* obj_class = NULL;
	GType _tmp1_;
	GTypeClass* _tmp2_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp3_;
	const gchar* _tmp4_;
	GParamSpec* _tmp5_;
	GParamSpec* _tmp6_;
	GParamSpec* _tmp7_;
	guint _tmp8_;
	GType type = 0UL;
	GParamSpec* _tmp9_;
	GType _tmp10_;
	GValue val = {0};
	GType _tmp11_;
	GValue _tmp12_ = {0};
	GParamSpec* _tmp13_;
	const gchar* _tmp14_;
	GType _tmp15_;
	GParamSpec* _tmp16_;
	GType _tmp17_;
	const gchar* _tmp102_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	if (g_strcmp0 (_tmp0_, "schema") == 0) {
		return;
	}
	_tmp1_ = G_TYPE_FROM_INSTANCE ((GObject*) self);
	_tmp2_ = g_type_class_ref (_tmp1_);
	obj_class = (GObjectClass*) _tmp2_;
	_tmp3_ = obj_class;
	_tmp4_ = key;
	_tmp5_ = g_object_class_find_property (_tmp3_, _tmp4_);
	_tmp6_ = _g_param_spec_ref0 (_tmp5_);
	prop = _tmp6_;
	_tmp7_ = prop;
	if (_tmp7_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp8_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
	_tmp9_ = prop;
	_tmp10_ = _tmp9_->value_type;
	type = _tmp10_;
	_tmp11_ = type;
	g_value_init (&_tmp12_, _tmp11_);
	val = _tmp12_;
	_tmp13_ = prop;
	_tmp14_ = _tmp13_->name;
	g_object_get_property ((GObject*) self, _tmp14_, &val);
	_tmp15_ = G_VALUE_TYPE (&val);
	_tmp16_ = prop;
	_tmp17_ = _tmp16_->value_type;
	if (_tmp15_ == _tmp17_) {
		GType _tmp18_;
		_tmp18_ = type;
		if (_tmp18_ == G_TYPE_INT) {
			GParamSpec* _tmp19_;
			const gchar* _tmp20_;
			GSettings* _tmp21_;
			const gchar* _tmp22_;
			gint _tmp23_;
			GValue _tmp24_ = {0};
			_tmp19_ = prop;
			_tmp20_ = _tmp19_->name;
			_tmp21_ = self->priv->_schema;
			_tmp22_ = key;
			_tmp23_ = g_settings_get_int (_tmp21_, _tmp22_);
			g_value_init (&_tmp24_, G_TYPE_INT);
			g_value_set_int (&_tmp24_, _tmp23_);
			g_object_set_property ((GObject*) self, _tmp20_, &_tmp24_);
			G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
		} else {
			GType _tmp25_;
			_tmp25_ = type;
			if (_tmp25_ == G_TYPE_UINT) {
				GParamSpec* _tmp26_;
				const gchar* _tmp27_;
				GSettings* _tmp28_;
				const gchar* _tmp29_;
				guint _tmp30_;
				GValue _tmp31_ = {0};
				_tmp26_ = prop;
				_tmp27_ = _tmp26_->name;
				_tmp28_ = self->priv->_schema;
				_tmp29_ = key;
				_tmp30_ = g_settings_get_uint (_tmp28_, _tmp29_);
				g_value_init (&_tmp31_, G_TYPE_UINT);
				g_value_set_uint (&_tmp31_, _tmp30_);
				g_object_set_property ((GObject*) self, _tmp27_, &_tmp31_);
				G_IS_VALUE (&_tmp31_) ? (g_value_unset (&_tmp31_), NULL) : NULL;
			} else {
				GType _tmp32_;
				_tmp32_ = type;
				if (_tmp32_ == G_TYPE_DOUBLE) {
					GParamSpec* _tmp33_;
					const gchar* _tmp34_;
					GSettings* _tmp35_;
					const gchar* _tmp36_;
					gdouble _tmp37_;
					GValue _tmp38_ = {0};
					_tmp33_ = prop;
					_tmp34_ = _tmp33_->name;
					_tmp35_ = self->priv->_schema;
					_tmp36_ = key;
					_tmp37_ = g_settings_get_double (_tmp35_, _tmp36_);
					g_value_init (&_tmp38_, G_TYPE_DOUBLE);
					g_value_set_double (&_tmp38_, _tmp37_);
					g_object_set_property ((GObject*) self, _tmp34_, &_tmp38_);
					G_IS_VALUE (&_tmp38_) ? (g_value_unset (&_tmp38_), NULL) : NULL;
				} else {
					GType _tmp39_;
					_tmp39_ = type;
					if (_tmp39_ == G_TYPE_STRING) {
						GParamSpec* _tmp40_;
						const gchar* _tmp41_;
						GSettings* _tmp42_;
						const gchar* _tmp43_;
						gchar* _tmp44_;
						GValue _tmp45_ = {0};
						_tmp40_ = prop;
						_tmp41_ = _tmp40_->name;
						_tmp42_ = self->priv->_schema;
						_tmp43_ = key;
						_tmp44_ = g_settings_get_string (_tmp42_, _tmp43_);
						g_value_init (&_tmp45_, G_TYPE_STRING);
						g_value_take_string (&_tmp45_, _tmp44_);
						g_object_set_property ((GObject*) self, _tmp41_, &_tmp45_);
						G_IS_VALUE (&_tmp45_) ? (g_value_unset (&_tmp45_), NULL) : NULL;
					} else {
						GType _tmp46_;
						_tmp46_ = type;
						if (_tmp46_ == G_TYPE_STRV) {
							GParamSpec* _tmp47_;
							const gchar* _tmp48_;
							GSettings* _tmp49_;
							const gchar* _tmp50_;
							gchar** _tmp51_;
							gchar** _tmp52_;
							GValue _tmp53_ = {0};
							_tmp47_ = prop;
							_tmp48_ = _tmp47_->name;
							_tmp49_ = self->priv->_schema;
							_tmp50_ = key;
							_tmp52_ = _tmp51_ = g_settings_get_strv (_tmp49_, _tmp50_);
							g_value_init (&_tmp53_, G_TYPE_STRV);
							g_value_take_boxed (&_tmp53_, _tmp52_);
							g_object_set_property ((GObject*) self, _tmp48_, &_tmp53_);
							G_IS_VALUE (&_tmp53_) ? (g_value_unset (&_tmp53_), NULL) : NULL;
						} else {
							GType _tmp54_;
							_tmp54_ = type;
							if (_tmp54_ == G_TYPE_BOOLEAN) {
								GParamSpec* _tmp55_;
								const gchar* _tmp56_;
								GSettings* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								GValue _tmp60_ = {0};
								_tmp55_ = prop;
								_tmp56_ = _tmp55_->name;
								_tmp57_ = self->priv->_schema;
								_tmp58_ = key;
								_tmp59_ = g_settings_get_boolean (_tmp57_, _tmp58_);
								g_value_init (&_tmp60_, G_TYPE_BOOLEAN);
								g_value_set_boolean (&_tmp60_, _tmp59_);
								g_object_set_property ((GObject*) self, _tmp56_, &_tmp60_);
								G_IS_VALUE (&_tmp60_) ? (g_value_unset (&_tmp60_), NULL) : NULL;
							} else {
								GType _tmp61_;
								_tmp61_ = type;
								if (_tmp61_ == G_TYPE_INT64) {
									GParamSpec* _tmp62_;
									const gchar* _tmp63_;
									GSettings* _tmp64_;
									const gchar* _tmp65_;
									GVariant* _tmp66_;
									GVariant* _tmp67_;
									gint64 _tmp68_;
									GValue _tmp69_ = {0};
									_tmp62_ = prop;
									_tmp63_ = _tmp62_->name;
									_tmp64_ = self->priv->_schema;
									_tmp65_ = key;
									_tmp66_ = g_settings_get_value (_tmp64_, _tmp65_);
									_tmp67_ = _tmp66_;
									_tmp68_ = g_variant_get_int64 (_tmp67_);
									g_value_init (&_tmp69_, G_TYPE_INT64);
									g_value_set_int64 (&_tmp69_, _tmp68_);
									g_object_set_property ((GObject*) self, _tmp63_, &_tmp69_);
									G_IS_VALUE (&_tmp69_) ? (g_value_unset (&_tmp69_), NULL) : NULL;
									_g_variant_unref0 (_tmp67_);
								} else {
									GType _tmp70_;
									_tmp70_ = type;
									if (_tmp70_ == G_TYPE_UINT64) {
										GParamSpec* _tmp71_;
										const gchar* _tmp72_;
										GSettings* _tmp73_;
										const gchar* _tmp74_;
										GVariant* _tmp75_;
										GVariant* _tmp76_;
										guint64 _tmp77_;
										GValue _tmp78_ = {0};
										_tmp71_ = prop;
										_tmp72_ = _tmp71_->name;
										_tmp73_ = self->priv->_schema;
										_tmp74_ = key;
										_tmp75_ = g_settings_get_value (_tmp73_, _tmp74_);
										_tmp76_ = _tmp75_;
										_tmp77_ = g_variant_get_uint64 (_tmp76_);
										g_value_init (&_tmp78_, G_TYPE_UINT64);
										g_value_set_uint64 (&_tmp78_, _tmp77_);
										g_object_set_property ((GObject*) self, _tmp72_, &_tmp78_);
										G_IS_VALUE (&_tmp78_) ? (g_value_unset (&_tmp78_), NULL) : NULL;
										_g_variant_unref0 (_tmp76_);
									} else {
										GType _tmp79_;
										gboolean _tmp80_;
										_tmp79_ = type;
										_tmp80_ = G_TYPE_IS_ENUM (_tmp79_);
										if (_tmp80_) {
											GParamSpec* _tmp81_;
											const gchar* _tmp82_;
											GSettings* _tmp83_;
											const gchar* _tmp84_;
											gint _tmp85_;
											GValue _tmp86_ = {0};
											_tmp81_ = prop;
											_tmp82_ = _tmp81_->name;
											_tmp83_ = self->priv->_schema;
											_tmp84_ = key;
											_tmp85_ = g_settings_get_enum (_tmp83_, _tmp84_);
											g_value_init (&_tmp86_, G_TYPE_INT);
											g_value_set_int (&_tmp86_, _tmp85_);
											g_object_set_property ((GObject*) self, _tmp82_, &_tmp86_);
											G_IS_VALUE (&_tmp86_) ? (g_value_unset (&_tmp86_), NULL) : NULL;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		GType _tmp87_;
		gboolean _tmp88_;
		_tmp87_ = type;
		_tmp88_ = g_type_is_a (_tmp87_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE);
		if (_tmp88_) {
			const gchar* _tmp89_;
			GObject* _tmp90_;
			GSettings* _tmp91_;
			const gchar* _tmp92_;
			gchar* _tmp93_;
			gchar* _tmp94_;
			_tmp89_ = key;
			g_object_get_property ((GObject*) self, _tmp89_, &val);
			_tmp90_ = g_value_get_object (&val);
			_tmp91_ = self->priv->_schema;
			_tmp92_ = key;
			_tmp93_ = g_settings_get_string (_tmp91_, _tmp92_);
			_tmp94_ = _tmp93_;
			granite_services_settings_serializable_settings_deserialize (G_TYPE_CHECK_INSTANCE_TYPE (_tmp90_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE) ? ((GraniteServicesSettingsSerializable*) _tmp90_) : NULL, _tmp94_);
			_g_free0 (_tmp94_);
			g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
			_g_param_spec_unref0 (prop);
			_g_type_class_unref0 (obj_class);
			return;
		} else {
			GType _tmp95_;
			const gchar* _tmp96_;
			const gchar* _tmp97_;
			GSettings* _tmp98_;
			gchar* _tmp99_;
			gchar* _tmp100_;
			gchar* _tmp101_;
			_tmp95_ = type;
			_tmp96_ = g_type_name (_tmp95_);
			_tmp97_ = key;
			_tmp98_ = self->priv->_schema;
			g_object_get (_tmp98_, "schema-id", &_tmp99_, NULL);
			_tmp100_ = _tmp99_;
			_tmp101_ = _tmp100_;
			g_debug ("Settings.vala:264: Unsupported settings type '%s' for key '%s' in sche" \
"ma '%s'", _tmp96_, _tmp97_, _tmp101_);
			_g_free0 (_tmp101_);
			g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
			_g_param_spec_unref0 (prop);
			_g_type_class_unref0 (obj_class);
			return;
		}
	}
	_tmp102_ = key;
	granite_services_settings_call_verify (self, _tmp102_);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}


static void granite_services_settings_save_key (GraniteServicesSettings* self, const gchar* key) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GObjectClass* obj_class = NULL;
	GType _tmp3_;
	GTypeClass* _tmp4_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp5_;
	const gchar* _tmp6_;
	GParamSpec* _tmp7_;
	GParamSpec* _tmp8_;
	GParamSpec* _tmp9_;
	gboolean success = FALSE;
	guint _tmp10_;
	GType type = 0UL;
	GParamSpec* _tmp11_;
	GType _tmp12_;
	GValue val = {0};
	GType _tmp13_;
	GValue _tmp14_ = {0};
	GParamSpec* _tmp15_;
	const gchar* _tmp16_;
	GType _tmp17_;
	GParamSpec* _tmp18_;
	GType _tmp19_;
	gboolean _tmp133_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp1_ = key;
	if (g_strcmp0 (_tmp1_, "schema") == 0) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->saving_key;
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = G_TYPE_FROM_INSTANCE ((GObject*) self);
	_tmp4_ = g_type_class_ref (_tmp3_);
	obj_class = (GObjectClass*) _tmp4_;
	_tmp5_ = obj_class;
	_tmp6_ = key;
	_tmp7_ = g_object_class_find_property (_tmp5_, _tmp6_);
	_tmp8_ = _g_param_spec_ref0 (_tmp7_);
	prop = _tmp8_;
	_tmp9_ = prop;
	if (_tmp9_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	success = TRUE;
	self->priv->saving_key = TRUE;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp10_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
	_tmp11_ = prop;
	_tmp12_ = _tmp11_->value_type;
	type = _tmp12_;
	_tmp13_ = type;
	g_value_init (&_tmp14_, _tmp13_);
	val = _tmp14_;
	_tmp15_ = prop;
	_tmp16_ = _tmp15_->name;
	g_object_get_property ((GObject*) self, _tmp16_, &val);
	_tmp17_ = G_VALUE_TYPE (&val);
	_tmp18_ = prop;
	_tmp19_ = _tmp18_->value_type;
	if (_tmp17_ == _tmp19_) {
		GType _tmp20_;
		_tmp20_ = type;
		if (_tmp20_ == G_TYPE_INT) {
			gint _tmp21_;
			GSettings* _tmp22_;
			const gchar* _tmp23_;
			gint _tmp24_;
			_tmp21_ = g_value_get_int (&val);
			_tmp22_ = self->priv->_schema;
			_tmp23_ = key;
			_tmp24_ = g_settings_get_int (_tmp22_, _tmp23_);
			if (_tmp21_ != _tmp24_) {
				GSettings* _tmp25_;
				const gchar* _tmp26_;
				gint _tmp27_;
				gboolean _tmp28_;
				_tmp25_ = self->priv->_schema;
				_tmp26_ = key;
				_tmp27_ = g_value_get_int (&val);
				_tmp28_ = g_settings_set_int (_tmp25_, _tmp26_, _tmp27_);
				success = _tmp28_;
			}
		} else {
			GType _tmp29_;
			_tmp29_ = type;
			if (_tmp29_ == G_TYPE_UINT) {
				guint _tmp30_;
				GSettings* _tmp31_;
				const gchar* _tmp32_;
				guint _tmp33_;
				_tmp30_ = g_value_get_uint (&val);
				_tmp31_ = self->priv->_schema;
				_tmp32_ = key;
				_tmp33_ = g_settings_get_uint (_tmp31_, _tmp32_);
				if (_tmp30_ != _tmp33_) {
					GSettings* _tmp34_;
					const gchar* _tmp35_;
					guint _tmp36_;
					gboolean _tmp37_;
					_tmp34_ = self->priv->_schema;
					_tmp35_ = key;
					_tmp36_ = g_value_get_uint (&val);
					_tmp37_ = g_settings_set_uint (_tmp34_, _tmp35_, _tmp36_);
					success = _tmp37_;
				}
			} else {
				GType _tmp38_;
				_tmp38_ = type;
				if (_tmp38_ == G_TYPE_INT64) {
					gint64 _tmp39_;
					GSettings* _tmp40_;
					const gchar* _tmp41_;
					GVariant* _tmp42_;
					GVariant* _tmp43_;
					gint64 _tmp44_;
					gboolean _tmp45_;
					_tmp39_ = g_value_get_int64 (&val);
					_tmp40_ = self->priv->_schema;
					_tmp41_ = key;
					_tmp42_ = g_settings_get_value (_tmp40_, _tmp41_);
					_tmp43_ = _tmp42_;
					_tmp44_ = g_variant_get_int64 (_tmp43_);
					_tmp45_ = _tmp39_ != _tmp44_;
					_g_variant_unref0 (_tmp43_);
					if (_tmp45_) {
						GSettings* _tmp46_;
						const gchar* _tmp47_;
						gint64 _tmp48_;
						GVariant* _tmp49_;
						GVariant* _tmp50_;
						gboolean _tmp51_;
						_tmp46_ = self->priv->_schema;
						_tmp47_ = key;
						_tmp48_ = g_value_get_int64 (&val);
						_tmp49_ = g_variant_new_int64 (_tmp48_);
						g_variant_ref_sink (_tmp49_);
						_tmp50_ = _tmp49_;
						_tmp51_ = g_settings_set_value (_tmp46_, _tmp47_, _tmp50_);
						success = _tmp51_;
						_g_variant_unref0 (_tmp50_);
					}
				} else {
					GType _tmp52_;
					_tmp52_ = type;
					if (_tmp52_ == G_TYPE_UINT64) {
						guint64 _tmp53_;
						GSettings* _tmp54_;
						const gchar* _tmp55_;
						GVariant* _tmp56_;
						GVariant* _tmp57_;
						guint64 _tmp58_;
						gboolean _tmp59_;
						_tmp53_ = g_value_get_uint64 (&val);
						_tmp54_ = self->priv->_schema;
						_tmp55_ = key;
						_tmp56_ = g_settings_get_value (_tmp54_, _tmp55_);
						_tmp57_ = _tmp56_;
						_tmp58_ = g_variant_get_uint64 (_tmp57_);
						_tmp59_ = _tmp53_ != _tmp58_;
						_g_variant_unref0 (_tmp57_);
						if (_tmp59_) {
							GSettings* _tmp60_;
							const gchar* _tmp61_;
							guint64 _tmp62_;
							GVariant* _tmp63_;
							GVariant* _tmp64_;
							gboolean _tmp65_;
							_tmp60_ = self->priv->_schema;
							_tmp61_ = key;
							_tmp62_ = g_value_get_uint64 (&val);
							_tmp63_ = g_variant_new_uint64 (_tmp62_);
							g_variant_ref_sink (_tmp63_);
							_tmp64_ = _tmp63_;
							_tmp65_ = g_settings_set_value (_tmp60_, _tmp61_, _tmp64_);
							success = _tmp65_;
							_g_variant_unref0 (_tmp64_);
						}
					} else {
						GType _tmp66_;
						_tmp66_ = type;
						if (_tmp66_ == G_TYPE_DOUBLE) {
							gdouble _tmp67_;
							GSettings* _tmp68_;
							const gchar* _tmp69_;
							gdouble _tmp70_;
							_tmp67_ = g_value_get_double (&val);
							_tmp68_ = self->priv->_schema;
							_tmp69_ = key;
							_tmp70_ = g_settings_get_double (_tmp68_, _tmp69_);
							if (_tmp67_ != _tmp70_) {
								GSettings* _tmp71_;
								const gchar* _tmp72_;
								gdouble _tmp73_;
								gboolean _tmp74_;
								_tmp71_ = self->priv->_schema;
								_tmp72_ = key;
								_tmp73_ = g_value_get_double (&val);
								_tmp74_ = g_settings_set_double (_tmp71_, _tmp72_, _tmp73_);
								success = _tmp74_;
							}
						} else {
							GType _tmp75_;
							_tmp75_ = type;
							if (_tmp75_ == G_TYPE_STRING) {
								const gchar* _tmp76_;
								GSettings* _tmp77_;
								const gchar* _tmp78_;
								gchar* _tmp79_;
								gchar* _tmp80_;
								gboolean _tmp81_;
								_tmp76_ = g_value_get_string (&val);
								_tmp77_ = self->priv->_schema;
								_tmp78_ = key;
								_tmp79_ = g_settings_get_string (_tmp77_, _tmp78_);
								_tmp80_ = _tmp79_;
								_tmp81_ = g_strcmp0 (_tmp76_, _tmp80_) != 0;
								_g_free0 (_tmp80_);
								if (_tmp81_) {
									GSettings* _tmp82_;
									const gchar* _tmp83_;
									const gchar* _tmp84_;
									gboolean _tmp85_;
									_tmp82_ = self->priv->_schema;
									_tmp83_ = key;
									_tmp84_ = g_value_get_string (&val);
									_tmp85_ = g_settings_set_string (_tmp82_, _tmp83_, _tmp84_);
									success = _tmp85_;
								}
							} else {
								GType _tmp86_;
								_tmp86_ = type;
								if (_tmp86_ == G_TYPE_STRV) {
									gchar** strings = NULL;
									gint strings_length1;
									gint _strings_size_;
									const gchar* _tmp87_;
									gchar** _tmp88_;
									gint _tmp88__length1;
									GSettings* _tmp89_;
									const gchar* _tmp90_;
									gchar** _tmp91_;
									gchar** _tmp92_;
									gchar** _tmp93_;
									gint _tmp93__length1;
									gboolean _tmp94_;
									strings = NULL;
									strings_length1 = 0;
									_strings_size_ = strings_length1;
									_tmp87_ = key;
									g_object_get ((GObject*) self, _tmp87_, &strings, NULL);
									_tmp88_ = strings;
									_tmp88__length1 = strings_length1;
									_tmp89_ = self->priv->_schema;
									_tmp90_ = key;
									_tmp92_ = _tmp91_ = g_settings_get_strv (_tmp89_, _tmp90_);
									_tmp93_ = _tmp92_;
									_tmp93__length1 = _vala_array_length (_tmp91_);
									_tmp94_ = _tmp88_ != _tmp93_;
									_tmp93_ = (_vala_array_free (_tmp93_, _tmp93__length1, (GDestroyNotify) g_free), NULL);
									if (_tmp94_) {
										GSettings* _tmp95_;
										const gchar* _tmp96_;
										gchar** _tmp97_;
										gint _tmp97__length1;
										gboolean _tmp98_;
										_tmp95_ = self->priv->_schema;
										_tmp96_ = key;
										_tmp97_ = strings;
										_tmp97__length1 = strings_length1;
										_tmp98_ = g_settings_set_strv (_tmp95_, _tmp96_, _tmp97_);
										success = _tmp98_;
									}
									strings = (_vala_array_free (strings, strings_length1, (GDestroyNotify) g_free), NULL);
								} else {
									GType _tmp99_;
									_tmp99_ = type;
									if (_tmp99_ == G_TYPE_BOOLEAN) {
										gboolean _tmp100_;
										GSettings* _tmp101_;
										const gchar* _tmp102_;
										gboolean _tmp103_;
										_tmp100_ = g_value_get_boolean (&val);
										_tmp101_ = self->priv->_schema;
										_tmp102_ = key;
										_tmp103_ = g_settings_get_boolean (_tmp101_, _tmp102_);
										if (_tmp100_ != _tmp103_) {
											GSettings* _tmp104_;
											const gchar* _tmp105_;
											gboolean _tmp106_;
											gboolean _tmp107_;
											_tmp104_ = self->priv->_schema;
											_tmp105_ = key;
											_tmp106_ = g_value_get_boolean (&val);
											_tmp107_ = g_settings_set_boolean (_tmp104_, _tmp105_, _tmp106_);
											success = _tmp107_;
										}
									} else {
										GType _tmp108_;
										gboolean _tmp109_;
										_tmp108_ = type;
										_tmp109_ = G_TYPE_IS_ENUM (_tmp108_);
										if (_tmp109_) {
											gint _tmp110_;
											GSettings* _tmp111_;
											const gchar* _tmp112_;
											gint _tmp113_;
											_tmp110_ = g_value_get_enum (&val);
											_tmp111_ = self->priv->_schema;
											_tmp112_ = key;
											_tmp113_ = g_settings_get_enum (_tmp111_, _tmp112_);
											if (_tmp110_ != _tmp113_) {
												GSettings* _tmp114_;
												const gchar* _tmp115_;
												gint _tmp116_;
												gboolean _tmp117_;
												_tmp114_ = self->priv->_schema;
												_tmp115_ = key;
												_tmp116_ = g_value_get_enum (&val);
												_tmp117_ = g_settings_set_enum (_tmp114_, _tmp115_, _tmp116_);
												success = _tmp117_;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		GType _tmp118_;
		gboolean _tmp119_;
		_tmp118_ = type;
		_tmp119_ = g_type_is_a (_tmp118_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE);
		if (_tmp119_) {
			GSettings* _tmp120_;
			const gchar* _tmp121_;
			GObject* _tmp122_;
			gchar* _tmp123_;
			gchar* _tmp124_;
			gboolean _tmp125_;
			_tmp120_ = self->priv->_schema;
			_tmp121_ = key;
			_tmp122_ = g_value_get_object (&val);
			_tmp123_ = granite_services_settings_serializable_settings_serialize (G_TYPE_CHECK_INSTANCE_TYPE (_tmp122_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE) ? ((GraniteServicesSettingsSerializable*) _tmp122_) : NULL);
			_tmp124_ = _tmp123_;
			_tmp125_ = g_settings_set_string (_tmp120_, _tmp121_, _tmp124_);
			success = _tmp125_;
			_g_free0 (_tmp124_);
		} else {
			GType _tmp126_;
			const gchar* _tmp127_;
			const gchar* _tmp128_;
			GSettings* _tmp129_;
			gchar* _tmp130_;
			gchar* _tmp131_;
			gchar* _tmp132_;
			_tmp126_ = type;
			_tmp127_ = g_type_name (_tmp126_);
			_tmp128_ = key;
			_tmp129_ = self->priv->_schema;
			g_object_get (_tmp129_, "schema-id", &_tmp130_, NULL);
			_tmp131_ = _tmp130_;
			_tmp132_ = _tmp131_;
			g_debug ("Settings.vala:338: Unsupported settings type '%s' for key '%s' in sche" \
"ma '%s'", _tmp127_, _tmp128_, _tmp132_);
			_g_free0 (_tmp132_);
		}
	}
	_tmp133_ = success;
	if (!_tmp133_) {
		const gchar* _tmp134_;
		_tmp134_ = key;
		g_warning ("Settings.vala:341: Key '%s' could not be written to.", _tmp134_);
	}
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
	self->priv->saving_key = FALSE;
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}


GSettings* granite_services_settings_get_schema (GraniteServicesSettings* self) {
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_schema;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void granite_services_settings_set_schema (GraniteServicesSettings* self, GSettings* value) {
	g_return_if_fail (self != NULL);
	if (granite_services_settings_get_schema (self) != value) {
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_schema);
		self->priv->_schema = _tmp1_;
		g_object_notify ((GObject *) self, "schema");
	}
}


static GObject * granite_services_settings_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GraniteServicesSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GType _tmp4_;
	GTypeClass* _tmp5_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp6_;
	guint _tmp7_;
	GParamSpec** _tmp8_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp9_;
	gint _tmp9__length1;
	parent_class = G_OBJECT_CLASS (granite_services_settings_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
	_tmp0_ = self->priv->_schema;
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	g_debug ("Settings.vala:163: Loading settings from schema '%s'", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = G_TYPE_FROM_INSTANCE ((GObject*) self);
	_tmp5_ = g_type_class_ref (_tmp4_);
	obj_class = (GObjectClass*) _tmp5_;
	_tmp6_ = obj_class;
	_tmp8_ = g_object_class_list_properties (_tmp6_, &_tmp7_);
	properties = _tmp8_;
	properties_length1 = _tmp7_;
	_properties_size_ = properties_length1;
	_tmp9_ = properties;
	_tmp9__length1 = properties_length1;
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
		prop_collection = _tmp9_;
		prop_collection_length1 = _tmp9__length1;
		for (prop_it = 0; prop_it < _tmp9__length1; prop_it = prop_it + 1) {
			GParamSpec* prop = NULL;
			prop = prop_collection[prop_it];
			{
				GParamSpec* _tmp10_;
				const gchar* _tmp11_;
				_tmp10_ = prop;
				_tmp11_ = _tmp10_->name;
				granite_services_settings_load_key (self, _tmp11_);
			}
		}
	}
	granite_services_settings_start_monitor (self);
	properties = (g_free (properties), NULL);
	_g_type_class_unref0 (obj_class);
	return obj;
}


static void granite_services_settings_class_init (GraniteServicesSettingsClass * klass) {
	granite_services_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteServicesSettingsPrivate));
	((GraniteServicesSettingsClass *) klass)->verify = (void (*) (GraniteServicesSettings *, const gchar*)) granite_services_settings_real_verify;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_services_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_services_settings_set_property;
	G_OBJECT_CLASS (klass)->constructor = granite_services_settings_constructor;
	G_OBJECT_CLASS (klass)->finalize = granite_services_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_SERVICES_SETTINGS_SCHEMA, g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * This signal is to be used in place of the standard {@link GLib.Object.notify} signal.
	         *
	         * This signal ''only'' emits after a property's value was verified.
	         *
	         * Note that in the case where a property was set to an invalid value,
	         * (and thus, sanitized to a valid value), the {@link GLib.Object.notify} signal will emit 
	         * twice: once with the invalid value and once with the sanitized value.
	         */
	granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL] = g_signal_new ("changed", GRANITE_SERVICES_TYPE_SETTINGS, G_SIGNAL_RUN_FIRST | G_SIGNAL_DETAILED | G_SIGNAL_NO_RECURSE | G_SIGNAL_ACTION | G_SIGNAL_NO_HOOKS, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_services_settings_instance_init (GraniteServicesSettings * self) {
	self->priv = GRANITE_SERVICES_SETTINGS_GET_PRIVATE (self);
}


static void granite_services_settings_finalize (GObject * obj) {
	GraniteServicesSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
	granite_services_settings_stop_monitor (self);
	_g_object_unref0 (self->priv->_schema);
	G_OBJECT_CLASS (granite_services_settings_parent_class)->finalize (obj);
}


/**
     * Class for interacting with an internal {@link GLib.Settings} using native Vala properties.
     * Clients of this class should not connect to the {@link GLib.Object.notify} signal.
     * Instead, they should connect to the {@link Granite.Services.Settings.changed} signal.
     *
     * For example, if a developer wanted to interact with desktop.Wallpaper's (http:/www.launchpad.net/pantheon-wallpaper) schema,
     * this is what his/her subclass might look like:
     *
     * {{{
     *    public class WallpaperSettings : Granite.Services.Settings {
     *    
     *        public PictureMode picture_mode { get; set; }
     *    
     *        public string picture_path { get; set; }
     *    
     *        public string background_color { get; set; }
     *    
     *        public WallpaperSettings () {
     *            base ("desktop.Wallpaper");
     *        }
     *    
     *        protected override void verify (string key) {
     *    
     *            switch (key) {
     *    
     *                case "background-color":
     *                    Gdk.Color bg;
     *                    if (!Gdk.Color.parse (background_color, out bg))
     *                        background_color = "#000000";
     *                    break;
     *            }
     *        }
     *    
     *    }
     * }}}
     *
     * Keep in mind that the developer must define his/her enums to match the schema's.
     * 
     * The following is a simplified explanation of how this library works:
*
     *  1. Any subclass looks at all properties it contains, and loads their initial values from the keys they represent.
     *     Because Vala properties are stored as GLib properties, the string representation of a property replaces underscores with
     *     hyphens (i.e. property_name becomes "property-name"). This is how this library knows which keys to load from. If the key
     *     does not exist, it will result in a fatal error.
     *  1. When a property of the subclass changes, the library will first verify the data before emitting a changed signal. If necessary,
     *     the library will change the value of the property while verifying.
     *     This is why developers should only act upon emissions of the changed () signal and never the native {@link GLib.Object.notify} signal.
     *  1. When the corresponding key of one of the properties of the subclass changes, it will also verify the data and change it, if necessary,
     *     before loading it into as the corresponding property's value.
     */
GType granite_services_settings_get_type (void) {
	static volatile gsize granite_services_settings_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesSettings), 0, (GInstanceInitFunc) granite_services_settings_instance_init, NULL };
		GType granite_services_settings_type_id;
		granite_services_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&granite_services_settings_type_id__volatile, granite_services_settings_type_id);
	}
	return granite_services_settings_type_id__volatile;
}


static void _vala_granite_services_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteServicesSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
	switch (property_id) {
		case GRANITE_SERVICES_SETTINGS_SCHEMA:
		g_value_set_object (value, granite_services_settings_get_schema (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_services_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteServicesSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
	switch (property_id) {
		case GRANITE_SERVICES_SETTINGS_SCHEMA:
		granite_services_settings_set_schema (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



