/* System.c generated by valac 0.36.4, the Vala compiler
 * generated from System.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>


#define GRANITE_SERVICES_TYPE_SYSTEM (granite_services_system_get_type ())
#define GRANITE_SERVICES_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SYSTEM, GraniteServicesSystem))
#define GRANITE_SERVICES_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_SERVICES_TYPE_SYSTEM, GraniteServicesSystemClass))
#define GRANITE_SERVICES_IS_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SYSTEM))
#define GRANITE_SERVICES_IS_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_SERVICES_TYPE_SYSTEM))
#define GRANITE_SERVICES_SYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_SERVICES_TYPE_SYSTEM, GraniteServicesSystemClass))

typedef struct _GraniteServicesSystem GraniteServicesSystem;
typedef struct _GraniteServicesSystemClass GraniteServicesSystemClass;
typedef struct _GraniteServicesSystemPrivate GraniteServicesSystemPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))

struct _GraniteServicesSystem {
	GObject parent_instance;
	GraniteServicesSystemPrivate * priv;
};

struct _GraniteServicesSystemClass {
	GObjectClass parent_class;
};


static gpointer granite_services_system_parent_class = NULL;

GType granite_services_system_get_type (void) G_GNUC_CONST;
enum  {
	GRANITE_SERVICES_SYSTEM_DUMMY_PROPERTY
};
void granite_services_system_open_uri (const gchar* uri);
void granite_services_system_open (GFile* file);
void granite_services_system_launch_with_files (GFile* app, GFile** files, int files_length1);
void granite_services_system_open_files (GFile** files, int files_length1);
void granite_services_system_launch (GFile* app);
gboolean granite_services_system_execute_command (const gchar* command);
static gboolean granite_services_system_path_is_mounted (const gchar* path);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static void granite_services_system_internal_launch (GFile* app, GList* files);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
GraniteServicesSystem* granite_services_system_new (void);
GraniteServicesSystem* granite_services_system_construct (GType object_type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
         * Opens the specified URI with the default application.  This can be used for opening websites
         * with the default browser, etc.
         *
         * @param uri the URI to open
         */
void granite_services_system_open_uri (const gchar* uri) {
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	g_return_if_fail (uri != NULL);
	_tmp0_ = uri;
	_tmp1_ = g_file_new_for_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	granite_services_system_open (_tmp2_);
	_g_object_unref0 (_tmp2_);
}


/**
         * Opens the specified file with the default application.
         *
         * @param file the {@link GLib.File} to open
         */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void granite_services_system_open (GFile* file) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile** _tmp2_;
	GFile** _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_tmp2_ = g_new0 (GFile*, 1 + 1);
	_tmp2_[0] = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 1;
	granite_services_system_launch_with_files (NULL, _tmp3_, 1);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_object_unref), NULL);
}


/**
         * Opens the specified files with the default application.
         *
         * @param files an array of {@link GLib.File} to open
         */
void granite_services_system_open_files (GFile** files, int files_length1) {
	GFile** _tmp0_;
	gint _tmp0__length1;
	_tmp0_ = files;
	_tmp0__length1 = files_length1;
	granite_services_system_launch_with_files (NULL, _tmp0_, _tmp0__length1);
}


/**
         * Launches the specified application.
         *
         * @param app the {@link GLib.File} representing the application to launch
         */
void granite_services_system_launch (GFile* app) {
	GFile* _tmp0_;
	GFile** _tmp1_;
	GFile** _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = g_new0 (GFile*, 0 + 1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = 0;
	granite_services_system_launch_with_files (_tmp0_, _tmp2_, 0);
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_object_unref), NULL);
}


/**
         * Executes the specified command.
         *
         * @param command the command to execute
         */
gboolean granite_services_system_execute_command (const gchar* command) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (command != NULL, FALSE);
	{
		GAppInfo* info = NULL;
		const gchar* _tmp0_;
		GAppInfo* _tmp1_;
		gboolean _tmp2_ = FALSE;
		GAppInfo* _tmp3_;
		gboolean _tmp4_;
		_tmp0_ = command;
		_tmp1_ = g_app_info_create_from_commandline (_tmp0_, "", 0, &_inner_error_);
		info = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch7_g_error;
		}
		_tmp3_ = info;
		_tmp4_ = g_app_info_launch (_tmp3_, NULL, NULL, &_inner_error_);
		_tmp2_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (info);
			goto __catch7_g_error;
		}
		if (_tmp2_) {
			result = TRUE;
			_g_object_unref0 (info);
			return result;
		}
		_g_object_unref0 (info);
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = command;
		g_warning ("System.vala:77: Failed to execute external '%s' command", _tmp5_);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp6_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp6_;
	}
	result = TRUE;
	return result;
}


/**
         * Launches the supplied files with the specified application.
         *
         * @param app the {@link GLib.File} representing the application to launch
         * @param files an array of {@link GLib.File} to open
         */
static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


void granite_services_system_launch_with_files (GFile* app, GFile** files, int files_length1) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GList* mounted_files = NULL;
	GFile** _tmp7_;
	gint _tmp7__length1;
	gboolean _tmp33_ = FALSE;
	GList* _tmp34_;
	guint _tmp35_;
	GError * _inner_error_ = NULL;
	_tmp1_ = app;
	if (_tmp1_ != NULL) {
		GFile* _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = app;
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
		_tmp0_ = !_tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = app;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		g_warning ("System.vala:92: Application '%s' doesn't exist", _tmp6_);
		_g_free0 (_tmp6_);
		return;
	}
	mounted_files = NULL;
	_tmp7_ = files;
	_tmp7__length1 = files_length1;
	{
		GFile** f_collection = NULL;
		gint f_collection_length1 = 0;
		gint _f_collection_size_ = 0;
		gint f_it = 0;
		f_collection = _tmp7_;
		f_collection_length1 = _tmp7__length1;
		for (f_it = 0; f_it < _tmp7__length1; f_it = f_it + 1) {
			GFile* _tmp8_;
			GFile* f = NULL;
			_tmp8_ = _g_object_ref0 (f_collection[f_it]);
			f = _tmp8_;
			{
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				GFile* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
				_tmp11_ = f;
				_tmp12_ = g_file_get_path (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = _tmp13_ != NULL;
				_g_free0 (_tmp13_);
				if (_tmp14_) {
					GFile* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					_tmp15_ = f;
					_tmp16_ = g_file_get_path (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp10_ = g_strcmp0 (_tmp17_, "") != 0;
					_g_free0 (_tmp17_);
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					gboolean _tmp18_ = FALSE;
					GFile* _tmp19_;
					gboolean _tmp20_;
					_tmp19_ = f;
					_tmp20_ = g_file_is_native (_tmp19_);
					if (_tmp20_) {
						_tmp18_ = TRUE;
					} else {
						GFile* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gboolean _tmp24_;
						_tmp21_ = f;
						_tmp22_ = g_file_get_path (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = granite_services_system_path_is_mounted (_tmp23_);
						_tmp18_ = _tmp24_;
						_g_free0 (_tmp23_);
					}
					_tmp9_ = _tmp18_;
				} else {
					_tmp9_ = FALSE;
				}
				if (_tmp9_) {
					GFile* _tmp25_;
					GFile* _tmp26_;
					_tmp25_ = f;
					_tmp26_ = _g_object_ref0 (_tmp25_);
					mounted_files = g_list_append (mounted_files, _tmp26_);
					_g_object_unref0 (f);
					continue;
				}
				{
					GFile* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					_tmp27_ = f;
					_tmp28_ = g_file_get_uri (_tmp27_);
					_tmp29_ = _tmp28_;
					g_app_info_launch_default_for_uri (_tmp29_, NULL, &_inner_error_);
					_g_free0 (_tmp29_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch8_g_error;
					}
				}
				goto __finally8;
				__catch8_g_error:
				{
					GFile* _tmp30_;
					GFile* _tmp31_;
					GFile* _tmp32_;
					g_clear_error (&_inner_error_);
					_inner_error_ = NULL;
					_tmp30_ = f;
					g_file_mount_enclosing_volume (_tmp30_, 0, NULL, NULL, NULL, NULL);
					_tmp31_ = f;
					_tmp32_ = _g_object_ref0 (_tmp31_);
					mounted_files = g_list_append (mounted_files, _tmp32_);
				}
				__finally8:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (f);
					__g_list_free__g_object_unref0_0 (mounted_files);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_object_unref0 (f);
			}
		}
	}
	_tmp34_ = mounted_files;
	_tmp35_ = g_list_length (_tmp34_);
	if (_tmp35_ > ((guint) 0)) {
		_tmp33_ = TRUE;
	} else {
		GFile** _tmp36_;
		gint _tmp36__length1;
		_tmp36_ = files;
		_tmp36__length1 = files_length1;
		_tmp33_ = _tmp36__length1 == 0;
	}
	if (_tmp33_) {
		GFile* _tmp37_;
		GList* _tmp38_;
		_tmp37_ = app;
		_tmp38_ = mounted_files;
		granite_services_system_internal_launch (_tmp37_, _tmp38_);
	}
	__g_list_free__g_object_unref0_0 (mounted_files);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gboolean granite_services_system_path_is_mounted (const gchar* path) {
	gboolean result = FALSE;
	GVolumeMonitor* _tmp0_;
	GVolumeMonitor* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = g_volume_monitor_get ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_volume_monitor_get_mounts (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	{
		GList* m_collection = NULL;
		GList* m_it = NULL;
		m_collection = _tmp3_;
		for (m_it = m_collection; m_it != NULL; m_it = m_it->next) {
			GMount* _tmp4_;
			GMount* m = NULL;
			_tmp4_ = _g_object_ref0 ((GMount*) m_it->data);
			m = _tmp4_;
			{
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GMount* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				gboolean _tmp10_;
				_tmp7_ = m;
				_tmp8_ = g_mount_get_root (_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = _tmp9_ != NULL;
				_g_object_unref0 (_tmp9_);
				if (_tmp10_) {
					GMount* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					_tmp11_ = m;
					_tmp12_ = g_mount_get_root (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = g_file_get_path (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp6_ = _tmp15_ != NULL;
					_g_free0 (_tmp15_);
					_g_object_unref0 (_tmp13_);
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					const gchar* _tmp16_;
					GMount* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gboolean _tmp22_;
					_tmp16_ = path;
					_tmp17_ = m;
					_tmp18_ = g_mount_get_root (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = g_file_get_path (_tmp19_);
					_tmp21_ = _tmp20_;
					_tmp22_ = string_contains (_tmp16_, _tmp21_);
					_tmp5_ = _tmp22_;
					_g_free0 (_tmp21_);
					_g_object_unref0 (_tmp19_);
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					result = TRUE;
					_g_object_unref0 (m);
					__g_list_free__g_object_unref0_0 (m_collection);
					return result;
				}
				_g_object_unref0 (m);
			}
		}
		__g_list_free__g_object_unref0_0 (m_collection);
	}
	result = FALSE;
	return result;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static void granite_services_system_internal_launch (GFile* app, GList* files) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GAppInfo* info = NULL;
	GFile* _tmp4_;
	GError * _inner_error_ = NULL;
	_tmp1_ = app;
	if (_tmp1_ == NULL) {
		GList* _tmp2_;
		guint _tmp3_;
		_tmp2_ = files;
		_tmp3_ = g_list_length (_tmp2_);
		_tmp0_ = _tmp3_ == ((guint) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = app;
	if (_tmp4_ != NULL) {
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GDesktopAppInfo* _tmp8_;
		_tmp5_ = app;
		_tmp6_ = g_file_get_path (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_desktop_app_info_new_from_filename (_tmp7_);
		_g_object_unref0 (info);
		info = (GAppInfo*) _tmp8_;
		_g_free0 (_tmp7_);
	} else {
		{
			GAppInfo* _tmp9_ = NULL;
			GList* _tmp10_;
			GList* _tmp11_;
			gconstpointer _tmp12_;
			GAppInfo* _tmp13_;
			GAppInfo* _tmp14_;
			_tmp10_ = files;
			_tmp11_ = g_list_first (_tmp10_);
			_tmp12_ = _tmp11_->data;
			_tmp13_ = g_file_query_default_handler ((GFile*) _tmp12_, NULL, &_inner_error_);
			_tmp9_ = _tmp13_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch9_g_error;
			}
			_tmp14_ = _tmp9_;
			_tmp9_ = NULL;
			_g_object_unref0 (info);
			info = _tmp14_;
			_g_object_unref0 (_tmp9_);
		}
		goto __finally9;
		__catch9_g_error:
		{
			g_clear_error (&_inner_error_);
			_inner_error_ = NULL;
			_g_object_unref0 (info);
			return;
		}
		__finally9:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		GList* _tmp15_;
		guint _tmp16_;
		GAppInfo* _tmp18_;
		gboolean _tmp19_;
		GAppInfo* _tmp22_;
		gboolean _tmp23_;
		_tmp15_ = files;
		_tmp16_ = g_list_length (_tmp15_);
		if (_tmp16_ == ((guint) 0)) {
			GAppInfo* _tmp17_;
			_tmp17_ = info;
			g_app_info_launch (_tmp17_, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch10_g_error;
			}
			_g_object_unref0 (info);
			return;
		}
		_tmp18_ = info;
		_tmp19_ = g_app_info_supports_files (_tmp18_);
		if (_tmp19_) {
			GAppInfo* _tmp20_;
			GList* _tmp21_;
			_tmp20_ = info;
			_tmp21_ = files;
			g_app_info_launch (_tmp20_, _tmp21_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch10_g_error;
			}
			_g_object_unref0 (info);
			return;
		}
		_tmp22_ = info;
		_tmp23_ = g_app_info_supports_uris (_tmp22_);
		if (_tmp23_) {
			GList* uris = NULL;
			GList* _tmp24_;
			GAppInfo* _tmp28_;
			GList* _tmp29_;
			GAppLaunchContext* _tmp30_;
			GAppLaunchContext* _tmp31_;
			uris = NULL;
			_tmp24_ = files;
			{
				GList* f_collection = NULL;
				GList* f_it = NULL;
				f_collection = _tmp24_;
				for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
					GFile* _tmp25_;
					GFile* f = NULL;
					_tmp25_ = _g_object_ref0 ((GFile*) f_it->data);
					f = _tmp25_;
					{
						GFile* _tmp26_;
						gchar* _tmp27_;
						_tmp26_ = f;
						_tmp27_ = g_file_get_uri (_tmp26_);
						uris = g_list_append (uris, _tmp27_);
						_g_object_unref0 (f);
					}
				}
			}
			_tmp28_ = info;
			_tmp29_ = uris;
			_tmp30_ = g_app_launch_context_new ();
			_tmp31_ = _tmp30_;
			g_app_info_launch_uris (_tmp28_, _tmp29_, _tmp31_, &_inner_error_);
			_g_object_unref0 (_tmp31_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				__g_list_free__g_free0_0 (uris);
				goto __catch10_g_error;
			}
			__g_list_free__g_free0_0 (uris);
			_g_object_unref0 (info);
			return;
		}
		g_error ("System.vala:160: Error opening files. The application doesn't support " \
"files/URIs or wasn't found.");
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GQuark _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp32_ = e->domain;
		_tmp33_ = g_quark_to_string (_tmp32_);
		_tmp34_ = g_strconcat ("Error: ", _tmp33_, NULL);
		_tmp35_ = _tmp34_;
		g_debug ("System.vala:162: %s", _tmp35_);
		_g_free0 (_tmp35_);
		_tmp36_ = e->message;
		g_error ("System.vala:163: %s", _tmp36_);
		_g_error_free0 (e);
	}
	__finally10:
	_g_object_unref0 (info);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return;
}


GraniteServicesSystem* granite_services_system_construct (GType object_type) {
	GraniteServicesSystem * self = NULL;
	self = (GraniteServicesSystem*) g_object_new (object_type, NULL);
	return self;
}


GraniteServicesSystem* granite_services_system_new (void) {
	return granite_services_system_construct (GRANITE_SERVICES_TYPE_SYSTEM);
}


static void granite_services_system_class_init (GraniteServicesSystemClass * klass) {
	granite_services_system_parent_class = g_type_class_peek_parent (klass);
}


static void granite_services_system_instance_init (GraniteServicesSystem * self) {
}


/**
     * Utility class for frequently-used system-related functions, such as opening files, launching
     * applications, or executing terminal commands.
     */
GType granite_services_system_get_type (void) {
	static volatile gsize granite_services_system_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_system_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSystemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_system_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesSystem), 0, (GInstanceInitFunc) granite_services_system_instance_init, NULL };
		GType granite_services_system_type_id;
		granite_services_system_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesSystem", &g_define_type_info, 0);
		g_once_init_leave (&granite_services_system_type_id__volatile, granite_services_system_type_id);
	}
	return granite_services_system_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



