/* Avatar.c generated by valac 0.36.4, the Vala compiler
 * generated from Avatar.vala, do not modify */

/*
 *  Copyright (C) 2015-2017 Granite Developers (https://launchpad.net/granite)
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 *
 *  Authored by: Felipe Escoto <felescoto95@hotmail.com>, Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define GRANITE_WIDGETS_TYPE_AVATAR (granite_widgets_avatar_get_type ())
#define GRANITE_WIDGETS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar))
#define GRANITE_WIDGETS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatarClass))
#define GRANITE_WIDGETS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_AVATAR))
#define GRANITE_WIDGETS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_AVATAR))
#define GRANITE_WIDGETS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatarClass))

typedef struct _GraniteWidgetsAvatar GraniteWidgetsAvatar;
typedef struct _GraniteWidgetsAvatarClass GraniteWidgetsAvatarClass;
typedef struct _GraniteWidgetsAvatarPrivate GraniteWidgetsAvatarPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GraniteWidgetsAvatar {
	GtkEventBox parent_instance;
	GraniteWidgetsAvatarPrivate * priv;
};

struct _GraniteWidgetsAvatarClass {
	GtkEventBoxClass parent_class;
};

struct _GraniteWidgetsAvatarPrivate {
	gboolean draw_theme_background;
	GdkPixbuf* _pixbuf;
};


static gpointer granite_widgets_avatar_parent_class = NULL;

GType granite_widgets_avatar_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_AVATAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatarPrivate))
enum  {
	GRANITE_WIDGETS_AVATAR_DUMMY_PROPERTY,
	GRANITE_WIDGETS_AVATAR_PIXBUF
};
static void granite_widgets_avatar_refresh_size_request (GraniteWidgetsAvatar* self);
static void _granite_widgets_avatar_refresh_size_request_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
#define GRANITE_WIDGETS_AVATAR_DEFAULT_ICON "avatar-default"
#define GRANITE_WIDGETS_AVATAR_DEFAULT_STYLE "avatar"
#define GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN 4
GraniteWidgetsAvatar* granite_widgets_avatar_new (void);
GraniteWidgetsAvatar* granite_widgets_avatar_construct (GType object_type);
GraniteWidgetsAvatar* granite_widgets_avatar_new_from_pixbuf (GdkPixbuf* pixbuf);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_pixbuf (GType object_type, GdkPixbuf* pixbuf);
GraniteWidgetsAvatar* granite_widgets_avatar_new_from_file (const gchar* filepath, gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_file (GType object_type, const gchar* filepath, gint pixel_size);
void granite_widgets_avatar_set_pixbuf (GraniteWidgetsAvatar* self, GdkPixbuf* value);
void granite_widgets_avatar_show_default (GraniteWidgetsAvatar* self, gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_new_with_default_icon (gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_with_default_icon (GType object_type, gint pixel_size);
GdkPixbuf* granite_widgets_avatar_get_pixbuf (GraniteWidgetsAvatar* self);
static gboolean granite_widgets_avatar_real_draw (GtkWidget* base, cairo_t* cr);
void granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
static GObject * granite_widgets_avatar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void granite_widgets_avatar_finalize (GObject * obj);
static void _vala_granite_widgets_avatar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_avatar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _granite_widgets_avatar_refresh_size_request_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	granite_widgets_avatar_refresh_size_request ((GraniteWidgetsAvatar*) self);
}


/**
     * Makes new Avatar widget
     *
     */
GraniteWidgetsAvatar* granite_widgets_avatar_construct (GType object_type) {
	GraniteWidgetsAvatar * self = NULL;
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
	return self;
}


GraniteWidgetsAvatar* granite_widgets_avatar_new (void) {
	return granite_widgets_avatar_construct (GRANITE_WIDGETS_TYPE_AVATAR);
}


/**
    * Creates a new Avatar from the speficied pixbuf
    *
    * @param pixbuf image to be used
    */
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_pixbuf (GType object_type, GdkPixbuf* pixbuf) {
	GraniteWidgetsAvatar * self = NULL;
	GdkPixbuf* _tmp0_;
	g_return_val_if_fail (pixbuf != NULL, NULL);
	_tmp0_ = pixbuf;
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, "pixbuf", _tmp0_, NULL);
	return self;
}


GraniteWidgetsAvatar* granite_widgets_avatar_new_from_pixbuf (GdkPixbuf* pixbuf) {
	return granite_widgets_avatar_construct_from_pixbuf (GRANITE_WIDGETS_TYPE_AVATAR, pixbuf);
}


/**
     * Creates a new Avatar from the speficied filepath and icon size
     *
     * @param filepath image to be used
     * @param pixel_size to scale the image
     */
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_file (GType object_type, const gchar* filepath, gint pixel_size) {
	GraniteWidgetsAvatar * self = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
	{
		gint size = 0;
		gint _tmp0_;
		GtkStyleContext* _tmp1_;
		gint _tmp2_;
		GdkPixbuf* _tmp3_ = NULL;
		const gchar* _tmp4_;
		GdkPixbuf* _tmp5_;
		_tmp0_ = pixel_size;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp2_ = gtk_style_context_get_scale (_tmp1_);
		size = _tmp0_ * _tmp2_;
		_tmp4_ = filepath;
		_tmp5_ = gdk_pixbuf_new_from_file_at_size (_tmp4_, size, size, &_inner_error_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
		granite_widgets_avatar_set_pixbuf (self, _tmp3_);
		_g_object_unref0 (_tmp3_);
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		gint _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = pixel_size;
		granite_widgets_avatar_show_default (self, _tmp6_);
		_g_error_free0 (e);
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


GraniteWidgetsAvatar* granite_widgets_avatar_new_from_file (const gchar* filepath, gint pixel_size) {
	return granite_widgets_avatar_construct_from_file (GRANITE_WIDGETS_TYPE_AVATAR, filepath, pixel_size);
}


/**
     * Creates a new Avatar with the default icon from theme without applying the css style
     *
     * @param pixel_size size of the icon to be loaded
     */
GraniteWidgetsAvatar* granite_widgets_avatar_construct_with_default_icon (GType object_type, gint pixel_size) {
	GraniteWidgetsAvatar * self = NULL;
	gint _tmp0_;
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
	_tmp0_ = pixel_size;
	granite_widgets_avatar_show_default (self, _tmp0_);
	return self;
}


GraniteWidgetsAvatar* granite_widgets_avatar_new_with_default_icon (gint pixel_size) {
	return granite_widgets_avatar_construct_with_default_icon (GRANITE_WIDGETS_TYPE_AVATAR, pixel_size);
}


static void granite_widgets_avatar_refresh_size_request (GraniteWidgetsAvatar* self) {
	GdkPixbuf* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pixbuf;
	if (_tmp0_ != NULL) {
		gint scale_factor = 0;
		GtkStyleContext* _tmp1_;
		gint _tmp2_;
		GdkPixbuf* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkPixbuf* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp2_ = gtk_style_context_get_scale (_tmp1_);
		scale_factor = _tmp2_;
		_tmp3_ = self->priv->_pixbuf;
		_tmp4_ = gdk_pixbuf_get_width (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = scale_factor;
		_tmp7_ = self->priv->_pixbuf;
		_tmp8_ = gdk_pixbuf_get_height (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = scale_factor;
		gtk_widget_set_size_request ((GtkWidget*) self, (_tmp5_ / _tmp6_) + (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2), (_tmp9_ / _tmp10_) + (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2));
		self->priv->draw_theme_background = TRUE;
	} else {
		gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
}


/**
     * Load the default avatar icon from theme into the widget without applying the css style
     *
     * @param pixel_size size of the icon to be loaded
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void granite_widgets_avatar_show_default (GraniteWidgetsAvatar* self, gint pixel_size) {
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_icon_theme_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	icon_theme = _tmp1_;
	{
		GdkPixbuf* _tmp2_ = NULL;
		gint _tmp3_;
		GtkStyleContext* _tmp4_;
		gint _tmp5_;
		GdkPixbuf* _tmp6_;
		_tmp3_ = pixel_size;
		_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp5_ = gtk_style_context_get_scale (_tmp4_);
		_tmp6_ = gtk_icon_theme_load_icon_for_scale (icon_theme, GRANITE_WIDGETS_AVATAR_DEFAULT_ICON, _tmp3_, _tmp5_, 0, &_inner_error_);
		_tmp2_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch18_g_error;
		}
		granite_widgets_avatar_set_pixbuf (self, _tmp2_);
		_g_object_unref0 (_tmp2_);
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		FILE* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = stderr;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		fprintf (_tmp7_, "Error setting default avatar icon: %s ", _tmp9_);
		_g_error_free0 (e);
	}
	__finally18:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (icon_theme);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->draw_theme_background = FALSE;
	_g_object_unref0 (icon_theme);
}


static gboolean granite_widgets_avatar_real_draw (GtkWidget* base, cairo_t* cr) {
	GraniteWidgetsAvatar * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp3_;
	gint width = 0;
	gint _tmp4_;
	gint height = 0;
	gint _tmp5_;
	gint scale_factor = 0;
	GtkStyleContext* _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
	self = (GraniteWidgetsAvatar*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = self->priv->_pixbuf;
	if (_tmp0_ == NULL) {
		cairo_t* _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = cr;
		_tmp2_ = GTK_WIDGET_CLASS (granite_widgets_avatar_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox), _tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	style_context = _tmp3_;
	_tmp4_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp4_ - (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2);
	_tmp5_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp5_ - (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2);
	_tmp6_ = style_context;
	_tmp7_ = gtk_style_context_get_scale (_tmp6_);
	scale_factor = _tmp7_;
	_tmp8_ = self->priv->draw_theme_background;
	if (_tmp8_) {
		gint border_radius = 0;
		GtkStyleContext* _tmp9_;
		GtkStyleContext* _tmp10_;
		GtkStateFlags _tmp11_;
		GValue _tmp12_ = {0};
		GValue _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint crop_radius = 0;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		cairo_t* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		cairo_t* _tmp24_;
		cairo_t* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		cairo_t* _tmp28_;
		GdkPixbuf* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		cairo_t* _tmp32_;
		cairo_t* _tmp33_;
		GtkStyleContext* _tmp34_;
		cairo_t* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		GtkStyleContext* _tmp38_;
		cairo_t* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		_tmp9_ = style_context;
		_tmp10_ = style_context;
		_tmp11_ = gtk_style_context_get_state (_tmp10_);
		gtk_style_context_get_property (_tmp9_, GTK_STYLE_PROPERTY_BORDER_RADIUS, _tmp11_, &_tmp12_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_value_get_int (&_tmp13_);
		_tmp15_ = _tmp14_;
		G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
		border_radius = _tmp15_;
		_tmp16_ = width;
		_tmp17_ = border_radius;
		_tmp18_ = width;
		_tmp19_ = MIN (_tmp16_ / 2, (_tmp17_ * _tmp18_) / 100);
		crop_radius = _tmp19_;
		_tmp20_ = cr;
		_tmp21_ = width;
		_tmp22_ = height;
		_tmp23_ = crop_radius;
		granite_drawing_utilities_cairo_rounded_rectangle (_tmp20_, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp21_, (gdouble) _tmp22_, (gdouble) _tmp23_);
		_tmp24_ = cr;
		cairo_save (_tmp24_);
		_tmp25_ = cr;
		_tmp26_ = scale_factor;
		_tmp27_ = scale_factor;
		cairo_scale (_tmp25_, 1.0 / _tmp26_, 1.0 / _tmp27_);
		_tmp28_ = cr;
		_tmp29_ = self->priv->_pixbuf;
		_tmp30_ = scale_factor;
		_tmp31_ = scale_factor;
		gdk_cairo_set_source_pixbuf (_tmp28_, _tmp29_, (gdouble) (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * _tmp30_), (gdouble) (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * _tmp31_));
		_tmp32_ = cr;
		cairo_fill_preserve (_tmp32_);
		_tmp33_ = cr;
		cairo_restore (_tmp33_);
		_tmp34_ = style_context;
		_tmp35_ = cr;
		_tmp36_ = width;
		_tmp37_ = height;
		gtk_render_background (_tmp34_, _tmp35_, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp36_, (gdouble) _tmp37_);
		_tmp38_ = style_context;
		_tmp39_ = cr;
		_tmp40_ = width;
		_tmp41_ = height;
		gtk_render_frame (_tmp38_, _tmp39_, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp40_, (gdouble) _tmp41_);
	} else {
		cairo_t* _tmp42_;
		cairo_t* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		GtkStyleContext* _tmp46_;
		cairo_t* _tmp47_;
		GdkPixbuf* _tmp48_;
		cairo_t* _tmp49_;
		_tmp42_ = cr;
		cairo_save (_tmp42_);
		_tmp43_ = cr;
		_tmp44_ = scale_factor;
		_tmp45_ = scale_factor;
		cairo_scale (_tmp43_, 1.0 / _tmp44_, 1.0 / _tmp45_);
		_tmp46_ = style_context;
		_tmp47_ = cr;
		_tmp48_ = self->priv->_pixbuf;
		gtk_render_icon (_tmp46_, _tmp47_, _tmp48_, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN);
		_tmp49_ = cr;
		cairo_restore (_tmp49_);
	}
	result = GDK_EVENT_STOP;
	return result;
}


GdkPixbuf* granite_widgets_avatar_get_pixbuf (GraniteWidgetsAvatar* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pixbuf;
	result = _tmp0_;
	return result;
}


void granite_widgets_avatar_set_pixbuf (GraniteWidgetsAvatar* self, GdkPixbuf* value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_avatar_get_pixbuf (self) != value) {
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_pixbuf);
		self->priv->_pixbuf = _tmp1_;
		g_object_notify ((GObject *) self, "pixbuf");
	}
}


static GObject * granite_widgets_avatar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsAvatar * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	parent_class = G_OBJECT_CLASS (granite_widgets_avatar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = style_context;
	gtk_style_context_add_class (_tmp2_, GRANITE_WIDGETS_AVATAR_DEFAULT_STYLE);
	g_signal_connect_object ((GObject*) self, "notify::pixbuf", (GCallback) _granite_widgets_avatar_refresh_size_request_g_object_notify, self, 0);
	_g_object_unref0 (style_context);
	return obj;
}


static void granite_widgets_avatar_class_init (GraniteWidgetsAvatarClass * klass) {
	granite_widgets_avatar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsAvatarPrivate));
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) granite_widgets_avatar_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_avatar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_avatar_set_property;
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_avatar_constructor;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_avatar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_AVATAR_PIXBUF, g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void granite_widgets_avatar_instance_init (GraniteWidgetsAvatar * self) {
	self->priv = GRANITE_WIDGETS_AVATAR_GET_PRIVATE (self);
	self->priv->draw_theme_background = TRUE;
}


static void granite_widgets_avatar_finalize (GObject * obj) {
	GraniteWidgetsAvatar * self;
	guint _tmp0_;
	GQuark _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
	g_signal_parse_name ("notify::pixbuf", G_TYPE_OBJECT, &_tmp0_, &_tmp1_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, _tmp1_, NULL, (GCallback) _granite_widgets_avatar_refresh_size_request_g_object_notify, self);
	_g_object_unref0 (self->priv->_pixbuf);
	G_OBJECT_CLASS (granite_widgets_avatar_parent_class)->finalize (obj);
}


/**
 * The Avatar widget allowes to theme & crop images with css BORDER_RADIUS property in the .avatar class.
 *
 */
GType granite_widgets_avatar_get_type (void) {
	static volatile gsize granite_widgets_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_avatar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsAvatar), 0, (GInstanceInitFunc) granite_widgets_avatar_instance_init, NULL };
		GType granite_widgets_avatar_type_id;
		granite_widgets_avatar_type_id = g_type_register_static (gtk_event_box_get_type (), "GraniteWidgetsAvatar", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_avatar_type_id__volatile, granite_widgets_avatar_type_id);
	}
	return granite_widgets_avatar_type_id__volatile;
}


static void _vala_granite_widgets_avatar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
	switch (property_id) {
		case GRANITE_WIDGETS_AVATAR_PIXBUF:
		g_value_set_object (value, granite_widgets_avatar_get_pixbuf (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_avatar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
	switch (property_id) {
		case GRANITE_WIDGETS_AVATAR_PIXBUF:
		granite_widgets_avatar_set_pixbuf (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



