/* OverlayBar.c generated by valac 0.36.4, the Vala compiler
 * generated from OverlayBar.vala, do not modify */

/*
 *  Copyright (C) 2012 ammonkey <am.monkeyd@gmail.com>
 *  Copyright (C) 2013 Julián Unrrein <junrrein@gmail.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define GRANITE_WIDGETS_TYPE_OVERLAY_BAR (granite_widgets_overlay_bar_get_type ())
#define GRANITE_WIDGETS_OVERLAY_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBar))
#define GRANITE_WIDGETS_OVERLAY_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBarClass))
#define GRANITE_WIDGETS_IS_OVERLAY_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_OVERLAY_BAR))
#define GRANITE_WIDGETS_IS_OVERLAY_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_OVERLAY_BAR))
#define GRANITE_WIDGETS_OVERLAY_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBarClass))

typedef struct _GraniteWidgetsOverlayBar GraniteWidgetsOverlayBar;
typedef struct _GraniteWidgetsOverlayBarClass GraniteWidgetsOverlayBarClass;
typedef struct _GraniteWidgetsOverlayBarPrivate GraniteWidgetsOverlayBarPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GraniteWidgetsOverlayBar {
	GtkEventBox parent_instance;
	GraniteWidgetsOverlayBarPrivate * priv;
};

struct _GraniteWidgetsOverlayBarClass {
	GtkEventBoxClass parent_class;
};

struct _GraniteWidgetsOverlayBarPrivate {
	GtkLabel* status_label;
};


static gpointer granite_widgets_overlay_bar_parent_class = NULL;

GType granite_widgets_overlay_bar_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_OVERLAY_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBarPrivate))
enum  {
	GRANITE_WIDGETS_OVERLAY_BAR_DUMMY_PROPERTY,
	GRANITE_WIDGETS_OVERLAY_BAR_STATUS
};
#define GRANITE_WIDGETS_OVERLAY_BAR_FALLBACK_THEME "\n" \
"   .overlay-bar {\n" \
"       background-color: @bg_color;\n" \
"       border-radius: 3px;\n" \
"       padding: 3px 6px;\n" \
"       margin: 3px;\n" \
"       border-style: solid;\n" \
"       border-width: 1px;\n" \
"       border-color: darker (@bg_color);\n" \
"   }"
GraniteWidgetsOverlayBar* granite_widgets_overlay_bar_new (GtkOverlay* overlay);
GraniteWidgetsOverlayBar* granite_widgets_overlay_bar_construct (GType object_type, GtkOverlay* overlay);
static void granite_widgets_overlay_bar_set_default_style (GraniteWidgetsOverlayBar* self);
static void granite_widgets_overlay_bar_update_spacing (GraniteWidgetsOverlayBar* self);
static void _granite_widgets_overlay_bar_update_spacing_gtk_style_context_changed (GtkStyleContext* _sender, gpointer self);
static void _gtk_widget_queue_resize_gtk_style_context_changed (GtkStyleContext* _sender, gpointer self);
static void granite_widgets_overlay_bar_real_parent_set (GtkWidget* base, GtkWidget* old_parent);
static gboolean granite_widgets_overlay_bar_enter_notify_callback (GraniteWidgetsOverlayBar* self, GdkEventCrossing* event);
static gboolean _granite_widgets_overlay_bar_enter_notify_callback_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean granite_widgets_overlay_bar_real_draw (GtkWidget* base, cairo_t* cr);
static GtkSizeRequestMode granite_widgets_overlay_bar_real_get_request_mode (GtkWidget* base);
static void granite_widgets_overlay_bar_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width);
static void granite_widgets_overlay_bar_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* minimum_height, gint* natural_height);
GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget, const gchar* stylesheet, const gchar* class_name, gint priority);
#define GRANITE_STYLE_CLASS_OVERLAY_BAR "overlay-bar"
const gchar* granite_widgets_overlay_bar_get_status (GraniteWidgetsOverlayBar* self);
void granite_widgets_overlay_bar_set_status (GraniteWidgetsOverlayBar* self, const gchar* value);
static void granite_widgets_overlay_bar_finalize (GObject * obj);
static void _vala_granite_widgets_overlay_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_overlay_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Create a new Overlay Bar, and add it to the {@link Gtk.Overlay}.
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _granite_widgets_overlay_bar_update_spacing_gtk_style_context_changed (GtkStyleContext* _sender, gpointer self) {
	granite_widgets_overlay_bar_update_spacing ((GraniteWidgetsOverlayBar*) self);
}


static void _gtk_widget_queue_resize_gtk_style_context_changed (GtkStyleContext* _sender, gpointer self) {
	gtk_widget_queue_resize ((GtkWidget*) self);
}


GraniteWidgetsOverlayBar* granite_widgets_overlay_bar_construct (GType object_type, GtkOverlay* overlay) {
	GraniteWidgetsOverlayBar * self = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkOverlay* _tmp7_;
	g_return_val_if_fail (overlay != NULL, NULL);
	self = (GraniteWidgetsOverlayBar*) g_object_new (object_type, NULL);
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp0_;
	_tmp1_ = self->priv->status_label;
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_END);
	_tmp2_ = self->priv->status_label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->status_label;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_END);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
	granite_widgets_overlay_bar_set_default_style (self);
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	ctx = _tmp5_;
	g_signal_connect_object (ctx, "changed", (GCallback) _granite_widgets_overlay_bar_update_spacing_gtk_style_context_changed, self, 0);
	g_signal_connect_object (ctx, "changed", (GCallback) _gtk_widget_queue_resize_gtk_style_context_changed, (GtkWidget*) self, G_CONNECT_AFTER);
	granite_widgets_overlay_bar_update_spacing (self);
	_tmp6_ = overlay;
	gtk_widget_add_events ((GtkWidget*) _tmp6_, (gint) GDK_ENTER_NOTIFY_MASK);
	_tmp7_ = overlay;
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) self);
	_g_object_unref0 (ctx);
	return self;
}


GraniteWidgetsOverlayBar* granite_widgets_overlay_bar_new (GtkOverlay* overlay) {
	return granite_widgets_overlay_bar_construct (GRANITE_WIDGETS_TYPE_OVERLAY_BAR, overlay);
}


static gboolean _granite_widgets_overlay_bar_enter_notify_callback_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
	gboolean result;
	result = granite_widgets_overlay_bar_enter_notify_callback ((GraniteWidgetsOverlayBar*) self, event);
	return result;
}


static void granite_widgets_overlay_bar_real_parent_set (GtkWidget* base, GtkWidget* old_parent) {
	GraniteWidgetsOverlayBar * self;
	GtkWidget* parent = NULL;
	GtkContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp5_;
	self = (GraniteWidgetsOverlayBar*) base;
	_tmp0_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	parent = _tmp1_;
	_tmp2_ = old_parent;
	if (_tmp2_ != NULL) {
		GtkWidget* _tmp3_;
		guint _tmp4_;
		_tmp3_ = old_parent;
		g_signal_parse_name ("enter-notify-event", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _granite_widgets_overlay_bar_enter_notify_callback_gtk_widget_enter_notify_event, self);
	}
	_tmp5_ = parent;
	if (_tmp5_ != NULL) {
		GtkWidget* _tmp6_;
		_tmp6_ = parent;
		g_signal_connect_object (_tmp6_, "enter-notify-event", (GCallback) _granite_widgets_overlay_bar_enter_notify_callback_gtk_widget_enter_notify_event, self, 0);
	}
	_g_object_unref0 (parent);
}


static gboolean granite_widgets_overlay_bar_real_draw (GtkWidget* base, cairo_t* cr) {
	GraniteWidgetsOverlayBar * self;
	gboolean result = FALSE;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	cairo_t* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	cairo_t* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	cairo_t* _tmp8_;
	gboolean _tmp9_;
	self = (GraniteWidgetsOverlayBar*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	_tmp2_ = cr;
	_tmp3_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp4_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	gtk_render_background (ctx, _tmp2_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp3_, (gdouble) _tmp4_);
	_tmp5_ = cr;
	_tmp6_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp7_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	gtk_render_frame (ctx, _tmp5_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp6_, (gdouble) _tmp7_);
	_tmp8_ = cr;
	_tmp9_ = GTK_WIDGET_CLASS (granite_widgets_overlay_bar_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox), _tmp8_);
	result = _tmp9_;
	_g_object_unref0 (ctx);
	return result;
}


static GtkSizeRequestMode granite_widgets_overlay_bar_real_get_request_mode (GtkWidget* base) {
	GraniteWidgetsOverlayBar * self;
	GtkSizeRequestMode result = 0;
	self = (GraniteWidgetsOverlayBar*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static void granite_widgets_overlay_bar_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width) {
	GraniteWidgetsOverlayBar * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	GtkRequisition label_min_size = {0};
	GtkRequisition label_natural_size = {0};
	GtkLabel* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStateFlags state = 0;
	GtkStateFlags _tmp5_;
	GtkBorder border = {0};
	GtkBorder _tmp6_ = {0};
	gint extra_allocation = 0;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkRequisition _tmp11_;
	gint _tmp12_;
	GtkRequisition _tmp13_;
	gint _tmp14_;
	self = (GraniteWidgetsOverlayBar*) base;
	_tmp0_ = self->priv->status_label;
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp0_, &_tmp1_, &_tmp2_);
	label_min_size = _tmp1_;
	label_natural_size = _tmp2_;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	ctx = _tmp4_;
	_tmp5_ = gtk_style_context_get_state (ctx);
	state = _tmp5_;
	gtk_style_context_get_border (ctx, state, &_tmp6_);
	border = _tmp6_;
	_tmp7_ = border;
	_tmp8_ = _tmp7_.left;
	_tmp9_ = border;
	_tmp10_ = _tmp9_.right;
	extra_allocation = (gint) (_tmp8_ + _tmp10_);
	_tmp11_ = label_min_size;
	_tmp12_ = _tmp11_.width;
	_vala_minimum_width = extra_allocation + _tmp12_;
	_tmp13_ = label_natural_size;
	_tmp14_ = _tmp13_.width;
	_vala_natural_width = extra_allocation + _tmp14_;
	_g_object_unref0 (ctx);
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void granite_widgets_overlay_bar_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* minimum_height, gint* natural_height) {
	GraniteWidgetsOverlayBar * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	GtkRequisition label_min_size = {0};
	GtkRequisition label_natural_size = {0};
	GtkLabel* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStateFlags state = 0;
	GtkStateFlags _tmp5_;
	GtkBorder border = {0};
	GtkBorder _tmp6_ = {0};
	gint extra_allocation = 0;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkRequisition _tmp11_;
	gint _tmp12_;
	GtkRequisition _tmp13_;
	gint _tmp14_;
	self = (GraniteWidgetsOverlayBar*) base;
	_tmp0_ = self->priv->status_label;
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp0_, &_tmp1_, &_tmp2_);
	label_min_size = _tmp1_;
	label_natural_size = _tmp2_;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	ctx = _tmp4_;
	_tmp5_ = gtk_style_context_get_state (ctx);
	state = _tmp5_;
	gtk_style_context_get_border (ctx, state, &_tmp6_);
	border = _tmp6_;
	_tmp7_ = border;
	_tmp8_ = _tmp7_.top;
	_tmp9_ = border;
	_tmp10_ = _tmp9_.bottom;
	extra_allocation = (gint) (_tmp8_ + _tmp10_);
	_tmp11_ = label_min_size;
	_tmp12_ = _tmp11_.height;
	_vala_minimum_height = extra_allocation + _tmp12_;
	_tmp13_ = label_natural_size;
	_tmp14_ = _tmp13_.height;
	_vala_natural_height = extra_allocation + _tmp14_;
	_g_object_unref0 (ctx);
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void granite_widgets_overlay_bar_update_spacing (GraniteWidgetsOverlayBar* self) {
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0;
	GtkStateFlags _tmp2_;
	GtkBorder padding = {0};
	GtkBorder _tmp3_ = {0};
	GtkLabel* _tmp4_;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkLabel* _tmp7_;
	GtkBorder _tmp8_;
	gint16 _tmp9_;
	GtkLabel* _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkLabel* _tmp13_;
	GtkBorder _tmp14_;
	gint16 _tmp15_;
	GtkBorder margin = {0};
	GtkBorder _tmp16_ = {0};
	GtkBorder _tmp17_;
	gint16 _tmp18_;
	GtkBorder _tmp19_;
	gint16 _tmp20_;
	GtkBorder _tmp21_;
	gint16 _tmp22_;
	GtkBorder _tmp23_;
	gint16 _tmp24_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	_tmp2_ = gtk_style_context_get_state (ctx);
	state = _tmp2_;
	gtk_style_context_get_padding (ctx, state, &_tmp3_);
	padding = _tmp3_;
	_tmp4_ = self->priv->status_label;
	_tmp5_ = padding;
	_tmp6_ = _tmp5_.top;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, (gint) _tmp6_);
	_tmp7_ = self->priv->status_label;
	_tmp8_ = padding;
	_tmp9_ = _tmp8_.bottom;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp7_, (gint) _tmp9_);
	_tmp10_ = self->priv->status_label;
	_tmp11_ = padding;
	_tmp12_ = _tmp11_.left;
	gtk_widget_set_margin_left ((GtkWidget*) _tmp10_, (gint) _tmp12_);
	_tmp13_ = self->priv->status_label;
	_tmp14_ = padding;
	_tmp15_ = _tmp14_.right;
	gtk_widget_set_margin_right ((GtkWidget*) _tmp13_, (gint) _tmp15_);
	gtk_style_context_get_margin (ctx, state, &_tmp16_);
	margin = _tmp16_;
	_tmp17_ = margin;
	_tmp18_ = _tmp17_.top;
	gtk_widget_set_margin_top ((GtkWidget*) self, (gint) _tmp18_);
	_tmp19_ = margin;
	_tmp20_ = _tmp19_.bottom;
	gtk_widget_set_margin_bottom ((GtkWidget*) self, (gint) _tmp20_);
	_tmp21_ = margin;
	_tmp22_ = _tmp21_.left;
	gtk_widget_set_margin_left ((GtkWidget*) self, (gint) _tmp22_);
	_tmp23_ = margin;
	_tmp24_ = _tmp23_.right;
	gtk_widget_set_margin_right ((GtkWidget*) self, (gint) _tmp24_);
	_g_object_unref0 (ctx);
}


static void granite_widgets_overlay_bar_set_default_style (GraniteWidgetsOverlayBar* self) {
	gint priority = 0;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	g_return_if_fail (self != NULL);
	priority = GTK_STYLE_PROVIDER_PRIORITY_FALLBACK;
	_tmp0_ = granite_widgets_utils_set_theming ((GtkWidget*) self, GRANITE_WIDGETS_OVERLAY_BAR_FALLBACK_THEME, GRANITE_STYLE_CLASS_OVERLAY_BAR, priority);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
}


static gboolean granite_widgets_overlay_bar_enter_notify_callback (GraniteWidgetsOverlayBar* self, GdkEventCrossing* event) {
	gboolean result = FALSE;
	GtkAlign _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = gtk_widget_get_halign ((GtkWidget*) self);
	if (_tmp0_ == GTK_ALIGN_START) {
		gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_END);
	} else {
		gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
	}
	result = FALSE;
	return result;
}


const gchar* granite_widgets_overlay_bar_get_status (GraniteWidgetsOverlayBar* self) {
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->status_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_overlay_bar_set_status (GraniteWidgetsOverlayBar* self, const gchar* value) {
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->status_label;
	_tmp1_ = value;
	gtk_label_set_label (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "status");
}


static void granite_widgets_overlay_bar_class_init (GraniteWidgetsOverlayBarClass * klass) {
	granite_widgets_overlay_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsOverlayBarPrivate));
	((GtkWidgetClass *) klass)->parent_set = (void (*) (GtkWidget *, GtkWidget*)) granite_widgets_overlay_bar_real_parent_set;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) granite_widgets_overlay_bar_real_draw;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget *)) granite_widgets_overlay_bar_real_get_request_mode;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) granite_widgets_overlay_bar_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget *, gint, gint*, gint*)) granite_widgets_overlay_bar_real_get_preferred_height_for_width;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_overlay_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_overlay_bar_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_overlay_bar_finalize;
	/**
	     * Status text displayed inside the Overlay Bar.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_OVERLAY_BAR_STATUS, g_param_spec_string ("status", "status", "status", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void granite_widgets_overlay_bar_instance_init (GraniteWidgetsOverlayBar * self) {
	self->priv = GRANITE_WIDGETS_OVERLAY_BAR_GET_PRIVATE (self);
}


static void granite_widgets_overlay_bar_finalize (GObject * obj) {
	GraniteWidgetsOverlayBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBar);
	_g_object_unref0 (self->priv->status_label);
	G_OBJECT_CLASS (granite_widgets_overlay_bar_parent_class)->finalize (obj);
}


/**
 * A floating status bar that displays a single line of text.
 *
 * This widget is intended to be used as an overlay for a {@link Gtk.Overlay} and is placed in the
 * bottom-right corner by default. You can change its position like you would do for any overlay
 * widget used in a {@link Gtk.Overlay}.
 *
 * The Overlay Bar displays a single line of text that can be changed using the "status" property.
 *
 * {{../../doc/images/OverlayBar.png}}
 *
 * This widget tries to avoid getting in front of the content being displayed inside the {@link Gtk.Overlay}
 * by moving itself horizontally to the opposite side from the current one when the mouse pointer enters
 * the widget.
 *
 * For this widget to function correctly, the event {@link Gdk.EventMask.ENTER_NOTIFY_MASK} must be set
 * for the parent {@link Gtk.Overlay}. Overlay Bar's constructor takes care of this automatically,
 * but you have to be careful not to unset the event for the {@link Gtk.Overlay} at a later stage.
 *
 * @see Gtk.Overlay
 */
GType granite_widgets_overlay_bar_get_type (void) {
	static volatile gsize granite_widgets_overlay_bar_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_overlay_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsOverlayBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_overlay_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsOverlayBar), 0, (GInstanceInitFunc) granite_widgets_overlay_bar_instance_init, NULL };
		GType granite_widgets_overlay_bar_type_id;
		granite_widgets_overlay_bar_type_id = g_type_register_static (gtk_event_box_get_type (), "GraniteWidgetsOverlayBar", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_overlay_bar_type_id__volatile, granite_widgets_overlay_bar_type_id);
	}
	return granite_widgets_overlay_bar_type_id__volatile;
}


static void _vala_granite_widgets_overlay_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsOverlayBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBar);
	switch (property_id) {
		case GRANITE_WIDGETS_OVERLAY_BAR_STATUS:
		g_value_set_string (value, granite_widgets_overlay_bar_get_status (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_overlay_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsOverlayBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_OVERLAY_BAR, GraniteWidgetsOverlayBar);
	switch (property_id) {
		case GRANITE_WIDGETS_OVERLAY_BAR_STATUS:
		granite_widgets_overlay_bar_set_status (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



