/* TimePicker.c generated by valac 0.36.4, the Vala compiler
 * generated from TimePicker.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Maxwell Barvian <maxwell@elementaryos.org>,
 *                          Corentin Noël <tintou@mailoo.org>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define GRANITE_WIDGETS_TYPE_TIME_PICKER (granite_widgets_time_picker_get_type ())
#define GRANITE_WIDGETS_TIME_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePicker))
#define GRANITE_WIDGETS_TIME_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePickerClass))
#define GRANITE_WIDGETS_IS_TIME_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_TIME_PICKER))
#define GRANITE_WIDGETS_IS_TIME_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_TIME_PICKER))
#define GRANITE_WIDGETS_TIME_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePickerClass))

typedef struct _GraniteWidgetsTimePicker GraniteWidgetsTimePicker;
typedef struct _GraniteWidgetsTimePickerClass GraniteWidgetsTimePickerClass;
typedef struct _GraniteWidgetsTimePickerPrivate GraniteWidgetsTimePickerPrivate;

#define GRANITE_WIDGETS_TYPE_MODE_BUTTON (granite_widgets_mode_button_get_type ())
#define GRANITE_WIDGETS_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_MODE_BUTTON, GraniteWidgetsModeButton))
#define GRANITE_WIDGETS_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_MODE_BUTTON, GraniteWidgetsModeButtonClass))
#define GRANITE_WIDGETS_IS_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_MODE_BUTTON))
#define GRANITE_WIDGETS_IS_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_MODE_BUTTON))
#define GRANITE_WIDGETS_MODE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_MODE_BUTTON, GraniteWidgetsModeButtonClass))

typedef struct _GraniteWidgetsModeButton GraniteWidgetsModeButton;
typedef struct _GraniteWidgetsModeButtonClass GraniteWidgetsModeButtonClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GRANITE_WIDGETS_TIME_PICKER_TIME_CHANGED_SIGNAL,
	GRANITE_WIDGETS_TIME_PICKER_LAST_SIGNAL
};
static guint granite_widgets_time_picker_signals[GRANITE_WIDGETS_TIME_PICKER_LAST_SIGNAL] = {0};

struct _GraniteWidgetsTimePicker {
	GtkEntry parent_instance;
	GraniteWidgetsTimePickerPrivate * priv;
};

struct _GraniteWidgetsTimePickerClass {
	GtkEntryClass parent_class;
	void (*position_dropdown) (GraniteWidgetsTimePicker* self, gint* x, gint* y);
};

struct _GraniteWidgetsTimePickerPrivate {
	gchar* _format_12;
	gchar* _format_24;
	GDateTime* _time;
	gchar* old_string;
	GtkSpinButton* hours_spinbutton;
	GtkSpinButton* minutes_spinbutton;
	GraniteWidgetsModeButton* am_pm_modebutton;
	gboolean changing_time;
	GtkPopover* popover;
};


static gpointer granite_widgets_time_picker_parent_class = NULL;

GType granite_widgets_time_picker_get_type (void) G_GNUC_CONST;
GType granite_widgets_mode_button_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_TIME_PICKER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePickerPrivate))
enum  {
	GRANITE_WIDGETS_TIME_PICKER_DUMMY_PROPERTY,
	GRANITE_WIDGETS_TIME_PICKER_FORMAT_12,
	GRANITE_WIDGETS_TIME_PICKER_FORMAT_24,
	GRANITE_WIDGETS_TIME_PICKER_TIME
};
#define GRANITE_WIDGETS_TIME_PICKER_OFFSET 15
#define GRANITE_WIDGETS_TIME_PICKER_MARGIN 6
GraniteWidgetsTimePicker* granite_widgets_time_picker_new_with_format (const gchar* format_12, const gchar* format_24);
GraniteWidgetsTimePicker* granite_widgets_time_picker_construct_with_format (GType object_type, const gchar* format_12, const gchar* format_24);
static void granite_widgets_time_picker_update_time (GraniteWidgetsTimePicker* self, gboolean is_hour);
GDateTime* granite_widgets_time_picker_get_time (GraniteWidgetsTimePicker* self);
gboolean granite_date_time_is_clock_format_12h (void);
gint granite_widgets_mode_button_get_selected (GraniteWidgetsModeButton* self);
static void granite_widgets_time_picker_update_text (GraniteWidgetsTimePicker* self, gboolean no_signal);
static void granite_widgets_time_picker_on_icon_press (GraniteWidgetsTimePicker* self, GtkEntryIconPosition position, GdkEvent* event);
void granite_widgets_time_picker_position_dropdown (GraniteWidgetsTimePicker* self, gint* x, gint* y);
static void granite_widgets_time_picker_real_position_dropdown (GraniteWidgetsTimePicker* self, gint* x, gint* y);
static void granite_widgets_time_picker_is_unfocused (GraniteWidgetsTimePicker* self);
static void granite_widgets_time_picker_parse_time (GraniteWidgetsTimePicker* self, const gchar* timestr);
static gint* _int_dup (gint* self);
void granite_widgets_time_picker_set_time (GraniteWidgetsTimePicker* self, GDateTime* value);
const gchar* granite_widgets_time_picker_get_format_12 (GraniteWidgetsTimePicker* self);
const gchar* granite_widgets_time_picker_get_format_24 (GraniteWidgetsTimePicker* self);
GraniteWidgetsTimePicker* granite_widgets_time_picker_new (void);
GraniteWidgetsTimePicker* granite_widgets_time_picker_construct (GType object_type);
static void granite_widgets_time_picker_set_format_12 (GraniteWidgetsTimePicker* self, const gchar* value);
static void granite_widgets_time_picker_set_format_24 (GraniteWidgetsTimePicker* self, const gchar* value);
void granite_widgets_mode_button_set_active (GraniteWidgetsModeButton* self, gint new_active_index);
static GObject * granite_widgets_time_picker_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
gchar* granite_date_time_get_default_time_format (gboolean is_12h, gboolean with_second);
static void _granite_widgets_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self);
GraniteWidgetsModeButton* granite_widgets_mode_button_new (void);
GraniteWidgetsModeButton* granite_widgets_mode_button_construct (GType object_type);
gint granite_widgets_mode_button_append_text (GraniteWidgetsModeButton* self, const gchar* text);
static void _granite_widgets_time_picker___lambda30_ (GraniteWidgetsTimePicker* self, GtkWidget* mode);
static void __granite_widgets_time_picker___lambda30__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender, GtkWidget* widget, gpointer self);
static void _granite_widgets_time_picker___lambda31_ (GraniteWidgetsTimePicker* self);
static void __granite_widgets_time_picker___lambda31__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static void _granite_widgets_time_picker___lambda32_ (GraniteWidgetsTimePicker* self);
static void __granite_widgets_time_picker___lambda32__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static gboolean _granite_widgets_time_picker___lambda33_ (GraniteWidgetsTimePicker* self);
static gboolean __granite_widgets_time_picker___lambda33__gtk_spin_button_output (GtkSpinButton* _sender, gpointer self);
static gboolean _granite_widgets_time_picker___lambda34_ (GraniteWidgetsTimePicker* self);
static gboolean __granite_widgets_time_picker___lambda34__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean _granite_widgets_time_picker___lambda35_ (GraniteWidgetsTimePicker* self, GdkEventScroll* event);
static gboolean __granite_widgets_time_picker___lambda35__gtk_widget_scroll_event (GtkWidget* _sender, GdkEventScroll* event, gpointer self);
static void _granite_widgets_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender, gpointer self);
static void granite_widgets_time_picker_finalize (GObject * obj);
static void _vala_granite_widgets_time_picker_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_time_picker_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
         * Creates a new TimePicker.
         *
         * @param format_12 The desired custom 12h format. For example "%l:%M %p".
         * @param format_24 The desired custom 24h format. For example "%H:%M".
         */
GraniteWidgetsTimePicker* granite_widgets_time_picker_construct_with_format (GType object_type, const gchar* format_12, const gchar* format_24) {
	GraniteWidgetsTimePicker * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (format_12 != NULL, NULL);
	g_return_val_if_fail (format_24 != NULL, NULL);
	_tmp0_ = format_12;
	_tmp1_ = format_24;
	self = (GraniteWidgetsTimePicker*) g_object_new (object_type, "format-12", _tmp0_, "format-24", _tmp1_, NULL);
	return self;
}


GraniteWidgetsTimePicker* granite_widgets_time_picker_new_with_format (const gchar* format_12, const gchar* format_24) {
	return granite_widgets_time_picker_construct_with_format (GRANITE_WIDGETS_TYPE_TIME_PICKER, format_12, format_24);
}


static void granite_widgets_time_picker_update_time (GraniteWidgetsTimePicker* self, gboolean is_hour) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->changing_time;
	if (_tmp0_ == TRUE) {
		return;
	}
	_tmp1_ = is_hour;
	if (_tmp1_ == TRUE) {
		gint new_hour = 0;
		GtkSpinButton* _tmp2_;
		gint _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gint _tmp6_;
		gboolean _tmp7_;
		_tmp2_ = self->priv->hours_spinbutton;
		_tmp3_ = gtk_spin_button_get_value_as_int (_tmp2_);
		_tmp4_ = granite_widgets_time_picker_get_time (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_date_time_get_hour (_tmp5_);
		new_hour = _tmp3_ - _tmp6_;
		_tmp7_ = granite_date_time_is_clock_format_12h ();
		if (_tmp7_) {
			gboolean _tmp8_ = FALSE;
			GtkSpinButton* _tmp9_;
			gint _tmp10_;
			_tmp9_ = self->priv->hours_spinbutton;
			_tmp10_ = gtk_spin_button_get_value_as_int (_tmp9_);
			if (_tmp10_ == 12) {
				GraniteWidgetsModeButton* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				_tmp11_ = self->priv->am_pm_modebutton;
				_tmp12_ = granite_widgets_mode_button_get_selected (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp8_ = _tmp13_ == 0;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				GDateTime* _tmp14_;
				GDateTime* _tmp15_;
				gint _tmp16_;
				GDateTime* _tmp17_;
				_tmp14_ = self->priv->_time;
				_tmp15_ = self->priv->_time;
				_tmp16_ = g_date_time_get_hour (_tmp15_);
				_tmp17_ = g_date_time_add_hours (_tmp14_, -_tmp16_);
				_g_date_time_unref0 (self->priv->_time);
				self->priv->_time = _tmp17_;
			} else {
				gboolean _tmp18_ = FALSE;
				GtkSpinButton* _tmp19_;
				gint _tmp20_;
				_tmp19_ = self->priv->hours_spinbutton;
				_tmp20_ = gtk_spin_button_get_value_as_int (_tmp19_);
				if (_tmp20_ < 12) {
					GraniteWidgetsModeButton* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					_tmp21_ = self->priv->am_pm_modebutton;
					_tmp22_ = granite_widgets_mode_button_get_selected (_tmp21_);
					_tmp23_ = _tmp22_;
					_tmp18_ = _tmp23_ == 0;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					GDateTime* _tmp24_;
					gint _tmp25_;
					GDateTime* _tmp26_;
					_tmp24_ = self->priv->_time;
					_tmp25_ = new_hour;
					_tmp26_ = g_date_time_add_hours (_tmp24_, _tmp25_);
					_g_date_time_unref0 (self->priv->_time);
					self->priv->_time = _tmp26_;
				} else {
					gboolean _tmp27_ = FALSE;
					GtkSpinButton* _tmp28_;
					gint _tmp29_;
					_tmp28_ = self->priv->hours_spinbutton;
					_tmp29_ = gtk_spin_button_get_value_as_int (_tmp28_);
					if (_tmp29_ == 12) {
						GraniteWidgetsModeButton* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						_tmp30_ = self->priv->am_pm_modebutton;
						_tmp31_ = granite_widgets_mode_button_get_selected (_tmp30_);
						_tmp32_ = _tmp31_;
						_tmp27_ = _tmp32_ == 1;
					} else {
						_tmp27_ = FALSE;
					}
					if (_tmp27_) {
						GDateTime* _tmp33_;
						GDateTime* _tmp34_;
						gint _tmp35_;
						GDateTime* _tmp36_;
						_tmp33_ = self->priv->_time;
						_tmp34_ = self->priv->_time;
						_tmp35_ = g_date_time_get_hour (_tmp34_);
						_tmp36_ = g_date_time_add_hours (_tmp33_, (-_tmp35_) + 12);
						_g_date_time_unref0 (self->priv->_time);
						self->priv->_time = _tmp36_;
					} else {
						gboolean _tmp37_ = FALSE;
						GtkSpinButton* _tmp38_;
						gint _tmp39_;
						_tmp38_ = self->priv->hours_spinbutton;
						_tmp39_ = gtk_spin_button_get_value_as_int (_tmp38_);
						if (_tmp39_ < 12) {
							GraniteWidgetsModeButton* _tmp40_;
							gint _tmp41_;
							gint _tmp42_;
							_tmp40_ = self->priv->am_pm_modebutton;
							_tmp41_ = granite_widgets_mode_button_get_selected (_tmp40_);
							_tmp42_ = _tmp41_;
							_tmp37_ = _tmp42_ == 1;
						} else {
							_tmp37_ = FALSE;
						}
						if (_tmp37_) {
							GDateTime* _tmp43_;
							gint _tmp44_;
							GDateTime* _tmp45_;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							gint _tmp48_;
							_tmp43_ = self->priv->_time;
							_tmp44_ = new_hour;
							_tmp45_ = g_date_time_add_hours (_tmp43_, _tmp44_ + 12);
							_g_date_time_unref0 (self->priv->_time);
							self->priv->_time = _tmp45_;
							_tmp46_ = granite_widgets_time_picker_get_time (self);
							_tmp47_ = _tmp46_;
							_tmp48_ = g_date_time_get_hour (_tmp47_);
							if (_tmp48_ <= 12) {
								GDateTime* _tmp49_;
								GDateTime* _tmp50_;
								_tmp49_ = self->priv->_time;
								_tmp50_ = g_date_time_add_hours (_tmp49_, 12);
								_g_date_time_unref0 (self->priv->_time);
								self->priv->_time = _tmp50_;
							}
						}
					}
				}
			}
		} else {
			GDateTime* _tmp51_;
			gint _tmp52_;
			GDateTime* _tmp53_;
			_tmp51_ = self->priv->_time;
			_tmp52_ = new_hour;
			_tmp53_ = g_date_time_add_hours (_tmp51_, _tmp52_);
			_g_date_time_unref0 (self->priv->_time);
			self->priv->_time = _tmp53_;
		}
	} else {
		GDateTime* _tmp54_;
		GDateTime* _tmp55_;
		GtkSpinButton* _tmp56_;
		gint _tmp57_;
		GDateTime* _tmp58_;
		GDateTime* _tmp59_;
		gint _tmp60_;
		GDateTime* _tmp61_;
		_tmp54_ = granite_widgets_time_picker_get_time (self);
		_tmp55_ = _tmp54_;
		_tmp56_ = self->priv->minutes_spinbutton;
		_tmp57_ = gtk_spin_button_get_value_as_int (_tmp56_);
		_tmp58_ = granite_widgets_time_picker_get_time (self);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_date_time_get_minute (_tmp59_);
		_tmp61_ = g_date_time_add_minutes (_tmp55_, _tmp57_ - _tmp60_);
		_g_date_time_unref0 (self->priv->_time);
		self->priv->_time = _tmp61_;
	}
	granite_widgets_time_picker_update_text (self, FALSE);
}


static void granite_widgets_time_picker_on_icon_press (GraniteWidgetsTimePicker* self, GtkEntryIconPosition position, GdkEvent* event) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp13_;
	GtkSpinButton* _tmp39_;
	GDateTime* _tmp40_;
	GDateTime* _tmp41_;
	gint _tmp42_;
	GdkRectangle rect = {0};
	gint x = 0;
	gint y = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	gint _tmp45_;
	gint _tmp46_;
	GtkPopover* _tmp47_;
	GdkRectangle _tmp48_;
	GtkPopover* _tmp49_;
	GtkPopover* _tmp50_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	granite_widgets_time_picker_update_text (self, FALSE);
	self->priv->changing_time = TRUE;
	_tmp1_ = granite_date_time_is_clock_format_12h ();
	if (_tmp1_) {
		GDateTime* _tmp2_;
		GDateTime* _tmp3_;
		gint _tmp4_;
		_tmp2_ = granite_widgets_time_picker_get_time (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_date_time_get_hour (_tmp3_);
		_tmp0_ = _tmp4_ > 12;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkSpinButton* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		gint _tmp8_;
		_tmp5_ = self->priv->hours_spinbutton;
		_tmp6_ = granite_widgets_time_picker_get_time (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_date_time_get_hour (_tmp7_);
		gtk_spin_button_set_value (_tmp5_, (gdouble) (_tmp8_ - 12));
	} else {
		GtkSpinButton* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		gint _tmp12_;
		_tmp9_ = self->priv->hours_spinbutton;
		_tmp10_ = granite_widgets_time_picker_get_time (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_date_time_get_hour (_tmp11_);
		gtk_spin_button_set_value (_tmp9_, (gdouble) _tmp12_);
	}
	_tmp13_ = granite_date_time_is_clock_format_12h ();
	if (_tmp13_) {
		GraniteWidgetsModeButton* _tmp14_;
		GraniteWidgetsModeButton* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		gint _tmp18_;
		GtkSpinButton* _tmp31_;
		_tmp14_ = self->priv->am_pm_modebutton;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, FALSE);
		_tmp15_ = self->priv->am_pm_modebutton;
		gtk_widget_show_all ((GtkWidget*) _tmp15_);
		_tmp16_ = granite_widgets_time_picker_get_time (self);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_date_time_get_hour (_tmp17_);
		if (_tmp18_ > 12) {
			GtkSpinButton* _tmp19_;
			GDateTime* _tmp20_;
			GDateTime* _tmp21_;
			gint _tmp22_;
			_tmp19_ = self->priv->hours_spinbutton;
			_tmp20_ = granite_widgets_time_picker_get_time (self);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_date_time_get_hour (_tmp21_);
			gtk_spin_button_set_value (_tmp19_, (gdouble) (_tmp22_ - 12));
		} else {
			GDateTime* _tmp23_;
			GDateTime* _tmp24_;
			gint _tmp25_;
			_tmp23_ = granite_widgets_time_picker_get_time (self);
			_tmp24_ = _tmp23_;
			_tmp25_ = g_date_time_get_hour (_tmp24_);
			if (_tmp25_ == 0) {
				GtkSpinButton* _tmp26_;
				_tmp26_ = self->priv->hours_spinbutton;
				gtk_spin_button_set_value (_tmp26_, (gdouble) 12);
			} else {
				GtkSpinButton* _tmp27_;
				GDateTime* _tmp28_;
				GDateTime* _tmp29_;
				gint _tmp30_;
				_tmp27_ = self->priv->hours_spinbutton;
				_tmp28_ = granite_widgets_time_picker_get_time (self);
				_tmp29_ = _tmp28_;
				_tmp30_ = g_date_time_get_hour (_tmp29_);
				gtk_spin_button_set_value (_tmp27_, (gdouble) _tmp30_);
			}
		}
		_tmp31_ = self->priv->hours_spinbutton;
		gtk_spin_button_set_range (_tmp31_, (gdouble) 1, (gdouble) 12);
	} else {
		GraniteWidgetsModeButton* _tmp32_;
		GraniteWidgetsModeButton* _tmp33_;
		GtkSpinButton* _tmp34_;
		GDateTime* _tmp35_;
		GDateTime* _tmp36_;
		gint _tmp37_;
		GtkSpinButton* _tmp38_;
		_tmp32_ = self->priv->am_pm_modebutton;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp32_, TRUE);
		_tmp33_ = self->priv->am_pm_modebutton;
		gtk_widget_hide ((GtkWidget*) _tmp33_);
		_tmp34_ = self->priv->hours_spinbutton;
		_tmp35_ = granite_widgets_time_picker_get_time (self);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_date_time_get_hour (_tmp36_);
		gtk_spin_button_set_value (_tmp34_, (gdouble) _tmp37_);
		_tmp38_ = self->priv->hours_spinbutton;
		gtk_spin_button_set_range (_tmp38_, (gdouble) 0, (gdouble) 23);
	}
	_tmp39_ = self->priv->minutes_spinbutton;
	_tmp40_ = granite_widgets_time_picker_get_time (self);
	_tmp41_ = _tmp40_;
	_tmp42_ = g_date_time_get_minute (_tmp41_);
	gtk_spin_button_set_value (_tmp39_, (gdouble) _tmp42_);
	self->priv->changing_time = FALSE;
	memset (&rect, 0, sizeof (GdkRectangle));
	x = 0;
	y = 0;
	granite_widgets_time_picker_position_dropdown (self, &_tmp43_, &_tmp44_);
	x = _tmp43_;
	y = _tmp44_;
	_tmp45_ = x;
	rect.x = _tmp45_;
	_tmp46_ = y;
	rect.y = _tmp46_;
	_tmp47_ = self->priv->popover;
	_tmp48_ = rect;
	gtk_popover_set_pointing_to (_tmp47_, &_tmp48_);
	_tmp49_ = self->priv->popover;
	gtk_popover_set_position (_tmp49_, GTK_POS_BOTTOM);
	_tmp50_ = self->priv->popover;
	gtk_widget_show_all ((GtkWidget*) _tmp50_);
}


static void granite_widgets_time_picker_real_position_dropdown (GraniteWidgetsTimePicker* self, gint* x, gint* y) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkAllocation size = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	gint _tmp4_;
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
	size = _tmp0_;
	_tmp1_ = size;
	_tmp2_ = _tmp1_.width;
	_vala_x = _tmp2_ - GRANITE_WIDGETS_TIME_PICKER_OFFSET;
	_tmp3_ = size;
	_tmp4_ = _tmp3_.height;
	_vala_y = _tmp4_;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}


void granite_widgets_time_picker_position_dropdown (GraniteWidgetsTimePicker* self, gint* x, gint* y) {
	g_return_if_fail (self != NULL);
	GRANITE_WIDGETS_TIME_PICKER_GET_CLASS (self)->position_dropdown (self, x, y);
}


static void granite_widgets_time_picker_is_unfocused (GraniteWidgetsTimePicker* self) {
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->popover;
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == FALSE) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		_tmp4_ = self->priv->old_string;
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_utf8_collate (_tmp4_, _tmp6_);
		_tmp0_ = _tmp7_ != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		_g_free0 (self->priv->old_string);
		self->priv->old_string = _tmp10_;
		_tmp11_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strdup (_tmp12_);
		_tmp14_ = _tmp13_;
		granite_widgets_time_picker_parse_time (self, _tmp14_);
		_g_free0 (_tmp14_);
	}
}


static gchar* string_to_utf8 (const gchar* self, int* result_length1) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (gchar, _tmp1_ + 1);
	_result_ = _tmp2_;
	_result__length1 = _tmp1_ + 1;
	__result__size_ = _result__length1;
	_tmp3_ = _result__length1;
	_result__length1 = _tmp3_ - 1;
	_tmp4_ = _result_;
	_tmp4__length1 = _result__length1;
	_tmp5_ = strlen (self);
	_tmp6_ = _tmp5_;
	memcpy (_tmp4_, self, (gsize) _tmp6_);
	_tmp7_ = _result_;
	_tmp7__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}


static gint* _int_dup (gint* self) {
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}


static gpointer __int_dup0 (gpointer self) {
	return self ? _int_dup (self) : NULL;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static void granite_widgets_time_picker_parse_time (GraniteWidgetsTimePicker* self, const gchar* timestr) {
	gchar* current = NULL;
	gchar* _tmp0_;
	gboolean is_hours = FALSE;
	gboolean is_suffix = FALSE;
	gboolean has_suffix = FALSE;
	gint* hour = NULL;
	gint* minute = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	gboolean _tmp83_ = FALSE;
	gboolean _tmp84_ = FALSE;
	gboolean _tmp85_;
	gboolean _tmp91_ = FALSE;
	gint* _tmp92_;
	gboolean _tmp94_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timestr != NULL);
	_tmp0_ = g_strdup ("");
	current = _tmp0_;
	is_hours = TRUE;
	is_suffix = FALSE;
	has_suffix = FALSE;
	hour = NULL;
	minute = NULL;
	_tmp1_ = timestr;
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
	_tmp3_ = _tmp2_;
	_tmp5_ = string_to_utf8 (_tmp3_, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_g_free0 (_tmp3_);
	{
		gchar* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = _tmp6_;
		c_collection_length1 = _tmp6__length1;
		for (c_it = 0; c_it < _tmp6__length1; c_it = c_it + 1) {
			gchar c = '\0';
			c = c_collection[c_it];
			{
				gchar _tmp7_;
				gboolean _tmp8_;
				_tmp7_ = c;
				_tmp8_ = g_ascii_isdigit (_tmp7_);
				if (_tmp8_) {
					const gchar* _tmp9_;
					gchar _tmp10_;
					gchar* _tmp11_;
					_tmp9_ = current;
					_tmp10_ = c;
					_tmp11_ = g_strdup_printf ("%s%c", _tmp9_, (gint) _tmp10_);
					_g_free0 (current);
					current = _tmp11_;
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_;
					gboolean _tmp30_ = FALSE;
					gboolean _tmp31_ = FALSE;
					gchar _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					gboolean _tmp35_;
					gboolean _tmp36_;
					gboolean _tmp45_ = FALSE;
					gchar _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					gboolean _tmp49_;
					gboolean _tmp50_;
					_tmp14_ = is_hours;
					if (_tmp14_ == TRUE) {
						gboolean _tmp15_;
						_tmp15_ = is_suffix;
						_tmp13_ = _tmp15_ == FALSE;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						const gchar* _tmp16_;
						_tmp16_ = current;
						_tmp12_ = g_strcmp0 (_tmp16_, "") != 0;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						const gchar* _tmp17_;
						gint _tmp18_;
						gint* _tmp19_;
						gchar* _tmp20_;
						is_hours = FALSE;
						_tmp17_ = current;
						_tmp18_ = atoi (_tmp17_);
						_tmp19_ = __int_dup0 (&_tmp18_);
						_g_free0 (hour);
						hour = _tmp19_;
						_tmp20_ = g_strdup ("");
						_g_free0 (current);
						current = _tmp20_;
					} else {
						gboolean _tmp21_ = FALSE;
						gboolean _tmp22_ = FALSE;
						gboolean _tmp23_;
						_tmp23_ = is_hours;
						if (_tmp23_ == FALSE) {
							gboolean _tmp24_;
							_tmp24_ = is_suffix;
							_tmp22_ = _tmp24_ == FALSE;
						} else {
							_tmp22_ = FALSE;
						}
						if (_tmp22_) {
							const gchar* _tmp25_;
							_tmp25_ = current;
							_tmp21_ = g_strcmp0 (_tmp25_, "") != 0;
						} else {
							_tmp21_ = FALSE;
						}
						if (_tmp21_) {
							const gchar* _tmp26_;
							gint _tmp27_;
							gint* _tmp28_;
							gchar* _tmp29_;
							_tmp26_ = current;
							_tmp27_ = atoi (_tmp26_);
							_tmp28_ = __int_dup0 (&_tmp27_);
							_g_free0 (minute);
							minute = _tmp28_;
							_tmp29_ = g_strdup ("");
							_g_free0 (current);
							current = _tmp29_;
						}
					}
					_tmp32_ = c;
					_tmp33_ = g_strdup_printf ("%c", _tmp32_);
					_tmp34_ = _tmp33_;
					_tmp35_ = string_contains (_tmp34_, "a");
					_tmp36_ = _tmp35_;
					_g_free0 (_tmp34_);
					if (_tmp36_) {
						_tmp31_ = TRUE;
					} else {
						gchar _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gboolean _tmp40_;
						_tmp37_ = c;
						_tmp38_ = g_strdup_printf ("%c", _tmp37_);
						_tmp39_ = _tmp38_;
						_tmp40_ = string_contains (_tmp39_, "p");
						_tmp31_ = _tmp40_;
						_g_free0 (_tmp39_);
					}
					if (_tmp31_) {
						gboolean _tmp41_;
						_tmp41_ = is_suffix;
						_tmp30_ = _tmp41_ == FALSE;
					} else {
						_tmp30_ = FALSE;
					}
					if (_tmp30_) {
						const gchar* _tmp42_;
						gchar _tmp43_;
						gchar* _tmp44_;
						is_suffix = TRUE;
						_tmp42_ = current;
						_tmp43_ = c;
						_tmp44_ = g_strdup_printf ("%s%c", _tmp42_, (gint) _tmp43_);
						_g_free0 (current);
						current = _tmp44_;
					}
					_tmp46_ = c;
					_tmp47_ = g_strdup_printf ("%c", _tmp46_);
					_tmp48_ = _tmp47_;
					_tmp49_ = string_contains (_tmp48_, "m");
					_tmp50_ = _tmp49_;
					_g_free0 (_tmp48_);
					if (_tmp50_) {
						gboolean _tmp51_;
						_tmp51_ = is_suffix;
						_tmp45_ = _tmp51_ == TRUE;
					} else {
						_tmp45_ = FALSE;
					}
					if (_tmp45_) {
						gboolean _tmp52_ = FALSE;
						gint* _tmp53_;
						gboolean _tmp55_ = FALSE;
						const gchar* _tmp56_;
						gboolean _tmp57_;
						GDateTime* _tmp75_;
						GDateTime* _tmp76_;
						gint* _tmp77_;
						GDateTime* _tmp78_;
						GDateTime* _tmp79_;
						gint _tmp80_;
						GDateTime* _tmp81_;
						GDateTime* _tmp82_;
						_tmp53_ = hour;
						if (_tmp53_ == NULL) {
							_tmp52_ = TRUE;
						} else {
							gint* _tmp54_;
							_tmp54_ = minute;
							_tmp52_ = _tmp54_ == NULL;
						}
						if (_tmp52_) {
							c_collection = (g_free (c_collection), NULL);
							_g_free0 (minute);
							_g_free0 (hour);
							_g_free0 (current);
							return;
						}
						_tmp56_ = current;
						_tmp57_ = string_contains (_tmp56_, "a");
						if (_tmp57_) {
							_tmp55_ = TRUE;
						} else {
							gint* _tmp58_;
							_tmp58_ = hour;
							_tmp55_ = (*_tmp58_) > 12;
						}
						if (_tmp55_) {
							GDateTime* _tmp59_;
							GDateTime* _tmp60_;
							gint* _tmp61_;
							GDateTime* _tmp62_;
							GDateTime* _tmp63_;
							gint _tmp64_;
							GDateTime* _tmp65_;
							GDateTime* _tmp66_;
							_tmp59_ = granite_widgets_time_picker_get_time (self);
							_tmp60_ = _tmp59_;
							_tmp61_ = hour;
							_tmp62_ = granite_widgets_time_picker_get_time (self);
							_tmp63_ = _tmp62_;
							_tmp64_ = g_date_time_get_hour (_tmp63_);
							_tmp65_ = g_date_time_add_hours (_tmp60_, (*_tmp61_) - _tmp64_);
							_tmp66_ = _tmp65_;
							granite_widgets_time_picker_set_time (self, _tmp66_);
							_g_date_time_unref0 (_tmp66_);
						} else {
							GDateTime* _tmp67_;
							GDateTime* _tmp68_;
							gint* _tmp69_;
							GDateTime* _tmp70_;
							GDateTime* _tmp71_;
							gint _tmp72_;
							GDateTime* _tmp73_;
							GDateTime* _tmp74_;
							_tmp67_ = granite_widgets_time_picker_get_time (self);
							_tmp68_ = _tmp67_;
							_tmp69_ = hour;
							_tmp70_ = granite_widgets_time_picker_get_time (self);
							_tmp71_ = _tmp70_;
							_tmp72_ = g_date_time_get_hour (_tmp71_);
							_tmp73_ = g_date_time_add_hours (_tmp68_, ((*_tmp69_) + 12) - _tmp72_);
							_tmp74_ = _tmp73_;
							granite_widgets_time_picker_set_time (self, _tmp74_);
							_g_date_time_unref0 (_tmp74_);
						}
						_tmp75_ = granite_widgets_time_picker_get_time (self);
						_tmp76_ = _tmp75_;
						_tmp77_ = minute;
						_tmp78_ = granite_widgets_time_picker_get_time (self);
						_tmp79_ = _tmp78_;
						_tmp80_ = g_date_time_get_minute (_tmp79_);
						_tmp81_ = g_date_time_add_minutes (_tmp76_, (*_tmp77_) - _tmp80_);
						_tmp82_ = _tmp81_;
						granite_widgets_time_picker_set_time (self, _tmp82_);
						_g_date_time_unref0 (_tmp82_);
						has_suffix = TRUE;
					}
				}
			}
		}
		c_collection = (g_free (c_collection), NULL);
	}
	_tmp85_ = is_hours;
	if (_tmp85_ == FALSE) {
		gboolean _tmp86_;
		_tmp86_ = is_suffix;
		_tmp84_ = _tmp86_ == FALSE;
	} else {
		_tmp84_ = FALSE;
	}
	if (_tmp84_) {
		const gchar* _tmp87_;
		_tmp87_ = current;
		_tmp83_ = g_strcmp0 (_tmp87_, "") != 0;
	} else {
		_tmp83_ = FALSE;
	}
	if (_tmp83_) {
		const gchar* _tmp88_;
		gint _tmp89_;
		gint* _tmp90_;
		_tmp88_ = current;
		_tmp89_ = atoi (_tmp88_);
		_tmp90_ = __int_dup0 (&_tmp89_);
		_g_free0 (minute);
		minute = _tmp90_;
	}
	_tmp92_ = hour;
	if (_tmp92_ == NULL) {
		_tmp91_ = TRUE;
	} else {
		gint* _tmp93_;
		_tmp93_ = minute;
		_tmp91_ = _tmp93_ == NULL;
	}
	if (_tmp91_) {
		granite_widgets_time_picker_update_text (self, FALSE);
		_g_free0 (minute);
		_g_free0 (hour);
		_g_free0 (current);
		return;
	}
	_tmp94_ = has_suffix;
	if (_tmp94_ == FALSE) {
		GDateTime* _tmp95_;
		GDateTime* _tmp96_;
		gint* _tmp97_;
		GDateTime* _tmp98_;
		GDateTime* _tmp99_;
		gint _tmp100_;
		GDateTime* _tmp101_;
		GDateTime* _tmp102_;
		GDateTime* _tmp103_;
		GDateTime* _tmp104_;
		gint* _tmp105_;
		GDateTime* _tmp106_;
		GDateTime* _tmp107_;
		gint _tmp108_;
		GDateTime* _tmp109_;
		GDateTime* _tmp110_;
		_tmp95_ = granite_widgets_time_picker_get_time (self);
		_tmp96_ = _tmp95_;
		_tmp97_ = hour;
		_tmp98_ = granite_widgets_time_picker_get_time (self);
		_tmp99_ = _tmp98_;
		_tmp100_ = g_date_time_get_hour (_tmp99_);
		_tmp101_ = g_date_time_add_hours (_tmp96_, (*_tmp97_) - _tmp100_);
		_tmp102_ = _tmp101_;
		granite_widgets_time_picker_set_time (self, _tmp102_);
		_g_date_time_unref0 (_tmp102_);
		_tmp103_ = granite_widgets_time_picker_get_time (self);
		_tmp104_ = _tmp103_;
		_tmp105_ = minute;
		_tmp106_ = granite_widgets_time_picker_get_time (self);
		_tmp107_ = _tmp106_;
		_tmp108_ = g_date_time_get_minute (_tmp107_);
		_tmp109_ = g_date_time_add_minutes (_tmp104_, (*_tmp105_) - _tmp108_);
		_tmp110_ = _tmp109_;
		granite_widgets_time_picker_set_time (self, _tmp110_);
		_g_date_time_unref0 (_tmp110_);
	}
	granite_widgets_time_picker_update_text (self, FALSE);
	_g_free0 (minute);
	_g_free0 (hour);
	_g_free0 (current);
}


static void granite_widgets_time_picker_update_text (GraniteWidgetsTimePicker* self, gboolean no_signal) {
	gboolean _tmp0_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_date_time_is_clock_format_12h ();
	if (_tmp0_) {
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = granite_widgets_time_picker_get_time (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->_format_12;
		_tmp4_ = g_date_time_format (_tmp2_, _tmp3_);
		_tmp5_ = _tmp4_;
		gtk_entry_set_text ((GtkEntry*) self, _tmp5_);
		_g_free0 (_tmp5_);
	} else {
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp6_ = granite_widgets_time_picker_get_time (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->_format_24;
		_tmp9_ = g_date_time_format (_tmp7_, _tmp8_);
		_tmp10_ = _tmp9_;
		gtk_entry_set_text ((GtkEntry*) self, _tmp10_);
		_g_free0 (_tmp10_);
	}
	_tmp11_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strdup (_tmp12_);
	_g_free0 (self->priv->old_string);
	self->priv->old_string = _tmp13_;
	_tmp14_ = no_signal;
	if (_tmp14_ == FALSE) {
		g_signal_emit (self, granite_widgets_time_picker_signals[GRANITE_WIDGETS_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
	}
}


GraniteWidgetsTimePicker* granite_widgets_time_picker_construct (GType object_type) {
	GraniteWidgetsTimePicker * self = NULL;
	self = (GraniteWidgetsTimePicker*) g_object_new (object_type, NULL);
	return self;
}


GraniteWidgetsTimePicker* granite_widgets_time_picker_new (void) {
	return granite_widgets_time_picker_construct (GRANITE_WIDGETS_TYPE_TIME_PICKER);
}


const gchar* granite_widgets_time_picker_get_format_12 (GraniteWidgetsTimePicker* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_format_12;
	result = _tmp0_;
	return result;
}


static void granite_widgets_time_picker_set_format_12 (GraniteWidgetsTimePicker* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, granite_widgets_time_picker_get_format_12 (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_format_12);
		self->priv->_format_12 = _tmp1_;
		g_object_notify ((GObject *) self, "format-12");
	}
}


const gchar* granite_widgets_time_picker_get_format_24 (GraniteWidgetsTimePicker* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_format_24;
	result = _tmp0_;
	return result;
}


static void granite_widgets_time_picker_set_format_24 (GraniteWidgetsTimePicker* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, granite_widgets_time_picker_get_format_24 (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_format_24);
		self->priv->_format_24 = _tmp1_;
		g_object_notify ((GObject *) self, "format-24");
	}
}


GDateTime* granite_widgets_time_picker_get_time (GraniteWidgetsTimePicker* self) {
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_time;
	if (_tmp0_ == NULL) {
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		_tmp1_ = g_date_time_new_now_local ();
		_tmp2_ = _tmp1_;
		granite_widgets_time_picker_set_time (self, _tmp2_);
		_g_date_time_unref0 (_tmp2_);
	}
	_tmp3_ = self->priv->_time;
	result = _tmp3_;
	return result;
}


static gpointer _g_date_time_ref0 (gpointer self) {
	return self ? g_date_time_ref (self) : NULL;
}


void granite_widgets_time_picker_set_time (GraniteWidgetsTimePicker* self, GDateTime* value) {
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
	_g_date_time_unref0 (self->priv->_time);
	self->priv->_time = _tmp1_;
	self->priv->changing_time = TRUE;
	_tmp2_ = self->priv->_time;
	_tmp3_ = g_date_time_get_hour (_tmp2_);
	if (_tmp3_ >= 12) {
		GraniteWidgetsModeButton* _tmp4_;
		_tmp4_ = self->priv->am_pm_modebutton;
		granite_widgets_mode_button_set_active (_tmp4_, 1);
	} else {
		GraniteWidgetsModeButton* _tmp5_;
		_tmp5_ = self->priv->am_pm_modebutton;
		granite_widgets_mode_button_set_active (_tmp5_, 0);
	}
	granite_widgets_time_picker_update_text (self, TRUE);
	self->priv->changing_time = FALSE;
	g_object_notify ((GObject *) self, "time");
}


static void _granite_widgets_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self) {
	granite_widgets_time_picker_on_icon_press ((GraniteWidgetsTimePicker*) self, p0, p1);
}


static void _granite_widgets_time_picker___lambda30_ (GraniteWidgetsTimePicker* self, GtkWidget* mode) {
	gboolean _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (mode != NULL);
	_tmp0_ = self->priv->changing_time;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->am_pm_modebutton;
	_tmp2_ = granite_widgets_mode_button_get_selected (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == 0) {
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		_tmp4_ = self->priv->_time;
		_tmp5_ = g_date_time_add_hours (_tmp4_, -12);
		_tmp6_ = _tmp5_;
		granite_widgets_time_picker_set_time (self, _tmp6_);
		_g_date_time_unref0 (_tmp6_);
	} else {
		GraniteWidgetsModeButton* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		_tmp7_ = self->priv->am_pm_modebutton;
		_tmp8_ = granite_widgets_mode_button_get_selected (_tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_ == 1) {
			GDateTime* _tmp10_;
			GDateTime* _tmp11_;
			GDateTime* _tmp12_;
			_tmp10_ = self->priv->_time;
			_tmp11_ = g_date_time_add_hours (_tmp10_, 12);
			_tmp12_ = _tmp11_;
			granite_widgets_time_picker_set_time (self, _tmp12_);
			_g_date_time_unref0 (_tmp12_);
		} else {
			g_assert_not_reached ();
		}
	}
	granite_widgets_time_picker_update_text (self, TRUE);
}


static void __granite_widgets_time_picker___lambda30__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender, GtkWidget* widget, gpointer self) {
	_granite_widgets_time_picker___lambda30_ ((GraniteWidgetsTimePicker*) self, widget);
}


static void _granite_widgets_time_picker___lambda31_ (GraniteWidgetsTimePicker* self) {
	granite_widgets_time_picker_update_time (self, TRUE);
}


static void __granite_widgets_time_picker___lambda31__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
	_granite_widgets_time_picker___lambda31_ ((GraniteWidgetsTimePicker*) self);
}


static void _granite_widgets_time_picker___lambda32_ (GraniteWidgetsTimePicker* self) {
	granite_widgets_time_picker_update_time (self, FALSE);
}


static void __granite_widgets_time_picker___lambda32__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
	_granite_widgets_time_picker___lambda32_ ((GraniteWidgetsTimePicker*) self);
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


static gboolean _granite_widgets_time_picker___lambda33_ (GraniteWidgetsTimePicker* self) {
	gboolean result = FALSE;
	gdouble val = 0.0;
	GtkSpinButton* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = self->priv->minutes_spinbutton;
	_tmp1_ = gtk_spin_button_get_value (_tmp0_);
	val = _tmp1_;
	_tmp2_ = val;
	if (_tmp2_ < ((gdouble) 10)) {
		GtkSpinButton* _tmp3_;
		gdouble _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp3_ = self->priv->minutes_spinbutton;
		_tmp4_ = val;
		_tmp5_ = double_to_string (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat ("0", _tmp6_, NULL);
		_tmp8_ = _tmp7_;
		gtk_entry_set_text ((GtkEntry*) _tmp3_, _tmp8_);
		_g_free0 (_tmp8_);
		_g_free0 (_tmp6_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean __granite_widgets_time_picker___lambda33__gtk_spin_button_output (GtkSpinButton* _sender, gpointer self) {
	gboolean result;
	result = _granite_widgets_time_picker___lambda33_ ((GraniteWidgetsTimePicker*) self);
	return result;
}


static gboolean _granite_widgets_time_picker___lambda34_ (GraniteWidgetsTimePicker* self) {
	gboolean result = FALSE;
	granite_widgets_time_picker_is_unfocused (self);
	result = FALSE;
	return result;
}


static gboolean __granite_widgets_time_picker___lambda34__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = _granite_widgets_time_picker___lambda34_ ((GraniteWidgetsTimePicker*) self);
	return result;
}


static gboolean _granite_widgets_time_picker___lambda35_ (GraniteWidgetsTimePicker* self, GdkEventScroll* event) {
	gboolean result = FALSE;
	GdkEventScroll* _tmp0_;
	GdkScrollDirection _tmp1_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->direction;
	switch (_tmp1_) {
		case GDK_SCROLL_UP:
		case GDK_SCROLL_RIGHT:
		{
			GDateTime* _tmp2_;
			GDateTime* _tmp3_;
			_tmp2_ = self->priv->_time;
			_tmp3_ = g_date_time_add_minutes (_tmp2_, 1);
			_g_date_time_unref0 (self->priv->_time);
			self->priv->_time = _tmp3_;
			break;
		}
		case GDK_SCROLL_DOWN:
		case GDK_SCROLL_LEFT:
		{
			GDateTime* _tmp4_;
			GDateTime* _tmp5_;
			_tmp4_ = self->priv->_time;
			_tmp5_ = g_date_time_add_minutes (_tmp4_, -1);
			_g_date_time_unref0 (self->priv->_time);
			self->priv->_time = _tmp5_;
			break;
		}
		default:
		{
			break;
		}
	}
	granite_widgets_time_picker_update_text (self, FALSE);
	result = FALSE;
	return result;
}


static gboolean __granite_widgets_time_picker___lambda35__gtk_widget_scroll_event (GtkWidget* _sender, GdkEventScroll* event, gpointer self) {
	gboolean result;
	result = _granite_widgets_time_picker___lambda35_ ((GraniteWidgetsTimePicker*) self, event);
	return result;
}


static void _granite_widgets_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender, gpointer self) {
	granite_widgets_time_picker_is_unfocused ((GraniteWidgetsTimePicker*) self);
}


static GObject * granite_widgets_time_picker_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsTimePicker * self;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	GtkGrid* pop_grid = NULL;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GraniteWidgetsModeButton* _tmp11_;
	GraniteWidgetsModeButton* _tmp12_;
	GraniteWidgetsModeButton* _tmp13_;
	GraniteWidgetsModeButton* _tmp14_;
	GraniteWidgetsModeButton* _tmp15_;
	GraniteWidgetsModeButton* _tmp16_;
	GraniteWidgetsModeButton* _tmp17_;
	gboolean _tmp18_;
	GtkSpinButton* _tmp21_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkSpinButton* _tmp25_;
	GtkSpinButton* _tmp26_;
	GtkSpinButton* _tmp27_;
	GtkSpinButton* _tmp28_;
	GtkLabel* separation_label = NULL;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkSpinButton* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	GtkSpinButton* _tmp35_;
	GtkGrid* _tmp36_;
	GraniteWidgetsModeButton* _tmp37_;
	GtkGrid* _tmp38_;
	GtkPopover* _tmp39_;
	GtkPopover* _tmp40_;
	GtkGrid* _tmp41_;
	parent_class = G_OBJECT_CLASS (granite_widgets_time_picker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePicker);
	_tmp0_ = self->priv->_format_12;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = granite_date_time_get_default_time_format (TRUE, FALSE);
		_tmp2_ = _tmp1_;
		granite_widgets_time_picker_set_format_12 (self, _tmp2_);
		_g_free0 (_tmp2_);
	}
	_tmp3_ = self->priv->_format_24;
	if (_tmp3_ == NULL) {
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = granite_date_time_get_default_time_format (FALSE, FALSE);
		_tmp5_ = _tmp4_;
		granite_widgets_time_picker_set_format_24 (self, _tmp5_);
		_g_free0 (_tmp5_);
	}
	gtk_entry_set_max_length ((GtkEntry*) self, 8);
	_tmp6_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("appointment-symbolic");
	_tmp7_ = _tmp6_;
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp7_, NULL);
	_g_object_unref0 (_tmp7_);
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) _granite_widgets_time_picker_on_icon_press_gtk_entry_icon_release, self, 0);
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp8_);
	pop_grid = _tmp8_;
	_tmp9_ = pop_grid;
	gtk_grid_set_column_spacing (_tmp9_, 6);
	_tmp10_ = pop_grid;
	gtk_grid_set_row_spacing (_tmp10_, 6);
	_tmp11_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->am_pm_modebutton);
	self->priv->am_pm_modebutton = _tmp11_;
	_tmp12_ = self->priv->am_pm_modebutton;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp12_, GTK_ORIENTATION_VERTICAL);
	_tmp13_ = self->priv->am_pm_modebutton;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp13_, TRUE);
	_tmp14_ = self->priv->am_pm_modebutton;
	granite_widgets_mode_button_append_text (_tmp14_, _ ("AM"));
	_tmp15_ = self->priv->am_pm_modebutton;
	granite_widgets_mode_button_append_text (_tmp15_, _ ("PM"));
	_tmp16_ = self->priv->am_pm_modebutton;
	g_signal_connect_object (_tmp16_, "mode-changed", (GCallback) __granite_widgets_time_picker___lambda30__granite_widgets_mode_button_mode_changed, self, 0);
	_tmp17_ = self->priv->am_pm_modebutton;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
	_tmp18_ = granite_date_time_is_clock_format_12h ();
	if (_tmp18_) {
		GtkSpinButton* _tmp19_;
		_tmp19_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
		g_object_ref_sink (_tmp19_);
		_g_object_unref0 (self->priv->hours_spinbutton);
		self->priv->hours_spinbutton = _tmp19_;
	} else {
		GtkSpinButton* _tmp20_;
		_tmp20_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
		g_object_ref_sink (_tmp20_);
		_g_object_unref0 (self->priv->hours_spinbutton);
		self->priv->hours_spinbutton = _tmp20_;
	}
	_tmp21_ = self->priv->hours_spinbutton;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp21_, GTK_ORIENTATION_VERTICAL);
	_tmp22_ = self->priv->hours_spinbutton;
	gtk_spin_button_set_wrap (_tmp22_, TRUE);
	_tmp23_ = self->priv->hours_spinbutton;
	g_signal_connect_object (_tmp23_, "value-changed", (GCallback) __granite_widgets_time_picker___lambda31__gtk_spin_button_value_changed, self, 0);
	_tmp24_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->minutes_spinbutton);
	self->priv->minutes_spinbutton = _tmp24_;
	_tmp25_ = self->priv->minutes_spinbutton;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp25_, GTK_ORIENTATION_VERTICAL);
	_tmp26_ = self->priv->minutes_spinbutton;
	gtk_spin_button_set_wrap (_tmp26_, TRUE);
	_tmp27_ = self->priv->minutes_spinbutton;
	g_signal_connect_object (_tmp27_, "value-changed", (GCallback) __granite_widgets_time_picker___lambda32__gtk_spin_button_value_changed, self, 0);
	_tmp28_ = self->priv->minutes_spinbutton;
	g_signal_connect_object (_tmp28_, "output", (GCallback) __granite_widgets_time_picker___lambda33__gtk_spin_button_output, self, 0);
	_tmp29_ = (GtkLabel*) gtk_label_new (_ (":"));
	g_object_ref_sink (_tmp29_);
	separation_label = _tmp29_;
	_tmp30_ = pop_grid;
	_tmp31_ = self->priv->hours_spinbutton;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 0, 1, 1);
	_tmp32_ = pop_grid;
	_tmp33_ = separation_label;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 1, 0, 1, 1);
	_tmp34_ = pop_grid;
	_tmp35_ = self->priv->minutes_spinbutton;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 2, 0, 1, 1);
	_tmp36_ = pop_grid;
	_tmp37_ = self->priv->am_pm_modebutton;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 3, 0, 1, 1);
	_tmp38_ = pop_grid;
	g_object_set ((GtkWidget*) _tmp38_, "margin", GRANITE_WIDGETS_TIME_PICKER_MARGIN, NULL);
	_tmp39_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp39_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp39_;
	_tmp40_ = self->priv->popover;
	_tmp41_ = pop_grid;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_FOCUS_CHANGE_MASK | GDK_SCROLL_MASK));
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __granite_widgets_time_picker___lambda34__gtk_widget_focus_out_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) __granite_widgets_time_picker___lambda35__gtk_widget_scroll_event, self, 0);
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) _granite_widgets_time_picker_is_unfocused_gtk_entry_activate, self, 0);
	granite_widgets_time_picker_update_text (self, FALSE);
	_g_object_unref0 (separation_label);
	_g_object_unref0 (pop_grid);
	return obj;
}


static void granite_widgets_time_picker_class_init (GraniteWidgetsTimePickerClass * klass) {
	granite_widgets_time_picker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsTimePickerPrivate));
	((GraniteWidgetsTimePickerClass *) klass)->position_dropdown = (void (*) (GraniteWidgetsTimePicker *, gint*, gint*)) granite_widgets_time_picker_real_position_dropdown;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_time_picker_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_time_picker_set_property;
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_time_picker_constructor;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_time_picker_finalize;
	/**
	         * Format used in 12h mode
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TIME_PICKER_FORMAT_12, g_param_spec_string ("format-12", "format-12", "format-12", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * Format used in 24h mode
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TIME_PICKER_FORMAT_24, g_param_spec_string ("format-24", "format-24", "format-24", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * Current time
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TIME_PICKER_TIME, g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Sent when the time got changed
	         */
	granite_widgets_time_picker_signals[GRANITE_WIDGETS_TIME_PICKER_TIME_CHANGED_SIGNAL] = g_signal_new ("time_changed", GRANITE_WIDGETS_TYPE_TIME_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_time_picker_instance_init (GraniteWidgetsTimePicker * self) {
	gchar* _tmp0_;
	self->priv = GRANITE_WIDGETS_TIME_PICKER_GET_PRIVATE (self);
	self->priv->_time = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->old_string = _tmp0_;
	self->priv->changing_time = FALSE;
}


static void granite_widgets_time_picker_finalize (GObject * obj) {
	GraniteWidgetsTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePicker);
	_g_free0 (self->priv->_format_12);
	_g_free0 (self->priv->_format_24);
	_g_date_time_unref0 (self->priv->_time);
	_g_free0 (self->priv->old_string);
	_g_object_unref0 (self->priv->hours_spinbutton);
	_g_object_unref0 (self->priv->minutes_spinbutton);
	_g_object_unref0 (self->priv->am_pm_modebutton);
	_g_object_unref0 (self->priv->popover);
	G_OBJECT_CLASS (granite_widgets_time_picker_parent_class)->finalize (obj);
}


/**
     * This widget allows users to easily pick a time.
     */
GType granite_widgets_time_picker_get_type (void) {
	static volatile gsize granite_widgets_time_picker_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_time_picker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsTimePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_time_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsTimePicker), 0, (GInstanceInitFunc) granite_widgets_time_picker_instance_init, NULL };
		GType granite_widgets_time_picker_type_id;
		granite_widgets_time_picker_type_id = g_type_register_static (gtk_entry_get_type (), "GraniteWidgetsTimePicker", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_time_picker_type_id__volatile, granite_widgets_time_picker_type_id);
	}
	return granite_widgets_time_picker_type_id__volatile;
}


static void _vala_granite_widgets_time_picker_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePicker);
	switch (property_id) {
		case GRANITE_WIDGETS_TIME_PICKER_FORMAT_12:
		g_value_set_string (value, granite_widgets_time_picker_get_format_12 (self));
		break;
		case GRANITE_WIDGETS_TIME_PICKER_FORMAT_24:
		g_value_set_string (value, granite_widgets_time_picker_get_format_24 (self));
		break;
		case GRANITE_WIDGETS_TIME_PICKER_TIME:
		g_value_set_boxed (value, granite_widgets_time_picker_get_time (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_time_picker_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TIME_PICKER, GraniteWidgetsTimePicker);
	switch (property_id) {
		case GRANITE_WIDGETS_TIME_PICKER_FORMAT_12:
		granite_widgets_time_picker_set_format_12 (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_TIME_PICKER_FORMAT_24:
		granite_widgets_time_picker_set_format_24 (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_TIME_PICKER_TIME:
		granite_widgets_time_picker_set_time (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



