/* Toast.c generated by valac 0.36.4, the Vala compiler
 * generated from Toast.vala, do not modify */

/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Artem Anufrij <artem.anufrij@live.de>
 *              Daniel Foré <daniel@elementary.io>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define GRANITE_WIDGETS_TYPE_TOAST (granite_widgets_toast_get_type ())
#define GRANITE_WIDGETS_TOAST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToast))
#define GRANITE_WIDGETS_TOAST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToastClass))
#define GRANITE_WIDGETS_IS_TOAST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_TOAST))
#define GRANITE_WIDGETS_IS_TOAST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_TOAST))
#define GRANITE_WIDGETS_TOAST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToastClass))

typedef struct _GraniteWidgetsToast GraniteWidgetsToast;
typedef struct _GraniteWidgetsToastClass GraniteWidgetsToastClass;
typedef struct _GraniteWidgetsToastPrivate GraniteWidgetsToastPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GRANITE_WIDGETS_TOAST_CLOSED_SIGNAL,
	GRANITE_WIDGETS_TOAST_DEFAULT_ACTION_SIGNAL,
	GRANITE_WIDGETS_TOAST_LAST_SIGNAL
};
static guint granite_widgets_toast_signals[GRANITE_WIDGETS_TOAST_LAST_SIGNAL] = {0};

struct _GraniteWidgetsToast {
	GtkRevealer parent_instance;
	GraniteWidgetsToastPrivate * priv;
};

struct _GraniteWidgetsToastClass {
	GtkRevealerClass parent_class;
};

struct _GraniteWidgetsToastPrivate {
	GtkLabel* notification_label;
	GtkButton* default_action_button;
	gchar* _title;
};


static gpointer granite_widgets_toast_parent_class = NULL;

GType granite_widgets_toast_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_TOAST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToastPrivate))
enum  {
	GRANITE_WIDGETS_TOAST_DUMMY_PROPERTY,
	GRANITE_WIDGETS_TOAST_TITLE
};
GraniteWidgetsToast* granite_widgets_toast_new (const gchar* title);
GraniteWidgetsToast* granite_widgets_toast_construct (GType object_type, const gchar* title);
void granite_widgets_toast_set_default_action (GraniteWidgetsToast* self, const gchar* label);
void granite_widgets_toast_send_notification (GraniteWidgetsToast* self);
const gchar* granite_widgets_toast_get_title (GraniteWidgetsToast* self);
void granite_widgets_toast_set_title (GraniteWidgetsToast* self, const gchar* value);
static GObject * granite_widgets_toast_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _granite_widgets_toast___lambda66_ (GraniteWidgetsToast* self);
static void __granite_widgets_toast___lambda66__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _granite_widgets_toast___lambda67_ (GraniteWidgetsToast* self);
static void __granite_widgets_toast___lambda67__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void granite_widgets_toast_finalize (GObject * obj);
static void _vala_granite_widgets_toast_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_toast_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
         * Creates a new Toast with #title as its title
         */
GraniteWidgetsToast* granite_widgets_toast_construct (GType object_type, const gchar* title) {
	GraniteWidgetsToast * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (title != NULL, NULL);
	_tmp0_ = title;
	self = (GraniteWidgetsToast*) g_object_new (object_type, "title", _tmp0_, NULL);
	return self;
}


GraniteWidgetsToast* granite_widgets_toast_new (const gchar* title) {
	return granite_widgets_toast_construct (GRANITE_WIDGETS_TYPE_TOAST, title);
}


/**
         * Sets the default action button label of #this to #label and hides the
         * button if #label is #null.
         */
void granite_widgets_toast_set_default_action (GraniteWidgetsToast* self, const gchar* label) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GtkButton* _tmp7_;
	const gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp1_ = label;
	if (g_strcmp0 (_tmp1_, "") == 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = label;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		GtkButton* _tmp3_;
		GtkButton* _tmp4_;
		_tmp3_ = self->priv->default_action_button;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp3_, TRUE);
		_tmp4_ = self->priv->default_action_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
	} else {
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
		_tmp5_ = self->priv->default_action_button;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
		_tmp6_ = self->priv->default_action_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	}
	_tmp7_ = self->priv->default_action_button;
	_tmp8_ = label;
	gtk_button_set_label (_tmp7_, _tmp8_);
}


/**
         * Sends the Toast on behalf of #this
         */
void granite_widgets_toast_send_notification (GraniteWidgetsToast* self) {
	g_return_if_fail (self != NULL);
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
}


const gchar* granite_widgets_toast_get_title (GraniteWidgetsToast* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}


void granite_widgets_toast_set_title (GraniteWidgetsToast* self, const gchar* value) {
	GtkLabel* _tmp0_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->notification_label;
	if (_tmp0_ != NULL) {
		GtkLabel* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = self->priv->notification_label;
		_tmp2_ = value;
		gtk_label_set_label (_tmp1_, _tmp2_);
	}
	_tmp3_ = value;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (self->priv->_title);
	self->priv->_title = _tmp4_;
	g_object_notify ((GObject *) self, "title");
}


static void _granite_widgets_toast___lambda66_ (GraniteWidgetsToast* self) {
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, FALSE);
	g_signal_emit (self, granite_widgets_toast_signals[GRANITE_WIDGETS_TOAST_DEFAULT_ACTION_SIGNAL], 0);
}


static void __granite_widgets_toast___lambda66__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_granite_widgets_toast___lambda66_ ((GraniteWidgetsToast*) self);
}


static void _granite_widgets_toast___lambda67_ (GraniteWidgetsToast* self) {
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, FALSE);
	g_signal_emit (self, granite_widgets_toast_signals[GRANITE_WIDGETS_TOAST_CLOSED_SIGNAL], 0);
}


static void __granite_widgets_toast___lambda67__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_granite_widgets_toast___lambda67_ ((GraniteWidgetsToast*) self);
}


static GObject * granite_widgets_toast_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsToast * self;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkButton* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGrid* notification_box = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkButton* _tmp14_;
	GtkGrid* _tmp15_;
	GtkLabel* _tmp16_;
	GtkGrid* _tmp17_;
	GtkButton* _tmp18_;
	GtkFrame* notification_frame = NULL;
	GtkFrame* _tmp19_;
	GtkFrame* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkFrame* _tmp22_;
	GtkGrid* _tmp23_;
	GtkFrame* _tmp24_;
	parent_class = G_OBJECT_CLASS (granite_widgets_toast_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToast);
	g_object_set ((GtkWidget*) self, "margin", 3, NULL);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
	_tmp0_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->default_action_button);
	self->priv->default_action_button = _tmp0_;
	_tmp1_ = self->priv->default_action_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = self->priv->default_action_button;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->priv->default_action_button;
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) __granite_widgets_toast___lambda66__gtk_button_clicked, self, 0);
	_tmp4_ = (GtkButton*) gtk_button_new_from_icon_name ("close-symbolic", GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp4_);
	close_button = _tmp4_;
	_tmp5_ = close_button;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "close-button");
	_tmp7_ = close_button;
	g_signal_connect_object (_tmp7_, "clicked", (GCallback) __granite_widgets_toast___lambda67__gtk_button_clicked, self, 0);
	_tmp8_ = granite_widgets_toast_get_title (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = (GtkLabel*) gtk_label_new (_tmp9_);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->notification_label);
	self->priv->notification_label = _tmp10_;
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp11_);
	notification_box = _tmp11_;
	_tmp12_ = notification_box;
	gtk_grid_set_column_spacing (_tmp12_, 12);
	_tmp13_ = notification_box;
	_tmp14_ = close_button;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = notification_box;
	_tmp16_ = self->priv->notification_label;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = notification_box;
	_tmp18_ = self->priv->default_action_button;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp19_);
	notification_frame = _tmp19_;
	_tmp20_ = notification_frame;
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
	gtk_style_context_add_class (_tmp21_, "app-notification");
	_tmp22_ = notification_frame;
	_tmp23_ = notification_box;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = notification_frame;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
	_g_object_unref0 (notification_frame);
	_g_object_unref0 (notification_box);
	_g_object_unref0 (close_button);
	return obj;
}


static void granite_widgets_toast_class_init (GraniteWidgetsToastClass * klass) {
	granite_widgets_toast_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsToastPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_toast_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_toast_set_property;
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_toast_constructor;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_toast_finalize;
	/**
	         * The notification text label to be displayed inside of #this
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TOAST_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	         * Emitted when the Toast is closed by activating the close button
	         */
	granite_widgets_toast_signals[GRANITE_WIDGETS_TOAST_CLOSED_SIGNAL] = g_signal_new ("closed", GRANITE_WIDGETS_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	         * Emitted when the default action button is activated
	         */
	granite_widgets_toast_signals[GRANITE_WIDGETS_TOAST_DEFAULT_ACTION_SIGNAL] = g_signal_new ("default_action", GRANITE_WIDGETS_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_toast_instance_init (GraniteWidgetsToast * self) {
	self->priv = GRANITE_WIDGETS_TOAST_GET_PRIVATE (self);
}


static void granite_widgets_toast_finalize (GObject * obj) {
	GraniteWidgetsToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToast);
	_g_object_unref0 (self->priv->notification_label);
	_g_object_unref0 (self->priv->default_action_button);
	_g_free0 (self->priv->_title);
	G_OBJECT_CLASS (granite_widgets_toast_parent_class)->finalize (obj);
}


GType granite_widgets_toast_get_type (void) {
	static volatile gsize granite_widgets_toast_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_toast_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsToastClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_toast_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsToast), 0, (GInstanceInitFunc) granite_widgets_toast_instance_init, NULL };
		GType granite_widgets_toast_type_id;
		granite_widgets_toast_type_id = g_type_register_static (gtk_revealer_get_type (), "GraniteWidgetsToast", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_toast_type_id__volatile, granite_widgets_toast_type_id);
	}
	return granite_widgets_toast_type_id__volatile;
}


static void _vala_granite_widgets_toast_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToast);
	switch (property_id) {
		case GRANITE_WIDGETS_TOAST_TITLE:
		g_value_set_string (value, granite_widgets_toast_get_title (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_toast_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOAST, GraniteWidgetsToast);
	switch (property_id) {
		case GRANITE_WIDGETS_TOAST_TITLE:
		granite_widgets_toast_set_title (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



