/* ToolButtonWithMenu.c generated by valac 0.36.4, the Vala compiler
 * generated from ToolButtonWithMenu.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Mathijs Henquet
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 *
 *  Authors: Mathijs Henquet <mathijs.henquet@gmail.com>,
 *           ammonkey <am.monkeyd@gmail.com>
 */
/*
 * ToolButtonWithMenu
 * - support long click / right click with depressed button states
 * - activate a GtkAction if any or popup a menu.
 * (used in history navigation buttons next/prev, appmenu)
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>


#define GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU (granite_widgets_tool_button_with_menu_get_type ())
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu))
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuClass))
#define GRANITE_WIDGETS_IS_TOOL_BUTTON_WITH_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU))
#define GRANITE_WIDGETS_IS_TOOL_BUTTON_WITH_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU))
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuClass))

typedef struct _GraniteWidgetsToolButtonWithMenu GraniteWidgetsToolButtonWithMenu;
typedef struct _GraniteWidgetsToolButtonWithMenuClass GraniteWidgetsToolButtonWithMenuClass;
typedef struct _GraniteWidgetsToolButtonWithMenuPrivate GraniteWidgetsToolButtonWithMenuPrivate;

#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_TYPE_HMENU_POSITION (granite_widgets_tool_button_with_menu_hmenu_position_get_type ())

#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_TYPE_VMENU_POSITION (granite_widgets_tool_button_with_menu_vmenu_position_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GdkEventButton_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventButton_free (var), NULL)))
typedef struct _Block10Data Block10Data;
enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_RIGHT_CLICK_SIGNAL,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_LAST_SIGNAL
};
static guint granite_widgets_tool_button_with_menu_signals[GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_LAST_SIGNAL] = {0};

struct _GraniteWidgetsToolButtonWithMenu {
	GtkToggleToolButton parent_instance;
	GraniteWidgetsToolButtonWithMenuPrivate * priv;
	GtkAction* myaction;
	gulong toggled_sig_id;
};

struct _GraniteWidgetsToolButtonWithMenuClass {
	GtkToggleToolButtonClass parent_class;
};

typedef enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_LEFT,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_RIGHT,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_INSIDE_WINDOW
} GraniteWidgetsToolButtonWithMenuHMenuPosition;

typedef enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_TOP,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_BOTTOM
} GraniteWidgetsToolButtonWithMenuVMenuPosition;

typedef GtkMenu* (*GraniteWidgetsToolButtonWithMenuMenuFetcher) (void* user_data);
struct _GraniteWidgetsToolButtonWithMenuPrivate {
	GraniteWidgetsToolButtonWithMenuHMenuPosition _horizontal_menu_position;
	GraniteWidgetsToolButtonWithMenuVMenuPosition _vertical_menu_position;
	guint LONG_PRESS_TIME;
	guint timeout_id;
	guint last_click_time;
	gboolean has_fetcher;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _fetcher;
	gpointer _fetcher_target;
	GtkMenu* _menu;
	GtkButton* button;
};

struct _Block10Data {
	int _ref_count_;
	GraniteWidgetsToolButtonWithMenu* self;
	GdkEventButton* ev;
};


static gpointer granite_widgets_tool_button_with_menu_parent_class = NULL;

GType granite_widgets_tool_button_with_menu_get_type (void) G_GNUC_CONST;
GType granite_widgets_tool_button_with_menu_hmenu_position_get_type (void) G_GNUC_CONST;
GType granite_widgets_tool_button_with_menu_vmenu_position_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuPrivate))
enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_DUMMY_PROPERTY,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HORIZONTAL_MENU_POSITION,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VERTICAL_MENU_POSITION,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU
};
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_action (GtkAction* action);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_action (GType object_type, GtkAction* action);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_stock (const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_stock (GType object_type, const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new (GtkImage* image, const gchar* label, GtkMenu* menu);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct (GType object_type, GtkImage* image, const gchar* label, GtkMenu* menu);
static void granite_widgets_tool_button_with_menu_update_menu_properties (GraniteWidgetsToolButtonWithMenu* self);
GtkMenu* granite_widgets_tool_button_with_menu_get_menu (GraniteWidgetsToolButtonWithMenu* self);
static void __lambda16_ (GraniteWidgetsToolButtonWithMenu* self);
static void granite_widgets_tool_button_with_menu_deactivate_menu (GraniteWidgetsToolButtonWithMenu* self);
static void ___lambda16__gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self);
void granite_widgets_tool_button_with_menu_popdown_menu (GraniteWidgetsToolButtonWithMenu* self);
static void _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self);
void granite_widgets_tool_button_with_menu_set_menu (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* value);
static gboolean granite_widgets_tool_button_with_menu_on_mnemonic_activate (GraniteWidgetsToolButtonWithMenu* self, gboolean group_cycling);
static gboolean _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self);
static gboolean granite_widgets_tool_button_with_menu_on_button_press_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static gboolean _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean granite_widgets_tool_button_with_menu_on_button_release_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static gboolean _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void granite_widgets_tool_button_with_menu_real_show_all (GtkWidget* base);
static void granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
void granite_widgets_tool_button_with_menu_popup_menu (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self);
static void _vala_GdkEventButton_free (GdkEventButton* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ___lambda17_ (Block10Data* _data10_);
static gboolean ____lambda17__gsource_func (gpointer self);
static void granite_widgets_tool_button_with_menu_fetch_menu (GraniteWidgetsToolButtonWithMenu* self);
static void granite_widgets_tool_button_with_menu_get_menu_position (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in);
static void _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
GraniteWidgetsToolButtonWithMenuMenuFetcher granite_widgets_tool_button_with_menu_get_fetcher (GraniteWidgetsToolButtonWithMenu* self, gpointer* result_target);
GraniteWidgetsToolButtonWithMenuHMenuPosition granite_widgets_tool_button_with_menu_get_horizontal_menu_position (GraniteWidgetsToolButtonWithMenu* self);
GraniteWidgetsToolButtonWithMenuVMenuPosition granite_widgets_tool_button_with_menu_get_vertical_menu_position (GraniteWidgetsToolButtonWithMenu* self);
void granite_widgets_tool_button_with_menu_set_horizontal_menu_position (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuHMenuPosition value);
void granite_widgets_tool_button_with_menu_set_vertical_menu_position (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuVMenuPosition value);
void granite_widgets_tool_button_with_menu_set_fetcher (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuMenuFetcher value, gpointer value_target);
static void granite_widgets_tool_button_with_menu_finalize (GObject * obj);
static void _vala_granite_widgets_tool_button_with_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_tool_button_with_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
         * VMenuPosition:
         */
GType granite_widgets_tool_button_with_menu_vmenu_position_get_type (void) {
	static volatile gsize granite_widgets_tool_button_with_menu_vmenu_position_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_tool_button_with_menu_vmenu_position_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_TOP, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_TOP", "top"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_BOTTOM, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_BOTTOM", "bottom"}, {0, NULL, NULL}};
		GType granite_widgets_tool_button_with_menu_vmenu_position_type_id;
		granite_widgets_tool_button_with_menu_vmenu_position_type_id = g_enum_register_static ("GraniteWidgetsToolButtonWithMenuVMenuPosition", values);
		g_once_init_leave (&granite_widgets_tool_button_with_menu_vmenu_position_type_id__volatile, granite_widgets_tool_button_with_menu_vmenu_position_type_id);
	}
	return granite_widgets_tool_button_with_menu_vmenu_position_type_id__volatile;
}


/**
         * HMenuPosition:
         */
GType granite_widgets_tool_button_with_menu_hmenu_position_get_type (void) {
	static volatile gsize granite_widgets_tool_button_with_menu_hmenu_position_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_tool_button_with_menu_hmenu_position_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_LEFT, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_LEFT", "left"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER", "center"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_RIGHT, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_RIGHT", "right"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_INSIDE_WINDOW, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_INSIDE_WINDOW", "inside-window"}, {0, NULL, NULL}};
		GType granite_widgets_tool_button_with_menu_hmenu_position_type_id;
		granite_widgets_tool_button_with_menu_hmenu_position_type_id = g_enum_register_static ("GraniteWidgetsToolButtonWithMenuHMenuPosition", values);
		g_once_init_leave (&granite_widgets_tool_button_with_menu_hmenu_position_type_id__volatile, granite_widgets_tool_button_with_menu_hmenu_position_type_id);
	}
	return granite_widgets_tool_button_with_menu_hmenu_position_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_action (GType object_type, GtkAction* action) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	GtkAction* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkAction* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkAction* _tmp8_;
	GtkAction* _tmp9_;
	GtkAction* _tmp10_;
	GtkAction* _tmp11_;
	g_return_val_if_fail (action != NULL, NULL);
	_tmp0_ = action;
	_tmp1_ = gtk_action_get_stock_id (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = action;
	_tmp4_ = gtk_action_get_label (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	self = (GraniteWidgetsToolButtonWithMenu*) granite_widgets_tool_button_with_menu_construct_from_stock (object_type, _tmp2_, GTK_ICON_SIZE_MENU, _tmp5_, _tmp7_);
	_g_object_unref0 (_tmp7_);
	gtk_activatable_set_use_action_appearance ((GtkActivatable*) self, TRUE);
	_tmp8_ = action;
	gtk_activatable_set_related_action ((GtkActivatable*) self, _tmp8_);
	_tmp9_ = action;
	GTK_ACTION_GET_CLASS (_tmp9_)->connect_proxy (_tmp9_, (GtkWidget*) self);
	_tmp10_ = action;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (self->myaction);
	self->myaction = _tmp11_;
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_action (GtkAction* action) {
	return granite_widgets_tool_button_with_menu_construct_from_action (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, action);
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_stock (GType object_type, const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	GtkImage* image = NULL;
	const gchar* _tmp0_;
	GtkIconSize _tmp1_;
	GtkImage* _tmp2_;
	const gchar* _tmp3_;
	GtkMenu* _tmp4_;
	g_return_val_if_fail (stock_image != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (menu != NULL, NULL);
	_tmp0_ = stock_image;
	_tmp1_ = size;
	_tmp2_ = (GtkImage*) gtk_image_new_from_stock (_tmp0_, _tmp1_);
	g_object_ref_sink (_tmp2_);
	image = _tmp2_;
	_tmp3_ = label;
	_tmp4_ = menu;
	self = (GraniteWidgetsToolButtonWithMenu*) granite_widgets_tool_button_with_menu_construct (object_type, image, _tmp3_, _tmp4_);
	_g_object_unref0 (image);
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_stock (const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu) {
	return granite_widgets_tool_button_with_menu_construct_from_stock (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, stock_image, size, label, menu);
}


static void __lambda16_ (GraniteWidgetsToolButtonWithMenu* self) {
	granite_widgets_tool_button_with_menu_deactivate_menu (self);
}


static void ___lambda16__gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self) {
	__lambda16_ ((GraniteWidgetsToolButtonWithMenu*) self);
}


static void _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self) {
	granite_widgets_tool_button_with_menu_popdown_menu ((GraniteWidgetsToolButtonWithMenu*) self);
}


static void granite_widgets_tool_button_with_menu_update_menu_properties (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenu* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_menu_attach_to_widget (_tmp1_, (GtkWidget*) self, NULL);
	_tmp2_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((GtkMenuShell*) _tmp3_, "deactivate", (GCallback) ___lambda16__gtk_menu_shell_deactivate, self, 0);
	_tmp4_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp5_ = _tmp4_;
	g_signal_connect_object ((GtkMenuShell*) _tmp5_, "deactivate", (GCallback) _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate, self, 0);
}


static gboolean _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_mnemonic_activate ((GraniteWidgetsToolButtonWithMenu*) self, group_cycling);
	return result;
}


static gboolean _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_button_press_event ((GraniteWidgetsToolButtonWithMenu*) self, event);
	return result;
}


static gboolean _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_button_release_event ((GraniteWidgetsToolButtonWithMenu*) self, event);
	return result;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct (GType object_type, GtkImage* image, const gchar* label, GtkMenu* menu) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	const gchar* _tmp6_;
	GtkMenu* _tmp7_;
	GtkWidget* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GdkEventMask _tmp12_;
	GdkEventMask _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	g_return_val_if_fail (image != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (menu != NULL, NULL);
	self = (GraniteWidgetsToolButtonWithMenu*) g_object_new (object_type, NULL);
	_tmp0_ = image;
	gtk_tool_button_set_icon_widget ((GtkToolButton*) self, (GtkWidget*) _tmp0_);
	_tmp1_ = label;
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	gtk_tool_button_set_label_widget ((GtkToolButton*) self, (GtkWidget*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = gtk_tool_button_get_label_widget ((GtkToolButton*) self);
	_tmp5_ = _tmp4_;
	gtk_label_set_use_underline (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp5_) : NULL, TRUE);
	g_object_set ((GtkWidget*) self, "can-focus", TRUE, NULL);
	_tmp6_ = label;
	gtk_tool_item_set_tooltip_text ((GtkToolItem*) self, _tmp6_);
	_tmp7_ = menu;
	granite_widgets_tool_button_with_menu_set_menu (self, _tmp7_);
	g_signal_connect_object ((GtkWidget*) self, "mnemonic-activate", (GCallback) _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate, self, 0);
	_tmp8_ = gtk_bin_get_child ((GtkBin*) self);
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_button_get_type ()) ? ((GtkButton*) _tmp8_) : NULL);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp9_;
	_tmp10_ = self->priv->button;
	_tmp11_ = self->priv->button;
	_tmp12_ = gtk_widget_get_events ((GtkWidget*) _tmp11_);
	_tmp13_ = _tmp12_;
	gtk_widget_set_events ((GtkWidget*) _tmp11_, _tmp13_ | (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
	_tmp14_ = self->priv->button;
	g_signal_connect_object ((GtkWidget*) _tmp14_, "button-press-event", (GCallback) _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event, self, 0);
	_tmp15_ = self->priv->button;
	g_signal_connect_object ((GtkWidget*) _tmp15_, "button-release-event", (GCallback) _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event, self, 0);
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new (GtkImage* image, const gchar* label, GtkMenu* menu) {
	return granite_widgets_tool_button_with_menu_construct (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, image, label, menu);
}


static void granite_widgets_tool_button_with_menu_real_show_all (GtkWidget* base) {
	GraniteWidgetsToolButtonWithMenu * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	self = (GraniteWidgetsToolButtonWithMenu*) base;
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
	GTK_WIDGET_CLASS (granite_widgets_tool_button_with_menu_parent_class)->show_all ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_tool_button_get_type (), GtkToggleToolButton));
}


static void granite_widgets_tool_button_with_menu_deactivate_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkAction* _tmp0_;
	GtkAction* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->myaction;
	if (_tmp0_ != NULL) {
		GtkAction* _tmp1_;
		_tmp1_ = self->myaction;
		gtk_action_block_activate (_tmp1_);
	}
	gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, FALSE);
	_tmp2_ = self->myaction;
	if (_tmp2_ != NULL) {
		GtkAction* _tmp3_;
		_tmp3_ = self->myaction;
		gtk_action_unblock_activate (_tmp3_);
	}
}


static void granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	GtkAction* _tmp0_;
	GtkAction* _tmp2_;
	GdkEventButton* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->myaction;
	if (_tmp0_ != NULL) {
		GtkAction* _tmp1_;
		_tmp1_ = self->myaction;
		gtk_action_block_activate (_tmp1_);
	}
	gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, TRUE);
	_tmp2_ = self->myaction;
	if (_tmp2_ != NULL) {
		GtkAction* _tmp3_;
		_tmp3_ = self->myaction;
		gtk_action_unblock_activate (_tmp3_);
	}
	_tmp4_ = ev;
	granite_widgets_tool_button_with_menu_popup_menu (self, _tmp4_);
}


static gboolean granite_widgets_tool_button_with_menu_on_button_release_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	guint32 _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp7_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	_tmp0_ = ev;
	_tmp1_ = _tmp0_->time;
	_tmp2_ = self->priv->last_click_time;
	_tmp3_ = self->priv->LONG_PRESS_TIME;
	if ((_tmp1_ - _tmp2_) < ((guint32) _tmp3_)) {
		GtkAction* _tmp4_;
		_tmp4_ = self->myaction;
		if (_tmp4_ != NULL) {
			GtkAction* _tmp5_;
			_tmp5_ = self->myaction;
			gtk_action_activate (_tmp5_);
		} else {
			GdkEventButton* _tmp6_;
			gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, TRUE);
			_tmp6_ = ev;
			granite_widgets_tool_button_with_menu_popup_menu (self, _tmp6_);
		}
	}
	_tmp7_ = self->priv->timeout_id;
	if (_tmp7_ > 0U) {
		guint _tmp8_;
		_tmp8_ = self->priv->timeout_id;
		g_source_remove (_tmp8_);
		self->priv->timeout_id = 0U;
	}
	result = TRUE;
	return result;
}


static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self) {
	return g_boxed_copy (gdk_event_get_type (), self);
}


static gpointer __vala_GdkEventButton_copy0 (gpointer self) {
	return self ? _vala_GdkEventButton_copy (self) : NULL;
}


static void _vala_GdkEventButton_free (GdkEventButton* self) {
	g_boxed_free (gdk_event_get_type (), self);
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		GraniteWidgetsToolButtonWithMenu* self;
		self = _data10_->self;
		__vala_GdkEventButton_free0 (_data10_->ev);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}


static gboolean ___lambda17_ (Block10Data* _data10_) {
	GraniteWidgetsToolButtonWithMenu* self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	self = _data10_->self;
	self->priv->timeout_id = 0U;
	_tmp0_ = _data10_->ev;
	granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (self, _tmp0_);
	result = FALSE;
	return result;
}


static gboolean ____lambda17__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda17_ (self);
	return result;
}


static gboolean granite_widgets_tool_button_with_menu_on_button_press_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean result = FALSE;
	Block10Data* _data10_;
	GdkEventButton* _tmp0_;
	GdkEventButton* _tmp1_;
	guint _tmp2_ = 0U;
	GtkAction* _tmp3_;
	guint max_press_time = 0U;
	gboolean _tmp5_ = FALSE;
	guint _tmp6_;
	GdkEventButton* _tmp13_;
	guint _tmp14_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = ev;
	_tmp1_ = __vala_GdkEventButton_copy0 (_tmp0_);
	__vala_GdkEventButton_free0 (_data10_->ev);
	_data10_->ev = _tmp1_;
	_tmp3_ = self->myaction;
	if (_tmp3_ != NULL) {
		guint _tmp4_;
		_tmp4_ = self->priv->LONG_PRESS_TIME;
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = 0U;
	}
	max_press_time = _tmp2_;
	_tmp6_ = self->priv->timeout_id;
	if (_tmp6_ == 0U) {
		GdkEventButton* _tmp7_;
		guint _tmp8_;
		_tmp7_ = _data10_->ev;
		_tmp8_ = _tmp7_->button;
		_tmp5_ = _tmp8_ == ((guint) 1);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GdkEventButton* _tmp9_;
		guint32 _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		_tmp9_ = _data10_->ev;
		_tmp10_ = _tmp9_->time;
		self->priv->last_click_time = (guint) _tmp10_;
		_tmp11_ = max_press_time;
		_tmp12_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp11_, ____lambda17__gsource_func, block10_data_ref (_data10_), block10_data_unref);
		self->priv->timeout_id = _tmp12_;
	}
	_tmp13_ = _data10_->ev;
	_tmp14_ = _tmp13_->button;
	if (_tmp14_ == ((guint) 3)) {
		GdkEventButton* _tmp15_;
		GtkAction* _tmp16_;
		_tmp15_ = _data10_->ev;
		g_signal_emit (self, granite_widgets_tool_button_with_menu_signals[GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_RIGHT_CLICK_SIGNAL], 0, _tmp15_);
		_tmp16_ = self->myaction;
		if (_tmp16_ != NULL) {
			GdkEventButton* _tmp17_;
			_tmp17_ = _data10_->ev;
			granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (self, _tmp17_);
		}
	}
	result = TRUE;
	block10_data_unref (_data10_);
	_data10_ = NULL;
	return result;
}


static gboolean granite_widgets_tool_button_with_menu_on_mnemonic_activate (GraniteWidgetsToolButtonWithMenu* self, gboolean group_cycling) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = group_cycling;
	if (!_tmp0_) {
		gtk_widget_activate ((GtkWidget*) self);
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
		g_object_get ((GtkWidget*) self, "can-focus", &_tmp1_, NULL);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			gtk_widget_grab_focus ((GtkWidget*) self);
		}
	}
	result = TRUE;
	return result;
}


static void _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	granite_widgets_tool_button_with_menu_get_menu_position ((GraniteWidgetsToolButtonWithMenu*) self, menu, x, y, push_in);
	g_object_unref (self);
}


void granite_widgets_tool_button_with_menu_popup_menu (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->has_fetcher;
	if (_tmp0_) {
		granite_widgets_tool_button_with_menu_fetch_menu (self);
	}
	{
		guint _tmp1_ = 0U;
		GdkEventButton* _tmp2_;
		guint32 _tmp5_ = 0U;
		GdkEventButton* _tmp6_;
		GtkMenu* _tmp10_;
		GtkMenu* _tmp11_;
		_tmp2_ = ev;
		if (_tmp2_ == NULL) {
			_tmp1_ = (guint) 0;
		} else {
			GdkEventButton* _tmp3_;
			guint _tmp4_;
			_tmp3_ = ev;
			_tmp4_ = _tmp3_->button;
			_tmp1_ = _tmp4_;
		}
		_tmp6_ = ev;
		if (_tmp6_ == NULL) {
			guint32 _tmp7_;
			_tmp7_ = gtk_get_current_event_time ();
			_tmp5_ = _tmp7_;
		} else {
			GdkEventButton* _tmp8_;
			guint32 _tmp9_;
			_tmp8_ = ev;
			_tmp9_ = _tmp8_->time;
			_tmp5_ = _tmp9_;
		}
		_tmp10_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp11_ = _tmp10_;
		gtk_menu_popup (_tmp11_, NULL, NULL, _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func, g_object_ref (self), _tmp1_, _tmp5_);
	}
	__finally22:
	{
		GtkMenu* _tmp12_;
		GtkMenu* _tmp13_;
		GtkWidget* _tmp14_;
		GtkWidget* _tmp15_;
		GtkWidget* _tmp16_;
		gboolean _tmp17_;
		GtkMenu* _tmp23_;
		GtkMenu* _tmp24_;
		_tmp12_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp13_ = _tmp12_;
		g_object_get (_tmp13_, "attach-widget", &_tmp14_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = _tmp16_ != NULL;
		_g_object_unref0 (_tmp16_);
		if (_tmp17_) {
			GtkMenu* _tmp18_;
			GtkMenu* _tmp19_;
			GtkWidget* _tmp20_;
			GtkWidget* _tmp21_;
			GtkWidget* _tmp22_;
			_tmp18_ = granite_widgets_tool_button_with_menu_get_menu (self);
			_tmp19_ = _tmp18_;
			g_object_get (_tmp19_, "attach-widget", &_tmp20_, NULL);
			_tmp21_ = _tmp20_;
			_tmp22_ = _tmp21_;
			gtk_widget_set_state_flags (_tmp22_, GTK_STATE_FLAG_SELECTED, TRUE);
			_g_object_unref0 (_tmp22_);
		}
		_tmp23_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp24_ = _tmp23_;
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp24_, FALSE);
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void granite_widgets_tool_button_with_menu_popdown_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_menu_popdown (_tmp1_);
	_tmp2_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp3_ = _tmp2_;
	g_object_get (_tmp3_, "attach-widget", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_ != NULL;
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GtkMenu* _tmp8_;
		GtkMenu* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
		_tmp8_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp9_ = _tmp8_;
		g_object_get (_tmp9_, "attach-widget", &_tmp10_, NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_;
		gtk_widget_set_state_flags (_tmp12_, GTK_STATE_FLAG_NORMAL, TRUE);
		_g_object_unref0 (_tmp12_);
	}
}


static void granite_widgets_tool_button_with_menu_fetch_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp1_;
	void* _tmp1__target;
	GtkMenu* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_fetcher (self, &_tmp0__target);
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	_tmp2_ = _tmp1_ (_tmp1__target);
	_g_object_unref0 (self->priv->_menu);
	self->priv->_menu = _tmp2_;
	granite_widgets_tool_button_with_menu_update_menu_properties (self);
}


static void granite_widgets_tool_button_with_menu_get_menu_position (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
	GtkAllocation menu_allocation = {0};
	GtkMenu* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GtkMenu* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	GtkMenu* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
	GdkWindow* _tmp17_;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	GtkAllocation allocation = {0};
	GtkMenu* _tmp20_;
	GtkWidget* _tmp21_;
	GtkWidget* _tmp22_;
	GtkWidget* _tmp23_;
	GtkAllocation _tmp24_ = {0};
	GraniteWidgetsToolButtonWithMenuHMenuPosition _tmp25_;
	GraniteWidgetsToolButtonWithMenuVMenuPosition _tmp47_;
	gint width = 0;
	gint height = 0;
	GtkMenu* _tmp53_;
	gint _tmp54_ = 0;
	gint _tmp55_ = 0;
	GraniteWidgetsToolButtonWithMenuHMenuPosition _tmp56_;
	gint _tmp79_;
	GtkAllocation _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	gint _tmp83_;
	GtkMenu* _tmp84_;
	GtkWidget* _tmp85_;
	GtkWidget* _tmp86_;
	GtkWidget* _tmp87_;
	GdkScreen* _tmp88_;
	gint _tmp89_;
	gboolean _tmp90_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_tmp0_ = menu;
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
	menu_allocation = _tmp1_;
	_tmp3_ = menu;
	g_object_get (_tmp3_, "attach-widget", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_ == NULL;
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		_tmp2_ = TRUE;
	} else {
		GtkMenu* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		GdkWindow* _tmp12_;
		_tmp8_ = menu;
		g_object_get (_tmp8_, "attach-widget", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_widget_get_window (_tmp11_);
		_tmp2_ = _tmp12_ == NULL;
		_g_object_unref0 (_tmp11_);
	}
	if (_tmp2_) {
		_vala_x = 0;
		_vala_y = 0;
		_vala_push_in = TRUE;
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp13_ = menu;
	g_object_get (_tmp13_, "attach-widget", &_tmp14_, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp15_;
	_tmp17_ = gtk_widget_get_window (_tmp16_);
	gdk_window_get_origin (_tmp17_, &_tmp18_, &_tmp19_);
	_vala_x = _tmp18_;
	_vala_y = _tmp19_;
	_g_object_unref0 (_tmp16_);
	_tmp20_ = menu;
	g_object_get (_tmp20_, "attach-widget", &_tmp21_, NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = _tmp22_;
	gtk_widget_get_allocation (_tmp23_, &_tmp24_);
	allocation = _tmp24_;
	_g_object_unref0 (_tmp23_);
	_tmp25_ = self->priv->_horizontal_menu_position;
	if (_tmp25_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_RIGHT) {
		gint _tmp26_;
		GtkAllocation _tmp27_;
		gint _tmp28_;
		_tmp26_ = _vala_x;
		_tmp27_ = allocation;
		_tmp28_ = _tmp27_.x;
		_vala_x = _tmp26_ + _tmp28_;
	} else {
		GraniteWidgetsToolButtonWithMenuHMenuPosition _tmp29_;
		_tmp29_ = self->priv->_horizontal_menu_position;
		if (_tmp29_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER) {
			gint _tmp30_;
			GtkAllocation _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			GtkAllocation _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			GtkAllocation _tmp37_;
			gint _tmp38_;
			_tmp30_ = _vala_x;
			_tmp31_ = allocation;
			_tmp32_ = _tmp31_.x;
			_vala_x = _tmp30_ + _tmp32_;
			_tmp33_ = _vala_x;
			_tmp34_ = menu_allocation;
			_tmp35_ = _tmp34_.width;
			_vala_x = _tmp33_ - (_tmp35_ / 2);
			_tmp36_ = _vala_x;
			_tmp37_ = allocation;
			_tmp38_ = _tmp37_.width;
			_vala_x = _tmp36_ + (_tmp38_ / 2);
		} else {
			gint _tmp39_;
			GtkAllocation _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			GtkAllocation _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			gint _tmp46_;
			_tmp39_ = _vala_x;
			_tmp40_ = allocation;
			_tmp41_ = _tmp40_.x;
			_vala_x = _tmp39_ + _tmp41_;
			_tmp42_ = _vala_x;
			_tmp43_ = menu_allocation;
			_tmp44_ = _tmp43_.width;
			_vala_x = _tmp42_ - _tmp44_;
			_tmp45_ = _vala_x;
			_tmp46_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
			_vala_x = _tmp45_ + _tmp46_;
		}
	}
	_tmp47_ = self->priv->_vertical_menu_position;
	if (_tmp47_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_TOP) {
		gint _tmp48_;
		GtkAllocation _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		_tmp48_ = _vala_y;
		_tmp49_ = menu_allocation;
		_tmp50_ = _tmp49_.height;
		_vala_y = _tmp48_ - _tmp50_;
		_tmp51_ = _vala_y;
		_tmp52_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
		_vala_y = _tmp51_ - _tmp52_;
	}
	_tmp53_ = menu;
	gtk_widget_get_size_request ((GtkWidget*) _tmp53_, &_tmp54_, &_tmp55_);
	width = _tmp54_;
	height = _tmp55_;
	_tmp56_ = self->priv->_horizontal_menu_position;
	if (_tmp56_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_INSIDE_WINDOW) {
		GtkWidget* parent_widget = NULL;
		GtkWidget* _tmp57_;
		GtkWidget* _tmp58_;
		GtkAllocation window_allocation = {0};
		GtkWidget* _tmp59_;
		GtkAllocation _tmp60_ = {0};
		GtkWidget* _tmp61_;
		GdkWindow* _tmp62_;
		gint _tmp63_ = 0;
		gint _tmp64_ = 0;
		gint parent_window_x0 = 0;
		gint _tmp65_;
		gint parent_window_xf = 0;
		gint _tmp66_;
		GtkAllocation _tmp67_;
		gint _tmp68_;
		gint _tmp69_;
		GtkAllocation _tmp70_;
		gint _tmp71_;
		gint _tmp72_;
		gint _tmp76_;
		gint _tmp77_;
		_tmp57_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		_tmp58_ = _g_object_ref0 (_tmp57_);
		parent_widget = _tmp58_;
		_tmp59_ = parent_widget;
		gtk_widget_get_allocation (_tmp59_, &_tmp60_);
		window_allocation = _tmp60_;
		_tmp61_ = parent_widget;
		_tmp62_ = gtk_widget_get_window (_tmp61_);
		gdk_window_get_origin (_tmp62_, &_tmp63_, &_tmp64_);
		_vala_x = _tmp63_;
		_vala_y = _tmp64_;
		_tmp65_ = _vala_x;
		parent_window_x0 = _tmp65_;
		_tmp66_ = parent_window_x0;
		_tmp67_ = window_allocation;
		_tmp68_ = _tmp67_.width;
		parent_window_xf = _tmp66_ + _tmp68_;
		_tmp69_ = _vala_x;
		_tmp70_ = menu_allocation;
		_tmp71_ = _tmp70_.width;
		_tmp72_ = parent_window_xf;
		if ((_tmp69_ + _tmp71_) > _tmp72_) {
			gint _tmp73_;
			GtkAllocation _tmp74_;
			gint _tmp75_;
			_tmp73_ = parent_window_xf;
			_tmp74_ = menu_allocation;
			_tmp75_ = _tmp74_.width;
			_vala_x = _tmp73_ - _tmp75_;
		}
		_tmp76_ = _vala_x;
		_tmp77_ = parent_window_x0;
		if (_tmp76_ < _tmp77_) {
			gint _tmp78_;
			_tmp78_ = parent_window_x0;
			_vala_x = _tmp78_;
		}
		_g_object_unref0 (parent_widget);
	}
	_tmp79_ = _vala_y;
	_tmp80_ = allocation;
	_tmp81_ = _tmp80_.y;
	_vala_y = _tmp79_ + _tmp81_;
	_tmp82_ = _vala_y;
	_tmp83_ = height;
	_tmp84_ = menu;
	g_object_get (_tmp84_, "attach-widget", &_tmp85_, NULL);
	_tmp86_ = _tmp85_;
	_tmp87_ = _tmp86_;
	_tmp88_ = gtk_widget_get_screen (_tmp87_);
	_tmp89_ = gdk_screen_get_height (_tmp88_);
	_tmp90_ = (_tmp82_ + _tmp83_) >= _tmp89_;
	_g_object_unref0 (_tmp87_);
	if (_tmp90_) {
		gint _tmp91_;
		gint _tmp92_;
		_tmp91_ = _vala_y;
		_tmp92_ = height;
		_vala_y = _tmp91_ - _tmp92_;
	} else {
		gint _tmp93_;
		GtkAllocation _tmp94_;
		gint _tmp95_;
		_tmp93_ = _vala_y;
		_tmp94_ = allocation;
		_tmp95_ = _tmp94_.height;
		_vala_y = _tmp93_ + _tmp95_;
	}
	_vala_push_in = TRUE;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (push_in) {
		*push_in = _vala_push_in;
	}
}


GraniteWidgetsToolButtonWithMenuHMenuPosition granite_widgets_tool_button_with_menu_get_horizontal_menu_position (GraniteWidgetsToolButtonWithMenu* self) {
	GraniteWidgetsToolButtonWithMenuHMenuPosition result;
	GraniteWidgetsToolButtonWithMenuHMenuPosition _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_horizontal_menu_position;
	result = _tmp0_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_horizontal_menu_position (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuHMenuPosition value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_tool_button_with_menu_get_horizontal_menu_position (self) != value) {
		GraniteWidgetsToolButtonWithMenuHMenuPosition _tmp0_;
		_tmp0_ = value;
		self->priv->_horizontal_menu_position = _tmp0_;
		g_object_notify ((GObject *) self, "horizontal-menu-position");
	}
}


GraniteWidgetsToolButtonWithMenuVMenuPosition granite_widgets_tool_button_with_menu_get_vertical_menu_position (GraniteWidgetsToolButtonWithMenu* self) {
	GraniteWidgetsToolButtonWithMenuVMenuPosition result;
	GraniteWidgetsToolButtonWithMenuVMenuPosition _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_vertical_menu_position;
	result = _tmp0_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_vertical_menu_position (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuVMenuPosition value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_tool_button_with_menu_get_vertical_menu_position (self) != value) {
		GraniteWidgetsToolButtonWithMenuVMenuPosition _tmp0_;
		_tmp0_ = value;
		self->priv->_vertical_menu_position = _tmp0_;
		g_object_notify ((GObject *) self, "vertical-menu-position");
	}
}


GraniteWidgetsToolButtonWithMenuMenuFetcher granite_widgets_tool_button_with_menu_get_fetcher (GraniteWidgetsToolButtonWithMenu* self, gpointer* result_target) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher result;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_fetcher;
	_tmp0__target = self->priv->_fetcher_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_fetcher (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuMenuFetcher value, gpointer value_target) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	self->priv->_fetcher = _tmp0_;
	self->priv->_fetcher_target = _tmp0__target;
	self->priv->has_fetcher = TRUE;
}


GtkMenu* granite_widgets_tool_button_with_menu_get_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* result;
	GtkMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_menu;
	result = _tmp0_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_menu (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->has_fetcher;
	if (_tmp0_) {
		g_warning ("ToolButtonWithMenu.vala:110: Don't set the menu property on a ToolMenu" \
"Button when there is already a menu fetcher");
	} else {
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
		_tmp1_ = value;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp2_;
		granite_widgets_tool_button_with_menu_update_menu_properties (self);
	}
	g_object_notify ((GObject *) self, "menu");
}


static void granite_widgets_tool_button_with_menu_class_init (GraniteWidgetsToolButtonWithMenuClass * klass) {
	granite_widgets_tool_button_with_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsToolButtonWithMenuPrivate));
	((GtkWidgetClass *) klass)->show_all = (void (*) (GtkWidget *)) granite_widgets_tool_button_with_menu_real_show_all;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_tool_button_with_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_tool_button_with_menu_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_tool_button_with_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HORIZONTAL_MENU_POSITION, g_param_spec_enum ("horizontal-menu-position", "horizontal-menu-position", "horizontal-menu-position", GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_TYPE_HMENU_POSITION, GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VERTICAL_MENU_POSITION, g_param_spec_enum ("vertical-menu-position", "vertical-menu-position", "vertical-menu-position", GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_TYPE_VMENU_POSITION, GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_BOTTOM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU, g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	granite_widgets_tool_button_with_menu_signals[GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_RIGHT_CLICK_SIGNAL] = g_signal_new ("right_click", GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
}


static void granite_widgets_tool_button_with_menu_instance_init (GraniteWidgetsToolButtonWithMenu * self) {
	GtkSettings* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self->priv = GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_PRIVATE (self);
	self->priv->_horizontal_menu_position = GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HMENU_POSITION_CENTER;
	self->priv->_vertical_menu_position = GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VMENU_POSITION_BOTTOM;
	_tmp0_ = gtk_settings_get_default ();
	g_object_get (_tmp0_, "gtk-double-click-time", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	self->priv->LONG_PRESS_TIME = ((guint) _tmp2_) * 2U;
	self->priv->timeout_id = 0U;
	self->priv->last_click_time = 0U;
	self->priv->has_fetcher = FALSE;
}


static void granite_widgets_tool_button_with_menu_finalize (GObject * obj) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	_g_object_unref0 (self->myaction);
	_g_object_unref0 (self->priv->_menu);
	_g_object_unref0 (self->priv->button);
	G_OBJECT_CLASS (granite_widgets_tool_button_with_menu_parent_class)->finalize (obj);
}


/**
     * ToolButtonWithMenu
     * - support long click / right click with depressed button states
     * - activate a GtkAction if any or popup a menu
     * (used in history navigation buttons and the AppMenu)
     */
GType granite_widgets_tool_button_with_menu_get_type (void) {
	static volatile gsize granite_widgets_tool_button_with_menu_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_tool_button_with_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsToolButtonWithMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_tool_button_with_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsToolButtonWithMenu), 0, (GInstanceInitFunc) granite_widgets_tool_button_with_menu_instance_init, NULL };
		GType granite_widgets_tool_button_with_menu_type_id;
		granite_widgets_tool_button_with_menu_type_id = g_type_register_static (gtk_toggle_tool_button_get_type (), "GraniteWidgetsToolButtonWithMenu", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_tool_button_with_menu_type_id__volatile, granite_widgets_tool_button_with_menu_type_id);
	}
	return granite_widgets_tool_button_with_menu_type_id__volatile;
}


static void _vala_granite_widgets_tool_button_with_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	switch (property_id) {
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HORIZONTAL_MENU_POSITION:
		g_value_set_enum (value, granite_widgets_tool_button_with_menu_get_horizontal_menu_position (self));
		break;
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VERTICAL_MENU_POSITION:
		g_value_set_enum (value, granite_widgets_tool_button_with_menu_get_vertical_menu_position (self));
		break;
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU:
		g_value_set_object (value, granite_widgets_tool_button_with_menu_get_menu (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_tool_button_with_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	switch (property_id) {
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_HORIZONTAL_MENU_POSITION:
		granite_widgets_tool_button_with_menu_set_horizontal_menu_position (self, g_value_get_enum (value));
		break;
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_VERTICAL_MENU_POSITION:
		granite_widgets_tool_button_with_menu_set_vertical_menu_position (self, g_value_get_enum (value));
		break;
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU:
		granite_widgets_tool_button_with_menu_set_menu (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



