/* WrapLabel.c generated by valac 0.36.4, the Vala compiler
 * generated from WrapLabel.vala, do not modify */

/*
 *  Copyright (C) 2010 troorl <troorl@gmail.com>
 *  Copyright (C) 2011 ammonkey <am.monkeyd@gmail.com>
 *  Copyright (C) 2012-2017 Granite Developers
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <cairo.h>


#define GRANITE_WIDGETS_TYPE_WRAP_LABEL (granite_widgets_wrap_label_get_type ())
#define GRANITE_WIDGETS_WRAP_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_WRAP_LABEL, GraniteWidgetsWrapLabel))
#define GRANITE_WIDGETS_WRAP_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_WRAP_LABEL, GraniteWidgetsWrapLabelClass))
#define GRANITE_WIDGETS_IS_WRAP_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_WRAP_LABEL))
#define GRANITE_WIDGETS_IS_WRAP_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_WRAP_LABEL))
#define GRANITE_WIDGETS_WRAP_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_WRAP_LABEL, GraniteWidgetsWrapLabelClass))

typedef struct _GraniteWidgetsWrapLabel GraniteWidgetsWrapLabel;
typedef struct _GraniteWidgetsWrapLabelClass GraniteWidgetsWrapLabelClass;
typedef struct _GraniteWidgetsWrapLabelPrivate GraniteWidgetsWrapLabelPrivate;

struct _GraniteWidgetsWrapLabel {
	GtkLabel parent_instance;
	GraniteWidgetsWrapLabelPrivate * priv;
	gint m_wrap_width;
	gint m_wrap_height;
};

struct _GraniteWidgetsWrapLabelClass {
	GtkLabelClass parent_class;
};


static gpointer granite_widgets_wrap_label_parent_class = NULL;

GType granite_widgets_wrap_label_get_type (void) G_GNUC_CONST;
enum  {
	GRANITE_WIDGETS_WRAP_LABEL_DUMMY_PROPERTY
};
GraniteWidgetsWrapLabel* granite_widgets_wrap_label_new (const gchar* str);
GraniteWidgetsWrapLabel* granite_widgets_wrap_label_construct (GType object_type, const gchar* str);
static void granite_widgets_wrap_label_set_wrap_width (GraniteWidgetsWrapLabel* self, gint width);
static void granite_widgets_wrap_label_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width);
static void granite_widgets_wrap_label_real_size_allocate (GtkWidget* base, GtkAllocation* alloc);
static void granite_widgets_wrap_label_finalize (GObject * obj);


/**
     * Create a new WrapLabel.
     *
     * @param str the content of the label
     */
GraniteWidgetsWrapLabel* granite_widgets_wrap_label_construct (GType object_type, const gchar* str) {
	GraniteWidgetsWrapLabel * self = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	self = (GraniteWidgetsWrapLabel*) g_object_new (object_type, NULL);
	g_object_set ((GtkLabel*) self, "wrap", TRUE, NULL);
	g_object_set ((GtkLabel*) self, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	gtk_misc_set_alignment ((GtkMisc*) self, (gfloat) 0, (gfloat) 0);
	_tmp0_ = str;
	gtk_label_set_text ((GtkLabel*) self, _tmp0_);
	_tmp1_ = self->m_wrap_width;
	granite_widgets_wrap_label_set_wrap_width (self, _tmp1_);
	return self;
}


GraniteWidgetsWrapLabel* granite_widgets_wrap_label_new (const gchar* str) {
	return granite_widgets_wrap_label_construct (GRANITE_WIDGETS_TYPE_WRAP_LABEL, str);
}


static void granite_widgets_wrap_label_set_wrap_width (GraniteWidgetsWrapLabel* self, gint width) {
	gint _tmp0_;
	PangoLayout* _tmp1_;
	gint _tmp2_;
	gint unused = 0;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_;
	gint _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = width;
	if (_tmp0_ == 0) {
		return;
	}
	_tmp1_ = gtk_label_get_layout ((GtkLabel*) self);
	_tmp2_ = width;
	pango_layout_set_width (_tmp1_, (gint) (_tmp2_ * PANGO_SCALE));
	unused = 0;
	_tmp3_ = gtk_label_get_layout ((GtkLabel*) self);
	pango_layout_get_pixel_size (_tmp3_, &_tmp4_, &_tmp5_);
	unused = _tmp4_;
	self->m_wrap_height = _tmp5_;
	_tmp6_ = self->m_wrap_width;
	_tmp7_ = width;
	if (_tmp6_ != _tmp7_) {
		gint _tmp8_;
		_tmp8_ = width;
		self->m_wrap_width = _tmp8_;
		gtk_widget_queue_resize ((GtkWidget*) self);
	}
}


static void granite_widgets_wrap_label_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width) {
	GraniteWidgetsWrapLabel * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint _tmp0_;
	self = (GraniteWidgetsWrapLabel*) base;
	_tmp0_ = self->m_wrap_width;
	_vala_natural_width = _tmp0_;
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void granite_widgets_wrap_label_real_size_allocate (GtkWidget* base, GtkAllocation* alloc) {
	GraniteWidgetsWrapLabel * self;
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	gint _tmp2_;
	self = (GraniteWidgetsWrapLabel*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	GTK_WIDGET_CLASS (granite_widgets_wrap_label_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_label_get_type (), GtkLabel), &_tmp0_);
	_tmp1_ = *alloc;
	_tmp2_ = _tmp1_.width;
	granite_widgets_wrap_label_set_wrap_width (self, _tmp2_);
}


static void granite_widgets_wrap_label_class_init (GraniteWidgetsWrapLabelClass * klass) {
	granite_widgets_wrap_label_parent_class = g_type_class_peek_parent (klass);
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) granite_widgets_wrap_label_real_get_preferred_width;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget *, GtkAllocation*)) granite_widgets_wrap_label_real_size_allocate;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_wrap_label_finalize;
}


static void granite_widgets_wrap_label_instance_init (GraniteWidgetsWrapLabel * self) {
	self->m_wrap_width = 0;
	self->m_wrap_height = 0;
}


static void granite_widgets_wrap_label_finalize (GObject * obj) {
	GraniteWidgetsWrapLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_WRAP_LABEL, GraniteWidgetsWrapLabel);
	G_OBJECT_CLASS (granite_widgets_wrap_label_parent_class)->finalize (obj);
}


/**
 * This is a label which is automatically wrapped.
 * If a line is too long, there will be a line break for instance.
 */
GType granite_widgets_wrap_label_get_type (void) {
	static volatile gsize granite_widgets_wrap_label_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_wrap_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsWrapLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_wrap_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsWrapLabel), 0, (GInstanceInitFunc) granite_widgets_wrap_label_instance_init, NULL };
		GType granite_widgets_wrap_label_type_id;
		granite_widgets_wrap_label_type_id = g_type_register_static (gtk_label_get_type (), "GraniteWidgetsWrapLabel", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_wrap_label_type_id__volatile, granite_widgets_wrap_label_type_id);
	}
	return granite_widgets_wrap_label_type_id__volatile;
}



