/* SourceList.c generated by valac 0.36.4, the Vala compiler
 * generated from SourceList.vala, do not modify */

/*
 *  Copyright (C) 2012-2014 Victor Martinez <victoreduardm@gmail.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/**
     * = WORKING INTERNALS =
     *
     * In order to offer a transparent Item-based API, and avoid the need of providing methods
     * to deal with items directly on the SourceList widget, it was decided to follow a monitor-like
     * implementation, where the source list permanently monitors its root item and any other
     * child item added to it. The task of monitoring the properties of the items has been
     * divided among different objects, as shown below:
     *
     * Monitored by: Object::method that receives the signals indicating the property change.
     * Applied by: Object::method that actually updates the tree to reflect the property changes
     *             (directly or indirectly, as in the case of the tree data model).
     *
     * ---------------------------------------------------------------------------------------------
     *   PROPERTY        |  MONITORED BY                     |  APPLIED BY
     * ---------------------------------------------------------------------------------------------
     * + Item            |                                   |
     *   - parent        | Not monitored                     | N/A
     *   - name          | DataModel::on_item_prop_changed   | Tree::name_cell_data_func
     *   - editable      | DataModel::on_item_prop_changed   | Queried when needed (See Tree::start_editing_item)
     *   - visible       | DataModel::on_item_prop_changed   | DataModel::filter_visible_func
     *   - icon          | DataModel::on_item_prop_changed   | Tree::icon_cell_data_func
     *   - activatable   | Same as @icon                     | Same as @icon
     * + ExpandableItem  |                                   |
     *   - collapsible   | DataModel::on_item_prop_changed   | Tree::update_expansion
     *                   |                                   | Tree::expander_cell_data_func
     *   - expanded      | Same as @collapsible              | Same as @collapsible
     * ---------------------------------------------------------------------------------------------
     * * Only automatic properties are monitored. ExpandableItem's additions/removals are handled by
     *   DataModel::add_item() and DataModel::remove_item()
     *
     * Other features:
     * - Sorting: this happens on the tree-model level (DataModel).
     */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM (granite_widgets_source_list_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))

typedef struct _GraniteWidgetsSourceListItem GraniteWidgetsSourceListItem;
typedef struct _GraniteWidgetsSourceListItemClass GraniteWidgetsSourceListItemClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM (granite_widgets_source_list_expandable_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))

typedef struct _GraniteWidgetsSourceListExpandableItem GraniteWidgetsSourceListExpandableItem;
typedef struct _GraniteWidgetsSourceListExpandableItemClass GraniteWidgetsSourceListExpandableItemClass;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE (granite_widgets_source_list_sortable_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, GraniteWidgetsSourceListSortable))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE))
#define GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, GraniteWidgetsSourceListSortableIface))

typedef struct _GraniteWidgetsSourceListSortable GraniteWidgetsSourceListSortable;
typedef struct _GraniteWidgetsSourceListSortableIface GraniteWidgetsSourceListSortableIface;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_LAST_SIGNAL
};
static guint granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_LAST_SIGNAL] = {0};

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE (granite_widgets_source_list_drag_source_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE, GraniteWidgetsSourceListDragSource))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE))
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE, GraniteWidgetsSourceListDragSourceIface))

typedef struct _GraniteWidgetsSourceListDragSource GraniteWidgetsSourceListDragSource;
typedef struct _GraniteWidgetsSourceListDragSourceIface GraniteWidgetsSourceListDragSourceIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST (granite_widgets_source_list_drag_dest_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, GraniteWidgetsSourceListDragDest))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST))
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, GraniteWidgetsSourceListDragDestIface))

typedef struct _GraniteWidgetsSourceListDragDest GraniteWidgetsSourceListDragDest;
typedef struct _GraniteWidgetsSourceListDragDestIface GraniteWidgetsSourceListDragDestIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST (granite_widgets_source_list_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList))
#define GRANITE_WIDGETS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))
#define GRANITE_WIDGETS_IS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_SOURCE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))

typedef struct _GraniteWidgetsSourceList GraniteWidgetsSourceList;
typedef struct _GraniteWidgetsSourceListClass GraniteWidgetsSourceListClass;
typedef struct _GraniteWidgetsSourceListPrivate GraniteWidgetsSourceListPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE (granite_widgets_source_list_tree_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))

typedef struct _GraniteWidgetsSourceListTree GraniteWidgetsSourceListTree;
typedef struct _GraniteWidgetsSourceListTreeClass GraniteWidgetsSourceListTreeClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL (granite_widgets_source_list_data_model_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))

typedef struct _GraniteWidgetsSourceListDataModel GraniteWidgetsSourceListDataModel;
typedef struct _GraniteWidgetsSourceListDataModelClass GraniteWidgetsSourceListDataModelClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListItemPrivate GraniteWidgetsSourceListItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_LAST_SIGNAL
};
static guint granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_LAST_SIGNAL] = {0};
typedef struct _GraniteWidgetsSourceListExpandableItemPrivate GraniteWidgetsSourceListExpandableItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_LAST_SIGNAL
};
static guint granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_LAST_SIGNAL] = {0};
typedef struct _GraniteWidgetsSourceListDataModelPrivate GraniteWidgetsSourceListDataModelPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER (granite_widgets_source_list_data_model_node_wrapper_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))

typedef struct _GraniteWidgetsSourceListDataModelNodeWrapper GraniteWidgetsSourceListDataModelNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperClass GraniteWidgetsSourceListDataModelNodeWrapperClass;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR (granite_widgets_source_list_data_model_item_monitor_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))

typedef struct _GraniteWidgetsSourceListDataModelItemMonitor GraniteWidgetsSourceListDataModelItemMonitor;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorClass GraniteWidgetsSourceListDataModelItemMonitorClass;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_COLUMN (granite_widgets_source_list_data_model_column_get_type ())
#define _granite_widgets_source_list_data_model_node_wrapper_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_node_wrapper_unref (var), NULL)))
#define _granite_widgets_source_list_data_model_item_monitor_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_item_monitor_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate GraniteWidgetsSourceListDataModelNodeWrapperPrivate;
#define _gtk_tree_row_reference_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_row_reference_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper GraniteWidgetsSourceListDataModelParamSpecNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate GraniteWidgetsSourceListDataModelItemMonitorPrivate;
typedef struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor GraniteWidgetsSourceListDataModelParamSpecItemMonitor;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_LAST_SIGNAL
};
static guint granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_LAST_SIGNAL] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_LAST_SIGNAL
};
static guint granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_LAST_SIGNAL] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON (granite_widgets_source_list_cell_renderer_icon_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIcon))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))

typedef struct _GraniteWidgetsSourceListCellRendererIcon GraniteWidgetsSourceListCellRendererIcon;
typedef struct _GraniteWidgetsSourceListCellRendererIconClass GraniteWidgetsSourceListCellRendererIconClass;
typedef struct _GraniteWidgetsSourceListCellRendererIconPrivate GraniteWidgetsSourceListCellRendererIconPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_LAST_SIGNAL
};
static guint granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_LAST_SIGNAL] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER (granite_widgets_source_list_cell_renderer_spacer_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))

typedef struct _GraniteWidgetsSourceListCellRendererSpacer GraniteWidgetsSourceListCellRendererSpacer;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerClass GraniteWidgetsSourceListCellRendererSpacerClass;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerPrivate GraniteWidgetsSourceListCellRendererSpacerPrivate;
typedef struct _GraniteWidgetsSourceListTreePrivate GraniteWidgetsSourceListTreePrivate;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE (granite_widgets_cell_renderer_badge_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadge))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))

typedef struct _GraniteWidgetsCellRendererBadge GraniteWidgetsCellRendererBadge;
typedef struct _GraniteWidgetsCellRendererBadgeClass GraniteWidgetsCellRendererBadgeClass;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER (granite_widgets_cell_renderer_expander_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpander))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))

typedef struct _GraniteWidgetsCellRendererExpander GraniteWidgetsCellRendererExpander;
typedef struct _GraniteWidgetsCellRendererExpanderClass GraniteWidgetsCellRendererExpanderClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TREE_TYPE_COLUMN (granite_widgets_source_list_tree_column_get_type ())
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
#define __g_list_free__gtk_tree_path_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__gtk_tree_path_free0_ (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_LAST_SIGNAL
};
static guint granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_LAST_SIGNAL] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_LAST_SIGNAL
};
static guint granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_LAST_SIGNAL] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteWidgetsSourceListSortableIface {
	GTypeInterface parent_iface;
	gboolean (*allow_dnd_sorting) (GraniteWidgetsSourceListSortable* self);
	gint (*compare) (GraniteWidgetsSourceListSortable* self, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b);
};

struct _GraniteWidgetsSourceListDragSourceIface {
	GTypeInterface parent_iface;
	gboolean (*draggable) (GraniteWidgetsSourceListDragSource* self);
	void (*prepare_selection_data) (GraniteWidgetsSourceListDragSource* self, GtkSelectionData* selection_data);
};

struct _GraniteWidgetsSourceListDragDestIface {
	GTypeInterface parent_iface;
	gboolean (*data_drop_possible) (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
	GdkDragAction (*data_received) (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
};

struct _GraniteWidgetsSourceList {
	GtkScrolledWindow parent_instance;
	GraniteWidgetsSourceListPrivate * priv;
};

struct _GraniteWidgetsSourceListClass {
	GtkScrolledWindowClass parent_class;
	void (*item_selected) (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
};

struct _GraniteWidgetsSourceListPrivate {
	GraniteWidgetsSourceListTree* tree;
	GraniteWidgetsSourceListDataModel* data_model;
};

typedef gint (*GraniteWidgetsSourceListSortFunc) (GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b, void* user_data) G_GNUC_DEPRECATED;
typedef gboolean (*GraniteWidgetsSourceListVisibleFunc) (GraniteWidgetsSourceListItem* item, void* user_data);
struct _GraniteWidgetsSourceListItem {
	GObject parent_instance;
	GraniteWidgetsSourceListItemPrivate * priv;
};

struct _GraniteWidgetsSourceListItemClass {
	GObjectClass parent_class;
	GtkMenu* (*get_context_menu) (GraniteWidgetsSourceListItem* self);
	void (*edited) (GraniteWidgetsSourceListItem* self, const gchar* new_name);
	void (*action_activated) (GraniteWidgetsSourceListItem* self);
	void (*activated) (GraniteWidgetsSourceListItem* self);
};

struct _GraniteWidgetsSourceListItemPrivate {
	GraniteWidgetsSourceListExpandableItem* _parent;
	gchar* _name;
	gchar* _badge;
	gboolean _editable;
	gboolean _visible;
	gboolean _selectable;
	GIcon* _icon;
	GIcon* _activatable;
};

struct _GraniteWidgetsSourceListExpandableItem {
	GraniteWidgetsSourceListItem parent_instance;
	GraniteWidgetsSourceListExpandableItemPrivate * priv;
};

struct _GraniteWidgetsSourceListExpandableItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
	void (*toggled) (GraniteWidgetsSourceListExpandableItem* self);
};

struct _GraniteWidgetsSourceListExpandableItemPrivate {
	gboolean _collapsible;
	gboolean _expanded;
	GeeCollection* children_list;
};

struct _GraniteWidgetsSourceListDataModel {
	GtkTreeModelFilter parent_instance;
	GraniteWidgetsSourceListDataModelPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelClass {
	GtkTreeModelFilterClass parent_class;
};

struct _GraniteWidgetsSourceListDataModelPrivate {
	GraniteWidgetsSourceListExpandableItem* _root;
	GeeHashMap* items;
	GeeHashMap* monitors;
	GtkTreeStore* child_tree;
	GraniteWidgetsSourceListVisibleFunc filter_func;
	gpointer filter_func_target;
};

typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS
} GraniteWidgetsSourceListDataModelColumn;

struct _Block14Data {
	int _ref_count_;
	GraniteWidgetsSourceListDataModel* self;
	GraniteWidgetsSourceListExpandableItem* parent;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapper {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelNodeWrapperPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelNodeWrapper *self);
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate {
	GtkTreeRowReference* row_reference;
};

struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListDataModelItemMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelItemMonitorPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelItemMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelItemMonitor *self);
};

struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate {
	GraniteWidgetsSourceListItem* item;
};

struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListCellRendererIcon {
	GtkCellRendererPixbuf parent_instance;
	GraniteWidgetsSourceListCellRendererIconPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererIconClass {
	GtkCellRendererPixbufClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacer {
	GtkCellRenderer parent_instance;
	GraniteWidgetsSourceListCellRendererSpacerPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererSpacerClass {
	GtkCellRendererClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacerPrivate {
	gint _level;
};

struct _GraniteWidgetsSourceListTree {
	GtkTreeView parent_instance;
	GraniteWidgetsSourceListTreePrivate * priv;
};

struct _GraniteWidgetsSourceListTreeClass {
	GtkTreeViewClass parent_class;
};

struct _GraniteWidgetsSourceListTreePrivate {
	GraniteWidgetsSourceListDataModel* _data_model;
	GraniteWidgetsSourceListItem* selected;
	GraniteWidgetsSourceListItem* edited;
	GtkEntry* editable_entry;
	GtkCellRendererText* text_cell;
	GraniteWidgetsSourceListCellRendererIcon* icon_cell;
	GraniteWidgetsSourceListCellRendererIcon* activatable_cell;
	GraniteWidgetsCellRendererBadge* badge_cell;
	GraniteWidgetsCellRendererExpander* primary_expander_cell;
	GraniteWidgetsCellRendererExpander* secondary_expander_cell;
	GeeHashMap* spacer_cells;
	gboolean unselectable_item_clicked;
};

typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS
} GraniteWidgetsSourceListTreeColumn;


static gpointer granite_widgets_source_list_parent_class = NULL;
static gpointer granite_widgets_source_list_item_parent_class = NULL;
static gpointer granite_widgets_source_list_expandable_item_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_node_wrapper_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_item_monitor_parent_class = NULL;
static GtkTreeDragSourceIface * granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface = NULL;
static GtkTreeDragDestIface * granite_widgets_source_list_data_model_gtk_tree_drag_dest_parent_iface = NULL;
static gpointer granite_widgets_source_list_cell_renderer_icon_parent_class = NULL;
static gpointer granite_widgets_source_list_cell_renderer_spacer_parent_class = NULL;
static gpointer granite_widgets_source_list_tree_parent_class = NULL;

GType granite_widgets_source_list_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_expandable_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_sortable_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_sortable_allow_dnd_sorting (GraniteWidgetsSourceListSortable* self);
gint granite_widgets_source_list_sortable_compare (GraniteWidgetsSourceListSortable* self, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b);
GType granite_widgets_source_list_drag_source_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_drag_source_draggable (GraniteWidgetsSourceListDragSource* self);
void granite_widgets_source_list_drag_source_prepare_selection_data (GraniteWidgetsSourceListDragSource* self, GtkSelectionData* selection_data);
GType granite_widgets_source_list_drag_dest_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_drag_dest_data_drop_possible (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
GdkDragAction granite_widgets_source_list_drag_dest_data_received (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
GType granite_widgets_source_list_get_type (void) G_GNUC_CONST;
static GType granite_widgets_source_list_tree_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ROOT,
	GRANITE_WIDGETS_SOURCE_LIST_SELECTED,
	GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE,
	GRANITE_WIDGETS_SOURCE_LIST_EDITING,
	GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION
};
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_new (void);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_construct (GType object_type);
GraniteWidgetsSourceList* granite_widgets_source_list_new (GraniteWidgetsSourceListExpandableItem* root);
GraniteWidgetsSourceList* granite_widgets_source_list_construct (GType object_type, GraniteWidgetsSourceListExpandableItem* root);
void granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* value);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_construct (GType object_type, GraniteWidgetsSourceListDataModel* data_model);
static void __lambda81_ (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static void ___lambda81__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
gboolean granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_set_sort_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) G_GNUC_DEPRECATED;
void granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target, gboolean refilter);
static void granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target);
void granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
gboolean granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self);
static void granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_enable_drag_source (GraniteWidgetsSourceList* self, GtkTargetEntry* src_entries, int src_entries_length1);
static void granite_widgets_source_list_tree_configure_drag_source (GraniteWidgetsSourceListTree* self, GtkTargetEntry* src_entries, int src_entries_length1);
void granite_widgets_source_list_disable_drag_source (GraniteWidgetsSourceList* self);
void granite_widgets_source_list_enable_drag_dest (GraniteWidgetsSourceList* self, GtkTargetEntry* dest_entries, int dest_entries_length1, GdkDragAction actions);
static void granite_widgets_source_list_tree_configure_drag_dest (GraniteWidgetsSourceListTree* self, GtkTargetEntry* dest_entries, int dest_entries_length1, GdkDragAction actions);
void granite_widgets_source_list_disable_drag_dest (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item, gboolean expand_parents, gboolean use_align, gfloat row_align);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self);
static gboolean granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean use_align, gfloat row_align);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent, gint index);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
guint granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self);
static GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self);
static void granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* value);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* value);
static void granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* value);
PangoEllipsizeMode granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self);
static PangoEllipsizeMode granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self, PangoEllipsizeMode value);
static void granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self, PangoEllipsizeMode value);
static gboolean granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self);
GtkSortType granite_widgets_source_list_get_sort_direction (GraniteWidgetsSourceList* self) G_GNUC_DEPRECATED;
void granite_widgets_source_list_set_sort_direction (GraniteWidgetsSourceList* self, GtkSortType value) G_GNUC_DEPRECATED;
static void granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE
};
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_new (const gchar* name);
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_construct (GType object_type, const gchar* name);
void granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self, const gchar* value);
GtkMenu* granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self);
static GtkMenu* granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self, GraniteWidgetsSourceListExpandableItem* value);
const gchar* granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self);
const gchar* granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self, const gchar* value);
gboolean granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self, gboolean value);
gboolean granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self, gboolean value);
gboolean granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self, gboolean value);
GIcon* granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self, GIcon* value);
GIcon* granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self, GIcon* value);
static void granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self, const gchar* new_name);
static void granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN
};
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_new (const gchar* name);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_construct (GType object_type, const gchar* name);
gboolean granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self);
GeeCollection* granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive);
static void granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item, gboolean inclusive, gboolean recursive, gboolean expanded);
void granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive);
void granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self, gboolean value);
void granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self);
gboolean granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self, gboolean value);
gboolean granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self);
guint granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self);
static void granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self);
static void granite_widgets_source_list_expandable_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gpointer granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance);
static void granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_node_wrapper_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance);
static void granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_item_monitor_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT
};
static GType granite_widgets_source_list_data_model_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE "item-parent-needs-update"
static gint granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b);
static gint _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self);
static void granite_widgets_source_list_data_model_resort (GraniteWidgetsSourceListDataModel* self);
static gboolean granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* child_model, GtkTreeIter* iter);
static gboolean _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GtkTreePath* granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static GtkTreeIter* granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model, GtkTreeIter* iter);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type, GtkTreeModel* model, GtkTreeIter* iter);
static void granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* parent);
static void granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_construct (GType object_type, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, const gchar* prop_name);
static void _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender, GraniteWidgetsSourceListItem* _self_, const gchar* prop_name, gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static gboolean ___lambda80_ (Block14Data* _data14_);
static gboolean ____lambda80__gsource_func (gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, GtkTreeIter* iter, GtkTreePath* path);
static gboolean granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter);
static gboolean granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path);
static gboolean granite_widgets_source_list_data_model_real_drag_data_received (GtkTreeDragDest* base, GtkTreePath* dest, GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListDataModel* self, GtkTreePath* dest, GtkTreePath* src_path);
static void granite_widgets_source_list_data_model_recursive_node_copy (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* src_iter, GtkTreeIter* dest_iter);
static void granite_widgets_source_list_data_model_move_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* src_iter, GtkTreeIter* dest_iter);
static gboolean granite_widgets_source_list_data_model_real_row_drop_possible (GtkTreeDragDest* base, GtkTreePath* dest, GtkSelectionData* selection_data);
static gint* _vala_array_dup5 (gint* self, int length);
static gint* _vala_array_dup6 (gint* self, int length);
static gboolean granite_widgets_source_list_data_model_real_drag_data_get (GtkTreeDragSource* base, GtkTreePath* path, GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_data_model_real_row_draggable (GtkTreeDragSource* base, GtkTreePath* path);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_DUMMY_PROPERTY
};
static gboolean granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper * obj);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_DUMMY_PROPERTY
};
static void granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self, GParamSpec* prop);
static void _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor * obj);
static void granite_widgets_source_list_data_model_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_data_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_data_model_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static GType granite_widgets_source_list_cell_renderer_icon_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_DUMMY_PROPERTY
};
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE GTK_ICON_SIZE_MENU
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_new (void);
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_construct (GType object_type);
static gboolean granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base, GdkEvent* event, GtkWidget* widget, const gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags);
static GType granite_widgets_source_list_cell_renderer_spacer_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL
};
static GtkSizeRequestMode granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base, GtkWidget* widget, gint* min_size, gint* natural_size);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base, GtkWidget* widget, gint width, gint* min_height, gint* natural_height);
static void granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base, cairo_t* context, GtkWidget* widget, GdkRectangle* bg_area, GdkRectangle* cell_area, GtkCellRendererState flags);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base, GtkWidget* widget, GdkRectangle* cell_area, gint* x_offset, gint* y_offset, gint* width, gint* height) G_GNUC_DEPRECATED;
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_new (void);
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type);
static gint granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self);
static void granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self, gint value);
static void granite_widgets_source_list_cell_renderer_spacer_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType granite_widgets_cell_renderer_badge_get_type (void) G_GNUC_CONST;
GType granite_widgets_cell_renderer_expander_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreePrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE
};
static void granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self, GtkCellEditable* editable, const gchar* path);
static void _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender, GtkCellEditable* editable, const gchar* path, gpointer self);
static void granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self);
static void _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender, gpointer self);
static void granite_widgets_source_list_tree_disable_item_property_monitor (GraniteWidgetsSourceListTree* self);
static GType granite_widgets_source_list_tree_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET "\n" \
"            .source-list.badge {\n" \
"                border-radius: 10px;\n" \
"                border-width: 0;\n" \
"                padding: 1px 2px 1px 2px;\n" \
"                font-weight: bold;\n" \
"            }\n" \
"        "
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION "level-indentation"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING "left-padding"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING "expander-spacing"
GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget, const gchar* stylesheet, const gchar* class_name, gint priority);
#define GRANITE_STYLE_CLASS_SOURCE_LIST "source-list"
static void granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListDataModel* value);
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_new (void);
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_construct (GType object_type);
void granite_widgets_cell_renderer_expander_set_is_category_expander (GraniteWidgetsCellRendererExpander* self, gboolean value);
static void granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self, const gchar* item_path_str);
static void _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender, const gchar* path, gpointer self);
static void granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_new (void);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_construct (GType object_type);
static void granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static gboolean granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected);
static gboolean _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self);
static void granite_widgets_source_list_tree_enable_item_property_monitor (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self, gint level, gboolean check_previous);
static gboolean granite_widgets_source_list_tree_real_drag_motion (GtkWidget* base, GdkDragContext* context, gint x, gint y, guint time);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_tree_real_drag_data_received (GtkWidget* base, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time);
static GtkTargetEntry* granite_widgets_source_list_tree_append_row_target_entry (GtkTargetEntry* orig, int orig_length1, int* result_length1);
static void _vala_array_add3 (GtkTargetEntry* * array, int* length, int* size, const GtkTargetEntry* value);
static void _vala_array_add4 (GtkTargetEntry* * array, int* length, int* size, const GtkTargetEntry* value);
static void granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static void granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* expandable_item);
static void granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static GtkTreePath* granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self);
static void _gtk_tree_path_free0_ (gpointer var);
static void _g_list_free__gtk_tree_path_free0_ (GList* self);
static void granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean scroll_to_item);
static void granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base);
static void granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self);
static void _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self, const gchar* item_path_str);
static gboolean granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_tree_real_row_expanded (GtkTreeView* base, GtkTreeIter* iter, GtkTreePath* path);
static void granite_widgets_source_list_tree_real_row_collapsed (GtkTreeView* base, GtkTreeIter* iter, GtkTreePath* path);
static void granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base, GtkTreePath* path, GtkTreeViewColumn* column);
static gboolean granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base, GdkEventKey* event);
static gboolean granite_widgets_source_list_tree_real_button_release_event (GtkWidget* base, GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base, GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, GtkCellRenderer* cell, gint x);
static gboolean granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, gint x);
static gint granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self, GtkCellRenderer* cell_renderer);
gboolean granite_widgets_utils_is_left_to_right (GtkWidget* widget);
static gboolean granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base);
static void granite_widgets_source_list_tree_menu_position_func (GraniteWidgetsSourceListTree* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in);
static void _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model, GtkTreeIter* iter);
void granite_widgets_cell_renderer_badge_set_text (GraniteWidgetsCellRendererBadge* self, const gchar* value);
static void granite_widgets_source_list_tree_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_tree_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_tree_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void granite_widgets_source_list_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Whether this item will allow users to re-arrange its children via DnD.
     *
     * This feature can co-exist with a sort algorithm (implemented
     * by {@link Granite.Widgets.SourceListSortable.compare}), but
     * the actual order of the items in the list will always
     * honor that method. The sort function has to be compatible with
     * the kind of DnD reordering the item wants to allow, since the user can
     * only reorder those items for which //compare// returns 0.
     *
     * @return Whether the item's children can be re-arranged by users.
     * @since 0.3
     */
gboolean granite_widgets_source_list_sortable_allow_dnd_sorting (GraniteWidgetsSourceListSortable* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE (self)->allow_dnd_sorting (self);
}


/**
     * Should return a negative integer, zero, or a positive integer if ''a''
     * sorts //before// ''b'', ''a'' sorts //with// ''b'', or ''a'' sorts
     * //after// ''b'' respectively. If two items compare as equal, their
     * order in the sorted source list is undefined.
     *
     * In order to ensure that the source list behaves as expected, this
     * method must define a partial order on the source list tree; i.e. it
     * must be reflexive, antisymmetric and transitive. Not complying with
     * those requirements could make the program fall into an infinite loop
     * and freeze the user interface.
     *
     * Should return //0// to allow any pair of items to be sortable via DnD.
     *
     * @param a First item.
     * @param b Second item.
     * @return A //negative// integer if //a// sorts before //b//,
     *         //zero// if //a// equals //b//, or a //positive//
     *         integer if //a// sorts after //b//.
     * @since 0.3
     */
gint granite_widgets_source_list_sortable_compare (GraniteWidgetsSourceListSortable* self, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b) {
	g_return_val_if_fail (self != NULL, 0);
	return GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE (self)->compare (self, a, b);
}


static void granite_widgets_source_list_sortable_base_init (GraniteWidgetsSourceListSortableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		     * Emitted after a user has re-ordered an item via DnD.
		     *
		     * @param moved The item that was moved to a different position by the user.
		     * @since 0.3
		     */
		granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL] = g_signal_new ("user_moved_item", GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	}
}


/**
 * An interface for sorting items.
 *
 * @since 0.3
 */
GType granite_widgets_source_list_sortable_get_type (void) {
	static volatile gsize granite_widgets_source_list_sortable_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_sortable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListSortableIface), (GBaseInitFunc) granite_widgets_source_list_sortable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_sortable_type_id;
		granite_widgets_source_list_sortable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListSortable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_sortable_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_sortable_type_id__volatile, granite_widgets_source_list_sortable_type_id);
	}
	return granite_widgets_source_list_sortable_type_id__volatile;
}


/**
     * Determines whether this item can be dragged outside the source list widget.
     *
     * Even if this method returns //false//, the item could still be dragged around
     * within the source list if its parent allows DnD reordering. This only happens
     * when the parent implements {@link Granite.Widgets.SourceListSortable}.
     *
     * @return //true// if the item can be dragged; //false// otherwise.
     * @since 0.3
     * @see Granite.Widgets.SourceListSortable
     */
gboolean granite_widgets_source_list_drag_source_draggable (GraniteWidgetsSourceListDragSource* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE (self)->draggable (self);
}


/**
     * This method is called when the drop site requests the data which is dragged.
     *
     * It is the responsibility of this method to fill //selection_data// with the
     * data in the format which is indicated by {@link Gtk.SelectionData.get_target}.
     *
     * @param selection_data {@link Gtk.SelectionData} containing source data.
     * @since 0.3
     * @see Gtk.SelectionData.set
     * @see Gtk.SelectionData.set_uris
     * @see Gtk.SelectionData.set_text
     */
void granite_widgets_source_list_drag_source_prepare_selection_data (GraniteWidgetsSourceListDragSource* self, GtkSelectionData* selection_data) {
	g_return_if_fail (self != NULL);
	GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE (self)->prepare_selection_data (self, selection_data);
}


static void granite_widgets_source_list_drag_source_base_init (GraniteWidgetsSourceListDragSourceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * An interface for dragging items out of the source list widget.
 *
 * @since 0.3
 */
GType granite_widgets_source_list_drag_source_get_type (void) {
	static volatile gsize granite_widgets_source_list_drag_source_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_drag_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDragSourceIface), (GBaseInitFunc) granite_widgets_source_list_drag_source_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_drag_source_type_id;
		granite_widgets_source_list_drag_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListDragSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_drag_source_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_drag_source_type_id__volatile, granite_widgets_source_list_drag_source_type_id);
	}
	return granite_widgets_source_list_drag_source_type_id__volatile;
}


/**
     * Determines whether //data// can be dropped into this item.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return //true// if the drop is possible; //false// otherwise.
     * @since 0.3
     */
gboolean granite_widgets_source_list_drag_dest_data_drop_possible (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE (self)->data_drop_possible (self, context, data);
}


/**
     * If a data drop is deemed possible, then this method is called
     * when the data is actually dropped into this item. Any actions
     * consequence of the data received should be handled here.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return The action taken, or //0// to indicate that the dropped data was not accepted.
     * @since 0.3
     */
GdkDragAction granite_widgets_source_list_drag_dest_data_received (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data) {
	g_return_val_if_fail (self != NULL, 0);
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE (self)->data_received (self, context, data);
}


static void granite_widgets_source_list_drag_dest_base_init (GraniteWidgetsSourceListDragDestIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * An interface for receiving data from other widgets via drag-and-drop.
 *
 * @since 0.3
 */
GType granite_widgets_source_list_drag_dest_get_type (void) {
	static volatile gsize granite_widgets_source_list_drag_dest_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_drag_dest_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDragDestIface), (GBaseInitFunc) granite_widgets_source_list_drag_dest_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_drag_dest_type_id;
		granite_widgets_source_list_drag_dest_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListDragDest", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_drag_dest_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_drag_dest_type_id__volatile, granite_widgets_source_list_drag_dest_type_id);
	}
	return granite_widgets_source_list_drag_dest_type_id__volatile;
}


/**
     * Creates a new {@link Granite.Widgets.SourceList}.
     *
     * @return A new {@link Granite.Widgets.SourceList}.
     * @since 0.2
     */
static void __lambda81_ (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	_tmp0_ = item;
	g_signal_emit (self, granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL], 0, _tmp0_);
}


static void ___lambda81__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	__lambda81_ ((GraniteWidgetsSourceList*) self, item);
}


GraniteWidgetsSourceList* granite_widgets_source_list_construct (GType object_type, GraniteWidgetsSourceListExpandableItem* root) {
	GraniteWidgetsSourceList * self = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListTree* _tmp2_;
	GraniteWidgetsSourceListTree* _tmp3_;
	GraniteWidgetsSourceListTree* _tmp4_;
	GraniteWidgetsSourceListTree* _tmp5_;
	g_return_val_if_fail (root != NULL, NULL);
	self = (GraniteWidgetsSourceList*) g_object_new (object_type, NULL);
	_tmp0_ = root;
	granite_widgets_source_list_set_root (self, _tmp0_);
	gtk_widget_push_composite_child ();
	_tmp1_ = self->priv->data_model;
	_tmp2_ = granite_widgets_source_list_tree_new (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->tree);
	self->priv->tree = _tmp2_;
	_tmp3_ = self->priv->tree;
	gtk_widget_set_composite_name ((GtkWidget*) _tmp3_, "treeview");
	gtk_widget_pop_composite_child ();
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	_tmp4_ = self->priv->tree;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp5_ = self->priv->tree;
	g_signal_connect_object (_tmp5_, "item-selected", (GCallback) ___lambda81__granite_widgets_source_list_tree_item_selected, self, 0);
	return self;
}


GraniteWidgetsSourceList* granite_widgets_source_list_new (GraniteWidgetsSourceListExpandableItem* root) {
	return granite_widgets_source_list_construct (GRANITE_WIDGETS_TYPE_SOURCE_LIST, root);
}


/**
     * Checks whether //item// is part of the source list.
     *
     * @param item The item to query.
     * @return //true// if the item belongs to the source list; //false// otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = self->priv->data_model;
	_tmp1_ = item;
	_tmp2_ = granite_widgets_source_list_data_model_has_item (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
     * Sets the method used for sorting items.
     *
     * This method is no longer used. It doesn't do anything. Expandable Items
     * should implement {@link Granite.Widgets.SourceListSortable} to sort their
     * children. That interface can also be used for sorting categories by
     * using a custom root item that implements it.
     *
     * @param sort_func The method to use for sorting items.
     * @since 0.2
     */
void granite_widgets_source_list_set_sort_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) {
	g_return_if_fail (self != NULL);
	g_warning ("SourceList.vala:2640: set_sort_func is deprecated and doesn't do anyth" \
"ing");
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


/**
     * Sets the method used for filtering out items.
     *
     * @param visible_func The method to use for filtering items.
     * @param refilter Whether to call {@link Granite.Widgets.SourceList.refilter} using the new function.
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.refilter
     * @since 0.2
     */
void granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target, gboolean refilter) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListVisibleFunc _tmp1_;
	void* _tmp1__target;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->data_model;
	_tmp1_ = visible_func;
	_tmp1__target = visible_func_target;
	granite_widgets_source_list_data_model_set_filter_func (_tmp0_, _tmp1_, _tmp1__target);
	_tmp2_ = refilter;
	if (_tmp2_) {
		granite_widgets_source_list_refilter (self);
	}
}


/**
     * Applies the filter method set by {@link Granite.Widgets.SourceList.set_filter_func}
     * to all the items that are part of the current tree.
     *
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.set_filter_func
     * @since 0.2
     */
void granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->data_model;
	gtk_tree_model_filter_refilter ((GtkTreeModelFilter*) _tmp0_);
}


/**
     * Queries the actual expansion state of //item//.
     *
     * @see Granite.Widgets.SourceList.ExpandableItem.expanded
     * @return Whether //item// is expanded or not.
     * @since 0.2
     */
gboolean granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkTreePath* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkTreePath* _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	_vala_return_val_if_fail (_tmp1_, "has_item (item)", FALSE);
	_tmp2_ = self->priv->data_model;
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_data_model_get_item_path (_tmp2_, _tmp3_);
	path = _tmp4_;
	_tmp6_ = path;
	if (_tmp6_ != NULL) {
		GraniteWidgetsSourceListTree* _tmp7_;
		GtkTreePath* _tmp8_;
		gboolean _tmp9_;
		_tmp7_ = self->priv->tree;
		_tmp8_ = path;
		_tmp9_ = gtk_tree_view_row_expanded ((GtkTreeView*) _tmp7_, _tmp8_);
		_tmp5_ = _tmp9_;
	} else {
		_tmp5_ = FALSE;
	}
	result = _tmp5_;
	_gtk_tree_path_free0 (path);
	return result;
}


/**
     * If //item// is editable, this activates the editor; otherwise, it does nothing.
     * If an item was already being edited, this will fail.
     *
     * @param item Item to edit.
     * @see Granite.Widgets.SourceList.Item.editable
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.stop_editing
     * @return true if the editing started successfully; false otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsSourceListTree* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	_vala_return_val_if_fail (_tmp1_, "has_item (item)", FALSE);
	_tmp2_ = self->priv->tree;
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_tree_start_editing_item (_tmp2_, _tmp3_);
	result = _tmp4_;
	return result;
}


/**
     * Cancels any editing operation going on.
     *
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.start_editing_item
     * @since 0.2
     */
void granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_editing (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GraniteWidgetsSourceListTree* _tmp2_;
		_tmp2_ = self->priv->tree;
		granite_widgets_source_list_tree_stop_editing (_tmp2_);
	}
}


/**
     * Turns Source List into a //drag source//.
     *
     * This enables items that implement {@link Granite.Widgets.SourceListDragSource}
     * to be dragged outside the Source List and drop data into external widgets.
     *
     * @param src_entries an array of {@link Gtk.TargetEntry}s indicating the targets
     * that the drag will support.
     * @see Granite.Widgets.SourceListDragSource
     * @see Granite.Widgets.SourceList.disable_drag_source
     * @since 0.3
     */
void granite_widgets_source_list_enable_drag_source (GraniteWidgetsSourceList* self, GtkTargetEntry* src_entries, int src_entries_length1) {
	GraniteWidgetsSourceListTree* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = src_entries;
	_tmp1__length1 = src_entries_length1;
	granite_widgets_source_list_tree_configure_drag_source (_tmp0_, _tmp1_, _tmp1__length1);
}


/**
     * Undoes the effect of {@link Granite.Widgets.SourceList.enable_drag_source}
     *
     * @see Granite.Widgets.SourceList.enable_drag_source
     * @since 0.3
     */
void granite_widgets_source_list_disable_drag_source (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListTree* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	granite_widgets_source_list_tree_configure_drag_source (_tmp0_, NULL, 0);
}


/**
     * Turns Source List into a //drop destination//.
     *
     * This enables items that implement {@link Granite.Widgets.SourceListDragDest}
     * to receive data from external widgets via drag-and-drop.
     *
     * @param dest_entries an array of {@link Gtk.TargetEntry}s indicating the drop
     * types that Source List items will accept.
     * @param actions a bitmask of possible actions for a drop onto Source List items.
     * @see Granite.Widgets.SourceListDragDest
     * @see Granite.Widgets.SourceList.disable_drag_dest
     * @since 0.3
     */
void granite_widgets_source_list_enable_drag_dest (GraniteWidgetsSourceList* self, GtkTargetEntry* dest_entries, int dest_entries_length1, GdkDragAction actions) {
	GraniteWidgetsSourceListTree* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	GdkDragAction _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = dest_entries;
	_tmp1__length1 = dest_entries_length1;
	_tmp2_ = actions;
	granite_widgets_source_list_tree_configure_drag_dest (_tmp0_, _tmp1_, _tmp1__length1, _tmp2_);
}


/**
     * Undoes the effect of {@link Granite.Widgets.SourceList.enable_drag_dest}
     *
     * @see Granite.Widgets.SourceList.enable_drag_dest
     * @since 0.3
     */
void granite_widgets_source_list_disable_drag_dest (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListTree* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	granite_widgets_source_list_tree_configure_drag_dest (_tmp0_, NULL, 0, 0);
}


/**
     * Scrolls the source list tree to make //item// visible.
     *
     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called
     * for the item's parent if //expand_parents// is //true//, to make sure it's not
     * hidden behind a collapsed row.
     *
     * If use_align is //false//, then the row_align argument is ignored, and the tree
     * does the minimum amount of work to scroll the item onto the screen. This means that
     * the item will be scrolled to the edge closest to its current position. If the item
     * is currently visible on the screen, nothing is done.
     *
     * @param item Item to scroll to.
     * @param expand_parents Whether to recursively expand item's parent in case they are collapsed.
     * @param use_align Whether to use the //row_align// argument.
     * @param row_align The vertical alignment of //item//. 0.0 means top, 0.5 center, and 1.0 bottom.
     * @return //true// if successful; //false// otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item, gboolean expand_parents, gboolean use_align, gfloat row_align) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	GraniteWidgetsSourceListTree* _tmp10_;
	GraniteWidgetsSourceListItem* _tmp11_;
	gboolean _tmp12_;
	gfloat _tmp13_;
	gboolean _tmp14_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	_vala_return_val_if_fail (_tmp1_, "has_item (item)", FALSE);
	_tmp3_ = expand_parents;
	if (_tmp3_) {
		GraniteWidgetsSourceListItem* _tmp4_;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_item_get_parent (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GraniteWidgetsSourceListItem* _tmp7_;
		GraniteWidgetsSourceListExpandableItem* _tmp8_;
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		_tmp7_ = item;
		_tmp8_ = granite_widgets_source_list_item_get_parent (_tmp7_);
		_tmp9_ = _tmp8_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp9_);
	}
	_tmp10_ = self->priv->tree;
	_tmp11_ = item;
	_tmp12_ = use_align;
	_tmp13_ = row_align;
	_tmp14_ = granite_widgets_source_list_tree_scroll_to_item (_tmp10_, _tmp11_, _tmp12_, _tmp13_);
	result = _tmp14_;
	return result;
}


/**
     * Gets the previous item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears before //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (reference != NULL, NULL);
	_tmp0_ = reference;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	_vala_return_val_if_fail (_tmp1_, "has_item (reference)", NULL);
	_tmp2_ = self->priv->data_model;
	_tmp3_ = reference;
	_tmp4_ = granite_widgets_source_list_data_model_get_item_iter (_tmp2_, _tmp3_);
	iter = _tmp4_;
	_tmp5_ = iter;
	if (_tmp5_ != NULL) {
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp6_;
		GraniteWidgetsSourceListDataModel* _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = iter;
		new_iter = *_tmp6_;
		_tmp7_ = self->priv->data_model;
		_tmp8_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp7_, &new_iter);
		if (_tmp8_) {
			GraniteWidgetsSourceListDataModel* _tmp9_;
			GtkTreeIter _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			_tmp9_ = self->priv->data_model;
			_tmp10_ = new_iter;
			_tmp11_ = granite_widgets_source_list_data_model_get_item (_tmp9_, &_tmp10_);
			result = _tmp11_;
			_g_free0 (iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (iter);
	return result;
}


/**
     * Gets the next item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears after //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (reference != NULL, NULL);
	_tmp0_ = reference;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	_vala_return_val_if_fail (_tmp1_, "has_item (reference)", NULL);
	_tmp2_ = self->priv->data_model;
	_tmp3_ = reference;
	_tmp4_ = granite_widgets_source_list_data_model_get_item_iter (_tmp2_, _tmp3_);
	iter = _tmp4_;
	_tmp5_ = iter;
	if (_tmp5_ != NULL) {
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp6_;
		GraniteWidgetsSourceListDataModel* _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = iter;
		new_iter = *_tmp6_;
		_tmp7_ = self->priv->data_model;
		_tmp8_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp7_, &new_iter);
		if (_tmp8_) {
			GraniteWidgetsSourceListDataModel* _tmp9_;
			GtkTreeIter _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			_tmp9_ = self->priv->data_model;
			_tmp10_ = new_iter;
			_tmp11_ = granite_widgets_source_list_data_model_get_item (_tmp9_, &_tmp10_);
			result = _tmp11_;
			_g_free0 (iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (iter);
	return result;
}


/**
     * Gets the first visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The first visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = parent;
	_tmp1_ = granite_widgets_source_list_get_nth_child (self, _tmp0_, 0);
	result = _tmp1_;
	return result;
}


/**
     * Gets the last visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The last visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	guint _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = parent;
	_tmp1_ = parent;
	_tmp2_ = granite_widgets_source_list_get_n_visible_children (self, _tmp1_);
	_tmp3_ = granite_widgets_source_list_get_nth_child (self, _tmp0_, ((gint) _tmp2_) - 1);
	result = _tmp3_;
	return result;
}


/**
     * Gets the number of visible children of an expandable item.
     *
     * @param parent Item to query.
     * @return Number of visible children of //parent//.
     * @since 0.2
     */
guint granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	guint result = 0U;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GtkTreeIter* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (parent != NULL, 0U);
	_tmp0_ = self->priv->data_model;
	_tmp1_ = parent;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_iter (_tmp0_, (GraniteWidgetsSourceListItem*) _tmp1_);
	parent_iter = _tmp2_;
	_tmp3_ = self->priv->data_model;
	_tmp4_ = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp3_, parent_iter);
	result = (guint) _tmp4_;
	_g_free0 (parent_iter);
	return result;
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent, gint index) {
	GraniteWidgetsSourceListItem* result = NULL;
	gint _tmp0_;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GtkTreeIter* _tmp3_;
	GtkTreeIter child_iter = {0};
	GraniteWidgetsSourceListDataModel* _tmp4_;
	GtkTreeIter* _tmp5_;
	gint _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = index;
	if (_tmp0_ < 0) {
		result = NULL;
		return result;
	}
	_tmp1_ = self->priv->data_model;
	_tmp2_ = parent;
	_tmp3_ = granite_widgets_source_list_data_model_get_item_iter (_tmp1_, (GraniteWidgetsSourceListItem*) _tmp2_);
	parent_iter = _tmp3_;
	_tmp4_ = self->priv->data_model;
	_tmp5_ = parent_iter;
	_tmp6_ = index;
	_tmp8_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp4_, &_tmp7_, _tmp5_, _tmp6_);
	child_iter = _tmp7_;
	if (_tmp8_) {
		GraniteWidgetsSourceListDataModel* _tmp9_;
		GtkTreeIter _tmp10_;
		GraniteWidgetsSourceListItem* _tmp11_;
		_tmp9_ = self->priv->data_model;
		_tmp10_ = child_iter;
		_tmp11_ = granite_widgets_source_list_data_model_get_item (_tmp9_, &_tmp10_);
		result = _tmp11_;
		_g_free0 (parent_iter);
		return result;
	}
	result = NULL;
	_g_free0 (parent_iter);
	return result;
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->data_model;
	_tmp1_ = granite_widgets_source_list_data_model_get_root (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* value) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->data_model;
	_tmp1_ = value;
	granite_widgets_source_list_data_model_set_root (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "root");
}


GraniteWidgetsSourceListItem* granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListTree* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_selected_item (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* value) {
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListTree* _tmp8_;
	GraniteWidgetsSourceListItem* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp1_ = value;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		_tmp2_ = value;
		_tmp3_ = granite_widgets_source_list_item_get_parent (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GraniteWidgetsSourceListItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		_tmp5_ = value;
		_tmp6_ = granite_widgets_source_list_item_get_parent (_tmp5_);
		_tmp7_ = _tmp6_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp7_);
	}
	_tmp8_ = self->priv->tree;
	_tmp9_ = value;
	granite_widgets_source_list_tree_set_selected_item (_tmp8_, _tmp9_);
	g_object_notify ((GObject *) self, "selected");
}


PangoEllipsizeMode granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self) {
	PangoEllipsizeMode result;
	GraniteWidgetsSourceListTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_ellipsize_mode (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self, PangoEllipsizeMode value) {
	GraniteWidgetsSourceListTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = value;
	granite_widgets_source_list_tree_set_ellipsize_mode (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "ellipsize-mode");
}


gboolean granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self) {
	gboolean result;
	GraniteWidgetsSourceListTree* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_editing (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


GtkSortType granite_widgets_source_list_get_sort_direction (GraniteWidgetsSourceList* self) {
	GtkSortType result;
	g_return_val_if_fail (self != NULL, 0);
	result = GTK_SORT_ASCENDING;
	return result;
}


void granite_widgets_source_list_set_sort_direction (GraniteWidgetsSourceList* self, GtkSortType value) {
	g_return_if_fail (self != NULL);
	g_warning ("SourceList.vala:2588: sort_direction is deprecated and no longer used");
	g_object_notify ((GObject *) self, "sort-direction");
}


static void granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.Item}.
         *
         * @param name Name of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.Item}.
         * @since 0.2
         */
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_construct (GType object_type, const gchar* name) {
	GraniteWidgetsSourceListItem * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (GraniteWidgetsSourceListItem*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	granite_widgets_source_list_item_set_name (self, _tmp0_);
	return self;
}


GraniteWidgetsSourceListItem* granite_widgets_source_list_item_new (const gchar* name) {
	return granite_widgets_source_list_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, name);
}


/**
         * Invoked when the item is secondary-clicked or when the usual menu keys are pressed.
         *
         * @return A {@link Gtk.Menu} or //null// if nothing should be displayed.
         * @since 0.2
         */
static GtkMenu* granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self) {
	GtkMenu* result = NULL;
	result = NULL;
	return result;
}


GtkMenu* granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS (self)->get_context_menu (self);
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self, GraniteWidgetsSourceListExpandableItem* value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_parent (self) != value) {
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_parent);
		self->priv->_parent = _tmp1_;
		g_object_notify ((GObject *) self, "parent");
	}
}


const gchar* granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, granite_widgets_source_list_item_get_name (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp1_;
		g_object_notify ((GObject *) self, "name");
	}
}


const gchar* granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_badge;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, granite_widgets_source_list_item_get_badge (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_badge);
		self->priv->_badge = _tmp1_;
		g_object_notify ((GObject *) self, "badge");
	}
}


gboolean granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_editable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_editable (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_editable = _tmp0_;
		g_object_notify ((GObject *) self, "editable");
	}
}


gboolean granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_visible;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_visible (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_visible = _tmp0_;
		g_object_notify ((GObject *) self, "visible");
	}
}


gboolean granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_selectable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_selectable (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_selectable = _tmp0_;
		g_object_notify ((GObject *) self, "selectable");
	}
}


GIcon* granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self) {
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self, GIcon* value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_icon (self) != value) {
		GIcon* _tmp0_;
		GIcon* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_icon);
		self->priv->_icon = _tmp1_;
		g_object_notify ((GObject *) self, "icon");
	}
}


GIcon* granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self) {
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_activatable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self, GIcon* value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_item_get_activatable (self) != value) {
		GIcon* _tmp0_;
		GIcon* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_activatable);
		self->priv->_activatable = _tmp1_;
		g_object_notify ((GObject *) self, "activatable");
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self, const gchar* new_name) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_if_fail (new_name != NULL);
	_tmp1_ = self->priv->_editable;
	if (_tmp1_) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = new_name;
		_tmp3_ = string_strip (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, "") != 0;
		_g_free0 (_tmp4_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp5_;
		_tmp5_ = new_name;
		granite_widgets_source_list_item_set_name (self, _tmp5_);
	}
}


static void granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self) {
}


static void granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self) {
}


static void granite_widgets_source_list_item_class_init (GraniteWidgetsSourceListItemClass * klass) {
	granite_widgets_source_list_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListItemPrivate));
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) granite_widgets_source_list_item_real_get_context_menu;
	((GraniteWidgetsSourceListItemClass *) klass)->edited = granite_widgets_source_list_item_real_edited;
	((GraniteWidgetsSourceListItemClass *) klass)->action_activated = granite_widgets_source_list_item_real_action_activated;
	((GraniteWidgetsSourceListItemClass *) klass)->activated = granite_widgets_source_list_item_real_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_item_finalize;
	/**
	         * Parent {@link Granite.Widgets.SourceList.ExpandableItem} of the item.
	         * ''Must not'' be modified.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT, g_param_spec_object ("parent", "parent", "parent", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * The item's name. Primary and most important information.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * A badge shown next to the item's name.
	         *
	         * It can be used for displaying the number of unread messages in the "Inbox" item,
	         * for instance.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE, g_param_spec_string ("badge", "badge", "badge", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item's name can be edited from within the source list.
	         *
	         * When this property is set to //true//, users can edit the item by pressing
	         * the F2 key, or by double-clicking its name.
	         *
	         * ''This property only works for selectable items''.
	         *
	         * @see Granite.Widgets.SourceList.Item.selectable
	         * @see Granite.Widgets.SourceList.start_editing_item
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE, g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item should appear in the source list's tree or not.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE, g_param_spec_boolean ("visible", "visible", "visible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item can be selected or not.
	         *
	         * Setting this property to true doesn't guarantee that the item will actually be
	         * selectable, since there are other external factors to take into account, like the
	         * item's {@link Granite.Widgets.SourceList.Item.visible} property; whether the item is
	         * a category; the parent item is collapsed, etc.
	         *
	         * @see Granite.Widgets.SourceList.Item.visible
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE, g_param_spec_boolean ("selectable", "selectable", "selectable", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Primary icon.
	         *
	         * This property should be used to give the user an idea of what the item represents
	         * (i.e. content type.)
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON, g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * An activatable icon that works like a button.
	         *
	         * It can be used for e.g. showing an //"eject"// icon on a device's item.
	         *
	         * @see Granite.Widgets.SourceList.Item.action_activated
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE, g_param_spec_object ("activatable", "activatable", "activatable", g_icon_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Emitted when the user has finished editing the item's name.
	         *
	         * By default, if the name doesn't consist of white space, it is automatically assigned
	         * to the {@link Granite.Widgets.SourceList.Item.name} property. The default behavior can
	         * be changed by overriding this signal.
	         * @param new_name The item's new name (result of editing.)
	         * @since 0.2
	         */
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL] = g_signal_new ("edited", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, edited), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	/**
	         * The {@link Granite.Widgets.SourceList.Item.activatable} icon was activated.
	         *
	         * @see Granite.Widgets.SourceList.Item.activatable
	         * @since 0.2
	         */
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("action_activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, action_activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	         * Emitted when the item is double-clicked or when it is selected and one of the keys:
	         * Space, Shift+Space, Return or Enter is pressed. This signal is //also// for
	         * editable items.
	         *
	         * @since 0.2
	         */
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_source_list_item_instance_init (GraniteWidgetsSourceListItem * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_badge = _tmp1_;
	self->priv->_editable = FALSE;
	self->priv->_visible = TRUE;
	self->priv->_selectable = TRUE;
}


static void granite_widgets_source_list_item_finalize (GObject * obj) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	_g_object_unref0 (self->priv->_parent);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_badge);
	_g_object_unref0 (self->priv->_icon);
	_g_object_unref0 (self->priv->_activatable);
	G_OBJECT_CLASS (granite_widgets_source_list_item_parent_class)->finalize (obj);
}


/**
     * A source list entry.
     *
     * Any change made to any of its properties will be ''automatically'' reflected
     * by the {@link Granite.Widgets.SourceList} widget.
     *
     * @since 0.2
     */
GType granite_widgets_source_list_item_get_type (void) {
	static volatile gsize granite_widgets_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListItem), 0, (GInstanceInitFunc) granite_widgets_source_list_item_instance_init, NULL };
		GType granite_widgets_source_list_item_type_id;
		granite_widgets_source_list_item_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteWidgetsSourceListItem", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_item_type_id__volatile, granite_widgets_source_list_item_type_id);
	}
	return granite_widgets_source_list_item_type_id__volatile;
}


static void _vala_granite_widgets_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT:
		g_value_set_object (value, granite_widgets_source_list_item_get_parent (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME:
		g_value_set_string (value, granite_widgets_source_list_item_get_name (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE:
		g_value_set_string (value, granite_widgets_source_list_item_get_badge (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_editable (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_visible (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_selectable (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON:
		g_value_set_object (value, granite_widgets_source_list_item_get_icon (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE:
		g_value_set_object (value, granite_widgets_source_list_item_get_activatable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT:
		granite_widgets_source_list_item_set_parent (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME:
		granite_widgets_source_list_item_set_name (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE:
		granite_widgets_source_list_item_set_badge (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE:
		granite_widgets_source_list_item_set_editable (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE:
		granite_widgets_source_list_item_set_visible (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE:
		granite_widgets_source_list_item_set_selectable (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON:
		granite_widgets_source_list_item_set_icon (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE:
		granite_widgets_source_list_item_set_activatable (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.ExpandableItem}
         *
         * @param name Title of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.ExpandableItem}.
         * @since 0.2
         */
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_construct (GType object_type, const gchar* name) {
	GraniteWidgetsSourceListExpandableItem * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	self = (GraniteWidgetsSourceListExpandableItem*) granite_widgets_source_list_item_construct (object_type, _tmp0_);
	granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) self, FALSE);
	return self;
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_new (const gchar* name) {
	return granite_widgets_source_list_expandable_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, name);
}


/**
         * Checks whether the item contains the specified child.
         *
         * This method only considers the item's immediate children.
         *
         * @param item Item to search.
         * @return Whether the item was found or not.
         * @since 0.2
         */
gboolean granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = self->priv->children_list;
	_tmp1_ = item;
	_tmp2_ = gee_collection_contains (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
         * Adds an item.
         *
         * {@link Granite.Widgets.SourceList.ExpandableItem.child_added} is fired after the item is added.
         *
         * While adding a child item, //the item it's being added to will set itself as the parent//.
         * Please note that items are required to have their //parent// property set to //null// before
         * being added, so make sure the item is removed from its previous parent before attempting
         * to add it to another item. For instance:
         * {{{
         * if (item.parent != null)
         *     item.parent.remove (item); // this will set item's parent to null
         * new_parent.add (item);
         * }}}
         *
         * @param item The item to add. Its parent __must__ be //null//.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_added
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GeeCollection* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_parent (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_if_fail (_tmp2_ == NULL, "item.parent == null");
	_tmp3_ = item;
	granite_widgets_source_list_item_set_parent (_tmp3_, self);
	_tmp4_ = self->priv->children_list;
	_tmp5_ = item;
	gee_collection_add (_tmp4_, _tmp5_);
	_tmp6_ = item;
	g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL], 0, _tmp6_);
}


/**
         * Removes an item.
         *
         * The {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signal is fired
         * //after removing the item//. Finally (i.e. after all the handlers have been invoked),
         * the item's {@link Granite.Widgets.SourceList.Item.parent} property is set to //null//.
         * This has the advantage of letting signal handlers know the parent from which //item//
         * is being removed.
         *
         * @param item The item to remove. This will fail if item has a different parent.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @see Granite.Widgets.SourceList.ExpandableItem.clear
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GeeCollection* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_parent (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_if_fail (_tmp2_ == self, "item.parent == this");
	_tmp3_ = self->priv->children_list;
	_tmp4_ = item;
	gee_collection_remove (_tmp3_, _tmp4_);
	_tmp5_ = item;
	g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL], 0, _tmp5_);
	_tmp6_ = item;
	granite_widgets_source_list_item_set_parent (_tmp6_, NULL);
}


/**
         * Removes all the items contained by the item. It works similarly to
         * {@link Granite.Widgets.SourceList.ExpandableItem.remove}.
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self) {
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_item_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			gboolean _tmp6_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp5_ = _item_it;
			_tmp6_ = gee_iterator_next (_tmp5_);
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = _item_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			item = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = item;
			granite_widgets_source_list_expandable_item_remove (self, _tmp9_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
}


/**
         * Expands the item and/or its children.
         *
         * @param inclusive Whether to also expand this item (true), or only its children (false).
         * @param recursive Whether to recursively expand all the children (true), or only
         * immediate children (false).
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = inclusive;
	_tmp1_ = recursive;
	granite_widgets_source_list_expandable_item_set_expansion (self, _tmp0_, _tmp1_, TRUE);
}


/**
         * Collapses the item and/or its children.
         *
         * @param inclusive Whether to also collapse this item (true), or only its children (false).
         * @param recursive Whether to recursively collapse all the children (true), or only
         * immediate children (false).
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = inclusive;
	_tmp1_ = recursive;
	granite_widgets_source_list_expandable_item_set_expansion (self, _tmp0_, _tmp1_, FALSE);
}


static void granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item, gboolean inclusive, gboolean recursive, gboolean expanded) {
	gboolean _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = inclusive;
	if (_tmp0_) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = item;
		_tmp2_ = expanded;
		granite_widgets_source_list_expandable_item_set_expanded (_tmp1_, _tmp2_);
	}
	{
		GeeIterator* _child_item_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
		_tmp3_ = item;
		_tmp4_ = granite_widgets_source_list_expandable_item_get_children (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_child_item_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_;
			GraniteWidgetsSourceListItem* child_item = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GraniteWidgetsSourceListExpandableItem* child_expandable_item = NULL;
			GraniteWidgetsSourceListItem* _tmp13_;
			GraniteWidgetsSourceListExpandableItem* _tmp14_;
			GraniteWidgetsSourceListExpandableItem* _tmp15_;
			_tmp9_ = _child_item_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _child_item_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			child_item = (GraniteWidgetsSourceListItem*) _tmp12_;
			_tmp13_ = child_item;
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp13_) : NULL);
			child_expandable_item = _tmp14_;
			_tmp15_ = child_expandable_item;
			if (_tmp15_ != NULL) {
				gboolean _tmp16_;
				_tmp16_ = recursive;
				if (_tmp16_) {
					GraniteWidgetsSourceListExpandableItem* _tmp17_;
					gboolean _tmp18_;
					_tmp17_ = child_expandable_item;
					_tmp18_ = expanded;
					granite_widgets_source_list_expandable_item_set_expansion (_tmp17_, TRUE, TRUE, _tmp18_);
				} else {
					GraniteWidgetsSourceListExpandableItem* _tmp19_;
					gboolean _tmp20_;
					_tmp19_ = child_expandable_item;
					_tmp20_ = expanded;
					granite_widgets_source_list_expandable_item_set_expanded (_tmp19_, _tmp20_);
				}
			}
			_g_object_unref0 (child_expandable_item);
			_g_object_unref0 (child_item);
		}
		_g_object_unref0 (_child_item_it);
	}
}


/**
         * Recursively expands the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
		_tmp3_ = _tmp2_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp3_);
	}
	granite_widgets_source_list_expandable_item_set_expanded (self, TRUE);
}


/**
         * Recursively collapses the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
		_tmp3_ = _tmp2_;
		granite_widgets_source_list_expandable_item_collapse_with_parents (_tmp3_);
	}
	granite_widgets_source_list_expandable_item_set_expanded (self, FALSE);
}


gboolean granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_collapsible;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_expandable_item_get_collapsible (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_collapsible = _tmp0_;
		g_object_notify ((GObject *) self, "collapsible");
	}
}


gboolean granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_expanded;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_collapsible;
		_tmp0_ = !_tmp2_;
	}
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self, gboolean value) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->_expanded;
	if (_tmp0_ != _tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = value;
		self->priv->_expanded = _tmp2_;
		g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL], 0);
	}
	g_object_notify ((GObject *) self, "expanded");
}


guint granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self) {
	guint result;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->children_list;
	_tmp1_ = gee_collection_get_size (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (guint) _tmp2_;
	return result;
}


GeeCollection* granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self) {
	GeeCollection* result;
	GeeArrayList* children_list_copy = NULL;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	children_list_copy = _tmp0_;
	_tmp1_ = self->priv->children_list;
	gee_array_list_add_all (children_list_copy, _tmp1_);
	result = (GeeCollection*) children_list_copy;
	return result;
}


static void granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self) {
}


static void granite_widgets_source_list_expandable_item_class_init (GraniteWidgetsSourceListExpandableItemClass * klass) {
	granite_widgets_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListExpandableItemPrivate));
	((GraniteWidgetsSourceListExpandableItemClass *) klass)->toggled = granite_widgets_source_list_expandable_item_real_toggled;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_expandable_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_expandable_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_expandable_item_finalize;
	/**
	         * Whether the item is collapsible or not.
	         *
	         * When set to //false//, the item is //always// expanded and the expander is
	         * not shown. Please note that this will also affect the value returned by the
	         * {@link Granite.Widgets.SourceList.ExpandableItem.expanded} property.
	         *
	         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE, g_param_spec_boolean ("collapsible", "collapsible", "collapsible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED, g_param_spec_boolean ("expanded", "expanded", "expanded", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Number of children contained by the item.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN, g_param_spec_uint ("n-children", "n-children", "n-children", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * The item's children.
	         *
	         * This returns a newly-created list containing the children.
	         * It's safe to iterate it while removing items with
	         * {@link Granite.Widgets.SourceList.ExpandableItem.remove}
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN, g_param_spec_object ("children", "children", "children", GEE_TYPE_COLLECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * Emitted when an item is added.
	         *
	         * @param item Item added.
	         * @see Granite.Widgets.SourceList.ExpandableItem.add
	         * @since 0.2
	         */
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL] = g_signal_new ("child_added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	/**
	         * Emitted when an item is removed.
	         *
	         * @param item Item removed.
	         * @see Granite.Widgets.SourceList.ExpandableItem.remove
	         * @since 0.2
	         */
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL] = g_signal_new ("child_removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	/**
	         * Emitted when the item is expanded or collapsed.
	         *
	         * @since 0.2
	         */
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL] = g_signal_new ("toggled", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListExpandableItemClass, toggled), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_source_list_expandable_item_instance_init (GraniteWidgetsSourceListExpandableItem * self) {
	GeeArrayList* _tmp0_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE (self);
	self->priv->_collapsible = TRUE;
	self->priv->_expanded = FALSE;
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->children_list = (GeeCollection*) _tmp0_;
}


static void granite_widgets_source_list_expandable_item_finalize (GObject * obj) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	_g_object_unref0 (self->priv->children_list);
	G_OBJECT_CLASS (granite_widgets_source_list_expandable_item_parent_class)->finalize (obj);
}


/**
     * An item that can contain more items.
     *
     * It supports all the properties inherited from {@link Granite.Widgets.SourceList.Item},
     * and behaves like a normal item, except when it is located at the root level; in that case,
     * the following properties are ignored by the widget:
     *
     * * {@link Granite.Widgets.SourceList.Item.selectable}
     * * {@link Granite.Widgets.SourceList.Item.editable}
     * * {@link Granite.Widgets.SourceList.Item.icon}
     * * {@link Granite.Widgets.SourceList.Item.activatable}
     * * {@link Granite.Widgets.SourceList.Item.badge}
     *
     * Root-level expandable items (i.e. Main Categories) are ''not'' displayed when they contain
     * zero visible children.
     *
     * @since 0.2
     */
GType granite_widgets_source_list_expandable_item_get_type (void) {
	static volatile gsize granite_widgets_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListExpandableItem), 0, (GInstanceInitFunc) granite_widgets_source_list_expandable_item_instance_init, NULL };
		GType granite_widgets_source_list_expandable_item_type_id;
		granite_widgets_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "GraniteWidgetsSourceListExpandableItem", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_expandable_item_type_id__volatile, granite_widgets_source_list_expandable_item_type_id);
	}
	return granite_widgets_source_list_expandable_item_type_id__volatile;
}


static void _vala_granite_widgets_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE:
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_collapsible (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED:
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_expanded (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN:
		g_value_set_uint (value, granite_widgets_source_list_expandable_item_get_n_children (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN:
		g_value_take_object (value, granite_widgets_source_list_expandable_item_get_children (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE:
		granite_widgets_source_list_expandable_item_set_collapsible (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED:
		granite_widgets_source_list_expandable_item_set_expanded (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static GType granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self) {
	GType result = 0UL;
	switch (self) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM:
		{
			result = GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


static GType granite_widgets_source_list_data_model_column_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_data_model_column_type_id;
		granite_widgets_source_list_data_model_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListDataModelColumn", values);
		g_once_init_leave (&granite_widgets_source_list_data_model_column_type_id__volatile, granite_widgets_source_list_data_model_column_type_id);
	}
	return granite_widgets_source_list_data_model_column_type_id__volatile;
}


static gint _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self) {
	gint result;
	result = granite_widgets_source_list_data_model_child_model_sort_func ((GraniteWidgetsSourceListDataModel*) self, model, a, b);
	return result;
}


static gboolean _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self) {
	gboolean result;
	result = granite_widgets_source_list_data_model_filter_visible_func ((GraniteWidgetsSourceListDataModel*) self, model, iter);
	return result;
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_construct (GType object_type) {
	GraniteWidgetsSourceListDataModel * self = NULL;
	GtkTreeStore* child_tree = NULL;
	GType _tmp0_;
	GtkTreeStore* _tmp1_;
	GtkTreeStore* _tmp2_;
	_tmp0_ = granite_widgets_source_list_data_model_column_type (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM);
	_tmp1_ = gtk_tree_store_new ((gint) GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, _tmp0_);
	child_tree = _tmp1_;
	self = (GraniteWidgetsSourceListDataModel*) g_object_new (object_type, "child-model", child_tree, "virtual-root", NULL, NULL);
	_tmp2_ = _g_object_ref0 (child_tree);
	_g_object_unref0 (self->priv->child_tree);
	self->priv->child_tree = _tmp2_;
	gtk_tree_sortable_set_default_sort_func ((GtkTreeSortable*) child_tree, _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
	granite_widgets_source_list_data_model_resort (self);
	gtk_tree_model_filter_set_visible_func ((GtkTreeModelFilter*) self, _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (child_tree);
	return self;
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_new (void) {
	return granite_widgets_source_list_data_model_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL);
}


static gboolean granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static void granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListDataModelNodeWrapper* node_reference = NULL;
	GeeHashMap* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	gpointer _tmp6_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	_vala_return_if_fail (_tmp1_, "has_item (item)");
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	_tmp4_ = self->priv->items;
	_tmp5_ = item;
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
	node_reference = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp6_;
	_tmp7_ = node_reference;
	if (_tmp7_ != NULL) {
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		GtkTreeIter* iter = NULL;
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp11_;
		GtkTreeIter* _tmp12_;
		GtkTreeIter* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GtkTreePath* _tmp15_;
		_tmp8_ = node_reference;
		_tmp9_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp8_);
		_tmp10_ = _tmp9_;
		path = _tmp10_;
		_tmp11_ = node_reference;
		_tmp12_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp11_);
		_tmp13_ = _tmp12_;
		iter = _tmp13_;
		_tmp15_ = path;
		if (_tmp15_ != NULL) {
			GtkTreeIter* _tmp16_;
			_tmp16_ = iter;
			_tmp14_ = _tmp16_ != NULL;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			GtkTreeStore* _tmp17_;
			GtkTreePath* _tmp18_;
			GtkTreeIter* _tmp19_;
			GtkTreeIter _tmp20_;
			GraniteWidgetsSourceListItem* _tmp21_;
			_tmp17_ = self->priv->child_tree;
			_tmp18_ = path;
			_tmp19_ = iter;
			_tmp20_ = *_tmp19_;
			gtk_tree_model_row_changed ((GtkTreeModel*) _tmp17_, _tmp18_, &_tmp20_);
			_tmp21_ = item;
			g_signal_emit (self, granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, _tmp21_);
		}
		_g_free0 (iter);
		_gtk_tree_path_free0 (path);
	}
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (node_reference);
}


static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self) {
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}


static gpointer __gtk_tree_iter_dup0 (gpointer self) {
	return self ? _gtk_tree_iter_dup (self) : NULL;
}


static void granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GtkTreeIter* parent_child_iter = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListExpandableItem* parent = NULL;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* _tmp5_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GtkTreeStore* _tmp19_;
	GtkTreeIter* _tmp20_;
	GtkTreeIter _tmp21_ = {0};
	GtkTreeIter _tmp22_;
	GtkTreeIter* _tmp23_;
	GtkTreeStore* _tmp24_;
	GtkTreeIter* _tmp25_;
	GraniteWidgetsSourceListItem* _tmp26_;
	GtkTreeIter _tmp27_;
	GeeHashMap* _tmp28_;
	GraniteWidgetsSourceListItem* _tmp29_;
	GtkTreeStore* _tmp30_;
	GtkTreeIter* _tmp31_;
	GtkTreeIter _tmp32_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp33_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp34_;
	GraniteWidgetsSourceListItem* _tmp35_;
	GraniteWidgetsSourceListItem* _tmp36_;
	GraniteWidgetsSourceListExpandableItem* _tmp37_;
	GraniteWidgetsSourceListExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListItem* _tmp38_;
	GraniteWidgetsSourceListExpandableItem* _tmp39_;
	GraniteWidgetsSourceListExpandableItem* _tmp40_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	_vala_return_if_fail (!_tmp1_, "!has_item (item)");
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	parent_child_iter = NULL;
	_tmp4_ = item;
	_tmp5_ = granite_widgets_source_list_item_get_parent (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	parent = _tmp7_;
	_tmp9_ = parent;
	if (_tmp9_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
		GraniteWidgetsSourceListExpandableItem* _tmp11_;
		GraniteWidgetsSourceListExpandableItem* _tmp12_;
		_tmp10_ = parent;
		_tmp11_ = granite_widgets_source_list_data_model_get_root (self);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp10_ != _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		GraniteWidgetsSourceListExpandableItem* _tmp13_;
		gboolean _tmp14_;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GtkTreeIter* _tmp17_;
		GtkTreeIter* _tmp18_;
		_tmp13_ = parent;
		_tmp14_ = granite_widgets_source_list_data_model_has_item (self, (GraniteWidgetsSourceListItem*) _tmp13_);
		if (!_tmp14_) {
			GraniteWidgetsSourceListExpandableItem* _tmp15_;
			_tmp15_ = parent;
			granite_widgets_source_list_data_model_add_item (self, (GraniteWidgetsSourceListItem*) _tmp15_);
		}
		_tmp16_ = parent;
		_tmp17_ = granite_widgets_source_list_data_model_get_item_child_iter (self, (GraniteWidgetsSourceListItem*) _tmp16_);
		_g_free0 (parent_child_iter);
		parent_child_iter = _tmp17_;
		_tmp18_ = parent_child_iter;
		_vala_assert (_tmp18_ != NULL, "parent_child_iter != null");
	}
	_tmp19_ = self->priv->child_tree;
	_tmp20_ = parent_child_iter;
	gtk_tree_store_append (_tmp19_, &_tmp21_, _tmp20_);
	_g_free0 (child_iter);
	_tmp22_ = _tmp21_;
	_tmp23_ = __gtk_tree_iter_dup0 (&_tmp22_);
	child_iter = _tmp23_;
	_tmp24_ = self->priv->child_tree;
	_tmp25_ = child_iter;
	_tmp26_ = item;
	_tmp27_ = *_tmp25_;
	gtk_tree_store_set (_tmp24_, &_tmp27_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, _tmp26_, -1, -1);
	_tmp28_ = self->priv->items;
	_tmp29_ = item;
	_tmp30_ = self->priv->child_tree;
	_tmp31_ = child_iter;
	_tmp32_ = *_tmp31_;
	_tmp33_ = granite_widgets_source_list_data_model_node_wrapper_new ((GtkTreeModel*) _tmp30_, &_tmp32_);
	_tmp34_ = _tmp33_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp34_);
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (_tmp34_);
	_tmp35_ = item;
	g_signal_emit (self, granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, _tmp35_);
	_tmp36_ = item;
	granite_widgets_source_list_data_model_add_property_monitor (self, _tmp36_);
	_tmp37_ = parent;
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp37_);
	_tmp38_ = item;
	_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp38_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp38_) : NULL);
	expandable = _tmp39_;
	_tmp40_ = expandable;
	if (_tmp40_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp52_;
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp41_;
			GeeCollection* _tmp42_;
			GeeCollection* _tmp43_;
			GeeCollection* _tmp44_;
			GeeIterator* _tmp45_;
			GeeIterator* _tmp46_;
			_tmp41_ = expandable;
			_tmp42_ = granite_widgets_source_list_expandable_item_get_children (_tmp41_);
			_tmp43_ = _tmp42_;
			_tmp44_ = _tmp43_;
			_tmp45_ = gee_iterable_iterator ((GeeIterable*) _tmp44_);
			_tmp46_ = _tmp45_;
			_g_object_unref0 (_tmp44_);
			_child_item_it = _tmp46_;
			while (TRUE) {
				GeeIterator* _tmp47_;
				gboolean _tmp48_;
				GraniteWidgetsSourceListItem* child_item = NULL;
				GeeIterator* _tmp49_;
				gpointer _tmp50_;
				GraniteWidgetsSourceListItem* _tmp51_;
				_tmp47_ = _child_item_it;
				_tmp48_ = gee_iterator_next (_tmp47_);
				if (!_tmp48_) {
					break;
				}
				_tmp49_ = _child_item_it;
				_tmp50_ = gee_iterator_get (_tmp49_);
				child_item = (GraniteWidgetsSourceListItem*) _tmp50_;
				_tmp51_ = child_item;
				granite_widgets_source_list_data_model_add_item (self, _tmp51_);
				_g_object_unref0 (child_item);
			}
			_g_object_unref0 (_child_item_it);
		}
		_tmp52_ = expandable;
		granite_widgets_source_list_data_model_add_children_monitor (self, _tmp52_);
	}
	_g_object_unref0 (expandable);
	_g_object_unref0 (parent);
	_g_free0 (child_iter);
	_g_free0 (parent_child_iter);
}


static void granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListItem* _tmp5_;
	GtkTreeIter* _tmp6_;
	GeeHashMap* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	GtkTreeIter* _tmp9_;
	GraniteWidgetsSourceListItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	_vala_return_if_fail (_tmp1_, "has_item (item)");
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	_tmp4_ = item;
	granite_widgets_source_list_data_model_remove_property_monitor (self, _tmp4_);
	_tmp5_ = item;
	_tmp6_ = granite_widgets_source_list_data_model_get_item_child_iter (self, _tmp5_);
	child_iter = _tmp6_;
	_tmp7_ = self->priv->items;
	_tmp8_ = item;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
	_tmp9_ = child_iter;
	if (_tmp9_ != NULL) {
		GtkTreeStore* _tmp10_;
		_tmp10_ = self->priv->child_tree;
		gtk_tree_store_remove (_tmp10_, child_iter);
	}
	_tmp11_ = item;
	_tmp12_ = granite_widgets_source_list_item_get_parent (_tmp11_);
	_tmp13_ = _tmp12_;
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp13_);
	_tmp14_ = item;
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp14_) : NULL);
	expandable = _tmp15_;
	_tmp16_ = expandable;
	if (_tmp16_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp17_;
		_tmp17_ = expandable;
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp17_);
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp18_;
			GeeCollection* _tmp19_;
			GeeCollection* _tmp20_;
			GeeCollection* _tmp21_;
			GeeIterator* _tmp22_;
			GeeIterator* _tmp23_;
			_tmp18_ = expandable;
			_tmp19_ = granite_widgets_source_list_expandable_item_get_children (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = _tmp20_;
			_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
			_tmp23_ = _tmp22_;
			_g_object_unref0 (_tmp21_);
			_child_item_it = _tmp23_;
			while (TRUE) {
				GeeIterator* _tmp24_;
				gboolean _tmp25_;
				GraniteWidgetsSourceListItem* child_item = NULL;
				GeeIterator* _tmp26_;
				gpointer _tmp27_;
				GraniteWidgetsSourceListItem* _tmp28_;
				_tmp24_ = _child_item_it;
				_tmp25_ = gee_iterator_next (_tmp24_);
				if (!_tmp25_) {
					break;
				}
				_tmp26_ = _child_item_it;
				_tmp27_ = gee_iterator_get (_tmp26_);
				child_item = (GraniteWidgetsSourceListItem*) _tmp27_;
				_tmp28_ = child_item;
				granite_widgets_source_list_data_model_remove_item (self, _tmp28_);
				_g_object_unref0 (child_item);
			}
			_g_object_unref0 (_child_item_it);
		}
	}
	_g_object_unref0 (expandable);
	_g_free0 (child_iter);
}


static void _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender, GraniteWidgetsSourceListItem* _self_, const gchar* prop_name, gpointer self) {
	granite_widgets_source_list_data_model_on_item_prop_changed ((GraniteWidgetsSourceListDataModel*) self, _self_, prop_name);
}


static void granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp1_;
	GeeHashMap* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_item_monitor_new (_tmp0_);
	wrapper = _tmp1_;
	_tmp2_ = self->priv->monitors;
	_tmp3_ = item;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, _tmp3_, wrapper);
	g_signal_connect_object (wrapper, "changed", (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self, 0);
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
}


static void granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper = NULL;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp3_;
	GeeHashMap* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->monitors;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	wrapper = (GraniteWidgetsSourceListDataModelItemMonitor*) _tmp2_;
	_tmp3_ = wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelItemMonitor* _tmp4_;
		guint _tmp5_;
		_tmp4_ = wrapper;
		g_signal_parse_name ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, &_tmp5_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self);
	}
	_tmp6_ = self->priv->monitors;
	_tmp7_ = item;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp6_, _tmp7_, NULL);
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
}


static void _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_data_model_on_item_child_added ((GraniteWidgetsSourceListDataModel*) self, item);
}


static void _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_data_model_on_item_child_removed ((GraniteWidgetsSourceListDataModel*) self, item);
}


static void granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_connect_object (_tmp0_, "child-added", (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self, G_CONNECT_AFTER);
	_tmp1_ = item;
	g_signal_connect_object (_tmp1_, "child-removed", (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self, G_CONNECT_AFTER);
}


static void granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	guint _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_parse_name ("child-added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self);
	_tmp2_ = item;
	g_signal_parse_name ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self);
}


static void granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	granite_widgets_source_list_data_model_add_item (self, _tmp0_);
}


static void granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	granite_widgets_source_list_data_model_remove_item (self, _tmp0_);
}


static void granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, const gchar* prop_name) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_return_if_fail (prop_name != NULL);
	_tmp0_ = prop_name;
	if (g_strcmp0 (_tmp0_, "parent") != 0) {
		GraniteWidgetsSourceListItem* _tmp1_;
		_tmp1_ = item;
		granite_widgets_source_list_data_model_update_item (self, _tmp1_);
	}
}


/**
         * Pushes a call to update_item() if //parent// is not //null//.
         *
         * This is needed because the visibility of categories depends on their n_children property,
         * and also because item expansion should be updated after adding or removing items.
         * If many updates are pushed, and the item has still not been updated, only one is processed.
         * This guarantees efficiency as updating a category item could trigger expensive actions.
         */
static Block14Data* block14_data_ref (Block14Data* _data14_) {
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}


static void block14_data_unref (void * _userdata_) {
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		GraniteWidgetsSourceListDataModel* self;
		self = _data14_->self;
		_g_object_unref0 (_data14_->parent);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}


static gboolean ___lambda80_ (Block14Data* _data14_) {
	GraniteWidgetsSourceListDataModel* self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	self = _data14_->self;
	_tmp0_ = _data14_->parent;
	if (_tmp0_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		_tmp1_ = _data14_->parent;
		granite_widgets_source_list_data_model_update_item (self, (GraniteWidgetsSourceListItem*) _tmp1_);
		_tmp2_ = _data14_->parent;
		g_object_set_data_full ((GObject*) _tmp2_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) FALSE), NULL);
	}
	result = FALSE;
	return result;
}


static gboolean ____lambda80__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda80_ (self);
	return result;
}


static void granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* parent) {
	Block14Data* _data14_;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	gboolean needs_update = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	gconstpointer _tmp4_;
	gboolean _tmp5_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GtkTreePath* _tmp7_;
	GtkTreePath* _tmp8_;
	g_return_if_fail (self != NULL);
	_data14_ = g_slice_new0 (Block14Data);
	_data14_->_ref_count_ = 1;
	_data14_->self = g_object_ref (self);
	_tmp0_ = parent;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data14_->parent);
	_data14_->parent = _tmp1_;
	_tmp2_ = _data14_->parent;
	if (_tmp2_ == NULL) {
		block14_data_unref (_data14_);
		_data14_ = NULL;
		return;
	}
	_tmp3_ = _data14_->parent;
	_tmp4_ = g_object_get_data ((GObject*) _tmp3_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE);
	needs_update = (gboolean) ((gintptr) _tmp4_);
	_tmp5_ = needs_update;
	if (_tmp5_) {
		block14_data_unref (_data14_);
		_data14_ = NULL;
		return;
	}
	_tmp6_ = _data14_->parent;
	_tmp7_ = granite_widgets_source_list_data_model_get_item_path (self, (GraniteWidgetsSourceListItem*) _tmp6_);
	path = _tmp7_;
	_tmp8_ = path;
	if (_tmp8_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		_tmp9_ = _data14_->parent;
		g_object_set_data_full ((GObject*) _tmp9_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) TRUE), NULL);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda80__gsource_func, block14_data_ref (_data14_), block14_data_unref);
	}
	_gtk_tree_path_free0 (path);
	block14_data_unref (_data14_);
	_data14_ = NULL;
}


/**
         * Returns the Item pointed by iter, or null if the iter doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
	result = item;
	return result;
}


/**
         * Returns the Item pointed by path, or null if the path doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path) {
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreePath* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	_tmp2_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp1_, _tmp0_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkTreeIter _tmp3_;
		GraniteWidgetsSourceListItem* _tmp4_;
		_tmp3_ = iter;
		_tmp4_ = granite_widgets_source_list_data_model_get_item (self, &_tmp3_);
		result = _tmp4_;
		return result;
	}
	result = NULL;
	return result;
}


/**
         * Returns a newly-created path pointing to the item, or null in case a valid path
         * is not found.
         */
static GtkTreePath* granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreePath* result = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* child_path = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	path = NULL;
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_get_item_child_path (self, _tmp0_);
	child_path = _tmp1_;
	_tmp2_ = child_path;
	if (_tmp2_ != NULL) {
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
		_tmp3_ = child_path;
		_tmp4_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp3_);
		_gtk_tree_path_free0 (path);
		path = _tmp4_;
	}
	result = path;
	_gtk_tree_path_free0 (child_path);
	return result;
}


/**
         * Returns a newly-created iterator pointing to the item, or null in case a valid iter
         * was not found.
         */
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_get_item_child_iter (self, _tmp0_);
	child_iter = _tmp1_;
	_tmp2_ = child_iter;
	if (_tmp2_ != NULL) {
		GtkTreeIter iter = {0};
		GtkTreeIter* _tmp3_;
		GtkTreeIter _tmp4_ = {0};
		GtkTreeIter _tmp5_;
		gboolean _tmp6_;
		_tmp3_ = child_iter;
		_tmp5_ = *_tmp3_;
		_tmp6_ = gtk_tree_model_filter_convert_child_iter_to_iter ((GtkTreeModelFilter*) self, &_tmp4_, &_tmp5_);
		iter = _tmp4_;
		if (_tmp6_) {
			GtkTreeIter* _tmp7_;
			_tmp7_ = __gtk_tree_iter_dup0 (&iter);
			result = _tmp7_;
			_g_free0 (child_iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (child_iter);
	return result;
}


/**
         * External "extra" filter method.
         */
static void granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target) {
	GraniteWidgetsSourceListVisibleFunc _tmp0_;
	void* _tmp0__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = visible_func;
	_tmp0__target = visible_func_target;
	self->priv->filter_func = _tmp0_;
	self->priv->filter_func_target = _tmp0__target;
}


/**
         * Checks whether an item is a category (i.e. a root-level expandable item).
         * The caller must pass an iter or path pointing to the item, but not both
         * (one of them must be null.)
         *
         * TODO: instead of checking the position of the iter or path, we should simply
         * check whether the item's parent is the root item and whether the item is
         * expandable. We don't do so right now because vala still allows client code
         * to access the Item.parent property, even though its setter is defined as internal.
         */
static gboolean granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, GtkTreeIter* iter, GtkTreePath* path) {
	gboolean result = FALSE;
	gboolean is_category = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	is_category = FALSE;
	_tmp0_ = item;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM)) {
		GtkTreeIter* _tmp1_;
		_tmp1_ = iter;
		if (_tmp1_ != NULL) {
			GtkTreePath* _tmp2_;
			GtkTreeIter* _tmp3_;
			GtkTreeIter _tmp4_;
			gboolean _tmp5_;
			_tmp2_ = path;
			_vala_assert (_tmp2_ == NULL, "path == null");
			_tmp3_ = iter;
			_tmp4_ = *_tmp3_;
			_tmp5_ = granite_widgets_source_list_data_model_is_iter_at_root_level (self, &_tmp4_);
			is_category = _tmp5_;
		} else {
			GtkTreeIter* _tmp6_;
			GtkTreePath* _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = iter;
			_vala_assert (_tmp6_ == NULL, "iter == null");
			_tmp7_ = path;
			_tmp8_ = granite_widgets_source_list_data_model_is_path_at_root_level (self, _tmp7_);
			is_category = _tmp8_;
		}
	}
	result = is_category;
	return result;
}


static gboolean granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter) {
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_tmp1_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = granite_widgets_source_list_data_model_is_path_at_root_level (self, _tmp2_);
	_tmp4_ = _tmp3_;
	_gtk_tree_path_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static gboolean granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path) {
	gboolean result = FALSE;
	GtkTreePath* _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = gtk_tree_path_get_depth (_tmp0_);
	result = _tmp1_ == 1;
	return result;
}


static void granite_widgets_source_list_data_model_resort (GraniteWidgetsSourceListDataModel* self) {
	GtkTreeStore* _tmp0_;
	GtkTreeStore* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->child_tree;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
	_tmp1_ = self->priv->child_tree;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp1_, GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
}


static gint granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b) {
	gint result = 0;
	gint order = 0;
	GraniteWidgetsSourceListItem* item_a = NULL;
	GraniteWidgetsSourceListItem* item_b = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* _tmp5_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListSortable* parent = NULL;
	GraniteWidgetsSourceListItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListSortable* _tmp13_;
	GraniteWidgetsSourceListSortable* _tmp14_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (model != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	order = 0;
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = *a;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item_a, -1, -1);
	_tmp2_ = self->priv->child_tree;
	_tmp3_ = *b;
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item_b, -1, -1);
	_tmp4_ = item_a;
	_tmp5_ = granite_widgets_source_list_item_get_parent (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = item_b;
	_tmp8_ = granite_widgets_source_list_item_get_parent (_tmp7_);
	_tmp9_ = _tmp8_;
	_vala_assert (_tmp6_ == _tmp9_, "item_a.parent == item_b.parent");
	_tmp10_ = item_a;
	_tmp11_ = granite_widgets_source_list_item_get_parent (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp12_) : NULL);
	parent = _tmp13_;
	_tmp14_ = parent;
	if (_tmp14_ != NULL) {
		GraniteWidgetsSourceListSortable* _tmp15_;
		GraniteWidgetsSourceListItem* _tmp16_;
		GraniteWidgetsSourceListItem* _tmp17_;
		gint _tmp18_;
		_tmp15_ = parent;
		_tmp16_ = item_a;
		_tmp17_ = item_b;
		_tmp18_ = granite_widgets_source_list_sortable_compare (_tmp15_, _tmp16_, _tmp17_);
		order = _tmp18_;
	}
	result = order;
	_g_object_unref0 (parent);
	_g_object_unref0 (item_b);
	_g_object_unref0 (item_a);
	return result;
}


static GtkTreeIter* granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	child_iter = NULL;
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp2_;
	_tmp3_ = child_node_wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp4_;
		GtkTreeIter* _tmp5_;
		GtkTreeIter* _tmp6_;
		_tmp4_ = child_node_wrapper;
		_tmp5_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (child_iter);
		child_iter = _tmp6_;
	}
	result = child_iter;
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
	return result;
}


static GtkTreePath* granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreePath* result = NULL;
	GtkTreePath* child_path = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	child_path = NULL;
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp2_;
	_tmp3_ = child_node_wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreePath* _tmp6_;
		_tmp4_ = child_node_wrapper;
		_tmp5_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_gtk_tree_path_free0 (child_path);
		child_path = _tmp6_;
	}
	result = child_path;
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
	return result;
}


/**
         * Filters the child-tree items based on their "visible" property.
         */
static gboolean granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* child_model, GtkTreeIter* iter) {
	gboolean result = FALSE;
	gboolean item_visible = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListVisibleFunc _tmp30_;
	void* _tmp30__target;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (child_model != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	item_visible = FALSE;
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
	_tmp2_ = item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GraniteWidgetsSourceListExpandableItem* expandable = NULL;
		GraniteWidgetsSourceListItem* _tmp6_;
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		_tmp3_ = item;
		_tmp4_ = granite_widgets_source_list_item_get_visible (_tmp3_);
		_tmp5_ = _tmp4_;
		item_visible = _tmp5_;
		_tmp6_ = item;
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp6_) : NULL);
		expandable = _tmp7_;
		_tmp9_ = expandable;
		if (_tmp9_ != NULL) {
			GtkTreeStore* _tmp10_;
			GtkTreeIter _tmp11_;
			gint _tmp12_;
			_tmp10_ = self->priv->child_tree;
			_tmp11_ = *iter;
			_tmp12_ = gtk_tree_store_iter_depth (_tmp10_, &_tmp11_);
			_tmp8_ = _tmp12_ == 0;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			guint n_visible_children = 0U;
			gboolean _tmp27_ = FALSE;
			gboolean _tmp28_;
			n_visible_children = (guint) 0;
			{
				GeeIterator* _child_item_it = NULL;
				GraniteWidgetsSourceListExpandableItem* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				GeeIterator* _tmp17_;
				GeeIterator* _tmp18_;
				_tmp13_ = expandable;
				_tmp14_ = granite_widgets_source_list_expandable_item_get_children (_tmp13_);
				_tmp15_ = _tmp14_;
				_tmp16_ = _tmp15_;
				_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
				_tmp18_ = _tmp17_;
				_g_object_unref0 (_tmp16_);
				_child_item_it = _tmp18_;
				while (TRUE) {
					GeeIterator* _tmp19_;
					gboolean _tmp20_;
					GraniteWidgetsSourceListItem* child_item = NULL;
					GeeIterator* _tmp21_;
					gpointer _tmp22_;
					GraniteWidgetsSourceListItem* _tmp23_;
					gboolean _tmp24_;
					gboolean _tmp25_;
					_tmp19_ = _child_item_it;
					_tmp20_ = gee_iterator_next (_tmp19_);
					if (!_tmp20_) {
						break;
					}
					_tmp21_ = _child_item_it;
					_tmp22_ = gee_iterator_get (_tmp21_);
					child_item = (GraniteWidgetsSourceListItem*) _tmp22_;
					_tmp23_ = child_item;
					_tmp24_ = granite_widgets_source_list_item_get_visible (_tmp23_);
					_tmp25_ = _tmp24_;
					if (_tmp25_) {
						guint _tmp26_;
						_tmp26_ = n_visible_children;
						n_visible_children = _tmp26_ + 1;
					}
					_g_object_unref0 (child_item);
				}
				_g_object_unref0 (_child_item_it);
			}
			_tmp28_ = item_visible;
			if (_tmp28_) {
				guint _tmp29_;
				_tmp29_ = n_visible_children;
				_tmp27_ = _tmp29_ > ((guint) 0);
			} else {
				_tmp27_ = FALSE;
			}
			item_visible = _tmp27_;
		}
		_g_object_unref0 (expandable);
	}
	_tmp30_ = self->priv->filter_func;
	_tmp30__target = self->priv->filter_func_target;
	if (_tmp30_ != NULL) {
		gboolean _tmp31_ = FALSE;
		gboolean _tmp32_;
		_tmp32_ = item_visible;
		if (_tmp32_) {
			GraniteWidgetsSourceListVisibleFunc _tmp33_;
			void* _tmp33__target;
			GraniteWidgetsSourceListItem* _tmp34_;
			gboolean _tmp35_;
			_tmp33_ = self->priv->filter_func;
			_tmp33__target = self->priv->filter_func_target;
			_tmp34_ = item;
			_tmp35_ = _tmp33_ (_tmp34_, _tmp33__target);
			_tmp31_ = _tmp35_;
		} else {
			_tmp31_ = FALSE;
		}
		item_visible = _tmp31_;
	}
	result = item_visible;
	_g_object_unref0 (item);
	return result;
}


/**
         * TreeDragDest implementation
         */
static gboolean granite_widgets_source_list_data_model_real_drag_data_received (GtkTreeDragDest* base, GtkTreePath* dest, GtkSelectionData* selection_data) {
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkSelectionData* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GtkTreePath* _tmp3_ = NULL;
	gboolean _tmp4_;
	GtkTreeModel* _tmp5_;
	self = (GraniteWidgetsSourceListDataModel*) base;
	g_return_val_if_fail (dest != NULL, FALSE);
	g_return_val_if_fail (selection_data != NULL, FALSE);
	_tmp1_ = selection_data;
	_tmp4_ = gtk_tree_get_row_drag_data (_tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (model);
	_tmp5_ = _g_object_ref0 (_tmp2_);
	model = _tmp5_;
	_gtk_tree_path_free0 (src_path);
	src_path = _tmp3_;
	if (_tmp4_) {
		GtkTreeModel* _tmp6_;
		GtkTreeStore* _tmp7_;
		_tmp6_ = model;
		_tmp7_ = self->priv->child_tree;
		_tmp0_ = _tmp6_ == _tmp7_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkTreePath* child_dest = NULL;
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		_tmp8_ = dest;
		_tmp9_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, _tmp8_);
		child_dest = _tmp9_;
		_tmp10_ = child_dest;
		if (_tmp10_ != NULL) {
			GtkTreePath* _tmp11_;
			GtkTreePath* _tmp12_;
			gboolean _tmp13_;
			_tmp11_ = child_dest;
			_tmp12_ = src_path;
			_tmp13_ = granite_widgets_source_list_data_model_child_tree_drag_data_received (self, _tmp11_, _tmp12_);
			if (_tmp13_) {
				result = TRUE;
				_gtk_tree_path_free0 (child_dest);
				_gtk_tree_path_free0 (src_path);
				_g_object_unref0 (model);
				return result;
			}
		}
		_gtk_tree_path_free0 (child_dest);
	}
	result = FALSE;
	_gtk_tree_path_free0 (src_path);
	_g_object_unref0 (model);
	return result;
}


static gpointer _gtk_tree_path_copy0 (gpointer self) {
	return self ? gtk_tree_path_copy (self) : NULL;
}


static gboolean granite_widgets_source_list_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListDataModel* self, GtkTreePath* dest, GtkTreePath* src_path) {
	gboolean result = FALSE;
	gboolean retval = FALSE;
	GtkTreeIter src_iter = {0};
	GtkTreeIter dest_iter = {0};
	GtkTreeStore* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkTreePath* prev = NULL;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp31_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (dest != NULL, FALSE);
	g_return_val_if_fail (src_path != NULL, FALSE);
	retval = FALSE;
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = src_path;
	_tmp3_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp2_, _tmp1_);
	src_iter = _tmp2_;
	if (!_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = dest;
	_tmp5_ = _gtk_tree_path_copy0 (_tmp4_);
	prev = _tmp5_;
	_tmp6_ = prev;
	_tmp7_ = gtk_tree_path_prev (_tmp6_);
	if (!_tmp7_) {
		GtkTreePath* parent = NULL;
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreeIter* dest_parent = NULL;
		gboolean _tmp10_ = FALSE;
		GtkTreePath* _tmp11_;
		gboolean _tmp12_;
		GtkTreeStore* _tmp20_;
		GtkTreeIter* _tmp21_;
		GtkTreeIter _tmp22_ = {0};
		_tmp8_ = dest;
		_tmp9_ = _gtk_tree_path_copy0 (_tmp8_);
		parent = _tmp9_;
		dest_parent = NULL;
		_tmp11_ = parent;
		_tmp12_ = gtk_tree_path_up (_tmp11_);
		if (_tmp12_) {
			GtkTreePath* _tmp13_;
			gint _tmp14_;
			_tmp13_ = parent;
			_tmp14_ = gtk_tree_path_get_depth (_tmp13_);
			_tmp10_ = _tmp14_ > 0;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			GtkTreeStore* _tmp15_;
			GtkTreePath* _tmp16_;
			GtkTreeIter _tmp17_ = {0};
			GtkTreeIter _tmp18_;
			GtkTreeIter* _tmp19_;
			_tmp15_ = self->priv->child_tree;
			_tmp16_ = parent;
			gtk_tree_model_get_iter ((GtkTreeModel*) _tmp15_, &_tmp17_, _tmp16_);
			_g_free0 (dest_parent);
			_tmp18_ = _tmp17_;
			_tmp19_ = __gtk_tree_iter_dup0 (&_tmp18_);
			dest_parent = _tmp19_;
		}
		_tmp20_ = self->priv->child_tree;
		_tmp21_ = dest_parent;
		gtk_tree_store_prepend (_tmp20_, &_tmp22_, _tmp21_);
		dest_iter = _tmp22_;
		retval = TRUE;
		_g_free0 (dest_parent);
		_gtk_tree_path_free0 (parent);
	} else {
		GtkTreeStore* _tmp23_;
		GtkTreePath* _tmp24_;
		GtkTreeIter _tmp25_ = {0};
		gboolean _tmp26_;
		_tmp23_ = self->priv->child_tree;
		_tmp24_ = prev;
		_tmp26_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp23_, &_tmp25_, _tmp24_);
		dest_iter = _tmp25_;
		if (_tmp26_) {
			GtkTreeIter tmp_iter = {0};
			GtkTreeIter _tmp27_;
			GtkTreeStore* _tmp28_;
			GtkTreeIter _tmp29_;
			GtkTreeIter _tmp30_ = {0};
			_tmp27_ = dest_iter;
			tmp_iter = _tmp27_;
			_tmp28_ = self->priv->child_tree;
			_tmp29_ = tmp_iter;
			gtk_tree_store_insert_after (_tmp28_, &_tmp30_, NULL, &_tmp29_);
			dest_iter = _tmp30_;
			retval = TRUE;
		}
	}
	_tmp31_ = retval;
	if (_tmp31_) {
		GtkTreeIter _tmp32_;
		GtkTreeIter _tmp33_;
		GraniteWidgetsSourceListItem* item = NULL;
		GtkTreeStore* _tmp34_;
		GtkTreeIter _tmp35_;
		GraniteWidgetsSourceListItem* _tmp36_;
		gboolean _tmp37_;
		GraniteWidgetsSourceListItem* _tmp38_;
		GraniteWidgetsSourceListSortable* parent = NULL;
		GraniteWidgetsSourceListItem* _tmp39_;
		GraniteWidgetsSourceListExpandableItem* _tmp40_;
		GraniteWidgetsSourceListExpandableItem* _tmp41_;
		GraniteWidgetsSourceListSortable* _tmp42_;
		GraniteWidgetsSourceListSortable* _tmp43_;
		gboolean _tmp44_;
		GraniteWidgetsSourceListSortable* _tmp45_;
		GraniteWidgetsSourceListItem* _tmp46_;
		_tmp32_ = src_iter;
		_tmp33_ = dest_iter;
		granite_widgets_source_list_data_model_recursive_node_copy (self, &_tmp32_, &_tmp33_);
		_tmp34_ = self->priv->child_tree;
		_tmp35_ = src_iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp34_, &_tmp35_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
		_tmp36_ = item;
		_tmp37_ = retval;
		g_return_val_if_fail (_tmp36_ != NULL, _tmp37_);
		_tmp38_ = item;
		granite_widgets_source_list_data_model_update_item (self, _tmp38_);
		_tmp39_ = item;
		_tmp40_ = granite_widgets_source_list_item_get_parent (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp41_) : NULL);
		parent = _tmp42_;
		_tmp43_ = parent;
		_tmp44_ = retval;
		g_return_val_if_fail (_tmp43_ != NULL, _tmp44_);
		_tmp45_ = parent;
		_tmp46_ = item;
		g_signal_emit (_tmp45_, granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL], 0, _tmp46_);
		_g_object_unref0 (parent);
		_g_object_unref0 (item);
	}
	result = retval;
	_gtk_tree_path_free0 (prev);
	return result;
}


static void granite_widgets_source_list_data_model_recursive_node_copy (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* src_iter, GtkTreeIter* dest_iter) {
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeIter child = {0};
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (src_iter != NULL);
	g_return_if_fail (dest_iter != NULL);
	_tmp0_ = *src_iter;
	_tmp1_ = *dest_iter;
	granite_widgets_source_list_data_model_move_item (self, &_tmp0_, &_tmp1_);
	_tmp2_ = self->priv->child_tree;
	_tmp3_ = *src_iter;
	_tmp5_ = gtk_tree_model_iter_children ((GtkTreeModel*) _tmp2_, &_tmp4_, &_tmp3_);
	child = _tmp4_;
	if (_tmp5_) {
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				GtkTreeIter copy = {0};
				GtkTreeStore* _tmp9_;
				GtkTreeIter _tmp10_;
				GtkTreeIter _tmp11_ = {0};
				GtkTreeIter _tmp12_;
				GtkTreeIter _tmp13_;
				if (!_tmp6_) {
					GtkTreeStore* _tmp7_;
					gboolean _tmp8_;
					_tmp7_ = self->priv->child_tree;
					_tmp8_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp7_, &child);
					if (!_tmp8_) {
						break;
					}
				}
				_tmp6_ = FALSE;
				_tmp9_ = self->priv->child_tree;
				_tmp10_ = *dest_iter;
				gtk_tree_store_append (_tmp9_, &_tmp11_, &_tmp10_);
				copy = _tmp11_;
				_tmp12_ = child;
				_tmp13_ = copy;
				granite_widgets_source_list_data_model_recursive_node_copy (self, &_tmp12_, &_tmp13_);
			}
		}
	}
}


static void granite_widgets_source_list_data_model_move_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* src_iter, GtkTreeIter* dest_iter) {
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GeeHashMap* _tmp4_;
	GtkTreeStore* _tmp5_;
	GtkTreeIter _tmp6_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp7_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (src_iter != NULL);
	g_return_if_fail (dest_iter != NULL);
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = *src_iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
	g_return_if_fail (item != NULL);
	_tmp2_ = self->priv->child_tree;
	_tmp3_ = *dest_iter;
	gtk_tree_store_set (_tmp2_, &_tmp3_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, item, -1, -1);
	_tmp4_ = self->priv->items;
	_tmp5_ = self->priv->child_tree;
	_tmp6_ = *dest_iter;
	_tmp7_ = granite_widgets_source_list_data_model_node_wrapper_new ((GtkTreeModel*) _tmp5_, &_tmp6_);
	_tmp8_ = _tmp7_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, item, _tmp8_);
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (_tmp8_);
	_g_object_unref0 (item);
}


static gint* _vala_array_dup5 (gint* self, int length) {
	return g_memdup (self, length * sizeof (gint));
}


static gint* _vala_array_dup6 (gint* self, int length) {
	return g_memdup (self, length * sizeof (gint));
}


static gboolean granite_widgets_source_list_data_model_real_row_drop_possible (GtkTreeDragDest* base, GtkTreePath* dest, GtkSelectionData* selection_data) {
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkSelectionData* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GtkTreePath* _tmp3_ = NULL;
	gboolean _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreePath* child_dest = NULL;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GtkTreePath* _tmp11_;
	gint src_depth = 0;
	GtkTreePath* _tmp15_;
	gint _tmp16_;
	gint dest_depth = 0;
	GtkTreePath* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GraniteWidgetsSourceListItem* parent = NULL;
	gint _tmp22_;
	GraniteWidgetsSourceListSortable* sortable = NULL;
	GraniteWidgetsSourceListItem* _tmp52_;
	GraniteWidgetsSourceListSortable* _tmp53_;
	gboolean _tmp54_ = FALSE;
	GraniteWidgetsSourceListSortable* _tmp55_;
	GraniteWidgetsSourceListItem* dest_item = NULL;
	GtkTreePath* _tmp58_;
	GraniteWidgetsSourceListItem* _tmp59_;
	GraniteWidgetsSourceListItem* _tmp60_;
	GraniteWidgetsSourceListItem* source_item = NULL;
	GtkTreePath* filter_src_path = NULL;
	GtkTreePath* _tmp61_;
	GtkTreePath* _tmp62_;
	GtkTreePath* _tmp63_;
	GraniteWidgetsSourceListItem* _tmp66_;
	GraniteWidgetsSourceListSortable* _tmp67_;
	GraniteWidgetsSourceListItem* _tmp68_;
	GraniteWidgetsSourceListItem* _tmp69_;
	gint _tmp70_;
	self = (GraniteWidgetsSourceListDataModel*) base;
	g_return_val_if_fail (dest != NULL, FALSE);
	g_return_val_if_fail (selection_data != NULL, FALSE);
	_tmp1_ = selection_data;
	_tmp4_ = gtk_tree_get_row_drag_data (_tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (model);
	_tmp5_ = _g_object_ref0 (_tmp2_);
	model = _tmp5_;
	_gtk_tree_path_free0 (src_path);
	src_path = _tmp3_;
	if (!_tmp4_) {
		_tmp0_ = TRUE;
	} else {
		GtkTreeModel* _tmp6_;
		GtkTreeStore* _tmp7_;
		_tmp6_ = model;
		_tmp7_ = self->priv->child_tree;
		_tmp0_ = _tmp6_ != _tmp7_;
	}
	if (_tmp0_) {
		result = FALSE;
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	_tmp8_ = dest;
	_tmp9_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, _tmp8_);
	child_dest = _tmp9_;
	_tmp11_ = child_dest;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		GtkTreePath* _tmp12_;
		GtkTreePath* _tmp13_;
		gint _tmp14_;
		_tmp12_ = src_path;
		_tmp13_ = child_dest;
		_tmp14_ = gtk_tree_path_compare (_tmp12_, _tmp13_);
		_tmp10_ = _tmp14_ == 0;
	}
	if (_tmp10_) {
		result = FALSE;
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	_tmp15_ = src_path;
	_tmp16_ = gtk_tree_path_get_depth (_tmp15_);
	src_depth = _tmp16_;
	_tmp17_ = child_dest;
	_tmp18_ = gtk_tree_path_get_depth (_tmp17_);
	dest_depth = _tmp18_;
	_tmp19_ = src_depth;
	_tmp20_ = dest_depth;
	if (_tmp19_ != _tmp20_) {
		result = FALSE;
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	_tmp21_ = src_depth;
	if (_tmp21_ < 1) {
		result = FALSE;
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	parent = NULL;
	_tmp22_ = src_depth;
	if (_tmp22_ == 1) {
		GraniteWidgetsSourceListExpandableItem* _tmp23_;
		GraniteWidgetsSourceListExpandableItem* _tmp24_;
		GraniteWidgetsSourceListItem* _tmp25_;
		_tmp23_ = granite_widgets_source_list_data_model_get_root (self);
		_tmp24_ = _tmp23_;
		_tmp25_ = _g_object_ref0 ((GraniteWidgetsSourceListItem*) _tmp24_);
		_g_object_unref0 (parent);
		parent = _tmp25_;
	} else {
		gint _tmp26_;
		gint* src_indices = NULL;
		GtkTreePath* _tmp27_;
		gint _tmp28_;
		gint* _tmp29_;
		gint* _tmp30_;
		gint _tmp30__length1;
		gint src_indices_length1;
		gint _src_indices_size_;
		gint* dest_indices = NULL;
		GtkTreePath* _tmp31_;
		gint _tmp32_;
		gint* _tmp33_;
		gint* _tmp34_;
		gint _tmp34__length1;
		gint dest_indices_length1;
		gint _dest_indices_size_;
		gint src_parent_index = 0;
		gint* _tmp35_;
		gint _tmp35__length1;
		gint _tmp36_;
		gint _tmp37_;
		gint dest_parent_index = 0;
		gint* _tmp38_;
		gint _tmp38__length1;
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		GtkTreePath* dest_parent = NULL;
		GtkTreePath* _tmp43_;
		GtkTreePath* _tmp44_;
		gboolean _tmp45_ = FALSE;
		GtkTreePath* _tmp46_;
		gboolean _tmp47_;
		GtkTreePath* _tmp50_;
		GraniteWidgetsSourceListItem* _tmp51_;
		_tmp26_ = dest_depth;
		_vala_assert (_tmp26_ > 1, "dest_depth > 1");
		_tmp27_ = src_path;
		_tmp29_ = gtk_tree_path_get_indices_with_depth (_tmp27_, &_tmp28_);
		_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup5 (_tmp29_, _tmp28_) : ((gpointer) _tmp29_);
		_tmp30__length1 = _tmp28_;
		src_indices = _tmp30_;
		src_indices_length1 = _tmp30__length1;
		_src_indices_size_ = src_indices_length1;
		_tmp31_ = child_dest;
		_tmp33_ = gtk_tree_path_get_indices_with_depth (_tmp31_, &_tmp32_);
		_tmp34_ = (_tmp33_ != NULL) ? _vala_array_dup6 (_tmp33_, _tmp32_) : ((gpointer) _tmp33_);
		_tmp34__length1 = _tmp32_;
		dest_indices = _tmp34_;
		dest_indices_length1 = _tmp34__length1;
		_dest_indices_size_ = dest_indices_length1;
		_tmp35_ = src_indices;
		_tmp35__length1 = src_indices_length1;
		_tmp36_ = src_depth;
		_tmp37_ = _tmp35_[_tmp36_ - 2];
		src_parent_index = _tmp37_;
		_tmp38_ = dest_indices;
		_tmp38__length1 = dest_indices_length1;
		_tmp39_ = dest_depth;
		_tmp40_ = _tmp38_[_tmp39_ - 2];
		dest_parent_index = _tmp40_;
		_tmp41_ = src_parent_index;
		_tmp42_ = dest_parent_index;
		if (_tmp41_ != _tmp42_) {
			result = FALSE;
			dest_indices = (g_free (dest_indices), NULL);
			src_indices = (g_free (src_indices), NULL);
			_g_object_unref0 (parent);
			_gtk_tree_path_free0 (child_dest);
			_gtk_tree_path_free0 (src_path);
			_g_object_unref0 (model);
			return result;
		}
		_tmp43_ = dest;
		_tmp44_ = _gtk_tree_path_copy0 (_tmp43_);
		dest_parent = _tmp44_;
		_tmp46_ = dest_parent;
		_tmp47_ = gtk_tree_path_up (_tmp46_);
		if (!_tmp47_) {
			_tmp45_ = TRUE;
		} else {
			GtkTreePath* _tmp48_;
			gint _tmp49_;
			_tmp48_ = dest_parent;
			_tmp49_ = gtk_tree_path_get_depth (_tmp48_);
			_tmp45_ = _tmp49_ < 1;
		}
		if (_tmp45_) {
			result = FALSE;
			_gtk_tree_path_free0 (dest_parent);
			dest_indices = (g_free (dest_indices), NULL);
			src_indices = (g_free (src_indices), NULL);
			_g_object_unref0 (parent);
			_gtk_tree_path_free0 (child_dest);
			_gtk_tree_path_free0 (src_path);
			_g_object_unref0 (model);
			return result;
		}
		_tmp50_ = dest_parent;
		_tmp51_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp50_);
		_g_object_unref0 (parent);
		parent = _tmp51_;
		_gtk_tree_path_free0 (dest_parent);
		dest_indices = (g_free (dest_indices), NULL);
		src_indices = (g_free (src_indices), NULL);
	}
	_tmp52_ = parent;
	_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp52_) : NULL);
	sortable = _tmp53_;
	_tmp55_ = sortable;
	if (_tmp55_ == NULL) {
		_tmp54_ = TRUE;
	} else {
		GraniteWidgetsSourceListSortable* _tmp56_;
		gboolean _tmp57_;
		_tmp56_ = sortable;
		_tmp57_ = granite_widgets_source_list_sortable_allow_dnd_sorting (_tmp56_);
		_tmp54_ = !_tmp57_;
	}
	if (_tmp54_) {
		result = FALSE;
		_g_object_unref0 (sortable);
		_g_object_unref0 (parent);
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	_tmp58_ = dest;
	_tmp59_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp58_);
	dest_item = _tmp59_;
	_tmp60_ = dest_item;
	if (_tmp60_ == NULL) {
		result = TRUE;
		_g_object_unref0 (dest_item);
		_g_object_unref0 (sortable);
		_g_object_unref0 (parent);
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	source_item = NULL;
	_tmp61_ = src_path;
	_tmp62_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp61_);
	filter_src_path = _tmp62_;
	_tmp63_ = filter_src_path;
	if (_tmp63_ != NULL) {
		GtkTreePath* _tmp64_;
		GraniteWidgetsSourceListItem* _tmp65_;
		_tmp64_ = filter_src_path;
		_tmp65_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp64_);
		_g_object_unref0 (source_item);
		source_item = _tmp65_;
	}
	_tmp66_ = source_item;
	if (_tmp66_ == NULL) {
		result = FALSE;
		_gtk_tree_path_free0 (filter_src_path);
		_g_object_unref0 (source_item);
		_g_object_unref0 (dest_item);
		_g_object_unref0 (sortable);
		_g_object_unref0 (parent);
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	_tmp67_ = sortable;
	_tmp68_ = dest_item;
	_tmp69_ = source_item;
	_tmp70_ = granite_widgets_source_list_sortable_compare (_tmp67_, _tmp68_, _tmp69_);
	if (_tmp70_ >= 0) {
		GtkTreePath* _tmp71_;
		gboolean _tmp72_;
		GraniteWidgetsSourceListItem* dest_item_prev = NULL;
		GtkTreePath* _tmp73_;
		GraniteWidgetsSourceListItem* _tmp74_;
		gboolean _tmp75_ = FALSE;
		gboolean _tmp76_ = FALSE;
		GraniteWidgetsSourceListItem* _tmp77_;
		_tmp71_ = dest;
		_tmp72_ = gtk_tree_path_prev (_tmp71_);
		if (!_tmp72_) {
			result = TRUE;
			_gtk_tree_path_free0 (filter_src_path);
			_g_object_unref0 (source_item);
			_g_object_unref0 (dest_item);
			_g_object_unref0 (sortable);
			_g_object_unref0 (parent);
			_gtk_tree_path_free0 (child_dest);
			_gtk_tree_path_free0 (src_path);
			_g_object_unref0 (model);
			return result;
		}
		_tmp73_ = dest;
		_tmp74_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp73_);
		dest_item_prev = _tmp74_;
		_tmp77_ = dest_item_prev;
		if (_tmp77_ != NULL) {
			GraniteWidgetsSourceListItem* _tmp78_;
			GraniteWidgetsSourceListItem* _tmp79_;
			_tmp78_ = dest_item_prev;
			_tmp79_ = source_item;
			_tmp76_ = _tmp78_ != _tmp79_;
		} else {
			_tmp76_ = FALSE;
		}
		if (_tmp76_) {
			GraniteWidgetsSourceListSortable* _tmp80_;
			GraniteWidgetsSourceListItem* _tmp81_;
			GraniteWidgetsSourceListItem* _tmp82_;
			gint _tmp83_;
			_tmp80_ = sortable;
			_tmp81_ = dest_item_prev;
			_tmp82_ = source_item;
			_tmp83_ = granite_widgets_source_list_sortable_compare (_tmp80_, _tmp81_, _tmp82_);
			_tmp75_ = _tmp83_ <= 0;
		} else {
			_tmp75_ = FALSE;
		}
		result = _tmp75_;
		_g_object_unref0 (dest_item_prev);
		_gtk_tree_path_free0 (filter_src_path);
		_g_object_unref0 (source_item);
		_g_object_unref0 (dest_item);
		_g_object_unref0 (sortable);
		_g_object_unref0 (parent);
		_gtk_tree_path_free0 (child_dest);
		_gtk_tree_path_free0 (src_path);
		_g_object_unref0 (model);
		return result;
	}
	result = FALSE;
	_gtk_tree_path_free0 (filter_src_path);
	_g_object_unref0 (source_item);
	_g_object_unref0 (dest_item);
	_g_object_unref0 (sortable);
	_g_object_unref0 (parent);
	_gtk_tree_path_free0 (child_dest);
	_gtk_tree_path_free0 (src_path);
	_g_object_unref0 (model);
	return result;
}


/**
         * Override default implementation of TreeDragSource
         *
         * drag_data_delete is not overriden because the default implementation
         * does exactly what we need.
         */
static gboolean granite_widgets_source_list_data_model_real_drag_data_get (GtkTreeDragSource* base, GtkTreePath* path, GtkSelectionData* selection_data) {
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkSelectionData* _tmp0_;
	GdkAtom _tmp1_;
	GdkAtom _tmp2_;
	GraniteWidgetsSourceListDragSource* drag_source_item = NULL;
	GtkTreePath* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListDragSource* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GraniteWidgetsSourceListDragSource* _tmp10_;
	self = (GraniteWidgetsSourceListDataModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (selection_data != NULL, FALSE);
	_tmp0_ = selection_data;
	_tmp1_ = gtk_selection_data_get_target (_tmp0_);
	_tmp2_ = gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW");
	if (_tmp1_ == _tmp2_) {
		GtkTreePath* _tmp3_;
		GtkSelectionData* _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = path;
		_tmp4_ = selection_data;
		_tmp5_ = granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface->drag_data_get ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), _tmp3_, _tmp4_);
		result = _tmp5_;
		return result;
	}
	_tmp6_ = path;
	_tmp7_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp6_);
	_tmp8_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE) ? ((GraniteWidgetsSourceListDragSource*) _tmp7_) : NULL;
	if (_tmp8_ == NULL) {
		_g_object_unref0 (_tmp7_);
	}
	drag_source_item = _tmp8_;
	_tmp10_ = drag_source_item;
	if (_tmp10_ != NULL) {
		GraniteWidgetsSourceListDragSource* _tmp11_;
		gboolean _tmp12_;
		_tmp11_ = drag_source_item;
		_tmp12_ = granite_widgets_source_list_drag_source_draggable (_tmp11_);
		_tmp9_ = _tmp12_;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GraniteWidgetsSourceListDragSource* _tmp13_;
		GtkSelectionData* _tmp14_;
		_tmp13_ = drag_source_item;
		_tmp14_ = selection_data;
		granite_widgets_source_list_drag_source_prepare_selection_data (_tmp13_, _tmp14_);
		result = TRUE;
		_g_object_unref0 (drag_source_item);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (drag_source_item);
	return result;
}


static gboolean granite_widgets_source_list_data_model_real_row_draggable (GtkTreeDragSource* base, GtkTreePath* path) {
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkTreePath* _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreePath* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	self = (GraniteWidgetsSourceListDataModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface->row_draggable ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), _tmp0_);
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = path;
	_tmp3_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp2_);
	item = _tmp3_;
	_tmp4_ = item;
	if (_tmp4_ != NULL) {
		GraniteWidgetsSourceListSortable* sortable_item = NULL;
		GraniteWidgetsSourceListItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		GraniteWidgetsSourceListSortable* _tmp8_;
		gboolean _tmp9_ = FALSE;
		GraniteWidgetsSourceListSortable* _tmp10_;
		GraniteWidgetsSourceListDragSource* drag_source_item = NULL;
		GraniteWidgetsSourceListItem* _tmp13_;
		GraniteWidgetsSourceListDragSource* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GraniteWidgetsSourceListDragSource* _tmp16_;
		_tmp5_ = item;
		_tmp6_ = granite_widgets_source_list_item_get_parent (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp7_) : NULL);
		sortable_item = _tmp8_;
		_tmp10_ = sortable_item;
		if (_tmp10_ != NULL) {
			GraniteWidgetsSourceListSortable* _tmp11_;
			gboolean _tmp12_;
			_tmp11_ = sortable_item;
			_tmp12_ = granite_widgets_source_list_sortable_allow_dnd_sorting (_tmp11_);
			_tmp9_ = _tmp12_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			result = TRUE;
			_g_object_unref0 (sortable_item);
			_g_object_unref0 (item);
			return result;
		}
		_tmp13_ = item;
		_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE) ? ((GraniteWidgetsSourceListDragSource*) _tmp13_) : NULL);
		drag_source_item = _tmp14_;
		_tmp16_ = drag_source_item;
		if (_tmp16_ != NULL) {
			GraniteWidgetsSourceListDragSource* _tmp17_;
			gboolean _tmp18_;
			_tmp17_ = drag_source_item;
			_tmp18_ = granite_widgets_source_list_drag_source_draggable (_tmp17_);
			_tmp15_ = _tmp18_;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			result = TRUE;
			_g_object_unref0 (drag_source_item);
			_g_object_unref0 (sortable_item);
			_g_object_unref0 (item);
			return result;
		}
		_g_object_unref0 (drag_source_item);
		_g_object_unref0 (sortable_item);
	}
	result = FALSE;
	_g_object_unref0 (item);
	return result;
}


static GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_root;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* value) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_root;
	if (_tmp0_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		_tmp1_ = self->priv->_root;
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp1_);
		{
			GeeIterator* _item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
			GeeIterator* _tmp7_;
			_tmp2_ = self->priv->_root;
			_tmp3_ = granite_widgets_source_list_expandable_item_get_children (_tmp2_);
			_tmp4_ = _tmp3_;
			_tmp5_ = _tmp4_;
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
			_tmp7_ = _tmp6_;
			_g_object_unref0 (_tmp5_);
			_item_it = _tmp7_;
			while (TRUE) {
				GeeIterator* _tmp8_;
				gboolean _tmp9_;
				GraniteWidgetsSourceListItem* item = NULL;
				GeeIterator* _tmp10_;
				gpointer _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp8_ = _item_it;
				_tmp9_ = gee_iterator_next (_tmp8_);
				if (!_tmp9_) {
					break;
				}
				_tmp10_ = _item_it;
				_tmp11_ = gee_iterator_get (_tmp10_);
				item = (GraniteWidgetsSourceListItem*) _tmp11_;
				_tmp12_ = item;
				granite_widgets_source_list_data_model_remove_item (self, _tmp12_);
				_g_object_unref0 (item);
			}
			_g_object_unref0 (_item_it);
		}
	}
	_tmp13_ = value;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	_g_object_unref0 (self->priv->_root);
	self->priv->_root = _tmp14_;
	_tmp15_ = self->priv->_root;
	granite_widgets_source_list_data_model_add_children_monitor (self, _tmp15_);
	{
		GeeIterator* _item_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
		_tmp16_ = self->priv->_root;
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_;
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
		_tmp21_ = _tmp20_;
		_g_object_unref0 (_tmp19_);
		_item_it = _tmp21_;
		while (TRUE) {
			GeeIterator* _tmp22_;
			gboolean _tmp23_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			GraniteWidgetsSourceListItem* _tmp26_;
			_tmp22_ = _item_it;
			_tmp23_ = gee_iterator_next (_tmp22_);
			if (!_tmp23_) {
				break;
			}
			_tmp24_ = _item_it;
			_tmp25_ = gee_iterator_get (_tmp24_);
			item = (GraniteWidgetsSourceListItem*) _tmp25_;
			_tmp26_ = item;
			granite_widgets_source_list_data_model_add_item (self, _tmp26_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
	g_object_notify ((GObject *) self, "root");
}


static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListDataModelNodeWrapper* self = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreeRowReference* _tmp5_;
	g_return_val_if_fail (model != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	self = (GraniteWidgetsSourceListDataModelNodeWrapper*) g_type_create_instance (object_type);
	_tmp0_ = model;
	_tmp1_ = model;
	_tmp2_ = *iter;
	_tmp3_ = gtk_tree_model_get_path (_tmp1_, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gtk_tree_row_reference_new (_tmp0_, _tmp4_);
	_gtk_tree_row_reference_free0 (self->priv->row_reference);
	self->priv->row_reference = _tmp5_;
	_gtk_tree_path_free0 (_tmp4_);
	return self;
}


static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model, GtkTreeIter* iter) {
	return granite_widgets_source_list_data_model_node_wrapper_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, model, iter);
}


static GtkTreeIter* granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	GtkTreeIter* result;
	GtkTreeIter* rv = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkTreePath* _path = NULL;
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
		_tmp2_ = granite_widgets_source_list_data_model_node_wrapper_get_path (self);
		_tmp3_ = _tmp2_;
		_path = _tmp3_;
		_tmp4_ = _path;
		if (_tmp4_ != NULL) {
			GtkTreeIter _iter = {0};
			const GtkTreeRowReference* _tmp5_;
			GtkTreeModel* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreeIter _tmp8_ = {0};
			gboolean _tmp9_;
			_tmp5_ = self->priv->row_reference;
			_tmp6_ = gtk_tree_row_reference_get_model (_tmp5_);
			_tmp7_ = _path;
			_tmp9_ = gtk_tree_model_get_iter (_tmp6_, &_tmp8_, _tmp7_);
			_iter = _tmp8_;
			if (_tmp9_) {
				GtkTreeIter _tmp10_;
				GtkTreeIter* _tmp11_;
				_tmp10_ = _iter;
				_tmp11_ = __gtk_tree_iter_dup0 (&_tmp10_);
				_g_free0 (rv);
				rv = _tmp11_;
			}
		}
		_gtk_tree_path_free0 (_path);
	}
	result = rv;
	return result;
}


static GtkTreePath* granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	GtkTreePath* result;
	GtkTreePath* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		const GtkTreeRowReference* _tmp3_;
		GtkTreePath* _tmp4_;
		_tmp3_ = self->priv->row_reference;
		_tmp4_ = gtk_tree_row_reference_get_path (_tmp3_);
		_gtk_tree_path_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		_gtk_tree_path_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


static gboolean granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	const GtkTreeRowReference* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->row_reference;
	if (_tmp1_ != NULL) {
		const GtkTreeRowReference* _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = self->priv->row_reference;
		_tmp3_ = gtk_tree_row_reference_valid (_tmp2_);
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_data_model_value_node_wrapper_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void granite_widgets_source_list_data_model_value_node_wrapper_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		granite_widgets_source_list_data_model_node_wrapper_unref (value->data[0].v_pointer);
	}
}


static void granite_widgets_source_list_data_model_value_node_wrapper_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* granite_widgets_source_list_data_model_value_node_wrapper_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GraniteWidgetsSourceListDataModelNodeWrapper * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GraniteWidgetsSourceListDataModelNodeWrapper ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GraniteWidgetsSourceListDataModelParamSpecNodeWrapper* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
	return value->data[0].v_pointer;
}


static void granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelNodeWrapper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
	}
}


static void granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelNodeWrapper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
	}
}


static void granite_widgets_source_list_data_model_node_wrapper_class_init (GraniteWidgetsSourceListDataModelNodeWrapperClass * klass) {
	granite_widgets_source_list_data_model_node_wrapper_parent_class = g_type_class_peek_parent (klass);
	((GraniteWidgetsSourceListDataModelNodeWrapperClass *) klass)->finalize = granite_widgets_source_list_data_model_node_wrapper_finalize;
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelNodeWrapperPrivate));
}


static void granite_widgets_source_list_data_model_node_wrapper_instance_init (GraniteWidgetsSourceListDataModelNodeWrapper * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper * obj) {
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper);
	g_signal_handlers_destroy (self);
	_gtk_tree_row_reference_free0 (self->priv->row_reference);
}


/**
         * An object that references a particular row in a model. This class is a wrapper built around
         * Gtk.TreeRowReference, and exists with the purpose of ensuring we never use invalid tree paths
         * or iters in the model, since most of these errors provoke failures due to GTK+ assertions
         * or, even worse, unexpected behavior.
         */
static GType granite_widgets_source_list_data_model_node_wrapper_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_node_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_node_wrapper_init, granite_widgets_source_list_data_model_value_node_wrapper_free_value, granite_widgets_source_list_data_model_value_node_wrapper_copy_value, granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer, "p", granite_widgets_source_list_data_model_value_node_wrapper_collect_value, "p", granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelNodeWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_node_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelNodeWrapper), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_node_wrapper_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_node_wrapper_type_id;
		granite_widgets_source_list_data_model_node_wrapper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelNodeWrapper", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile, granite_widgets_source_list_data_model_node_wrapper_type_id);
	}
	return granite_widgets_source_list_data_model_node_wrapper_type_id__volatile;
}


static gpointer granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance) {
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance) {
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	granite_widgets_source_list_data_model_item_monitor_on_notify ((GraniteWidgetsSourceListDataModelItemMonitor*) self, pspec);
}


static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_construct (GType object_type, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListDataModelItemMonitor* self = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_val_if_fail (item != NULL, NULL);
	self = (GraniteWidgetsSourceListDataModelItemMonitor*) g_type_create_instance (object_type);
	_tmp0_ = item;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->item);
	self->priv->item = _tmp1_;
	_tmp2_ = item;
	g_signal_connect_after ((GObject*) _tmp2_, "notify", (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
	return self;
}


static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item) {
	return granite_widgets_source_list_data_model_item_monitor_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, item);
}


static void granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self, GParamSpec* prop) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GParamSpec* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prop != NULL);
	_tmp0_ = self->priv->item;
	_tmp1_ = prop;
	_tmp2_ = _tmp1_->name;
	g_signal_emit (self, granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL], 0, _tmp0_, _tmp2_);
}


static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}


static void granite_widgets_source_list_data_model_value_item_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void granite_widgets_source_list_data_model_value_item_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		granite_widgets_source_list_data_model_item_monitor_unref (value->data[0].v_pointer);
	}
}


static void granite_widgets_source_list_data_model_value_item_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer granite_widgets_source_list_data_model_value_item_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* granite_widgets_source_list_data_model_value_item_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GraniteWidgetsSourceListDataModelItemMonitor * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* granite_widgets_source_list_data_model_value_item_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GraniteWidgetsSourceListDataModelItemMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GraniteWidgetsSourceListDataModelParamSpecItemMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
	return value->data[0].v_pointer;
}


static void granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelItemMonitor * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_item_monitor_unref (old);
	}
}


static void granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelItemMonitor * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_item_monitor_unref (old);
	}
}


static void granite_widgets_source_list_data_model_item_monitor_class_init (GraniteWidgetsSourceListDataModelItemMonitorClass * klass) {
	granite_widgets_source_list_data_model_item_monitor_parent_class = g_type_class_peek_parent (klass);
	((GraniteWidgetsSourceListDataModelItemMonitorClass *) klass)->finalize = granite_widgets_source_list_data_model_item_monitor_finalize;
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelItemMonitorPrivate));
	granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL] = g_signal_new ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_TYPE_STRING);
}


static void granite_widgets_source_list_data_model_item_monitor_instance_init (GraniteWidgetsSourceListDataModelItemMonitor * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor * obj) {
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	GraniteWidgetsSourceListItem* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->item;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
	_g_object_unref0 (self->priv->item);
}


/**
         * Helper object used to monitor item property changes.
         */
static GType granite_widgets_source_list_data_model_item_monitor_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_item_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_item_monitor_init, granite_widgets_source_list_data_model_value_item_monitor_free_value, granite_widgets_source_list_data_model_value_item_monitor_copy_value, granite_widgets_source_list_data_model_value_item_monitor_peek_pointer, "p", granite_widgets_source_list_data_model_value_item_monitor_collect_value, "p", granite_widgets_source_list_data_model_value_item_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelItemMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_item_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelItemMonitor), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_item_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_item_monitor_type_id;
		granite_widgets_source_list_data_model_item_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelItemMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile, granite_widgets_source_list_data_model_item_monitor_type_id);
	}
	return granite_widgets_source_list_data_model_item_monitor_type_id__volatile;
}


static gpointer granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance) {
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance) {
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void granite_widgets_source_list_data_model_class_init (GraniteWidgetsSourceListDataModelClass * klass) {
	granite_widgets_source_list_data_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_data_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_data_model_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_data_model_finalize;
	/**
	         * Root item.
	         *
	         * This item is not actually part of the model. It's only used as a proxy
	         * for adding and removing items.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT, g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL] = g_signal_new ("item_updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
}


static void granite_widgets_source_list_data_model_gtk_tree_drag_source_interface_init (GtkTreeDragSourceIface * iface) {
	granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface = g_type_interface_peek_parent (iface);
	iface->drag_data_get = (gboolean (*) (GtkTreeDragSource *, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_drag_data_get;
	iface->row_draggable = (gboolean (*) (GtkTreeDragSource *, GtkTreePath*)) granite_widgets_source_list_data_model_real_row_draggable;
}


static void granite_widgets_source_list_data_model_gtk_tree_drag_dest_interface_init (GtkTreeDragDestIface * iface) {
	granite_widgets_source_list_data_model_gtk_tree_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
	iface->drag_data_received = (gboolean (*) (GtkTreeDragDest *, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_drag_data_received;
	iface->row_drop_possible = (gboolean (*) (GtkTreeDragDest *, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_row_drop_possible;
}


static void granite_widgets_source_list_data_model_instance_init (GraniteWidgetsSourceListDataModel * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_PRIVATE (self);
	_tmp0_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, (GBoxedCopyFunc) granite_widgets_source_list_data_model_node_wrapper_ref, (GDestroyNotify) granite_widgets_source_list_data_model_node_wrapper_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->items = _tmp0_;
	_tmp1_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, (GBoxedCopyFunc) granite_widgets_source_list_data_model_item_monitor_ref, (GDestroyNotify) granite_widgets_source_list_data_model_item_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->monitors = _tmp1_;
}


static void granite_widgets_source_list_data_model_finalize (GObject * obj) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	_g_object_unref0 (self->priv->_root);
	_g_object_unref0 (self->priv->items);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->child_tree);
	G_OBJECT_CLASS (granite_widgets_source_list_data_model_parent_class)->finalize (obj);
}


/**
     * The model backing the SourceList tree.
     *
     * It monitors item property changes, and handles children additions and removals. It also controls
     * the visibility of the items based on their "visible" property, and on their number of children,
     * if they happen to be categories. Its main purpose is to provide an easy and practical interface
     * for sorting, adding, removing and updating items, eliminating the need of repeatedly dealing with
     * the Gtk.TreeModel API directly.
     */
static GType granite_widgets_source_list_data_model_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModel), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_drag_source_info = { (GInterfaceInitFunc) granite_widgets_source_list_data_model_gtk_tree_drag_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_drag_dest_info = { (GInterfaceInitFunc) granite_widgets_source_list_data_model_gtk_tree_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType granite_widgets_source_list_data_model_type_id;
		granite_widgets_source_list_data_model_type_id = g_type_register_static (gtk_tree_model_filter_get_type (), "GraniteWidgetsSourceListDataModel", &g_define_type_info, 0);
		g_type_add_interface_static (granite_widgets_source_list_data_model_type_id, GTK_TYPE_TREE_DRAG_SOURCE, &gtk_tree_drag_source_info);
		g_type_add_interface_static (granite_widgets_source_list_data_model_type_id, GTK_TYPE_TREE_DRAG_DEST, &gtk_tree_drag_dest_info);
		g_once_init_leave (&granite_widgets_source_list_data_model_type_id__volatile, granite_widgets_source_list_data_model_type_id);
	}
	return granite_widgets_source_list_data_model_type_id__volatile;
}


static void _vala_granite_widgets_source_list_data_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT:
		g_value_set_object (value, granite_widgets_source_list_data_model_get_root (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_data_model_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT:
		granite_widgets_source_list_data_model_set_root (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_construct (GType object_type) {
	GraniteWidgetsSourceListCellRendererIcon * self = NULL;
	self = (GraniteWidgetsSourceListCellRendererIcon*) g_object_new (object_type, NULL);
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
	g_object_set ((GtkCellRendererPixbuf*) self, "stock-size", (guint) GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE, NULL);
	g_object_set ((GtkCellRendererPixbuf*) self, "follow-state", TRUE, NULL);
	return self;
}


static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_new (void) {
	return granite_widgets_source_list_cell_renderer_icon_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON);
}


static gboolean granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base, GdkEvent* event, GtkWidget* widget, const gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags) {
	GraniteWidgetsSourceListCellRendererIcon * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	self = (GraniteWidgetsSourceListCellRendererIcon*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (background_area != NULL, FALSE);
	g_return_val_if_fail (cell_area != NULL, FALSE);
	_tmp0_ = path;
	g_signal_emit (self, granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL], 0, _tmp0_);
	result = TRUE;
	return result;
}


static void granite_widgets_source_list_cell_renderer_icon_class_init (GraniteWidgetsSourceListCellRendererIconClass * klass) {
	granite_widgets_source_list_cell_renderer_icon_parent_class = g_type_class_peek_parent (klass);
	((GtkCellRendererClass *) klass)->activate = (gboolean (*) (GtkCellRenderer *, GdkEvent*, GtkWidget*, const gchar*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_cell_renderer_icon_real_activate;
	granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void granite_widgets_source_list_cell_renderer_icon_instance_init (GraniteWidgetsSourceListCellRendererIcon * self) {
}


/**
     * Class responsible for rendering Item.icon and Item.activatable. It also
     * notifies about clicks through the activated() signal.
     */
static GType granite_widgets_source_list_cell_renderer_icon_get_type (void) {
	static volatile gsize granite_widgets_source_list_cell_renderer_icon_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererIcon), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_icon_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_icon_type_id;
		granite_widgets_source_list_cell_renderer_icon_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "GraniteWidgetsSourceListCellRendererIcon", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile, granite_widgets_source_list_cell_renderer_icon_type_id);
	}
	return granite_widgets_source_list_cell_renderer_icon_type_id__volatile;
}


static GtkSizeRequestMode granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	GtkSizeRequestMode result = 0;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base, GtkWidget* widget, gint* min_size, gint* natural_size) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_size = 0;
	gint _vala_natural_size = 0;
	guint _tmp0_;
	guint _tmp1_;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_object_get ((GtkCellRenderer*) self, "xpad", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_vala_natural_size = 2 * ((gint) _tmp1_);
	_vala_min_size = _vala_natural_size;
	if (min_size) {
		*min_size = _vala_min_size;
	}
	if (natural_size) {
		*natural_size = _vala_natural_size;
	}
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base, GtkWidget* widget, gint width, gint* min_height, gint* natural_height) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_height = 0;
	gint _vala_natural_height = 0;
	guint _tmp0_;
	guint _tmp1_;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_object_get ((GtkCellRenderer*) self, "ypad", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_vala_natural_height = 2 * ((gint) _tmp1_);
	_vala_min_height = _vala_natural_height;
	if (min_height) {
		*min_height = _vala_min_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base, cairo_t* context, GtkWidget* widget, GdkRectangle* bg_area, GdkRectangle* cell_area, GtkCellRendererState flags) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (context != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (bg_area != NULL);
	g_return_if_fail (cell_area != NULL);
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base, GtkWidget* widget, GdkRectangle* cell_area, gint* x_offset, gint* y_offset, gint* width, gint* height) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_assert_not_reached ();
	if (x_offset) {
		*x_offset = _vala_x_offset;
	}
	if (y_offset) {
		*y_offset = _vala_y_offset;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}


static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type) {
	GraniteWidgetsSourceListCellRendererSpacer * self = NULL;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) g_object_new (object_type, NULL);
	return self;
}


static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_new (void) {
	return granite_widgets_source_list_cell_renderer_spacer_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER);
}


static gint granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_level;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self, gint value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_cell_renderer_spacer_get_level (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_level = _tmp0_;
		g_object_notify ((GObject *) self, "level");
	}
}


static void granite_widgets_source_list_cell_renderer_spacer_class_init (GraniteWidgetsSourceListCellRendererSpacerClass * klass) {
	granite_widgets_source_list_cell_renderer_spacer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListCellRendererSpacerPrivate));
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer *)) granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode;
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width;
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width;
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer *, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_cell_renderer_spacer_real_render;
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer *, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_cell_renderer_spacer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_cell_renderer_spacer_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_cell_renderer_spacer_finalize;
	/**
	         * Indentation level represented by this cell renderer
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL, g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void granite_widgets_source_list_cell_renderer_spacer_instance_init (GraniteWidgetsSourceListCellRendererSpacer * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_PRIVATE (self);
	self->priv->_level = -1;
}


static void granite_widgets_source_list_cell_renderer_spacer_finalize (GObject * obj) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	G_OBJECT_CLASS (granite_widgets_source_list_cell_renderer_spacer_parent_class)->finalize (obj);
}


/**
     * A cell renderer that only adds space.
     */
static GType granite_widgets_source_list_cell_renderer_spacer_get_type (void) {
	static volatile gsize granite_widgets_source_list_cell_renderer_spacer_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererSpacerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_spacer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererSpacer), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_spacer_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_spacer_type_id;
		granite_widgets_source_list_cell_renderer_spacer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "GraniteWidgetsSourceListCellRendererSpacer", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile, granite_widgets_source_list_cell_renderer_spacer_type_id);
	}
	return granite_widgets_source_list_cell_renderer_spacer_type_id__volatile;
}


static void _vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL:
		g_value_set_int (value, granite_widgets_source_list_cell_renderer_spacer_get_level (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL:
		granite_widgets_source_list_cell_renderer_spacer_set_level (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender, GtkCellEditable* editable, const gchar* path, gpointer self) {
	granite_widgets_source_list_tree_on_editing_started ((GraniteWidgetsSourceListTree*) self, editable, path);
}


static void _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender, gpointer self) {
	granite_widgets_source_list_tree_on_editing_canceled ((GraniteWidgetsSourceListTree*) self);
}


static GType granite_widgets_source_list_tree_column_get_type (void) {
	static volatile gsize granite_widgets_source_list_tree_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_tree_column_type_id;
		granite_widgets_source_list_tree_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListTreeColumn", values);
		g_once_init_leave (&granite_widgets_source_list_tree_column_type_id__volatile, granite_widgets_source_list_tree_column_type_id);
	}
	return granite_widgets_source_list_tree_column_type_id__volatile;
}


static void _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_expander_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender, const gchar* path, gpointer self) {
	granite_widgets_source_list_tree_on_activatable_activated ((GraniteWidgetsSourceListTree*) self, path);
}


static void _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_icon_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_badge_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_name_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
}


static gboolean _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self) {
	gboolean result;
	result = granite_widgets_source_list_tree_select_func ((GraniteWidgetsSourceListTree*) self, selection, model, path, path_currently_selected);
	return result;
}


static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_construct (GType object_type, GraniteWidgetsSourceListDataModel* data_model) {
	GraniteWidgetsSourceListTree * self = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	GtkTreeViewColumn* item_column = NULL;
	GtkTreeViewColumn* _tmp4_;
	GraniteWidgetsCellRendererExpander* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GraniteWidgetsCellRendererExpander* _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	GraniteWidgetsCellRendererExpander* _tmp9_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp10_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp11_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp12_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp13_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp14_;
	GraniteWidgetsCellRendererBadge* _tmp15_;
	GraniteWidgetsCellRendererBadge* _tmp16_;
	GraniteWidgetsCellRendererBadge* _tmp17_;
	GraniteWidgetsCellRendererBadge* _tmp18_;
	GraniteWidgetsCellRendererBadge* _tmp19_;
	GtkCellRendererText* _tmp20_;
	GtkCellRendererText* _tmp21_;
	GtkCellRendererText* _tmp22_;
	GtkCellRendererText* _tmp23_;
	GtkCellRendererText* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkCellRendererText* _tmp28_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp29_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp30_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp31_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp32_;
	GraniteWidgetsCellRendererExpander* _tmp33_;
	gint expander_spacing = 0;
	GraniteWidgetsCellRendererExpander* _tmp34_;
	GraniteWidgetsCellRendererExpander* _tmp35_;
	GraniteWidgetsCellRendererExpander* _tmp36_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp37_;
	GtkTreeSelection* _tmp38_;
	g_return_val_if_fail (data_model != NULL, NULL);
	self = (GraniteWidgetsSourceListTree*) g_object_new (object_type, NULL);
	_tmp0_ = granite_widgets_utils_set_theming ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET, GRANITE_STYLE_CLASS_SOURCE_LIST, GTK_STYLE_PROVIDER_PRIORITY_FALLBACK);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
	_tmp2_ = data_model;
	granite_widgets_source_list_tree_set_data_model (self, _tmp2_);
	_tmp3_ = data_model;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp3_);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
	g_object_set ((GtkTreeView*) self, "enable-grid-lines", GTK_TREE_VIEW_GRID_LINES_NONE, NULL);
	gtk_tree_view_set_expander_column ((GtkTreeView*) self, NULL);
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
	_tmp4_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp4_);
	item_column = _tmp4_;
	gtk_tree_view_column_set_expand (item_column, TRUE);
	gtk_tree_view_insert_column ((GtkTreeView*) self, item_column, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	_tmp5_ = granite_widgets_cell_renderer_expander_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->secondary_expander_cell);
	self->priv->secondary_expander_cell = _tmp5_;
	_tmp6_ = self->priv->secondary_expander_cell;
	granite_widgets_cell_renderer_expander_set_is_category_expander (_tmp6_, TRUE);
	_tmp7_ = self->priv->secondary_expander_cell;
	g_object_set ((GtkCellRenderer*) _tmp7_, "xpad", (guint) 10, NULL);
	_tmp8_ = self->priv->secondary_expander_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp8_, FALSE);
	_tmp9_ = self->priv->secondary_expander_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp9_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp10_ = granite_widgets_source_list_cell_renderer_icon_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->activatable_cell);
	self->priv->activatable_cell = _tmp10_;
	_tmp11_ = self->priv->activatable_cell;
	g_object_set ((GtkCellRenderer*) _tmp11_, "xpad", (guint) 6, NULL);
	_tmp12_ = self->priv->activatable_cell;
	g_signal_connect_object (_tmp12_, "activated", (GCallback) _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated, self, 0);
	_tmp13_ = self->priv->activatable_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp13_, FALSE);
	_tmp14_ = self->priv->activatable_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp14_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp15_ = granite_widgets_cell_renderer_badge_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->badge_cell);
	self->priv->badge_cell = _tmp15_;
	_tmp16_ = self->priv->badge_cell;
	g_object_set ((GtkCellRenderer*) _tmp16_, "xpad", (guint) 1, NULL);
	_tmp17_ = self->priv->badge_cell;
	g_object_set ((GtkCellRenderer*) _tmp17_, "xalign", (gfloat) 1, NULL);
	_tmp18_ = self->priv->badge_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp18_, FALSE);
	_tmp19_ = self->priv->badge_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp19_, _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp20_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->text_cell);
	self->priv->text_cell = _tmp20_;
	_tmp21_ = self->priv->text_cell;
	g_object_set (_tmp21_, "editable-set", TRUE, NULL);
	_tmp22_ = self->priv->text_cell;
	g_object_set (_tmp22_, "editable", FALSE, NULL);
	_tmp23_ = self->priv->text_cell;
	g_signal_connect_object ((GtkCellRenderer*) _tmp23_, "editing-started", (GCallback) _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started, self, 0);
	_tmp24_ = self->priv->text_cell;
	g_signal_connect_object ((GtkCellRenderer*) _tmp24_, "editing-canceled", (GCallback) _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
	_tmp25_ = self->priv->text_cell;
	g_object_set (_tmp25_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	_tmp26_ = self->priv->text_cell;
	g_object_set ((GtkCellRenderer*) _tmp26_, "xalign", (gfloat) 0, NULL);
	_tmp27_ = self->priv->text_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp27_, TRUE);
	_tmp28_ = self->priv->text_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp28_, _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp29_ = granite_widgets_source_list_cell_renderer_icon_new ();
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->icon_cell);
	self->priv->icon_cell = _tmp29_;
	_tmp30_ = self->priv->icon_cell;
	g_object_set ((GtkCellRenderer*) _tmp30_, "xpad", (guint) 2, NULL);
	_tmp31_ = self->priv->icon_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp31_, FALSE);
	_tmp32_ = self->priv->icon_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp32_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp33_ = granite_widgets_cell_renderer_expander_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->primary_expander_cell);
	self->priv->primary_expander_cell = _tmp33_;
	gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, &expander_spacing, NULL);
	_tmp34_ = self->priv->primary_expander_cell;
	g_object_set ((GtkCellRenderer*) _tmp34_, "xpad", (guint) (expander_spacing / 2), NULL);
	_tmp35_ = self->priv->primary_expander_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp35_, FALSE);
	_tmp36_ = self->priv->primary_expander_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp36_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp37_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp38_ = _g_object_ref0 (_tmp37_);
	selection = _tmp38_;
	gtk_tree_selection_set_mode (selection, GTK_SELECTION_BROWSE);
	gtk_tree_selection_set_select_function (selection, _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func, g_object_ref (self), g_object_unref);
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
	granite_widgets_source_list_tree_add_spacer_cell_for_level (self, 1, TRUE);
	granite_widgets_source_list_tree_configure_drag_source (self, NULL, 0);
	granite_widgets_source_list_tree_configure_drag_dest (self, NULL, 0, 0);
	_g_object_unref0 (selection);
	_g_object_unref0 (item_column);
	return self;
}


static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model) {
	return granite_widgets_source_list_tree_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, data_model);
}


static gpointer _gtk_target_list_ref0 (gpointer self) {
	return self ? gtk_target_list_ref (self) : NULL;
}


static gboolean granite_widgets_source_list_tree_real_drag_motion (GtkWidget* base, GdkDragContext* context, gint x, gint y, guint time) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GdkDragContext* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint _tmp3_;
	gboolean _tmp4_;
	GtkTreePath* suggested_path = NULL;
	GtkTreePath* current_path = NULL;
	GtkTreeViewDropPosition suggested_pos = 0;
	GtkTreeViewDropPosition current_pos = 0;
	gint _tmp5_;
	gint _tmp6_;
	GtkTreePath* _tmp7_ = NULL;
	GtkTreeViewDropPosition _tmp8_ = 0;
	gboolean _tmp9_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = context;
	_tmp1_ = x;
	_tmp2_ = y;
	_tmp3_ = time;
	_tmp4_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->drag_motion ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	if (!_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = x;
	_tmp6_ = y;
	_tmp9_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, _tmp5_, _tmp6_, &_tmp7_, &_tmp8_);
	_gtk_tree_path_free0 (suggested_path);
	suggested_path = _tmp7_;
	suggested_pos = _tmp8_;
	if (_tmp9_) {
		GtkTreePath* _tmp10_ = NULL;
		GtkTreeViewDropPosition _tmp11_ = 0;
		gboolean _tmp12_ = FALSE;
		GtkTreePath* _tmp13_;
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp10_, &_tmp11_);
		_gtk_tree_path_free0 (current_path);
		current_path = _tmp10_;
		current_pos = _tmp11_;
		_tmp13_ = current_path;
		if (_tmp13_ != NULL) {
			GtkTreePath* _tmp14_;
			GtkTreePath* _tmp15_;
			gint _tmp16_;
			_tmp14_ = suggested_path;
			_tmp15_ = current_path;
			_tmp16_ = gtk_tree_path_compare (_tmp14_, _tmp15_);
			_tmp12_ = _tmp16_ == 0;
		} else {
			_tmp12_ = FALSE;
		}
		if (_tmp12_) {
			GtkWidget* source_widget = NULL;
			GdkDragContext* _tmp17_;
			GtkWidget* _tmp18_;
			GtkWidget* _tmp19_;
			gboolean dragging_treemodel_row = FALSE;
			GtkWidget* _tmp20_;
			gboolean _tmp21_;
			_tmp17_ = context;
			_tmp18_ = gtk_drag_get_source_widget (_tmp17_);
			_tmp19_ = _g_object_ref0 (_tmp18_);
			source_widget = _tmp19_;
			_tmp20_ = source_widget;
			dragging_treemodel_row = _tmp20_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
			_tmp21_ = dragging_treemodel_row;
			if (_tmp21_) {
				GtkTreeViewDropPosition _tmp22_;
				_tmp22_ = current_pos;
				if (_tmp22_ != GTK_TREE_VIEW_DROP_BEFORE) {
					GtkTreeViewDropPosition _tmp23_;
					_tmp23_ = current_pos;
					if (_tmp23_ == GTK_TREE_VIEW_DROP_INTO_OR_BEFORE) {
						GtkTreePath* _tmp24_;
						_tmp24_ = current_path;
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp24_, GTK_TREE_VIEW_DROP_BEFORE);
					} else {
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
					}
				}
			} else {
				GtkTreeViewDropPosition _tmp25_;
				GraniteWidgetsSourceListDragDest* dest = NULL;
				GraniteWidgetsSourceListDataModel* _tmp29_;
				GtkTreePath* _tmp30_;
				GraniteWidgetsSourceListItem* _tmp31_;
				GraniteWidgetsSourceListDragDest* _tmp32_;
				GraniteWidgetsSourceListDragDest* _tmp33_;
				_tmp25_ = current_pos;
				if (_tmp25_ == GTK_TREE_VIEW_DROP_BEFORE) {
					GtkTreePath* _tmp26_;
					_tmp26_ = current_path;
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp26_, GTK_TREE_VIEW_DROP_INTO_OR_BEFORE);
				} else {
					GtkTreeViewDropPosition _tmp27_;
					_tmp27_ = current_pos;
					if (_tmp27_ == GTK_TREE_VIEW_DROP_AFTER) {
						GtkTreePath* _tmp28_;
						_tmp28_ = current_path;
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp28_, GTK_TREE_VIEW_DROP_INTO_OR_AFTER);
					}
				}
				_tmp29_ = self->priv->_data_model;
				_tmp30_ = current_path;
				_tmp31_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp29_, _tmp30_);
				_tmp32_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp31_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp31_) : NULL;
				if (_tmp32_ == NULL) {
					_g_object_unref0 (_tmp31_);
				}
				dest = _tmp32_;
				_tmp33_ = dest;
				if (_tmp33_ != NULL) {
					GtkTargetList* target_list = NULL;
					GtkTargetList* _tmp34_;
					GtkTargetList* _tmp35_;
					GdkAtom target = 0U;
					GdkDragContext* _tmp36_;
					GtkTargetList* _tmp37_;
					GdkAtom _tmp38_;
					GdkDragContext* _tmp39_;
					GdkDragContext* _tmp40_;
					GdkDragAction _tmp41_;
					GdkDragContext* _tmp42_;
					GdkAtom _tmp43_;
					guint _tmp44_;
					_tmp34_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
					_tmp35_ = _gtk_target_list_ref0 (_tmp34_);
					target_list = _tmp35_;
					_tmp36_ = context;
					_tmp37_ = target_list;
					_tmp38_ = gtk_drag_dest_find_target ((GtkWidget*) self, _tmp36_, _tmp37_);
					target = _tmp38_;
					_tmp39_ = context;
					_tmp40_ = context;
					_tmp41_ = gdk_drag_context_get_suggested_action (_tmp40_);
					g_object_set_data_full ((GObject*) _tmp39_, "suggested-dnd-action", (gpointer) ((gintptr) ((gint) _tmp41_)), NULL);
					_tmp42_ = context;
					_tmp43_ = target;
					_tmp44_ = time;
					gtk_drag_get_data ((GtkWidget*) self, _tmp42_, _tmp43_, (guint32) _tmp44_);
					_gtk_target_list_unref0 (target_list);
				} else {
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
				}
				_g_object_unref0 (dest);
			}
			_g_object_unref0 (source_widget);
		}
	} else {
		gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
		result = FALSE;
		_gtk_tree_path_free0 (current_path);
		_gtk_tree_path_free0 (suggested_path);
		return result;
	}
	result = TRUE;
	_gtk_tree_path_free0 (current_path);
	_gtk_tree_path_free0 (suggested_path);
	return result;
}


static void granite_widgets_source_list_tree_real_drag_data_received (GtkWidget* base, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time) {
	GraniteWidgetsSourceListTree * self;
	GtkTargetList* target_list = NULL;
	GtkTargetList* _tmp0_;
	GtkTargetList* _tmp1_;
	GdkAtom target = 0U;
	GdkDragContext* _tmp2_;
	GtkTargetList* _tmp3_;
	GdkAtom _tmp4_;
	GdkAtom _tmp5_;
	GdkAtom _tmp6_;
	GtkTreePath* path = NULL;
	GtkTreeViewDropPosition pos = 0;
	GdkDragContext* _tmp13_;
	gconstpointer _tmp14_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	_tmp0_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
	_tmp1_ = _gtk_target_list_ref0 (_tmp0_);
	target_list = _tmp1_;
	_tmp2_ = context;
	_tmp3_ = target_list;
	_tmp4_ = gtk_drag_dest_find_target ((GtkWidget*) self, _tmp2_, _tmp3_);
	target = _tmp4_;
	_tmp5_ = target;
	_tmp6_ = gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW");
	if (_tmp5_ == _tmp6_) {
		GdkDragContext* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GtkSelectionData* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		_tmp7_ = context;
		_tmp8_ = x;
		_tmp9_ = y;
		_tmp10_ = selection_data;
		_tmp11_ = info;
		_tmp12_ = time;
		GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->drag_data_received ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_);
		_gtk_target_list_unref0 (target_list);
		return;
	}
	_tmp13_ = context;
	_tmp14_ = g_object_get_data ((GObject*) _tmp13_, "suggested-dnd-action");
	if (((gint) ((gintptr) _tmp14_)) != 0) {
		GdkDragContext* _tmp15_;
		GtkTreePath* _tmp16_ = NULL;
		GtkTreeViewDropPosition _tmp17_ = 0;
		GtkTreePath* _tmp18_;
		GdkDragContext* _tmp31_;
		GdkDragContext* _tmp32_;
		GdkDragAction _tmp33_;
		guint _tmp34_;
		_tmp15_ = context;
		g_object_set_data_full ((GObject*) _tmp15_, "suggested-dnd-action", (gpointer) ((gintptr) 0), NULL);
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp16_, &_tmp17_);
		_gtk_tree_path_free0 (path);
		path = _tmp16_;
		pos = _tmp17_;
		_tmp18_ = path;
		if (_tmp18_ != NULL) {
			GraniteWidgetsSourceListDragDest* dest = NULL;
			GraniteWidgetsSourceListDataModel* _tmp19_;
			GtkTreePath* _tmp20_;
			GraniteWidgetsSourceListItem* _tmp21_;
			GraniteWidgetsSourceListDragDest* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GraniteWidgetsSourceListDragDest* _tmp24_;
			_tmp19_ = self->priv->_data_model;
			_tmp20_ = path;
			_tmp21_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp19_, _tmp20_);
			_tmp22_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp21_) : NULL;
			if (_tmp22_ == NULL) {
				_g_object_unref0 (_tmp21_);
			}
			dest = _tmp22_;
			_tmp24_ = dest;
			if (_tmp24_ == NULL) {
				_tmp23_ = TRUE;
			} else {
				GraniteWidgetsSourceListDragDest* _tmp25_;
				GdkDragContext* _tmp26_;
				GtkSelectionData* _tmp27_;
				gboolean _tmp28_;
				_tmp25_ = dest;
				_tmp26_ = context;
				_tmp27_ = selection_data;
				_tmp28_ = granite_widgets_source_list_drag_dest_data_drop_possible (_tmp25_, _tmp26_, _tmp27_);
				_tmp23_ = !_tmp28_;
			}
			if (_tmp23_) {
				GdkDragContext* _tmp29_;
				guint _tmp30_;
				gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
				_tmp29_ = context;
				_tmp30_ = time;
				gdk_drag_status (_tmp29_, 0, (guint32) _tmp30_);
				_g_object_unref0 (dest);
				_gtk_tree_path_free0 (path);
				_gtk_target_list_unref0 (target_list);
				return;
			}
			_g_object_unref0 (dest);
		}
		_tmp31_ = context;
		_tmp32_ = context;
		_tmp33_ = gdk_drag_context_get_suggested_action (_tmp32_);
		_tmp34_ = time;
		gdk_drag_status (_tmp31_, _tmp33_, (guint32) _tmp34_);
	} else {
		gint _tmp35_;
		gint _tmp36_;
		GtkTreePath* _tmp37_ = NULL;
		GtkTreeViewDropPosition _tmp38_ = 0;
		gboolean _tmp39_;
		GdkDragContext* _tmp53_;
		guint _tmp54_;
		_tmp35_ = x;
		_tmp36_ = y;
		_tmp39_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, _tmp35_, _tmp36_, &_tmp37_, &_tmp38_);
		_gtk_tree_path_free0 (path);
		path = _tmp37_;
		pos = _tmp38_;
		if (_tmp39_) {
			GraniteWidgetsSourceListDragDest* drag_dest = NULL;
			GraniteWidgetsSourceListDataModel* _tmp40_;
			GtkTreePath* _tmp41_;
			GraniteWidgetsSourceListItem* _tmp42_;
			GraniteWidgetsSourceListDragDest* _tmp43_;
			GraniteWidgetsSourceListDragDest* _tmp44_;
			_tmp40_ = self->priv->_data_model;
			_tmp41_ = path;
			_tmp42_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp40_, _tmp41_);
			_tmp43_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp42_) : NULL;
			if (_tmp43_ == NULL) {
				_g_object_unref0 (_tmp42_);
			}
			drag_dest = _tmp43_;
			_tmp44_ = drag_dest;
			if (_tmp44_ != NULL) {
				GdkDragAction action = 0;
				GraniteWidgetsSourceListDragDest* _tmp45_;
				GdkDragContext* _tmp46_;
				GtkSelectionData* _tmp47_;
				GdkDragAction _tmp48_;
				GdkDragContext* _tmp49_;
				GdkDragAction _tmp50_;
				GdkDragAction _tmp51_;
				guint _tmp52_;
				_tmp45_ = drag_dest;
				_tmp46_ = context;
				_tmp47_ = selection_data;
				_tmp48_ = granite_widgets_source_list_drag_dest_data_received (_tmp45_, _tmp46_, _tmp47_);
				action = _tmp48_;
				_tmp49_ = context;
				_tmp50_ = action;
				_tmp51_ = action;
				_tmp52_ = time;
				gtk_drag_finish (_tmp49_, _tmp50_ != 0, _tmp51_ == GDK_ACTION_MOVE, (guint32) _tmp52_);
				_g_object_unref0 (drag_dest);
				_gtk_tree_path_free0 (path);
				_gtk_target_list_unref0 (target_list);
				return;
			}
			_g_object_unref0 (drag_dest);
		}
		_tmp53_ = context;
		_tmp54_ = time;
		gtk_drag_finish (_tmp53_, FALSE, FALSE, (guint32) _tmp54_);
	}
	_gtk_tree_path_free0 (path);
	_gtk_target_list_unref0 (target_list);
}


static void granite_widgets_source_list_tree_configure_drag_source (GraniteWidgetsSourceListTree* self, GtkTargetEntry* src_entries, int src_entries_length1) {
	GtkTargetEntry* entries = NULL;
	GtkTargetEntry* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	GtkTargetEntry* _tmp2_;
	gint entries_length1;
	gint _entries_size_;
	g_return_if_fail (self != NULL);
	_tmp0_ = src_entries;
	_tmp0__length1 = src_entries_length1;
	_tmp2_ = granite_widgets_source_list_tree_append_row_target_entry (_tmp0_, _tmp0__length1, &_tmp1_);
	entries = _tmp2_;
	entries_length1 = _tmp1_;
	_entries_size_ = entries_length1;
	gtk_tree_view_unset_rows_drag_source ((GtkTreeView*) self);
	gtk_tree_view_enable_model_drag_source ((GtkTreeView*) self, GDK_BUTTON1_MASK, entries, entries_length1, GDK_ACTION_MOVE);
	entries = (g_free (entries), NULL);
}


static void granite_widgets_source_list_tree_configure_drag_dest (GraniteWidgetsSourceListTree* self, GtkTargetEntry* dest_entries, int dest_entries_length1, GdkDragAction actions) {
	GtkTargetEntry* entries = NULL;
	GtkTargetEntry* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	GtkTargetEntry* _tmp2_;
	gint entries_length1;
	gint _entries_size_;
	GdkDragAction _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = dest_entries;
	_tmp0__length1 = dest_entries_length1;
	_tmp2_ = granite_widgets_source_list_tree_append_row_target_entry (_tmp0_, _tmp0__length1, &_tmp1_);
	entries = _tmp2_;
	entries_length1 = _tmp1_;
	_entries_size_ = entries_length1;
	gtk_tree_view_unset_rows_drag_dest ((GtkTreeView*) self);
	_tmp3_ = actions;
	gtk_tree_view_enable_model_drag_dest ((GtkTreeView*) self, entries, entries_length1, GDK_ACTION_MOVE | _tmp3_);
	entries = (g_free (entries), NULL);
}


static void _vala_array_add3 (GtkTargetEntry* * array, int* length, int* size, const GtkTargetEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkTargetEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add4 (GtkTargetEntry* * array, int* length, int* size, const GtkTargetEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkTargetEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static GtkTargetEntry* granite_widgets_source_list_tree_append_row_target_entry (GtkTargetEntry* orig, int orig_length1, int* result_length1) {
	GtkTargetEntry* result = NULL;
	static const GtkTargetEntry row_target_entry = {"GTK_TREE_MODEL_ROW", (guint) GTK_TARGET_SAME_WIDGET, (guint) 0};
	GtkTargetEntry* entries = NULL;
	GtkTargetEntry* _tmp0_;
	gint entries_length1;
	gint _entries_size_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	GtkTargetEntry* _tmp2_;
	gint _tmp2__length1;
	GtkTargetEntry* _tmp6_;
	gint _tmp6__length1;
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
	entries = _tmp0_;
	entries_length1 = 0;
	_entries_size_ = entries_length1;
	_tmp1_ = entries;
	_tmp1__length1 = entries_length1;
	_vala_array_add3 (&entries, &entries_length1, &_entries_size_, &row_target_entry);
	_tmp2_ = orig;
	_tmp2__length1 = orig_length1;
	if (_tmp2_ != NULL) {
		GtkTargetEntry* _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = orig;
		_tmp3__length1 = orig_length1;
		{
			GtkTargetEntry* target_entry_collection = NULL;
			gint target_entry_collection_length1 = 0;
			gint _target_entry_collection_size_ = 0;
			gint target_entry_it = 0;
			target_entry_collection = _tmp3_;
			target_entry_collection_length1 = _tmp3__length1;
			for (target_entry_it = 0; target_entry_it < _tmp3__length1; target_entry_it = target_entry_it + 1) {
				GtkTargetEntry target_entry = {0};
				target_entry = target_entry_collection[target_entry_it];
				{
					GtkTargetEntry* _tmp4_;
					gint _tmp4__length1;
					GtkTargetEntry _tmp5_;
					_tmp4_ = entries;
					_tmp4__length1 = entries_length1;
					_tmp5_ = target_entry;
					_vala_array_add4 (&entries, &entries_length1, &_entries_size_, &_tmp5_);
				}
			}
		}
	}
	_tmp6_ = entries;
	_tmp6__length1 = entries_length1;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	return result;
}


static void _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_tree_on_model_item_updated ((GraniteWidgetsSourceListTree*) self, item);
}


static void granite_widgets_source_list_tree_enable_item_property_monitor (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_data_model;
	g_signal_connect_object (_tmp0_, "item-updated", (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self, G_CONNECT_AFTER);
}


static void granite_widgets_source_list_tree_disable_item_property_monitor (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_data_model;
	g_signal_parse_name ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self);
}


static void granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListExpandableItem* expandable_item = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp0_) : NULL);
	expandable_item = _tmp1_;
	_tmp2_ = expandable_item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp3_ = expandable_item;
		granite_widgets_source_list_tree_update_expansion (self, _tmp3_);
	}
	_g_object_unref0 (expandable_item);
}


static void _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_spacer_cell_data_func (cell_layout, cell, tree_model, iter);
}


static void granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self, gint level, gboolean check_previous) {
	gint _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = level;
	_vala_return_if_fail (_tmp0_ > 0, "level > 0");
	_tmp1_ = self->priv->spacer_cells;
	if (_tmp1_ == NULL) {
		GeeHashMap* _tmp2_;
		_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		_g_object_unref0 (self->priv->spacer_cells);
		self->priv->spacer_cells = _tmp2_;
	}
	_tmp3_ = self->priv->spacer_cells;
	_tmp4_ = level;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
	if (!_tmp5_) {
		GraniteWidgetsSourceListCellRendererSpacer* spacer_cell = NULL;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp6_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp7_;
		gint _tmp8_;
		GeeHashMap* _tmp9_;
		gint _tmp10_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp11_;
		guint cell_xpadding = 0U;
		gint _tmp12_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp15_;
		guint _tmp16_;
		GtkTreeViewColumn* item_column = NULL;
		GtkTreeViewColumn* _tmp17_;
		GtkTreeViewColumn* _tmp18_;
		GtkTreeViewColumn* _tmp19_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp20_;
		GtkTreeViewColumn* _tmp21_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp22_;
		gboolean _tmp23_;
		_tmp6_ = granite_widgets_source_list_cell_renderer_spacer_new ();
		g_object_ref_sink (_tmp6_);
		spacer_cell = _tmp6_;
		_tmp7_ = spacer_cell;
		_tmp8_ = level;
		granite_widgets_source_list_cell_renderer_spacer_set_level (_tmp7_, _tmp8_);
		_tmp9_ = self->priv->spacer_cells;
		_tmp10_ = level;
		_tmp11_ = spacer_cell;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) _tmp10_), _tmp11_);
		_tmp12_ = level;
		switch (_tmp12_) {
			case 1:
			{
				gint left_padding = 0;
				gint _tmp13_;
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, &left_padding, NULL);
				_tmp13_ = left_padding;
				cell_xpadding = (guint) (_tmp13_ / 2);
				break;
			}
			case 2:
			{
				cell_xpadding = (guint) 0;
				break;
			}
			default:
			{
				gint level_indentation = 0;
				gint _tmp14_;
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, &level_indentation, NULL);
				_tmp14_ = level_indentation;
				cell_xpadding = (guint) (_tmp14_ / 2);
				break;
			}
		}
		_tmp15_ = spacer_cell;
		_tmp16_ = cell_xpadding;
		g_object_set ((GtkCellRenderer*) _tmp15_, "xpad", _tmp16_, NULL);
		_tmp17_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
		_tmp18_ = _g_object_ref0 (_tmp17_);
		item_column = _tmp18_;
		_tmp19_ = item_column;
		_tmp20_ = spacer_cell;
		gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp19_, (GtkCellRenderer*) _tmp20_, FALSE);
		_tmp21_ = item_column;
		_tmp22_ = spacer_cell;
		gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp21_, (GtkCellRenderer*) _tmp22_, _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func, NULL, NULL);
		_tmp23_ = check_previous;
		if (_tmp23_) {
			{
				gint i = 0;
				gint _tmp24_;
				_tmp24_ = level;
				i = _tmp24_ - 1;
				{
					gboolean _tmp25_ = FALSE;
					_tmp25_ = TRUE;
					while (TRUE) {
						gint _tmp27_;
						gint _tmp28_;
						if (!_tmp25_) {
							gint _tmp26_;
							_tmp26_ = i;
							i = _tmp26_ - 1;
						}
						_tmp25_ = FALSE;
						_tmp27_ = i;
						if (!(_tmp27_ > 0)) {
							break;
						}
						_tmp28_ = i;
						granite_widgets_source_list_tree_add_spacer_cell_for_level (self, _tmp28_, FALSE);
					}
				}
			}
		}
		_g_object_unref0 (item_column);
		_g_object_unref0 (spacer_cell);
	}
}


/**
         * Evaluates whether the item at the specified path can be selected or not.
         */
static gboolean granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected) {
	gboolean result = FALSE;
	gboolean selectable = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (selection != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	selectable = FALSE;
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = path;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp0_, _tmp1_);
	item = _tmp2_;
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		GtkTreePath* _tmp6_;
		gboolean _tmp7_;
		_tmp4_ = self->priv->_data_model;
		_tmp5_ = item;
		_tmp6_ = path;
		_tmp7_ = granite_widgets_source_list_data_model_is_category (_tmp4_, _tmp5_, NULL, _tmp6_);
		if (!_tmp7_) {
			GraniteWidgetsSourceListItem* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp8_ = item;
			_tmp9_ = granite_widgets_source_list_item_get_selectable (_tmp8_);
			_tmp10_ = _tmp9_;
			selectable = _tmp10_;
		}
	}
	result = selectable;
	_g_object_unref0 (item);
	return result;
}


static void _gtk_tree_path_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL));
}


static void _g_list_free__gtk_tree_path_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _gtk_tree_path_free0_, NULL);
	g_list_free (self);
}


static GtkTreePath* granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self) {
	GtkTreePath* result = NULL;
	GtkTreePath* selected_path = NULL;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	selected_path = NULL;
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	selection = _tmp1_;
	_tmp2_ = selection;
	if (_tmp2_ != NULL) {
		GtkTreeModel* model = NULL;
		GList* selected_rows = NULL;
		GtkTreeSelection* _tmp3_;
		GtkTreeModel* _tmp4_ = NULL;
		GList* _tmp5_;
		GtkTreeModel* _tmp6_;
		GList* _tmp7_;
		guint _tmp8_;
		_tmp3_ = selection;
		_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
		_g_object_unref0 (model);
		_tmp6_ = _g_object_ref0 (_tmp4_);
		model = _tmp6_;
		selected_rows = _tmp5_;
		_tmp7_ = selected_rows;
		_tmp8_ = g_list_length (_tmp7_);
		if (_tmp8_ == ((guint) 1)) {
			GList* _tmp9_;
			gconstpointer _tmp10_;
			GtkTreePath* _tmp11_;
			_tmp9_ = selected_rows;
			_tmp10_ = g_list_nth_data (_tmp9_, (guint) 0);
			_tmp11_ = _gtk_tree_path_copy0 ((GtkTreePath*) _tmp10_);
			_gtk_tree_path_free0 (selected_path);
			selected_path = _tmp11_;
		}
		__g_list_free__gtk_tree_path_free0_0 (selected_rows);
		_g_object_unref0 (model);
	}
	result = selected_path;
	_g_object_unref0 (selection);
	return result;
}


static void granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean scroll_to_item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = item;
	if (_tmp0_ == NULL) {
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp1_;
		GtkTreeSelection* _tmp2_;
		GtkTreeSelection* _tmp3_;
		_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		selection = _tmp2_;
		_tmp3_ = selection;
		if (_tmp3_ != NULL) {
			GtkTreeSelection* _tmp4_;
			_tmp4_ = selection;
			gtk_tree_selection_unselect_all (_tmp4_);
		}
		_g_object_unref0 (self->priv->selected);
		self->priv->selected = NULL;
		g_signal_emit (self, granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL], 0, NULL);
		_g_object_unref0 (selection);
	} else {
		GraniteWidgetsSourceListItem* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = item;
		_tmp6_ = granite_widgets_source_list_item_get_selectable (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			gboolean _tmp8_;
			GtkTreePath* to_select = NULL;
			GraniteWidgetsSourceListDataModel* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			GtkTreePath* _tmp12_;
			GtkTreePath* _tmp13_;
			_tmp8_ = scroll_to_item;
			if (_tmp8_) {
				GraniteWidgetsSourceListItem* _tmp9_;
				_tmp9_ = item;
				granite_widgets_source_list_tree_scroll_to_item (self, _tmp9_, FALSE, (gfloat) 0);
			}
			_tmp10_ = self->priv->_data_model;
			_tmp11_ = item;
			_tmp12_ = granite_widgets_source_list_data_model_get_item_path (_tmp10_, _tmp11_);
			to_select = _tmp12_;
			_tmp13_ = to_select;
			if (_tmp13_ != NULL) {
				GtkTreePath* _tmp14_;
				GtkTreeViewColumn* _tmp15_;
				GtkCellRendererText* _tmp16_;
				_tmp14_ = to_select;
				_tmp15_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
				_tmp16_ = self->priv->text_cell;
				gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp14_, _tmp15_, (GtkCellRenderer*) _tmp16_, FALSE);
			}
			_gtk_tree_path_free0 (to_select);
		}
	}
}


static void granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base) {
	GraniteWidgetsSourceListTree * self;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GraniteWidgetsSourceListItem* new_item = NULL;
	GraniteWidgetsSourceListItem* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp8_;
	self = (GraniteWidgetsSourceListTree*) base;
	_tmp0_ = granite_widgets_source_list_tree_get_selected_path (self);
	path = _tmp0_;
	_tmp2_ = path;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp3_;
		GtkTreePath* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		_tmp3_ = self->priv->_data_model;
		_tmp4_ = path;
		_tmp5_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp3_, _tmp4_);
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp5_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	_tmp6_ = _g_object_ref0 (_tmp1_);
	new_item = _tmp6_;
	_tmp8_ = new_item;
	if (_tmp8_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp9_;
		GraniteWidgetsSourceListItem* _tmp10_;
		_tmp9_ = new_item;
		_tmp10_ = self->priv->selected;
		_tmp7_ = _tmp9_ != _tmp10_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		GraniteWidgetsSourceListItem* _tmp11_;
		GraniteWidgetsSourceListItem* _tmp12_;
		GraniteWidgetsSourceListItem* _tmp13_;
		_tmp11_ = new_item;
		_tmp12_ = _g_object_ref0 (_tmp11_);
		_g_object_unref0 (self->priv->selected);
		self->priv->selected = _tmp12_;
		_tmp13_ = new_item;
		g_signal_emit (self, granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL], 0, _tmp13_);
	}
	_g_object_unref0 (new_item);
	_g_object_unref0 (_tmp1_);
	_gtk_tree_path_free0 (path);
}


static gboolean granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean use_align, gfloat row_align) {
	gboolean result = FALSE;
	gboolean scrolled = FALSE;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	scrolled = FALSE;
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = item;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, _tmp1_);
	path = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ != NULL) {
		GtkTreePath* _tmp4_;
		gboolean _tmp5_;
		gfloat _tmp6_;
		_tmp4_ = path;
		_tmp5_ = use_align;
		_tmp6_ = row_align;
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp4_, NULL, _tmp5_, _tmp6_, (gfloat) 0);
		scrolled = TRUE;
	}
	result = scrolled;
	_gtk_tree_path_free0 (path);
	return result;
}


static gboolean granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp11_;
	GraniteWidgetsSourceListItem* _tmp12_;
	GtkTreePath* _tmp13_;
	GtkTreePath* _tmp14_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_editable (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_val_if_fail (_tmp2_, "item.editable", FALSE);
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_item_get_selectable (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_return_val_if_fail (_tmp5_, "item.selectable", FALSE);
	_tmp7_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		GraniteWidgetsSourceListItem* _tmp9_;
		GraniteWidgetsSourceListItem* _tmp10_;
		_tmp9_ = item;
		_tmp10_ = self->priv->edited;
		_tmp6_ = _tmp9_ == _tmp10_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp11_ = self->priv->_data_model;
	_tmp12_ = item;
	_tmp13_ = granite_widgets_source_list_data_model_get_item_path (_tmp11_, _tmp12_);
	path = _tmp13_;
	_tmp14_ = path;
	if (_tmp14_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp15_;
		GtkCellRendererText* _tmp16_;
		GtkTreePath* _tmp17_;
		GtkTreeViewColumn* _tmp18_;
		GtkCellRendererText* _tmp19_;
		_tmp15_ = item;
		self->priv->edited = _tmp15_;
		_tmp16_ = self->priv->text_cell;
		g_object_set (_tmp16_, "editable", TRUE, NULL);
		_tmp17_ = path;
		_tmp18_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
		_tmp19_ = self->priv->text_cell;
		gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp17_, _tmp18_, (GtkCellRenderer*) _tmp19_, TRUE);
	} else {
		GraniteWidgetsSourceListItem* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp20_ = item;
		_tmp21_ = granite_widgets_source_list_item_get_name (_tmp20_);
		_tmp22_ = _tmp21_;
		g_warning ("SourceList.vala:2005: Could not edit \"%s\": path not found", _tmp22_);
	}
	_tmp23_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp24_ = _tmp23_;
	result = _tmp24_;
	_gtk_tree_path_free0 (path);
	return result;
}


static void granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp1_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GraniteWidgetsSourceListItem* _tmp3_;
		_tmp3_ = self->priv->edited;
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListDataModel* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreePath* _tmp7_;
		_tmp4_ = self->priv->_data_model;
		_tmp5_ = self->priv->edited;
		_tmp6_ = granite_widgets_source_list_data_model_get_item_path (_tmp4_, _tmp5_);
		path = _tmp6_;
		_tmp7_ = path;
		if (_tmp7_ != NULL) {
			GtkTreePath* _tmp8_;
			GtkTreeViewColumn* _tmp9_;
			GtkCellRendererText* _tmp10_;
			_tmp8_ = path;
			_tmp9_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
			_tmp10_ = self->priv->text_cell;
			gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp8_, _tmp9_, (GtkCellRenderer*) _tmp10_, FALSE);
		}
		_gtk_tree_path_free0 (path);
	}
}


static void _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self) {
	granite_widgets_source_list_tree_on_editing_done ((GraniteWidgetsSourceListTree*) self);
}


static void granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self, GtkCellEditable* editable, const gchar* path) {
	GtkCellEditable* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (editable != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = editable;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp0_) : NULL);
	_g_object_unref0 (self->priv->editable_entry);
	self->priv->editable_entry = _tmp1_;
	_tmp2_ = self->priv->editable_entry;
	if (_tmp2_ != NULL) {
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		_tmp3_ = self->priv->editable_entry;
		g_signal_connect_object ((GtkCellEditable*) _tmp3_, "editing-done", (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self, 0);
		_tmp4_ = self->priv->editable_entry;
		g_object_set (_tmp4_, "editable", TRUE, NULL);
	}
}


static void granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self) {
	GtkEntry* _tmp0_;
	GtkCellRendererText* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->editable_entry;
	if (_tmp0_ != NULL) {
		GtkEntry* _tmp1_;
		GtkEntry* _tmp2_;
		guint _tmp3_;
		_tmp1_ = self->priv->editable_entry;
		g_object_set (_tmp1_, "editable", FALSE, NULL);
		_tmp2_ = self->priv->editable_entry;
		g_signal_parse_name ("editing-done", GTK_TYPE_CELL_EDITABLE, &_tmp3_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GtkCellEditable*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self);
	}
	_tmp4_ = self->priv->text_cell;
	g_object_set (_tmp4_, "editable", FALSE, NULL);
	self->priv->edited = NULL;
}


static void granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp2_ = self->priv->edited;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->edited;
		_tmp4_ = granite_widgets_source_list_item_get_editable (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GtkEntry* _tmp6_;
		_tmp6_ = self->priv->editable_entry;
		_tmp0_ = _tmp6_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GraniteWidgetsSourceListItem* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		_tmp7_ = self->priv->edited;
		_tmp8_ = self->priv->editable_entry;
		_tmp9_ = gtk_entry_get_text (_tmp8_);
		g_signal_emit (_tmp7_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL], 0, _tmp9_);
	}
	granite_widgets_source_list_tree_on_editing_canceled (self);
}


static void granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self, const gchar* item_path_str) {
	GraniteWidgetsSourceListItem* item = NULL;
	const gchar* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item_path_str != NULL);
	_tmp0_ = item_path_str;
	_tmp1_ = granite_widgets_source_list_tree_get_item_from_path_string (self, _tmp0_);
	item = _tmp1_;
	_tmp2_ = item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		_tmp3_ = item;
		g_signal_emit (_tmp3_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL], 0);
	}
	_g_object_unref0 (item);
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self, const gchar* item_path_str) {
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreePath* item_path = NULL;
	const gchar* _tmp0_;
	GtkTreePath* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item_path_str != NULL, NULL);
	_tmp0_ = item_path_str;
	_tmp1_ = gtk_tree_path_new_from_string (_tmp0_);
	item_path = _tmp1_;
	_tmp2_ = self->priv->_data_model;
	_tmp3_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp2_, item_path);
	result = _tmp3_;
	_gtk_tree_path_free0 (item_path);
	return result;
}


static gboolean granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_expandable_item_get_collapsible (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp3_ = item;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_expandable_item_get_expanded (_tmp4_);
		_tmp6_ = _tmp5_;
		granite_widgets_source_list_expandable_item_set_expanded (_tmp3_, !_tmp6_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


/**
         * Updates the tree to reflect the ''expanded'' property of expandable_item.
         */
static void granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* expandable_item) {
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expandable_item != NULL);
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = expandable_item;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, (GraniteWidgetsSourceListItem*) _tmp1_);
	path = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ != NULL) {
		GtkTreePath* _tmp4_;
		gint _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp4_ = path;
		_tmp5_ = gtk_tree_path_get_depth (_tmp4_);
		granite_widgets_source_list_tree_add_spacer_cell_for_level (self, _tmp5_ + 1, TRUE);
		_tmp6_ = expandable_item;
		_tmp7_ = granite_widgets_source_list_expandable_item_get_expanded (_tmp6_);
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			GtkTreePath* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GraniteWidgetsSourceListItem* _tmp11_;
			_tmp9_ = path;
			gtk_tree_view_expand_row ((GtkTreeView*) self, _tmp9_, FALSE);
			_tmp11_ = self->priv->selected;
			if (_tmp11_ != NULL) {
				GraniteWidgetsSourceListItem* _tmp12_;
				GraniteWidgetsSourceListExpandableItem* _tmp13_;
				GraniteWidgetsSourceListExpandableItem* _tmp14_;
				GraniteWidgetsSourceListExpandableItem* _tmp15_;
				_tmp12_ = self->priv->selected;
				_tmp13_ = granite_widgets_source_list_item_get_parent (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = expandable_item;
				_tmp10_ = _tmp14_ == _tmp15_;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				GraniteWidgetsSourceListItem* _tmp16_;
				_tmp16_ = self->priv->selected;
				granite_widgets_source_list_tree_set_selected (self, _tmp16_, TRUE);
			}
			{
				GeeIterator* _child_item_it = NULL;
				GraniteWidgetsSourceListExpandableItem* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeCollection* _tmp20_;
				GeeIterator* _tmp21_;
				GeeIterator* _tmp22_;
				_tmp17_ = expandable_item;
				_tmp18_ = granite_widgets_source_list_expandable_item_get_children (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = _tmp19_;
				_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
				_tmp22_ = _tmp21_;
				_g_object_unref0 (_tmp20_);
				_child_item_it = _tmp22_;
				while (TRUE) {
					GeeIterator* _tmp23_;
					gboolean _tmp24_;
					GraniteWidgetsSourceListItem* child_item = NULL;
					GeeIterator* _tmp25_;
					gpointer _tmp26_;
					GraniteWidgetsSourceListExpandableItem* child_expandable_item = NULL;
					GraniteWidgetsSourceListItem* _tmp27_;
					GraniteWidgetsSourceListExpandableItem* _tmp28_;
					GraniteWidgetsSourceListExpandableItem* _tmp29_;
					_tmp23_ = _child_item_it;
					_tmp24_ = gee_iterator_next (_tmp23_);
					if (!_tmp24_) {
						break;
					}
					_tmp25_ = _child_item_it;
					_tmp26_ = gee_iterator_get (_tmp25_);
					child_item = (GraniteWidgetsSourceListItem*) _tmp26_;
					_tmp27_ = child_item;
					_tmp28_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp27_) : NULL);
					child_expandable_item = _tmp28_;
					_tmp29_ = child_expandable_item;
					if (_tmp29_ != NULL) {
						GraniteWidgetsSourceListExpandableItem* _tmp30_;
						_tmp30_ = child_expandable_item;
						granite_widgets_source_list_tree_update_expansion (self, _tmp30_);
					}
					_g_object_unref0 (child_expandable_item);
					_g_object_unref0 (child_item);
				}
				_g_object_unref0 (_child_item_it);
			}
		} else {
			GtkTreePath* _tmp31_;
			_tmp31_ = path;
			gtk_tree_view_collapse_row ((GtkTreeView*) self, _tmp31_);
		}
	}
	_gtk_tree_path_free0 (path);
}


static void granite_widgets_source_list_tree_real_row_expanded (GtkTreeView* base, GtkTreeIter* iter, GtkTreePath* path) {
	GraniteWidgetsSourceListTree * self;
	GraniteWidgetsSourceListExpandableItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_if_fail (iter != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = *iter;
	_tmp2_ = granite_widgets_source_list_data_model_get_item (_tmp0_, &_tmp1_);
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp2_) : NULL;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (_tmp2_);
	}
	item = _tmp3_;
	g_return_if_fail (item != NULL);
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
	granite_widgets_source_list_expandable_item_set_expanded (item, TRUE);
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
	_g_object_unref0 (item);
}


static void granite_widgets_source_list_tree_real_row_collapsed (GtkTreeView* base, GtkTreeIter* iter, GtkTreePath* path) {
	GraniteWidgetsSourceListTree * self;
	GraniteWidgetsSourceListExpandableItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_if_fail (iter != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = *iter;
	_tmp2_ = granite_widgets_source_list_data_model_get_item (_tmp0_, &_tmp1_);
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp2_) : NULL;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (_tmp2_);
	}
	item = _tmp3_;
	g_return_if_fail (item != NULL);
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
	granite_widgets_source_list_expandable_item_set_expanded (item, FALSE);
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
	_g_object_unref0 (item);
}


static void granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base, GtkTreePath* path, GtkTreeViewColumn* column) {
	GraniteWidgetsSourceListTree * self;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = column;
	_tmp1_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	if (_tmp0_ == _tmp1_) {
		GraniteWidgetsSourceListItem* item = NULL;
		GraniteWidgetsSourceListDataModel* _tmp2_;
		GtkTreePath* _tmp3_;
		GraniteWidgetsSourceListItem* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		_tmp2_ = self->priv->_data_model;
		_tmp3_ = path;
		_tmp4_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp2_, _tmp3_);
		item = _tmp4_;
		_tmp5_ = item;
		if (_tmp5_ != NULL) {
			GraniteWidgetsSourceListItem* _tmp6_;
			_tmp6_ = item;
			g_signal_emit (_tmp6_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL], 0);
		}
		_g_object_unref0 (item);
	}
}


static gboolean granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base, GdkEventKey* event) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GdkEventKey* _tmp15_;
	gboolean _tmp16_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GdkEventKey* _tmp2_;
		guint _tmp3_;
		_tmp2_ = event;
		_tmp3_ = _tmp2_->keyval;
		switch (_tmp3_) {
			case GDK_KEY_F2:
			{
				GdkModifierType modifiers = 0;
				GdkModifierType _tmp4_;
				gboolean _tmp5_ = FALSE;
				GdkEventKey* _tmp6_;
				GdkModifierType _tmp7_;
				GdkModifierType _tmp8_;
				_tmp4_ = gtk_accelerator_get_default_mod_mask ();
				modifiers = _tmp4_;
				_tmp6_ = event;
				_tmp7_ = _tmp6_->state;
				_tmp8_ = modifiers;
				if ((_tmp7_ & _tmp8_) == 0) {
					GraniteWidgetsSourceListItem* _tmp9_;
					GraniteWidgetsSourceListItem* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp9_ = granite_widgets_source_list_tree_get_selected_item (self);
					_tmp10_ = _tmp9_;
					_tmp11_ = granite_widgets_source_list_item_get_editable (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp5_ = _tmp12_;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					GraniteWidgetsSourceListItem* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
					_tmp13_ = granite_widgets_source_list_tree_get_selected_item (self);
					_tmp14_ = _tmp13_;
					granite_widgets_source_list_tree_start_editing_item (self, _tmp14_);
				}
				break;
			}
			default:
			break;
		}
	}
	_tmp15_ = event;
	_tmp16_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp15_);
	result = _tmp16_;
	return result;
}


static gboolean granite_widgets_source_list_tree_real_button_release_event (GtkWidget* base, GdkEventButton* event) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GdkEventButton* _tmp31_;
	gboolean _tmp32_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = self->priv->unselectable_item_clicked;
	if (_tmp1_) {
		GdkEventButton* _tmp2_;
		GdkWindow* _tmp3_;
		GdkWindow* _tmp4_;
		_tmp2_ = event;
		_tmp3_ = _tmp2_->window;
		_tmp4_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
		_tmp0_ = _tmp3_ == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkTreePath* path = NULL;
		GtkTreeViewColumn* column = NULL;
		gint x = 0;
		GdkEventButton* _tmp5_;
		gdouble _tmp6_;
		gint y = 0;
		GdkEventButton* _tmp7_;
		gdouble _tmp8_;
		gint cell_x = 0;
		gint cell_y = 0;
		gint _tmp9_;
		gint _tmp10_;
		GtkTreePath* _tmp11_ = NULL;
		GtkTreeViewColumn* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gboolean _tmp15_;
		GtkTreeViewColumn* _tmp16_;
		self->priv->unselectable_item_clicked = FALSE;
		_tmp5_ = event;
		_tmp6_ = _tmp5_->x;
		x = (gint) _tmp6_;
		_tmp7_ = event;
		_tmp8_ = _tmp7_->y;
		y = (gint) _tmp8_;
		_tmp9_ = x;
		_tmp10_ = y;
		_tmp15_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp9_, _tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
		_gtk_tree_path_free0 (path);
		path = _tmp11_;
		_g_object_unref0 (column);
		_tmp16_ = _g_object_ref0 (_tmp12_);
		column = _tmp16_;
		cell_x = _tmp13_;
		cell_y = _tmp14_;
		if (_tmp15_) {
			GraniteWidgetsSourceListExpandableItem* item = NULL;
			GraniteWidgetsSourceListDataModel* _tmp17_;
			GtkTreePath* _tmp18_;
			GraniteWidgetsSourceListItem* _tmp19_;
			GraniteWidgetsSourceListExpandableItem* _tmp20_;
			GraniteWidgetsSourceListExpandableItem* _tmp21_;
			_tmp17_ = self->priv->_data_model;
			_tmp18_ = path;
			_tmp19_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp17_, _tmp18_);
			_tmp20_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp19_) : NULL;
			if (_tmp20_ == NULL) {
				_g_object_unref0 (_tmp19_);
			}
			item = _tmp20_;
			_tmp21_ = item;
			if (_tmp21_ != NULL) {
				gboolean _tmp22_ = FALSE;
				GraniteWidgetsSourceListExpandableItem* _tmp23_;
				gboolean _tmp24_;
				gboolean _tmp25_;
				_tmp23_ = item;
				_tmp24_ = granite_widgets_source_list_item_get_selectable ((GraniteWidgetsSourceListItem*) _tmp23_);
				_tmp25_ = _tmp24_;
				if (!_tmp25_) {
					_tmp22_ = TRUE;
				} else {
					GraniteWidgetsSourceListDataModel* _tmp26_;
					GraniteWidgetsSourceListExpandableItem* _tmp27_;
					GtkTreePath* _tmp28_;
					gboolean _tmp29_;
					_tmp26_ = self->priv->_data_model;
					_tmp27_ = item;
					_tmp28_ = path;
					_tmp29_ = granite_widgets_source_list_data_model_is_category (_tmp26_, (GraniteWidgetsSourceListItem*) _tmp27_, NULL, _tmp28_);
					_tmp22_ = _tmp29_;
				}
				if (_tmp22_) {
					GraniteWidgetsSourceListExpandableItem* _tmp30_;
					_tmp30_ = item;
					granite_widgets_source_list_tree_toggle_expansion (self, _tmp30_);
				}
			}
			_g_object_unref0 (item);
		}
		_g_object_unref0 (column);
		_gtk_tree_path_free0 (path);
	}
	_tmp31_ = event;
	_tmp32_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp31_);
	result = _tmp32_;
	return result;
}


static gboolean granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint x = 0;
	GdkEventButton* _tmp5_;
	gdouble _tmp6_;
	gint y = 0;
	GdkEventButton* _tmp7_;
	gdouble _tmp8_;
	gint cell_x = 0;
	gint cell_y = 0;
	gint _tmp9_;
	gint _tmp10_;
	GtkTreePath* _tmp11_ = NULL;
	GtkTreeViewColumn* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gboolean _tmp15_;
	GtkTreeViewColumn* _tmp16_;
	GdkEventButton* _tmp87_;
	gboolean _tmp88_;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->window;
	_tmp2_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
	if (_tmp1_ != _tmp2_) {
		GdkEventButton* _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = event;
		_tmp4_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp3_);
		result = _tmp4_;
		return result;
	}
	_tmp5_ = event;
	_tmp6_ = _tmp5_->x;
	x = (gint) _tmp6_;
	_tmp7_ = event;
	_tmp8_ = _tmp7_->y;
	y = (gint) _tmp8_;
	_tmp9_ = x;
	_tmp10_ = y;
	_tmp15_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp9_, _tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	_gtk_tree_path_free0 (path);
	path = _tmp11_;
	_g_object_unref0 (column);
	_tmp16_ = _g_object_ref0 (_tmp12_);
	column = _tmp16_;
	cell_x = _tmp13_;
	cell_y = _tmp14_;
	if (_tmp15_) {
		GraniteWidgetsSourceListItem* item = NULL;
		GraniteWidgetsSourceListDataModel* _tmp17_;
		GtkTreePath* _tmp18_;
		GraniteWidgetsSourceListItem* _tmp19_;
		GdkRectangle start_cell_area = {0};
		GtkTreePath* _tmp20_;
		GtkTreeViewColumn* _tmp21_;
		GdkRectangle _tmp22_ = {0};
		gint _tmp23_;
		GdkRectangle _tmp24_;
		gint _tmp25_;
		gboolean _tmp26_ = FALSE;
		GraniteWidgetsSourceListItem* _tmp27_;
		_tmp17_ = self->priv->_data_model;
		_tmp18_ = path;
		_tmp19_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp17_, _tmp18_);
		item = _tmp19_;
		_tmp20_ = path;
		_tmp21_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
		gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp20_, _tmp21_, &_tmp22_);
		start_cell_area = _tmp22_;
		_tmp23_ = cell_x;
		_tmp24_ = start_cell_area;
		_tmp25_ = _tmp24_.x;
		cell_x = _tmp23_ - _tmp25_;
		_tmp27_ = item;
		if (_tmp27_ != NULL) {
			GtkTreeViewColumn* _tmp28_;
			GtkTreeViewColumn* _tmp29_;
			_tmp28_ = column;
			_tmp29_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
			_tmp26_ = _tmp28_ == _tmp29_;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			GdkEventButton* _tmp30_;
			guint _tmp31_;
			granite_widgets_source_list_tree_stop_editing (self);
			_tmp30_ = event;
			_tmp31_ = _tmp30_->button;
			if (_tmp31_ == ((guint) GDK_BUTTON_SECONDARY)) {
				GraniteWidgetsSourceListItem* _tmp32_;
				GdkEventButton* _tmp33_;
				_tmp32_ = item;
				_tmp33_ = event;
				granite_widgets_source_list_tree_popup_context_menu (self, _tmp32_, _tmp33_);
			} else {
				GdkEventButton* _tmp34_;
				guint _tmp35_;
				_tmp34_ = event;
				_tmp35_ = _tmp34_->button;
				if (_tmp35_ == ((guint) GDK_BUTTON_PRIMARY)) {
					gboolean is_expandable = FALSE;
					GraniteWidgetsSourceListItem* _tmp36_;
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_;
					gboolean is_category = FALSE;
					GdkEventButton* _tmp43_;
					GdkEventType _tmp44_;
					_tmp36_ = item;
					is_expandable = G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM);
					_tmp38_ = is_expandable;
					if (_tmp38_) {
						GraniteWidgetsSourceListDataModel* _tmp39_;
						GraniteWidgetsSourceListItem* _tmp40_;
						GtkTreePath* _tmp41_;
						gboolean _tmp42_;
						_tmp39_ = self->priv->_data_model;
						_tmp40_ = item;
						_tmp41_ = path;
						_tmp42_ = granite_widgets_source_list_data_model_is_category (_tmp39_, _tmp40_, NULL, _tmp41_);
						_tmp37_ = _tmp42_;
					} else {
						_tmp37_ = FALSE;
					}
					is_category = _tmp37_;
					_tmp43_ = event;
					_tmp44_ = _tmp43_->type;
					if (_tmp44_ == GDK_BUTTON_PRESS) {
						gboolean _tmp45_;
						_tmp45_ = is_expandable;
						if (_tmp45_) {
							gboolean _tmp46_ = FALSE;
							gboolean _tmp47_;
							gboolean _tmp57_ = FALSE;
							gboolean _tmp58_ = FALSE;
							gboolean _tmp59_;
							_tmp47_ = is_category;
							if (_tmp47_) {
								_tmp46_ = TRUE;
							} else {
								gboolean _tmp48_ = FALSE;
								GraniteWidgetsSourceListItem* _tmp49_;
								gboolean _tmp50_;
								gboolean _tmp51_;
								_tmp49_ = item;
								_tmp50_ = granite_widgets_source_list_item_get_selectable (_tmp49_);
								_tmp51_ = _tmp50_;
								if (!_tmp51_) {
									GtkTreeViewColumn* _tmp52_;
									GtkTreePath* _tmp53_;
									GraniteWidgetsSourceListCellRendererIcon* _tmp54_;
									gint _tmp55_;
									gboolean _tmp56_;
									_tmp52_ = column;
									_tmp53_ = path;
									_tmp54_ = self->priv->activatable_cell;
									_tmp55_ = cell_x;
									_tmp56_ = granite_widgets_source_list_tree_over_cell (self, _tmp52_, _tmp53_, (GtkCellRenderer*) _tmp54_, _tmp55_);
									_tmp48_ = !_tmp56_;
								} else {
									_tmp48_ = FALSE;
								}
								_tmp46_ = _tmp48_;
							}
							self->priv->unselectable_item_clicked = _tmp46_;
							_tmp59_ = self->priv->unselectable_item_clicked;
							if (!_tmp59_) {
								GtkTreeViewColumn* _tmp60_;
								GtkTreePath* _tmp61_;
								gint _tmp62_;
								gboolean _tmp63_;
								_tmp60_ = column;
								_tmp61_ = path;
								_tmp62_ = cell_x;
								_tmp63_ = granite_widgets_source_list_tree_over_primary_expander (self, _tmp60_, _tmp61_, _tmp62_);
								_tmp58_ = _tmp63_;
							} else {
								_tmp58_ = FALSE;
							}
							if (_tmp58_) {
								GraniteWidgetsSourceListItem* _tmp64_;
								gboolean _tmp65_;
								_tmp64_ = item;
								_tmp65_ = granite_widgets_source_list_tree_toggle_expansion (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp64_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp64_) : NULL);
								_tmp57_ = _tmp65_;
							} else {
								_tmp57_ = FALSE;
							}
							if (_tmp57_) {
								result = TRUE;
								_g_object_unref0 (item);
								_g_object_unref0 (column);
								_gtk_tree_path_free0 (path);
								return result;
							}
						}
					} else {
						gboolean _tmp66_ = FALSE;
						gboolean _tmp67_ = FALSE;
						gboolean _tmp68_ = FALSE;
						gboolean _tmp69_ = FALSE;
						gboolean _tmp70_ = FALSE;
						GdkEventButton* _tmp71_;
						GdkEventType _tmp72_;
						_tmp71_ = event;
						_tmp72_ = _tmp71_->type;
						if (_tmp72_ == GDK_2BUTTON_PRESS) {
							gboolean _tmp73_;
							_tmp73_ = is_category;
							_tmp70_ = !_tmp73_;
						} else {
							_tmp70_ = FALSE;
						}
						if (_tmp70_) {
							GraniteWidgetsSourceListItem* _tmp74_;
							gboolean _tmp75_;
							gboolean _tmp76_;
							_tmp74_ = item;
							_tmp75_ = granite_widgets_source_list_item_get_editable (_tmp74_);
							_tmp76_ = _tmp75_;
							_tmp69_ = _tmp76_;
						} else {
							_tmp69_ = FALSE;
						}
						if (_tmp69_) {
							GraniteWidgetsSourceListItem* _tmp77_;
							gboolean _tmp78_;
							gboolean _tmp79_;
							_tmp77_ = item;
							_tmp78_ = granite_widgets_source_list_item_get_selectable (_tmp77_);
							_tmp79_ = _tmp78_;
							_tmp68_ = _tmp79_;
						} else {
							_tmp68_ = FALSE;
						}
						if (_tmp68_) {
							GtkTreeViewColumn* _tmp80_;
							GtkTreePath* _tmp81_;
							GtkCellRendererText* _tmp82_;
							gint _tmp83_;
							gboolean _tmp84_;
							_tmp80_ = column;
							_tmp81_ = path;
							_tmp82_ = self->priv->text_cell;
							_tmp83_ = cell_x;
							_tmp84_ = granite_widgets_source_list_tree_over_cell (self, _tmp80_, _tmp81_, (GtkCellRenderer*) _tmp82_, _tmp83_);
							_tmp67_ = _tmp84_;
						} else {
							_tmp67_ = FALSE;
						}
						if (_tmp67_) {
							GraniteWidgetsSourceListItem* _tmp85_;
							gboolean _tmp86_;
							_tmp85_ = item;
							_tmp86_ = granite_widgets_source_list_tree_start_editing_item (self, _tmp85_);
							_tmp66_ = _tmp86_;
						} else {
							_tmp66_ = FALSE;
						}
						if (_tmp66_) {
							result = TRUE;
							_g_object_unref0 (item);
							_g_object_unref0 (column);
							_gtk_tree_path_free0 (path);
							return result;
						}
					}
				}
			}
		}
		_g_object_unref0 (item);
	}
	_tmp87_ = event;
	_tmp88_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), _tmp87_);
	result = _tmp88_;
	_g_object_unref0 (column);
	_gtk_tree_path_free0 (path);
	return result;
}


static gboolean granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, gint x) {
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeModel* _tmp8_;
	GtkTreeIter _tmp9_;
	GraniteWidgetsCellRendererExpander* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTreeModel* _tmp13_;
	GtkTreeModel* _tmp14_;
	GtkTreeIter _tmp15_;
	gint _tmp16_;
	gint indentation_level = 0;
	GtkTreePath* _tmp17_;
	gint _tmp18_;
	GraniteWidgetsSourceListCellRendererSpacer* last_spacer_cell = NULL;
	GeeHashMap* _tmp19_;
	gint _tmp20_;
	gpointer _tmp21_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp22_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (col != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = path;
	_tmp4_ = gtk_tree_model_get_iter (_tmp1_, &_tmp3_, _tmp2_);
	iter = _tmp3_;
	if (!_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = col;
	_tmp6_ = self->priv->primary_expander_cell;
	_tmp7_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = iter;
	granite_widgets_source_list_tree_expander_cell_data_func (self, (GtkCellLayout*) _tmp5_, (GtkCellRenderer*) _tmp6_, _tmp8_, &_tmp9_);
	_tmp10_ = self->priv->primary_expander_cell;
	_tmp11_ = gtk_cell_renderer_get_visible ((GtkCellRenderer*) _tmp10_);
	_tmp12_ = _tmp11_;
	if (!_tmp12_) {
		result = FALSE;
		return result;
	}
	_tmp13_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = iter;
	_tmp16_ = gtk_tree_model_iter_n_children (_tmp14_, &_tmp15_);
	if (_tmp16_ < 1) {
		result = FALSE;
		return result;
	}
	_tmp17_ = path;
	_tmp18_ = gtk_tree_path_get_depth (_tmp17_);
	indentation_level = _tmp18_;
	_tmp19_ = self->priv->spacer_cells;
	_tmp20_ = indentation_level;
	_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
	last_spacer_cell = (GraniteWidgetsSourceListCellRendererSpacer*) _tmp21_;
	_tmp22_ = last_spacer_cell;
	if (_tmp22_ != NULL) {
		gint cell_x = 0;
		gint cell_width = 0;
		GtkTreeViewColumn* _tmp23_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp24_;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gboolean _tmp27_;
		_tmp23_ = col;
		_tmp24_ = last_spacer_cell;
		_tmp27_ = gtk_tree_view_column_cell_get_position (_tmp23_, (GtkCellRenderer*) _tmp24_, &_tmp25_, &_tmp26_);
		cell_x = _tmp25_;
		cell_width = _tmp26_;
		if (_tmp27_) {
			gint expander_width = 0;
			GraniteWidgetsCellRendererExpander* _tmp28_;
			gint _tmp29_;
			gboolean _tmp30_;
			gboolean _tmp39_ = FALSE;
			gint _tmp40_;
			gint _tmp41_;
			_tmp28_ = self->priv->primary_expander_cell;
			_tmp29_ = granite_widgets_source_list_tree_get_cell_width (self, (GtkCellRenderer*) _tmp28_);
			expander_width = _tmp29_ + 1;
			_tmp30_ = granite_widgets_utils_is_left_to_right ((GtkWidget*) self);
			if (_tmp30_) {
				gint indentation_offset = 0;
				gint _tmp31_;
				gint _tmp32_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gint _tmp35_;
				_tmp31_ = cell_x;
				_tmp32_ = cell_width;
				indentation_offset = _tmp31_ + _tmp32_;
				_tmp34_ = x;
				_tmp35_ = indentation_offset;
				if (_tmp34_ >= _tmp35_) {
					gint _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					_tmp36_ = x;
					_tmp37_ = indentation_offset;
					_tmp38_ = expander_width;
					_tmp33_ = _tmp36_ <= (_tmp37_ + _tmp38_);
				} else {
					_tmp33_ = FALSE;
				}
				result = _tmp33_;
				_g_object_unref0 (last_spacer_cell);
				return result;
			}
			_tmp40_ = x;
			_tmp41_ = cell_x;
			if (_tmp40_ <= _tmp41_) {
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				_tmp42_ = x;
				_tmp43_ = cell_x;
				_tmp44_ = expander_width;
				_tmp39_ = _tmp42_ >= (_tmp43_ - _tmp44_);
			} else {
				_tmp39_ = FALSE;
			}
			result = _tmp39_;
			_g_object_unref0 (last_spacer_cell);
			return result;
		}
	}
	result = FALSE;
	_g_object_unref0 (last_spacer_cell);
	return result;
}


static gboolean granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, GtkCellRenderer* cell, gint x) {
	gboolean result = FALSE;
	gint cell_x = 0;
	gint cell_width = 0;
	gboolean found = FALSE;
	GtkTreeViewColumn* _tmp0_;
	GtkCellRenderer* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (col != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (cell != NULL, FALSE);
	_tmp0_ = col;
	_tmp1_ = cell;
	_tmp4_ = gtk_tree_view_column_cell_get_position (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
	cell_x = _tmp2_;
	cell_width = _tmp3_;
	found = _tmp4_;
	_tmp7_ = found;
	if (_tmp7_) {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = x;
		_tmp9_ = cell_x;
		_tmp6_ = _tmp8_ > _tmp9_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp10_ = x;
		_tmp11_ = cell_x;
		_tmp12_ = cell_width;
		_tmp5_ = _tmp10_ < (_tmp11_ + _tmp12_);
	} else {
		_tmp5_ = FALSE;
	}
	result = _tmp5_;
	return result;
}


static gint granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self, GtkCellRenderer* cell_renderer) {
	gint result = 0;
	GtkRequisition min_req = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (cell_renderer != NULL, 0);
	_tmp0_ = cell_renderer;
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, NULL);
	min_req = _tmp1_;
	_tmp2_ = min_req;
	_tmp3_ = _tmp2_.width;
	result = _tmp3_;
	return result;
}


static gboolean granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = (GraniteWidgetsSourceListTree*) base;
	_tmp0_ = granite_widgets_source_list_tree_popup_context_menu (self, NULL, NULL);
	result = _tmp0_;
	return result;
}


static void _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	granite_widgets_source_list_tree_menu_position_func ((GraniteWidgetsSourceListTree*) self, menu, x, y, push_in);
	g_object_unref (self);
}


static gboolean granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, GdkEventButton* event) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = item;
	if (_tmp0_ == NULL) {
		GraniteWidgetsSourceListItem* _tmp1_;
		GraniteWidgetsSourceListItem* _tmp2_;
		_tmp1_ = granite_widgets_source_list_tree_get_selected_item (self);
		_tmp2_ = _tmp1_;
		item = _tmp2_;
	}
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GtkMenu* menu = NULL;
		GraniteWidgetsSourceListItem* _tmp4_;
		GtkMenu* _tmp5_;
		GtkMenu* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_item_get_context_menu (_tmp4_);
		menu = _tmp5_;
		_tmp6_ = menu;
		if (_tmp6_ != NULL) {
			guint32 _tmp7_ = 0U;
			GdkEventButton* _tmp8_;
			guint32 time = 0U;
			guint _tmp12_ = 0U;
			GdkEventButton* _tmp13_;
			guint button = 0U;
			GtkMenu* _tmp16_;
			GdkEventButton* _tmp17_;
			_tmp8_ = event;
			if (_tmp8_ != NULL) {
				GdkEventButton* _tmp9_;
				guint32 _tmp10_;
				_tmp9_ = event;
				_tmp10_ = _tmp9_->time;
				_tmp7_ = _tmp10_;
			} else {
				guint32 _tmp11_;
				_tmp11_ = gtk_get_current_event_time ();
				_tmp7_ = _tmp11_;
			}
			time = _tmp7_;
			_tmp13_ = event;
			if (_tmp13_ != NULL) {
				GdkEventButton* _tmp14_;
				guint _tmp15_;
				_tmp14_ = event;
				_tmp15_ = _tmp14_->button;
				_tmp12_ = _tmp15_;
			} else {
				_tmp12_ = (guint) 0;
			}
			button = _tmp12_;
			_tmp16_ = menu;
			gtk_menu_attach_to_widget (_tmp16_, (GtkWidget*) self, NULL);
			_tmp17_ = event;
			if (_tmp17_ != NULL) {
				GtkMenu* _tmp18_;
				guint _tmp19_;
				guint32 _tmp20_;
				_tmp18_ = menu;
				_tmp19_ = button;
				_tmp20_ = time;
				gtk_menu_popup (_tmp18_, NULL, NULL, NULL, NULL, _tmp19_, _tmp20_);
			} else {
				GtkMenu* _tmp21_;
				guint _tmp22_;
				guint32 _tmp23_;
				GtkMenu* _tmp24_;
				_tmp21_ = menu;
				_tmp22_ = button;
				_tmp23_ = time;
				gtk_menu_popup (_tmp21_, NULL, NULL, _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func, g_object_ref (self), _tmp22_, _tmp23_);
				_tmp24_ = menu;
				gtk_menu_shell_select_first ((GtkMenuShell*) _tmp24_, FALSE);
			}
			result = TRUE;
			_g_object_unref0 (menu);
			return result;
		}
		_g_object_unref0 (menu);
	}
	result = FALSE;
	return result;
}


/**
         * Positions a menu based on an item's coordinates.
         *
         * This function is only used for menu pop-ups triggered by events other than button
         * presses (e.g. key-press events). Since such events provide no coordinates, it is
         * assumed that the item in question is the one currently selected.
         */
static void granite_widgets_source_list_tree_menu_position_func (GraniteWidgetsSourceListTree* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	GdkRectangle item_bin_coords = {0};
	GtkTreePath* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GdkRectangle _tmp12_ = {0};
	gint item_y = 0;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	gint item_x = 0;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	gboolean is_ltr = FALSE;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gint widget_x = 0;
	gint widget_y = 0;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	GdkWindow* _tmp28_;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_vala_push_in = TRUE;
	_vala_y = 0;
	_tmp0_ = _vala_y;
	_vala_x = _tmp0_;
	_tmp2_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp4_;
		_tmp4_ = gtk_widget_get_realized ((GtkWidget*) self);
		_tmp1_ = !_tmp4_;
	}
	if (_tmp1_) {
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp5_ = self->priv->_data_model;
	_tmp6_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = granite_widgets_source_list_data_model_get_item_path (_tmp5_, _tmp7_);
	path = _tmp8_;
	_tmp9_ = path;
	if (_tmp9_ == NULL) {
		_gtk_tree_path_free0 (path);
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp10_ = path;
	_tmp11_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp10_, _tmp11_, &_tmp12_);
	item_bin_coords = _tmp12_;
	_tmp13_ = item_bin_coords;
	_tmp14_ = _tmp13_.y;
	_tmp15_ = item_bin_coords;
	_tmp16_ = _tmp15_.height;
	item_y = _tmp14_ + (_tmp16_ / 2);
	_tmp17_ = item_bin_coords;
	_tmp18_ = _tmp17_.x;
	item_x = _tmp18_;
	_tmp19_ = granite_widgets_utils_is_left_to_right ((GtkWidget*) self);
	is_ltr = _tmp19_;
	_tmp20_ = is_ltr;
	if (_tmp20_) {
		gint _tmp21_;
		GdkRectangle _tmp22_;
		gint _tmp23_;
		_tmp21_ = item_x;
		_tmp22_ = item_bin_coords;
		_tmp23_ = _tmp22_.width;
		item_x = _tmp21_ + (_tmp23_ - 6);
	}
	_tmp24_ = item_x;
	_tmp25_ = item_y;
	gtk_tree_view_convert_bin_window_to_widget_coords ((GtkTreeView*) self, _tmp24_, _tmp25_, &_tmp26_, &_tmp27_);
	widget_x = _tmp26_;
	widget_y = _tmp27_;
	_tmp28_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_get_origin (_tmp28_, &_tmp29_, &_tmp30_);
	_vala_x = _tmp29_;
	_vala_y = _tmp30_;
	_tmp31_ = _vala_x;
	_tmp32_ = widget_x;
	_tmp33_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp34_ = CLAMP (_tmp32_, 0, _tmp33_);
	_vala_x = _tmp31_ + _tmp34_;
	_tmp35_ = _vala_y;
	_tmp36_ = widget_y;
	_tmp37_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp38_ = CLAMP (_tmp36_, 0, _tmp37_);
	_vala_y = _tmp35_ + _tmp38_;
	_tmp39_ = is_ltr;
	if (!_tmp39_) {
		GtkRequisition menu_req = {0};
		GtkMenu* _tmp40_;
		GtkRequisition _tmp41_ = {0};
		gint _tmp42_;
		GtkRequisition _tmp43_;
		gint _tmp44_;
		_tmp40_ = menu;
		gtk_widget_get_preferred_size ((GtkWidget*) _tmp40_, &_tmp41_, NULL);
		menu_req = _tmp41_;
		_tmp42_ = _vala_y;
		_tmp43_ = menu_req;
		_tmp44_ = _tmp43_.width;
		_vala_y = _tmp42_ - _tmp44_;
	}
	_gtk_tree_path_free0 (path);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (push_in) {
		*push_in = _vala_push_in;
	}
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListDataModel* data_model = NULL;
	GtkTreeModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GtkTreeIter _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (model != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = model;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL) ? ((GraniteWidgetsSourceListDataModel*) _tmp0_) : NULL);
	data_model = _tmp1_;
	_vala_assert (data_model != NULL, "data_model != null");
	_tmp2_ = *iter;
	_tmp3_ = granite_widgets_source_list_data_model_get_item (data_model, &_tmp2_);
	result = _tmp3_;
	_g_object_unref0 (data_model);
	return result;
}


static void granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListCellRendererSpacer* spacer = NULL;
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp1_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp2_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkTreePath* path = NULL;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	GtkTreePath* _tmp8_;
	gint level = 0;
	GtkTreePath* _tmp9_;
	GtkCellRenderer* _tmp12_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER) ? ((GraniteWidgetsSourceListCellRendererSpacer*) _tmp0_) : NULL);
	spacer = _tmp1_;
	_tmp2_ = spacer;
	_vala_assert (_tmp2_ != NULL, "spacer != null");
	_tmp3_ = spacer;
	_tmp4_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_assert (_tmp5_ > 0, "spacer.level > 0");
	_tmp6_ = model;
	_tmp7_ = *iter;
	_tmp8_ = gtk_tree_model_get_path (_tmp6_, &_tmp7_);
	path = _tmp8_;
	level = -1;
	_tmp9_ = path;
	if (_tmp9_ != NULL) {
		GtkTreePath* _tmp10_;
		gint _tmp11_;
		_tmp10_ = path;
		_tmp11_ = gtk_tree_path_get_depth (_tmp10_);
		level = _tmp11_;
	}
	_tmp12_ = renderer;
	_tmp13_ = spacer;
	_tmp14_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = level;
	gtk_cell_renderer_set_visible (_tmp12_, _tmp15_ <= _tmp16_);
	_gtk_tree_path_free0 (path);
	_g_object_unref0 (spacer);
}


static void granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRenderer* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GString* text = NULL;
	GString* _tmp3_;
	PangoWeight weight = 0;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GtkCellRendererText* _tmp16_;
	PangoWeight _tmp17_;
	GtkCellRendererText* _tmp18_;
	GString* _tmp19_;
	const gchar* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) _tmp0_) : NULL);
	text_renderer = _tmp1_;
	_tmp2_ = text_renderer;
	_vala_assert (_tmp2_ != NULL, "text_renderer != null");
	_tmp3_ = g_string_new ("");
	text = _tmp3_;
	weight = PANGO_WEIGHT_NORMAL;
	_tmp4_ = model;
	_tmp5_ = *iter;
	_tmp6_ = granite_widgets_source_list_tree_get_item_from_model (_tmp4_, &_tmp5_);
	item = _tmp6_;
	_tmp7_ = item;
	if (_tmp7_ != NULL) {
		GString* _tmp8_;
		GraniteWidgetsSourceListItem* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GraniteWidgetsSourceListDataModel* _tmp12_;
		GraniteWidgetsSourceListItem* _tmp13_;
		GtkTreeIter _tmp14_;
		gboolean _tmp15_;
		_tmp8_ = text;
		_tmp9_ = item;
		_tmp10_ = granite_widgets_source_list_item_get_name (_tmp9_);
		_tmp11_ = _tmp10_;
		g_string_append (_tmp8_, _tmp11_);
		_tmp12_ = self->priv->_data_model;
		_tmp13_ = item;
		_tmp14_ = *iter;
		_tmp15_ = granite_widgets_source_list_data_model_is_category (_tmp12_, _tmp13_, &_tmp14_, NULL);
		if (_tmp15_) {
			weight = PANGO_WEIGHT_BOLD;
		}
	}
	_tmp16_ = text_renderer;
	_tmp17_ = weight;
	g_object_set (_tmp16_, "weight", (gint) _tmp17_, NULL);
	_tmp18_ = text_renderer;
	_tmp19_ = text;
	_tmp20_ = _tmp19_->str;
	g_object_set (_tmp18_, "text", _tmp20_, NULL);
	_g_object_unref0 (item);
	_g_string_free0 (text);
	_g_object_unref0 (text_renderer);
}


static void granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsCellRendererBadge* badge_renderer = NULL;
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsCellRendererBadge* _tmp1_;
	GraniteWidgetsCellRendererBadge* _tmp2_;
	gchar* text = NULL;
	gchar* _tmp3_;
	gboolean visible = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsCellRendererBadge* _tmp27_;
	gboolean _tmp28_;
	GraniteWidgetsCellRendererBadge* _tmp29_;
	const gchar* _tmp30_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE) ? ((GraniteWidgetsCellRendererBadge*) _tmp0_) : NULL);
	badge_renderer = _tmp1_;
	_tmp2_ = badge_renderer;
	_vala_assert (_tmp2_ != NULL, "badge_renderer != null");
	_tmp3_ = g_strdup ("");
	text = _tmp3_;
	visible = FALSE;
	_tmp4_ = model;
	_tmp5_ = *iter;
	_tmp6_ = granite_widgets_source_list_tree_get_item_from_model (_tmp4_, &_tmp5_);
	item = _tmp6_;
	_tmp7_ = item;
	if (_tmp7_ != NULL) {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		GraniteWidgetsSourceListDataModel* _tmp10_;
		GraniteWidgetsSourceListItem* _tmp11_;
		GtkTreeIter _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp22_;
		_tmp10_ = self->priv->_data_model;
		_tmp11_ = item;
		_tmp12_ = *iter;
		_tmp13_ = granite_widgets_source_list_data_model_is_category (_tmp10_, _tmp11_, &_tmp12_, NULL);
		if (!_tmp13_) {
			GraniteWidgetsSourceListItem* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			_tmp14_ = item;
			_tmp15_ = granite_widgets_source_list_item_get_badge (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp9_ = _tmp16_ != NULL;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			GraniteWidgetsSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			_tmp17_ = item;
			_tmp18_ = granite_widgets_source_list_item_get_badge (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = string_strip (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp8_ = g_strcmp0 (_tmp21_, "") != 0;
			_g_free0 (_tmp21_);
		} else {
			_tmp8_ = FALSE;
		}
		visible = _tmp8_;
		_tmp22_ = visible;
		if (_tmp22_) {
			GraniteWidgetsSourceListItem* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp23_ = item;
			_tmp24_ = granite_widgets_source_list_item_get_badge (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strdup (_tmp25_);
			_g_free0 (text);
			text = _tmp26_;
		}
	}
	_tmp27_ = badge_renderer;
	_tmp28_ = visible;
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp27_, _tmp28_);
	_tmp29_ = badge_renderer;
	_tmp30_ = text;
	granite_widgets_cell_renderer_badge_set_text (_tmp29_, _tmp30_);
	_g_object_unref0 (item);
	_g_free0 (text);
	_g_object_unref0 (badge_renderer);
}


static void granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListCellRendererIcon* icon_renderer = NULL;
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp1_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp2_;
	gboolean visible = FALSE;
	GIcon* icon = NULL;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp27_;
	gboolean _tmp28_;
	GIcon* _tmp29_ = NULL;
	gboolean _tmp30_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON) ? ((GraniteWidgetsSourceListCellRendererIcon*) _tmp0_) : NULL);
	icon_renderer = _tmp1_;
	_tmp2_ = icon_renderer;
	_vala_assert (_tmp2_ != NULL, "icon_renderer != null");
	visible = FALSE;
	icon = NULL;
	_tmp3_ = model;
	_tmp4_ = *iter;
	_tmp5_ = granite_widgets_source_list_tree_get_item_from_model (_tmp3_, &_tmp4_);
	item = _tmp5_;
	_tmp6_ = item;
	if (_tmp6_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp7_;
		GraniteWidgetsSourceListItem* _tmp8_;
		GtkTreeIter _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		_tmp7_ = self->priv->_data_model;
		_tmp8_ = item;
		_tmp9_ = *iter;
		_tmp10_ = granite_widgets_source_list_data_model_is_category (_tmp7_, _tmp8_, &_tmp9_, NULL);
		visible = !_tmp10_;
		_tmp11_ = visible;
		if (_tmp11_) {
			GraniteWidgetsSourceListCellRendererIcon* _tmp12_;
			GraniteWidgetsSourceListCellRendererIcon* _tmp13_;
			_tmp12_ = icon_renderer;
			_tmp13_ = self->priv->icon_cell;
			if (_tmp12_ == _tmp13_) {
				GraniteWidgetsSourceListItem* _tmp14_;
				GIcon* _tmp15_;
				GIcon* _tmp16_;
				GIcon* _tmp17_;
				_tmp14_ = item;
				_tmp15_ = granite_widgets_source_list_item_get_icon (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _g_object_ref0 (_tmp16_);
				_g_object_unref0 (icon);
				icon = _tmp17_;
			} else {
				GraniteWidgetsSourceListCellRendererIcon* _tmp18_;
				GraniteWidgetsSourceListCellRendererIcon* _tmp19_;
				_tmp18_ = icon_renderer;
				_tmp19_ = self->priv->activatable_cell;
				if (_tmp18_ == _tmp19_) {
					GraniteWidgetsSourceListItem* _tmp20_;
					GIcon* _tmp21_;
					GIcon* _tmp22_;
					GIcon* _tmp23_;
					_tmp20_ = item;
					_tmp21_ = granite_widgets_source_list_item_get_activatable (_tmp20_);
					_tmp22_ = _tmp21_;
					_tmp23_ = _g_object_ref0 (_tmp22_);
					_g_object_unref0 (icon);
					icon = _tmp23_;
				} else {
					g_assert_not_reached ();
				}
			}
		}
	}
	_tmp25_ = visible;
	if (_tmp25_) {
		GIcon* _tmp26_;
		_tmp26_ = icon;
		_tmp24_ = _tmp26_ != NULL;
	} else {
		_tmp24_ = FALSE;
	}
	visible = _tmp24_;
	_tmp27_ = icon_renderer;
	_tmp28_ = visible;
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp27_, _tmp28_);
	_tmp30_ = visible;
	if (_tmp30_) {
		GIcon* _tmp31_;
		_tmp31_ = icon;
		_tmp29_ = _tmp31_;
	} else {
		_tmp29_ = NULL;
	}
	_tmp32_ = icon_renderer;
	g_object_set ((GtkCellRendererPixbuf*) _tmp32_, "gicon", _tmp29_, NULL);
	_g_object_unref0 (item);
	_g_object_unref0 (icon);
	_g_object_unref0 (icon_renderer);
}


/**
         * Controls expander visibility.
         */
static void granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkCellRenderer* _tmp15_;
	GraniteWidgetsCellRendererExpander* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = model;
	_tmp1_ = *iter;
	_tmp2_ = granite_widgets_source_list_tree_get_item_from_model (_tmp0_, &_tmp1_);
	item = _tmp2_;
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* expandable_item = NULL;
		GraniteWidgetsSourceListItem* _tmp4_;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp4_) : NULL);
		expandable_item = _tmp5_;
		_tmp6_ = expandable_item;
		if (_tmp6_ != NULL) {
			gboolean _tmp7_ = FALSE;
			GtkCellRenderer* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			GtkCellRenderer* _tmp14_;
			_tmp8_ = renderer;
			g_object_get (_tmp8_, "is-expander", &_tmp9_, NULL);
			_tmp10_ = _tmp9_;
			if (_tmp10_) {
				GraniteWidgetsSourceListExpandableItem* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				_tmp11_ = expandable_item;
				_tmp12_ = granite_widgets_source_list_expandable_item_get_collapsible (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp7_ = _tmp13_;
			} else {
				_tmp7_ = FALSE;
			}
			_tmp14_ = renderer;
			g_object_set (_tmp14_, "is-expander", _tmp7_, NULL);
		}
		_g_object_unref0 (expandable_item);
	}
	_tmp15_ = renderer;
	_tmp16_ = self->priv->primary_expander_cell;
	if (_tmp15_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
		GtkCellRenderer* _tmp17_;
		GraniteWidgetsSourceListDataModel* _tmp18_;
		GtkTreeIter _tmp19_;
		gboolean _tmp20_;
		_tmp17_ = renderer;
		_tmp18_ = self->priv->_data_model;
		_tmp19_ = *iter;
		_tmp20_ = granite_widgets_source_list_data_model_is_iter_at_root_level (_tmp18_, &_tmp19_);
		gtk_cell_renderer_set_visible (_tmp17_, !_tmp20_);
	} else {
		GtkCellRenderer* _tmp21_;
		GraniteWidgetsCellRendererExpander* _tmp22_;
		_tmp21_ = renderer;
		_tmp22_ = self->priv->secondary_expander_cell;
		if (_tmp21_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
			GtkCellRenderer* _tmp23_;
			GraniteWidgetsSourceListDataModel* _tmp24_;
			GraniteWidgetsSourceListItem* _tmp25_;
			GtkTreeIter _tmp26_;
			gboolean _tmp27_;
			_tmp23_ = renderer;
			_tmp24_ = self->priv->_data_model;
			_tmp25_ = item;
			_tmp26_ = *iter;
			_tmp27_ = granite_widgets_source_list_data_model_is_category (_tmp24_, _tmp25_, &_tmp26_, NULL);
			gtk_cell_renderer_set_visible (_tmp23_, _tmp27_);
		} else {
			g_assert_not_reached ();
		}
	}
	_g_object_unref0 (item);
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListDataModel* result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_model;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListDataModel* value) {
	g_return_if_fail (self != NULL);
	if (granite_widgets_source_list_tree_get_data_model (self) != value) {
		GraniteWidgetsSourceListDataModel* _tmp0_;
		GraniteWidgetsSourceListDataModel* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_data_model);
		self->priv->_data_model = _tmp1_;
		g_object_notify ((GObject *) self, "data-model");
	}
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->selected;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* value) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	granite_widgets_source_list_tree_set_selected (self, _tmp0_, TRUE);
	g_object_notify ((GObject *) self, "selected-item");
}


static gboolean granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self) {
	gboolean result;
	GtkCellRendererText* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->text_cell;
	g_object_get ((GtkCellRenderer*) _tmp0_, "editing", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static PangoEllipsizeMode granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self) {
	PangoEllipsizeMode result;
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->text_cell;
	g_object_get (_tmp0_, "ellipsize", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self, PangoEllipsizeMode value) {
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->text_cell;
	_tmp1_ = value;
	g_object_set (_tmp0_, "ellipsize", _tmp1_, NULL);
	g_object_notify ((GObject *) self, "ellipsize-mode");
}


static void granite_widgets_source_list_tree_class_init (GraniteWidgetsSourceListTreeClass * klass) {
	GParamSpecInt* _tmp0_;
	GParamSpecInt* _tmp1_;
	GParamSpecInt* _tmp2_;
	GParamSpecInt* _tmp3_;
	GParamSpecInt* _tmp4_;
	GParamSpecInt* _tmp5_;
	granite_widgets_source_list_tree_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListTreePrivate));
	((GtkWidgetClass *) klass)->drag_motion = (gboolean (*) (GtkWidget *, GdkDragContext*, gint, gint, guint)) granite_widgets_source_list_tree_real_drag_motion;
	((GtkWidgetClass *) klass)->drag_data_received = (void (*) (GtkWidget *, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint)) granite_widgets_source_list_tree_real_drag_data_received;
	((GtkTreeViewClass *) klass)->cursor_changed = (void (*) (GtkTreeView *)) granite_widgets_source_list_tree_real_cursor_changed;
	((GtkTreeViewClass *) klass)->row_expanded = (void (*) (GtkTreeView *, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_tree_real_row_expanded;
	((GtkTreeViewClass *) klass)->row_collapsed = (void (*) (GtkTreeView *, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_tree_real_row_collapsed;
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView *, GtkTreePath*, GtkTreeViewColumn*)) granite_widgets_source_list_tree_real_row_activated;
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget *, GdkEventKey*)) granite_widgets_source_list_tree_real_key_release_event;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget *, GdkEventButton*)) granite_widgets_source_list_tree_real_button_release_event;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget *, GdkEventButton*)) granite_widgets_source_list_tree_real_button_press_event;
	((GtkWidgetClass *) klass)->popup_menu = (gboolean (*) (GtkWidget *)) granite_widgets_source_list_tree_real_popup_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_tree_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_tree_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_tree_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL, g_param_spec_object ("data-model", "data-model", "data-model", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM, g_param_spec_object ("selected-item", "selected-item", "selected-item", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING, g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE, g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL] = g_signal_new ("item_selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	_tmp0_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, "Level Indentation", "Space to add at the beginning of every indentation level. Must be an e" \
"ven number.", 1, 50, 6, G_PARAM_READABLE);
	_tmp1_ = _tmp0_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp1_);
	_g_param_spec_unref0 (_tmp1_);
	_tmp2_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, "Left Padding", "Padding added to the left side of the tree. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
	_tmp3_ = _tmp2_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp3_);
	_g_param_spec_unref0 (_tmp3_);
	_tmp4_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, "Expander Spacing", "Space added between an item and its expander. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
	_tmp5_ = _tmp4_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp5_);
	_g_param_spec_unref0 (_tmp5_);
}


static void granite_widgets_source_list_tree_instance_init (GraniteWidgetsSourceListTree * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_PRIVATE (self);
	self->priv->unselectable_item_clicked = FALSE;
}


static void granite_widgets_source_list_tree_finalize (GObject * obj) {
	GraniteWidgetsSourceListTree * self;
	GtkCellRendererText* _tmp0_;
	guint _tmp1_;
	GtkCellRendererText* _tmp2_;
	guint _tmp3_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	_tmp0_ = self->priv->text_cell;
	g_signal_parse_name ("editing-started", gtk_cell_renderer_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkCellRenderer*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started, self);
	_tmp2_ = self->priv->text_cell;
	g_signal_parse_name ("editing-canceled", gtk_cell_renderer_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkCellRenderer*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self);
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
	_g_object_unref0 (self->priv->_data_model);
	_g_object_unref0 (self->priv->selected);
	_g_object_unref0 (self->priv->editable_entry);
	_g_object_unref0 (self->priv->text_cell);
	_g_object_unref0 (self->priv->icon_cell);
	_g_object_unref0 (self->priv->activatable_cell);
	_g_object_unref0 (self->priv->badge_cell);
	_g_object_unref0 (self->priv->primary_expander_cell);
	_g_object_unref0 (self->priv->secondary_expander_cell);
	_g_object_unref0 (self->priv->spacer_cells);
	G_OBJECT_CLASS (granite_widgets_source_list_tree_parent_class)->finalize (obj);
}


/**
     * The tree that actually displays the items.
     *
     * All the user interaction happens here.
     */
static GType granite_widgets_source_list_tree_get_type (void) {
	static volatile gsize granite_widgets_source_list_tree_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListTree), 0, (GInstanceInitFunc) granite_widgets_source_list_tree_instance_init, NULL };
		GType granite_widgets_source_list_tree_type_id;
		granite_widgets_source_list_tree_type_id = g_type_register_static (gtk_tree_view_get_type (), "GraniteWidgetsSourceListTree", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_tree_type_id__volatile, granite_widgets_source_list_tree_type_id);
	}
	return granite_widgets_source_list_tree_type_id__volatile;
}


static void _vala_granite_widgets_source_list_tree_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL:
		g_value_set_object (value, granite_widgets_source_list_tree_get_data_model (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM:
		g_value_set_object (value, granite_widgets_source_list_tree_get_selected_item (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING:
		g_value_set_boolean (value, granite_widgets_source_list_tree_get_editing (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE:
		g_value_set_enum (value, granite_widgets_source_list_tree_get_ellipsize_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_tree_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL:
		granite_widgets_source_list_tree_set_data_model (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM:
		granite_widgets_source_list_tree_set_selected_item (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE:
		granite_widgets_source_list_tree_set_ellipsize_mode (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void granite_widgets_source_list_class_init (GraniteWidgetsSourceListClass * klass) {
	granite_widgets_source_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListPrivate));
	((GraniteWidgetsSourceListClass *) klass)->item_selected = granite_widgets_source_list_real_item_selected;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_finalize;
	/**
	     * Root-level expandable item.
	     *
	     * This item contains the first-level source list items. It //only serves as an item container//.
	     * It is used to add and remove items to/from the widget.
	     *
	     * Internally, it allows the source list to connect to its {@link Granite.Widgets.SourceList.ExpandableItem.child_added}
	     * and {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signals in order to monitor
	     * new children additions/removals.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ROOT, g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The current selected item.
	     *
	     * Setting it to //null// un-selects the previously selected item, if there was any.
	     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called on the
	     * item's parent to make sure it's possible to select it.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_SELECTED, g_param_spec_object ("selected", "selected", "selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Text ellipsize mode.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE, g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Whether an item is being edited.
	     *
	     * @see Granite.Widgets.SourceList.start_editing_item
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EDITING, g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Sort direction to use along with the sort function.
	     *
	     * This property is no longer used. It doesn't do anything.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION, g_param_spec_enum ("sort-direction", "sort-direction", "sort-direction", GTK_TYPE_SORT_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
	/**
	     * Emitted when the source list selection changes.
	     *
	     * @param item Selected item; //null// if nothing is selected.
	     * @since 0.2
	     */
	granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL] = g_signal_new ("item_selected", GRANITE_WIDGETS_TYPE_SOURCE_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListClass, item_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
}


static void granite_widgets_source_list_instance_init (GraniteWidgetsSourceList * self) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_GET_PRIVATE (self);
	_tmp0_ = granite_widgets_source_list_data_model_new ();
	self->priv->data_model = _tmp0_;
}


static void granite_widgets_source_list_finalize (GObject * obj) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	_g_object_unref0 (self->priv->tree);
	_g_object_unref0 (self->priv->data_model);
	G_OBJECT_CLASS (granite_widgets_source_list_parent_class)->finalize (obj);
}


/**
 * A widget that can display a list of items organized in categories.
 *
 * The source list widget consists of a collection of items, some of which are also expandable (and
 * thus can contain more items). All the items displayed in the source list are children of the widget's
 * root item. The API is meant to be used as follows:
 *
 * 1. Create the items you want to display in the source list, setting the appropriate values for their
 * properties. The desired hierarchy is achieved by creating expandable items and adding items to them.
 * These will be displayed as descendants in the widget's tree structure. The expandable items that are
 * not nested inside any other item are considered to be at root level, and should be added to
 * the widget's root item.<<BR>>
 *
 * Expandable items located at the root level are treated as categories, and only support text.
 *
 * ''Example''<<BR>>
 * The final tree will have the following structure:
 * {{{
 * Libraries
 *   Music
 * Stores
 *   My Store
 *      Music
 *      Podcasts
 * Devices
 *   Player 1
 *   Player 2
 * }}}
 *
 * {{{
 * var library_category = new Granite.Widgets.SourceList.ExpandableItem ("Libraries");
 * var store_category = new Granite.Widgets.SourceList.ExpandableItem ("Stores");
 * var device_category = new Granite.Widgets.SourceList.ExpandableItem ("Devices");
 *
 * var music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * // "Libraries" will be the parent category of "Music"
 * library_category.add (music_item);
 *
 * // We plan to add sub-items to the store, so let's use an expandable item
 * var my_store_item = new Granite.Widgets.SourceList.ExpandableItem ("My Store");
 * store_category.add (my_store_item);
 *
 * var my_store_podcast_item = new Granite.Widgets.SourceList.Item ("Podcasts");
 * var my_store_music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * my_store_item.add (my_store_music_item);
 * my_store_item.add (my_store_podcast_item);
 *
 * var player1_item = new Granite.Widgets.SourceList.Item ("Player 1");
 * var player2_item = new Granite.Widgets.SourceList.Item ("Player 2");
 *
 * device_category.add (player1_item);
 * device_category.add (player2_item);
 * }}}
 *
 * 2. Create a source list widget.<<BR>>
 * {{{
 * var source_list = new Granite.Widgets.SourceList ();
 * }}}
 *
 * 3. Add root-level items to the {@link Granite.Widgets.SourceList.root} item.
 * This item only serves as a container, and all its properties are ignored by the widget.
 *
 * {{{
 * // This will add the main categories (including their children) to the source list. After
 * // having being added to be widget, any other item added to any of these items
 * // (or any other child item in a deeper level) will be automatically added too.
 * // There's no need to deal with the source list widget directly.
 *
 * var root = source_list.root;
 *
 * root.add (library_category);
 * root.add (store_category);
 * root.add (device_category);
 * }}}
 *
 * The steps mentioned above are enough for initializing the source list. Future changes to the items'
 * properties are ''automatically'' reflected by the widget.
 *
 * Final steps would involve connecting handlers to the source list events, being
 * {@link Granite.Widgets.SourceList.item_selected} the most important, as it indicates that
 * the selection was modified.
 *
 * It is strongly recommended to pack the source list into the GUI using the
 * {@link Granite.Widgets.ThinPaned} widget. It has aesthetic advantages and offers a wider
 * re-size handle than {@link Gtk.Paned}. This is usually done as follows:
 * {{{
 * var pane = new Granite.Widgets.ThinPaned ();
 * pane.pack1 (source_list, false, false);
 * pane.pack2 (content_area, true, false);
 * }}}
 *
 * @since 0.2
 * @see Granite.Widgets.ThinPaned
 */
GType granite_widgets_source_list_get_type (void) {
	static volatile gsize granite_widgets_source_list_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceList), 0, (GInstanceInitFunc) granite_widgets_source_list_instance_init, NULL };
		GType granite_widgets_source_list_type_id;
		granite_widgets_source_list_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "GraniteWidgetsSourceList", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_type_id__volatile, granite_widgets_source_list_type_id);
	}
	return granite_widgets_source_list_type_id__volatile;
}


static void _vala_granite_widgets_source_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT:
		g_value_set_object (value, granite_widgets_source_list_get_root (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED:
		g_value_set_object (value, granite_widgets_source_list_get_selected (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE:
		g_value_set_enum (value, granite_widgets_source_list_get_ellipsize_mode (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EDITING:
		g_value_set_boolean (value, granite_widgets_source_list_get_editing (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
		g_value_set_enum (value, granite_widgets_source_list_get_sort_direction (self));
G_GNUC_END_IGNORE_DEPRECATIONS
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT:
		granite_widgets_source_list_set_root (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED:
		granite_widgets_source_list_set_selected (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE:
		granite_widgets_source_list_set_ellipsize_mode (self, g_value_get_enum (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
		granite_widgets_source_list_set_sort_direction (self, g_value_get_enum (value));
G_GNUC_END_IGNORE_DEPRECATIONS
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



